################################################################################
# FILE        : balloon.tcl
# DESCRIPTION : 
#===============================================================================
# HISTORY     : MM/DD/YYYY AUTHOR  MODIFICATIONS
#               09/15/2000 NIE    Create
#===============================================================================
################################################################################

namespace eval balloon {

} ;#end namespace


        option add *Balloonhelp*background white widgetDefault
        option add *Balloonhelp*foreground black widgetDefault
        option add *Balloonhelp.info.wrapLength 3i widgetDefault
        option add *Balloonhelp.info.justify left widgetDefault
        option add *Balloonhelp.info.font -*-lucida-medium-r-normal-sans-*-120-*  widgetDefault
  

        if {[catch {toplevel .balloonhelp -class Balloonhelp   -borderwidth 1 -relief flat -background lightblue}]} then {
            # Source-Code wurde wahrscheinlich schon einmal geladen
        } else {
           label .balloonhelp.arrow                                            -background lightblue  ;# -bitmap info
              pack .balloonhelp.arrow              -side left -fill both
           label .balloonhelp.info                                             -background lightblue
              pack .balloonhelp.info               -side left -fill y

           wm overrideredirect .balloonhelp 1
           wm withdraw .balloonhelp
        }




     proc ::balloon::balloonhelp_for {b mesg} {
        global bhInfo
           set bhInfo($b) $mesg
           bind $b <Enter> {::balloon::balloonhelp_pending %W}
           bind $b <Leave> {::balloon::balloonhelp_cancel}

     }


     proc ::balloon::balloonhelp_pending {b} {
        global bhInfo statuszeile
           ::balloon::balloonhelp_cancel
           set statuszeile "$bhInfo($b)"
           set bhInfo(pending) [after 600 [list ::balloon::balloonhelp_show $b]]
     }


     proc ::balloon::balloonhelp_cancel {} {
        global bhInfo statuszeile
           if {[info exists bhInfo(pending)]} {
           after cancel $bhInfo(pending)
           unset bhInfo(pending)
           }
           set statuszeile " "
        wm withdraw .balloonhelp
     }


     proc ::balloon::balloonhelp_show {b} {
        global bhInfo
           if {$bhInfo(active)} {
              .balloonhelp.info configure -text $bhInfo($b)
           set x [expr [winfo rootx $b]+25]                        ;# justiert den Label
           set y [expr [winfo rooty $b]+[winfo height $b]]
        wm geometry .balloonhelp +$x+$y
        wm deiconify .balloonhelp
           raise .balloonhelp
           }
 
        unset bhInfo(pending)
     }


     set bhInfo(active) 1
  
     proc ::balloon::balloonhelp_control {state} {
        global bhInfo
           if {$state} {
           set bhInfo(active) 1
           } else {
           ::balloon::balloonhelp_cancel
           set bhInfo(active) 0
           }
     }


#### Example
##  z.B ballonhelp_for .b.but1 "Hallo World!"
##  ::balloon::balloonhelp_for .link.frame.left.butt1   "ProLink Demo on \nthe Example Shaft"
##  Angabe:    nam+proc            object                     Anzeigetext
