#######################################################
#C  Unterprogramm zur Bestimmung der Werte y1'' bis yn''
#C  (fuer periodische Splines!)
#C
      proc cubicp  {N X_ Y_ Y2_} {

          upvar $X_ X
          upvar $Y_ Y
          upvar $Y2_ Y2
#C
#      dimension X(1),Y(1),Y2(1),F(1),G(1),H(1)
#c     dimension X(NMA),Y(NMA),Y2(NMA),F(NMA),G(NMA),H(NMA)
#C
#c Gegeben: nma = Definierte Laenge der eindimensionalen Felder
#c            n = Anzahl der Stuetzstellen
#c            x = x-Werte der Funktion, fuer die der Spline gesucht ist
#c            y = y-Werte der Funktion, fuer die der Spline gesucht ist
#c
#c Gesucht:  y2 = 2. Ableitung der Funktion y(x)
#c
#c Zwischen-Speicher   a = a (s.o)
#c                     b = b (s.o)
#c                     c = c (s.o)
#c                     d = d (s.o)
#c
#c...................................................................
#c...................................................................
      global epsMinZahl

      set N1 [expr $N-1]
      set N2 [expr $N1-1]
      set J1  1
      set G(1) 0.
      set F(1) 0.
      set H(1) -1.
      set H1   [expr $X($N) - $X($N1)]
      set W    $H1
      set H2   [expr $X($N1) - $X($N2)]
      set U    [expr 2.*($H1+$H2)]
      set R1   [expr ($Y($N) - $Y($N1))/$H1]
      set R2   [expr ($Y($N1) - $Y($N2))/$H2]
      set V    [expr 6.*($R1-$R2)]
#C
#      DO 10 K=1,N2
        for {set K 1} {$K <= $N2} {incr K} {
          set J2 [expr $K+1]
          set H2 [expr $X($J2) - $X($K)]
          set R2 [expr ($Y($J2) - $Y($K))/$H2]
          if {$K != 1}  then {
              set U  [expr $U - $W*$H($J1)]
              set V  [expr $V - $W*$F($J1)]
              set W  [expr -1*$G($J1)*$W]
          }
          set Z  [expr 1./(2.*($H1+$H2) - $H1*$G($J1))]
          set G($K) [expr $Z*$H2]
          set H($K) [expr -1*$Z*$H($J1)*$H1]
          set F($K) [expr $Z*(6.*($R2-$R1)-$H1*$F($J1))]
          set J1 $K
          set H1 $H2
          set R1 $R2
        }
#   10 CONTINUE

      set H2 [expr $W+$H1]
      set H1 [expr ($V - $H2*$F($N2)) / ($U - $H2*($G($N2) + $H($N2)))]
      set Y2($N1) $H1

#C
#      DO 20 J1=2,N1
        for {set J1 2}  {$J1 <= $N1} {incr J1} {
          set K    [expr $N-$J1]
          if {[expr abs($H($K))] != 0.0} then {
              if {[expr abs($H($K))] < $epsMinZahl} then {
                   #puts "Zahl $H($K) zu klein, Korrektur"
                   set H($K) 0.
              }
          }
          set Y2($K) [expr $F($K) - $G($K)*$Y2([expr $K+1])]
          set Y2($K) [expr $F($K) - $G($K)*$Y2([expr $K+1]) - $H($K)*$H1]
#   20 CONTINUE
        }

#C
      set Y2($N) $Y2(1)
}
##########################################
