#############################################################
# Ausgabe der Hilfe
proc ThelpHelp {helpfile {xPos 100}  {yPos 40} } {

    global statuszeile

    set w .info
    destroy $w

#   DSNewWindow "." $w "Dromeg: Hilfefenster"  100 40
    DSNewWindow "." $w "Dromeg: Hilfefenster"  $xPos $yPos

    frame $w.f1
    frame $w.f2
    pack $w.f1 $w.f2 -in $w -side top

#    text $w.text -relief raised -bd 2 -yscrollcommand "$w.scroll set"
    text $w.text -bd 2 -yscrollcommand "$w.scroll set" -wrap word \
	-width 80 -height 23 -background grey -spacing2 2 
    pack $w.text -in $w.f1 -side left
    scrollbar $w.scroll -command "$w.text yview"
    pack $w.scroll -in $w.f1 -side right -fill y

    set helpFile [open $helpfile]
	set i 0
	while { [gets $helpFile Zeile] >= 0} {
	    incr i
	    $w.text insert end [string range "$Zeile\n" 1 end]
	    if {[string range $Zeile 0 0] == "H"} then {
		$w.text tag add gross $i.0 $i.end
	    } elseif {[string range $Zeile 0 0] == "R" || \
	    [string range $Zeile 0 0] == "M" || \
	    [string range $Zeile 0 0] == "s" || \
	    [string range $Zeile 0 0] == "S"} then {
		set j 1
		while {[string first "	" \
		[string range $Zeile $j end] ] == 0} {
		    set j [expr $j+1]
		}
		
		if {[string range $Zeile 0 0] == "S"} then {
		    $w.text tag add boldsunken $i.[expr $j-1] $i.end
		} elseif {[string range $Zeile 0 0] == "s"} then {
		    $w.text tag add sunken $i.[expr $j-1] $i.end
		} else {
		    $w.text tag add raised $i.[expr $j-1] $i.end
		}
		if {[string range $Zeile 0 0] == "M"} then {
		    $w.text tag add menu $i.[expr $j-1] $i.end
		}
	    } elseif {[string range $Zeile 1 7] == "	o  "} then {
		$w.text tag add mark $i.4 $i.5
	    } elseif {[string range $Zeile 1 3] == "o  "} then {
		$w.text tag add mark $i.0 $i.1
	    }
	}
    close $helpFile
    $w.text tag configure gross -font -*-*-bold-*-*--*-*-*-*-*-*-*-* 
    $w.text tag configure mark -font -*-*-bold-*-*--*-*-*-*-*-*-*-* 
    $w.text tag configure menu -background orange 
    $w.text tag configure raised -relief raised -background grey \
	    -borderwidth 2 -tabs " " -spacing3 2
#	    -font -*-courier-*-*-*--*-*-*-*-m-*-*-*
    $w.text tag configure boldsunken -relief sunken -background grey \
	    -borderwidth 2 -tabs " " -spacing3 2 \
	    -font -*-*-bold-*-*--*-*-*-*-*-*-*-* 
    $w.text tag configure sunken -relief sunken -background grey \
	    -borderwidth 2 -tabs " " -spacing3 2 


    button $w.button -text "Fenster schliessen" -command \
	"destroy $w"
    pack $w.button -in $w.f2 -side bottom -anchor s
}
#############################################################
# Ausgabe der Versions-Nummer 
proc ThelpCopyright {programName} {

    set w .info
    destroy $w

    DSNewWindow "." $w "Dromeg: Copyright-Fenster"  100 40

    frame $w.f1
    frame $w.f2
    pack $w.f1 $w.f2 -in $w -side top

    text $w.text -relief raised -bd 2 -yscrollcommand "$w.scroll set" \
	-width 80 -height 23
    pack $w.text -in $w.f1 -side left
    scrollbar $w.scroll -command "$w.text yview"
    pack $w.scroll -in $w.f1 -side right -fill y

    $w.text insert end "Programm $programName\n"
    $w.text insert end "Copyright by Volker Jaekel 1999, 2000, 02, 09, 11, 13, 14\n\n"
    $w.text insert end "1) Dieses Programm darf nur unter dem Namen $programName verwendet werden.\n"
    $w.text insert end "     Der Nutzer verpflichtet sich, bei Veroeffentlichungen von Ergebnissen,\n"
    $w.text insert end "     die er mit Hilfe dieses Programms erarbeitet hat, die Dissertation"
    $w.text insert end "\n\n"
    $w.text insert end "     Einteilung einer eben bewegten Ebene in Felder"
    $w.text insert end " mit qualitativ gleichen \n"
    $w.text insert end "     Koppelpunktbahnen"
    $w.text insert end " unter besonderer Beruecksichtigung der"
    $w.text insert end " Uebergangskurve\n"
    $w.text insert end "     zu zitieren\n"
    $w.text insert end "\n"
    $w.text insert end "2) Das Kopieren dieses Programms fuer kommerzielle Zwecke ist verboten.\n"
    $w.text insert end "     Unter kommerziellen Zwecken soll an dieser Stelle das Kopieren fuer ein\n"
    $w.text insert end "     Entgeld verstanden werden, dass die Kosten des Informationstraegers\n"
    $w.text insert end "     uebersteigt.\n"
    $w.text insert end "     Die Nutzung des Programms zum Entwickeln kommerziell genutzter Getriebe\n"
    $w.text insert end "     ist ausdruecklich erlaubt\n"
    $w.text insert end "\n"
    $w.text insert end "3) Das Kopieren des geaenderten Quellcodes dieses Programms ist verboten.\n"
    $w.text insert end "     Zum Aufheben des Verbots muss der geaenderte Quellcode an Volker Jaekel\n"
    $w.text insert end "     (V.Jaekel@t-online.de) geschickt werden. Im Copyright des geaenderten\n"
    $w.text insert end "     Quellcodes muss auf dieses Programm und dessen Copyright verwiesen werden.\n"
    $w.text insert end "     Es ist nicht erlaubt, den geaenderten Quellcode fuer.\n"
    $w.text insert end "     kommerzelle Zwecke entsprechend Punkt 2) zu verwenden.\n"
    $w.text insert end "\n"

    button $w.button -text "Fenster schliessen" -command \
	"destroy $w"
    pack $w.button -in $w.f2 -side bottom -anchor s
}
#############################################################
# Ausgabe der Versions-Nummer
proc ThelpVersion {programName programVersion} {

    set w .info
    destroy $w

    DSNewWindow "." $w "Dromeg: Infofenster"  100 40

    frame $w.f1
    frame $w.f2
    pack $w.f1 $w.f2 -in $w -side top

    text $w.text -relief raised -bd 2 -width 65 -height 26
    pack $w.text -in $w.f1 -side left

    $w.text insert end "Programm $programName\n"
    $w.text insert end "Version $programVersion\n\n"
    $w.text insert end "Erstellt Anfang 1999\n"
    $w.text insert end "Modifiziert: 2000,2002,2009,2011,2013,2014\n"
    $w.text insert end "Getestet unter WindowsXP, Windows7 & 8, Solaris 2.6 \n\n"
    $w.text insert end "Copyright by Volker Jaekel\n\n"
    $w.text insert end "eMail: v.jaekel@t-online.de\n"
    $w.text insert end "updates: http://getriebetechnik.v-jaekel.info/download.html\n\n"
    $w.text insert end "Die Theorie zu diesem Programm ist zu lesen"
    $w.text insert end " in der 1999\n"
    $w.text insert end "von Volker Jaekel an der Universitaet Siegen eingereichten\n"
    $w.text insert end "Dissertation:\n"
    $w.text insert end "Einteilung einer eben bewegten Ebene in Felder"
    $w.text insert end " mit qualitativ\ngleichen Koppelpunktbahnen"
    $w.text insert end " unter besonderer\nBeruecksichtigung der"
    $w.text insert end " Uebergangskurve.\n"
    $w.text insert end "Fortschritt-Berichte VDI, Reihe 1, Nr. 324,\n"
    $w.text insert end " VDI Verlag GmbH, Duesseldorf 2000\n"
    $w.text insert end "(kann als PDF-Datei auch im Internet herunter\n"
    $w.text insert end "geladen werden: http://getriebetechnik.v-jaekel.info/\n"
    $w.text insert end "dissertation-volker-jaekel-2000.pdf)\n"
    if {$programName != "DROMEG-T"} then {
        $w.text insert end "\n"
        $w.text insert end "sowie in dem Beitrag\n"
        $w.text insert end "Zielgefuehrte Simulation zum Auffinden von Koppelpunkten fuer das Antreiben "
        $w.text insert end "von totalschwingfaehigen Doppelschwingen\n" 
        $w.text insert end "erschienen im VDI-Bericht 1707\n"
        $w.text insert end "Kurvengetriebe, Koppelgetriebe, gesteuerte Antriebe, Seite 145-164\n"
        $w.text insert end "VDI-Verlag Duesseldorf 2002\n"
        $w.text insert end "(Begleittext zur Getriebetagung 2002)" 
    }

    button $w.button -text "Fenster schliessen" -command \
	"destroy $w"
    pack $w.button -in $w.f2 -side bottom -anchor s
}
#################################################################
proc DSNewWindow {w wn title x y} {
# w	Variable des Parent-Windows
# wn	Variable des Neuen Windows
# title Name des neuen Fensters
# x	Position des neuen Fensters in x-Richtung 
# y	Position des neuen Fensters in y-Richtung

    set parentPosition [wm geometry $w]
    set xstart [expr [string first "+" $parentPosition]+1]
    set xstring [string range $parentPosition $xstart end]
    set xend [expr [string first "+" $xstring]-1]
    set xpos [string range $xstring 0 $xend]
    set ystart [expr $xend+2]
    set ypos [string range $xstring $ystart end]
#   set geometry "+[expr $xpos+100]+[expr $ypos+40]"
    set geometry "+[expr $xpos+$x]+[expr $ypos+$y]"

    toplevel $wn
    wm geometry $wn "$geometry"
    wm focus $wn
    wm title $wn $title
    wm transient $wn $w
    wm group $wn $w 
}
#############################################################
proc xLiesKnotenMittelpunkt {wc Knoten} {

    global showGetriebe

    if {$showGetriebe != 0} then {
        # nur Berechnung durchfuehren, wenn Getriebe auch dargestellt ist.
        set Alt [$wc coords $Knoten]  
        return [expr ( [lrange $Alt 0 0] + [lrange $Alt 2 2] )/2]
    }
}
######################################################
proc yLiesKnotenMittelpunkt {wc Knoten} {

    global showGetriebe

    if {$showGetriebe != 0} then {
        # nur Berechnung durchfuehren, wenn Getriebe auch dargestellt ist.
        set Alt [$wc coords $Knoten]  
        return [expr ( [lrange $Alt 1 1] + [lrange $Alt 3 3] )/2]
    }
}
######################################################
proc Knoten {wc x y tag {dxfFile "no"} {radius 1.}} {     ;# Erzeugt neuen Knoten bei (x,y)
    global KnotenX KnotenY KanteVon KanteNach pradi_ lineWidth
    #set Knoten [$wc create oval [expr $x-$pradi_] [expr $y-$pradi_] \
    #		       [expr $x+$pradi_] [expr $y+$pradi_] \
    #		       -outline black -fill white \
    #		       -tags $tag]


    #if {$lineWidth == 0} then {
        set pradi $pradi_
    #} else {
    #    set pradi [expr $pradi_*2.]
    #}


    set Knoten [dxfKreis $wc $dxfFile "-" black [expr $x-$pradi*$radius] [expr $y-$pradi*$radius] \
    		       [expr $x+$pradi*$radius] [expr $y+$pradi*$radius] $tag white]
    		       
    #tk_messageBox -message "Knoten=$Knoten"

    if {$Knoten != ""} then {
        $wc addtag Knoten withtag $Knoten
        set KnotenX($Knoten) $x
        set KnotenY($Knoten) $y
        set KanteVon($Knoten) {}
        set KanteNach($Knoten) {}
    }
}
######################################################
#Erzeugt Kante zwischen Knoten
proc Kante {wc von nach tag tag2 {dxfFile "no"} {xA 0} {yA 0} {xE 0} {yE 0}} {

    global KnotenX KnotenY KanteVon KanteNach pradi_
    
    if {$dxfFile != "no"} then {
        set eps 0.000000001
        set ierr [geraden8_steigung_2p $xA $yA $xE $yE $eps st]
        if {$ierr == 1} then {
            # Senkrechte
            if {$yE > $yA} then {
                set yAn [expr $yA + $pradi_]
                set yEn [expr $yE - $pradi_]
                set xAn $xA
                set xEn $xE
            } else {
                set yAn [expr $yA - $pradi_]
                set yEn [expr $yE + $pradi_]
                set xAn $xA
                set xEn $xE
            }
        } else {
            set Pi [expr 4.*atan(1.)]
            set alpha [expr atan($st)]
            if {$xE > $xA} then {
                set alpha [expr $alpha + $Pi]
            }
            set xAn [expr $xA - $pradi_*cos($alpha)]
            set xEn [expr $xE + $pradi_*cos($alpha)]
            set yAn [expr $yA - $pradi_*sin($alpha)]
            set yEn [expr $yE + $pradi_*sin($alpha)]
        }
        #tk_messageBox -message "dxfLinie $wc $dxfFile '-' brown $xAn $yAn $xEn $yEn $tag"
        # Farben fr Gelenkgetriebe
        if {$tag == 2} then {
            # Glied 2
            set color "green"
         } elseif {$tag < 5} then {
            # Glieder 1, 3, 4
            set color "red"
        } elseif {$tag < 7} then {
            # Verbindungsgeraden von den Gestellgelenken zum Momentanpol
            set color "magenta"
        } elseif {$tag < 9} then {
            set color "green"
        } else {
            set color "brown"
        }
        dxfLinie $wc $dxfFile "-" $color $xAn $yAn $xEn $yEn $tag
    } else {
        set Kante [$wc create line $KnotenX($von) $KnotenY($von) \
        $KnotenX($nach) $KnotenY($nach) \
        		      -tags $tag]
        $wc addtag $tag2 withtag $Kante
        $wc addtag $tag2- withtag $Kante
        $wc lower $Kante
        lappend KanteVon($von) $Kante
        lappend KanteNach($nach) $Kante
        return $Kante
    }
}
######################################################
# Ermitteln der Steigung einer Geraden, die durch 2 gegebene Punkte
# geht

proc geraden8_steigung_2p {x1 y1 x2 y2 eps  st_} {

    upvar $st_ st

# geg.: x1,y1,x2,y2,eps
# ges.: st,ierr

# x1    : x-Koordinate des 1. Punktes auf der Geraden
# y1    : y-Koordinate des 1. Punktes auf der Geraden
# x2    : x-Koordinate des 2. Punktes auf der Geraden
# y2    : y-Koordinate des 2. Punktes auf der Geraden
# eps   : Grenzwert: Zahlen, die kleiner als diese Zahl sind, werden,
#                    wenn sie im Nenner stehen, als 0 angesehen
# st    : Steigung der Geraden
# ierr  : Kennzahl
#         ierr=0: Es trat kein Fehler auf
#         ierr=1: Die Steigung ist (+/-) Unendlich
#..................................................................
#..................................................................

    set ierr 1
    set dn [expr $x1-$x2]

    if {[expr abs($dn)] > $eps} then {
        set st [expr ($y1-$y2)/$dn]
        set ierr 0
    }

    return $ierr
}
#################################################################################
proc VerschiebeKnoten {wc Knoten xDist yDist} {

    global KnotenX KnotenY KanteVon KanteNach showGetriebe
    
    if {$showGetriebe != 0} then {
    # nur Verschiebungen durchfuehren, wenn Getriebe auch dargestellt ist.

        $wc move $Knoten $xDist $yDist
        set KnotenX($Knoten) [expr $KnotenX($Knoten)+$xDist]
        set KnotenY($Knoten) [expr $KnotenY($Knoten)+$yDist]
        foreach Kante $KanteVon($Knoten) {
        $wc coords $Kante $KnotenX($Knoten) $KnotenY($Knoten) \
            [lindex [$wc coords $Kante] 2] \
            [lindex [$wc coords $Kante] 3] 
        }
    
        foreach Kante $KanteNach($Knoten) {
          $wc coords $Kante \
            [lindex [$wc coords $Kante] 0] \
            [lindex [$wc coords $Kante] 1] \
            $KnotenX($Knoten) $KnotenY($Knoten)
        }
    }
}
#############################################################
proc VsetTochoidenPunktFarbe {phi_grad} {

    global wc iN_M

    if {$phi_grad < 0} then {
        set umdr_ 0
    } elseif {$phi_grad < 360} then {
        set umdr_ [expr $iN_M -1]
    } elseif {$phi_grad < 720} then {
        set umdr_ [expr $iN_M -2]
    } elseif {$phi_grad < 1080} then {
        set umdr_ [expr $iN_M -3]
    } elseif {$phi_grad < 1440} then {
        set umdr_ [expr $iN_M -4]
    } elseif {$phi_grad < 1800} then {
        set umdr_ [expr $iN_M -5]
    } elseif {$phi_grad < 2160} then {
        set umdr_ [expr $iN_M -6]
    } elseif {$phi_grad < 2520} then {
        set umdr_ [expr $iN_M -7]
    } elseif {$phi_grad < 2880} then {
        set umdr_ [expr $iN_M -8]
    } else {
        set umdr_ [expr $iN_M -9]
    }
    
    if {$umdr_==0} {
        set rgb1 d
    } elseif {$umdr_==4} {
        set rgb1 8
    } else {
        set rgb1 0
    }
    if {$umdr_==1} {
        set rgb2 d
    } elseif {$umdr_==5} {
        set rgb2 8
    } else {
        set rgb2 0
    }
    if {$umdr_==2} {
        set rgb3 d
    } elseif {$umdr_==6} {
        set rgb3 8
    } else {
        set rgb3 0
    }

    $wc itemconfigure t -fill [dxfColorRGB $rgb1$rgb2$rgb3]
}
###############################################################
proc t_wait {string} {

    global tWait tWaitString irunMaxI tWait_Zaehler
    
    if {[info exists tWait_Zaehler] == 0} then {
        set tWait_Zaehler 0
    }
    incr tWait_Zaehler

    set tWaitString $string

    frame .wait$tWait_Zaehler
    pack .wait$tWait_Zaehler
    tkwait visibility .wait$tWait_Zaehler
    destroy .wait$tWait_Zaehler
    set tWaitString "nicht laeuft"
}
#############################################################
proc Vpostscript {} {

    global wc plotName
    global phi_grad rG_ phi_ rR m_ iN gamma0_ Pi iN_M a_ massstab
    global phi1 getriebeTyp_ 

    set b "\\"
    regsub -all $b$b $plotName "/"  plotName
    
    set filename [file tail $plotName]
    if {[regexp {d=([0-9][0-9])[.]} $filename dummy delta] == 1} then {
        # Abspeichern einer Serie (Winkel)
        # filename=*d=xx.eps
        #tk_messageBox -message delta=$delta
        if {[string index $delta 0] == 0} then {
            set delta [string index $delta 1]
        }
        
        regsub {d=[0-9][0-9][.]eps$} $plotName "" plotNameX
        
        # fuer Trochoiden
        if {$getriebeTyp_ == "Gelenkgetriebe"} then {
            # Gelenkgetriebe
            #k_messageBox -message "plotNameX=$plotNameX"
            TRunGetriebe 1 1. 0 $delta $plotNameX
        } else {
            # Trochoide
            set winkl [expr $iN_M*360.]
            set phi_grad_old $phi_grad
            set alpha 0.
            set iiii 0
            while {$alpha < $winkl & $iiii < 100} {
                incr iiii
                set phi_grad [expr $alpha + $phi_grad_old]
    
                set phi_ [expr $phi_grad*$Pi/180.]
                VsetTochoidenPunktFarbe $phi_grad
                
                modifyGetriebe $wc $rR
                modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    
                #tk_messageBox -message "$plotNameX$phi_grad.eps\nEnde bei $winkl"
                #frame .wait
                #pack .wait
                #tkwait visibility .wait
                #destroy .wait
                t_wait Vpostscript_1
                set alphaG [expr int($alpha)]
                set null "0"
                if {$alpha < 10} then {
                    $wc postscript -file "$plotNameX$null$null$null$alphaG.eps"
                } elseif {$alpha < 100} then {
                    $wc postscript -file "$plotNameX$null$null$alphaG.eps"
                } elseif {$alpha < 1000} then {
                    $wc postscript -file "$plotNameX$null$alphaG.eps"
                } else {
                    $wc postscript -file "$plotNameX$alphaG.eps"
                }
    
                set alpha [expr $alpha + $delta]
            }
    
            set phi_grad $phi_grad_old
            set phi_ [expr $phi_grad*$Pi/180.]
            modifyGetriebe $wc $rR
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
            $wc itemconfigure t -fill white
        }
    } elseif {[regexp {a=([0-9][0-9][.][0-9][0-9])[,]([0-9][0-9][.][0-9][0-9])[.]} $filename dummy deltaA endA] == 1} then {
        # Abspeichern einer Serie (Abstand)
        # filename=*a=xx.xx,xx.xx.eps (Abstand-Delta,Endabstand)
        #tk_messageBox -message "a deltaA=$deltaA, a_/massstab=$a_/$massstab, endA=$endA\n[expr $a_ + $deltaA]"
        #c:/temp/dromeg-a=00.25,03.00.eps
        #R:/Dokumente/Volker/dromeg/bilder/epi-1/animation/dromeg-a=00.25,04.00.eps
        
        regsub {a=([0-9][0-9][.][0-9][0-9])[,]([0-9][0-9][.][0-9][0-9])[.]eps$} $plotName "" plotNameX
        
        # fuer Trochoiden
        # Punkt einfaerben
        #$wc itemconfigure t -fill [dxfColorRGB d00]
        set phi_ [expr $phi_grad*$Pi/180.]
        VsetTochoidenPunktFarbe $phi_grad

        set a_ [expr $a_ + $deltaA*$massstab]
        set i 0
        set iiii 0
        while {$a_ < [expr $endA*$massstab] && $iiii < 100} {
            incr i
            incr iiii
            modifyGetriebe $wc $rR
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi

            #frame .wait
            #pack .wait
            #tkwait visibility .wait
            #destroy .wait
            t_wait Vpostscript_2
            set a_ [expr $a_ + $deltaA*$massstab]
            #tk_messageBox -message "x deltaA=$deltaA, a_=$a_, endA=$endA\n[expr $a_ + $deltaA]"

            if {$i > 3} then {
                $wc postscript -file "$plotNameX$i.eps"
            } else {
                $wc postscript -file "$plotNameX[expr 90+$i].eps"
            }
            if {$i > 1} then {
                $wc postscript -file "$plotNameX[expr 90-$i].eps"
            }
        }
        $wc itemconfigure t -fill white
    } else {
        # Abspeichern einer Datei
        $wc postscript -file $plotName
    }
    #R:\Dokumente\Volker\dromeg\bilder\eps\animation\epitrochoide_4_3_x_d=15.eps
}
#############################################################
proc VPostscript {} {
    global plotName plotName_old

    set plotName_old $plotName

    #TCreateEntryButton " " {$wc postscript -file $plotName}
    TCreateEntryButton " " Vpostscript \
	{set plotName $plotName_old} 80 \
	{"Dateiname:" plotName} 
    TShowSubwindow  {100} {40} {Plot-Datei erstellen}
}
############################################################
proc TprepareRestart {} {

    global irunMaxI irunStep startTrochoideNeu

    if {[info exists irunMaxI] == 1 && $irunMaxI != 0} then {
        # Trochoide luft. Trochoide anhalten
        set irunMaxI 0
        #tkwait variable irunStep
        #t_wait TprepareRestart

        set startTrochoideNeu 1
    } else {
        set startTrochoideNeu 0
    }
}
############################################################
proc TRestartTrochoide {} {

    global startTrochoideNeu tWait RichtungBackup geschwBackup
    global irunStep
    global Android wc

    #if {[info exists startTrochoideNeu] == 1} then {
    #     tk_messageBox -message "startTrochoideNeu=$startTrochoideNeu"
    #} else {
    #     tk_messageBox -message "startTrochoideNeu existiert nicht"
    #}

    if {[info exists startTrochoideNeu] == 1 && $startTrochoideNeu == 1} then {
        #Getriebe erneut starten
        TRunTrochoide -1 1
    #} else {
    #    tk_messageBox -message "Getriebe wird nicht neu gestartet"
    }
    if {$Android == 1} then {
        bind $wc <<PinchToZoom>> {TSetZoomFenster2finger %W %X %Y %x %y %s}
        bind $wc <<FingerMotion>> {TSetscroll %X %Y %x %y %s}
        bind $wc <<FingerUp>> {TSetFinishScroll}
    }
}
#############################################################
proc TZoomOut {} {

    global massstab last_massstab xMoveto last_xMoveto yMoveto
    global last_yMoveto 0x last_0x 0y last_0y

    TprepareRestart

    set last_massstab $massstab
    set last_xMoveto $xMoveto
    set last_yMoveto $yMoveto
    set last_0x $0x
    set last_0y $0y
    set faktor 2.
    TChangeZoom $faktor
    TRestartTrochoide
}
#############################################################
proc TZoomLast {} {

    global wc massstab last_massstab xMoveto yMoveto
    global last_xMoveto last_yMoveto 0x 0y last_0x last_0y

    #tk_messageBox -message "0x=$0x, 0y=$0y,last_0x=last_$0x, last_0y=$last_0y\nxMoveto=$xMoveto, yMoveto=$yMoveto, last_xMoveto=$last_xMoveto, ylast_Moveto=$last_yMoveto\nmassstab=$massstab, last_massstab=$last_massstab"

    TprepareRestart
    set dummy $massstab
    set massstab $last_massstab
    set last_massstab $dummy
    set dummy $xMoveto
    set xMoveto $last_xMoveto
    set last_xMoveto $dummy
    set dummy $yMoveto
    set yMoveto $last_yMoveto
    set last_yMoveto $dummy
    set dummy $0x
    set 0x $last_0x
    set last_0x $dummy
    set dummy $0y
    set 0y $last_0y
    set last_0y $dummy

    TSetZoomFenster_special

    $wc xview moveto $xMoveto
    $wc yview moveto $yMoveto
    TRestartTrochoide
}
#############################################################
proc TChangeZoom {faktor} {
    global massstab
    global xZoomPos1 canvas_width 0x xneu xzoom
    global yZoomPos1 canvas_height 0y yneu yzoom

    TprepareRestart
    set massstab [expr $massstab/$faktor]

    set delta [expr ($faktor-1.)/2.]
    set xZoomPos1 [expr -$canvas_width*$delta]
    set yZoomPos1 [expr $canvas_height+$canvas_height*$delta]
    set xzoom [expr $xZoomPos1-$0x]
    set yzoom [expr $yZoomPos1-$0y]
    set xneu [expr $canvas_width+$canvas_width*$delta]
    set yneu [expr -$canvas_height*$delta]

    TSetZoomFenster_special

    TZoomMoveto
    TRestartTrochoide
}
#############################################################
proc xyViewDefault {} {
    global wc xregion_ yregion_ canvas_width canvas_height
    global xMoveto yMoveto last_xMoveto last_yMoveto 0x 0y
    global last_0x last_0y default_xMoveto default_yMoveto

    set last_0x $0x
    set last_0y $0y
    set last_xMoveto $xMoveto
    set last_yMoveto $yMoveto
    set 0x [expr $canvas_width/2.]
    set 0y [expr $canvas_height/2.]
    set xMoveto [expr 1./$xregion_*($xregion_/2.-$0x)]
    set yMoveto [expr 1./$yregion_*($yregion_/2.-$0y)]
    $wc xview moveto $xMoveto
    $wc yview moveto $yMoveto
    set default_xMoveto $xMoveto
    set default_yMoveto $yMoveto
}
#############################################################
proc TSetZoomFenster {} {

# xzoom,yzoom: Koordinaten in "Getriebekoordinaten" des 1. Punktes des
#	       Zoom-Rechtecks
# xneu,yneu:   Koordinaten in "Getriebekoordinaten" des 2. Punktes des
#	       Zoom-Rechtecks
# 0x,0y:       Ursprung der "Getriebekoordinaten" in Koordinaten des
#	       Bildschirms (Ursprung oben links)
# xMoveto:     Position des linken randes des Bildauschnitts relativ
#	       zu $xregion_ als Zahlenwert zwischen 0 und 1
# xregion_:    Region, die durch verschieben des Bildausschnitts
#	       sichtbar gemacht werden kann, ohne den Massstab zu
#	       aendern

    global massstab wc last_massstab xneu yneu
    global canvas_height canvas_width xzoom yzoom zoom_v 0x 0y
    global statuszeile last_xMoveto last_yMoveto xMoveto yMoveto
    global last_0x last_0y yZoomPos1 xZoomPos1 yZoomPos2 xZoomPos2

    setStatuszeile "Zoomauschnitt festlegen durch Aufziehen eines \
Rechtecks bei gedrueckter 'linker Maustaste'"
    set last_massstab $massstab
    set last_xMoveto $xMoveto
    set last_yMoveto $yMoveto
    set last_0x $0x
    set last_0y $0y

    bind $wc <ButtonPress-1> {
	set xZoomPos1 %x
	set yZoomPos1 %y
	set xzoom [expr $xZoomPos1-$0x]
	set yzoom [expr $yZoomPos1-$0y]
	set xn [expr $xzoom+1]
	set yn [expr $yzoom+1]
	$wc create rectangle $xzoom $yzoom $xn $yn -tags zoom
	set zoom_v [expr double($canvas_width)/double($canvas_height)]
    }
    bind $wc <B1-Motion> {
	set xZoomPos2 %x
	set yZoomPos2 %y
	set xneu [expr $xZoomPos2-$0x]
	set yneu [expr $yZoomPos2-$0y]
	if {[expr ($xneu-$xzoom)*($yneu-$yzoom)] > 0} then {
	    set sign -1.
	} else {
	    set sign 1.
	}
	if {[expr abs($xneu-$xzoom)/$canvas_width] > \
	[expr abs($yneu-$yzoom)/$canvas_height]} then {
	    set yneu [expr $yzoom+$sign*($xzoom-$xneu)/$zoom_v]
	    set yZoomPos2 [expr $yZoomPos1+\
		$sign*($xZoomPos1-$xZoomPos2)/$zoom_v]
	} else {
	    set xneu [expr $xzoom+$sign*($yzoom-$yneu)*$zoom_v]
	    set xZoomPos2 [expr $xZoomPos1+\
		$sign*($yZoomPos1-$yZoomPos2)*$zoom_v]
	}
	$wc coords zoom $xzoom $yzoom $xneu $yneu
    }
    bind $wc <ButtonRelease-1> {
	$wc delete zoom
	bind $wc <ButtonPress-1> {}
	bind $wc <B1-Motion> {}
	bind $wc <ButtonRelease-1> {}
	if {$xneu < $xzoom} then {
	    set dummy $xneu
	    set xneu $xzoom
	    set xzoom $dummy
	    set dummy $xZoomPos2
	    set xZoomPos2 $xZoomPos1
	    set xZoomPos1 $dummy
	}
	if {$yneu > $yzoom} then {
	    set dummy $yneu
	    set yneu $yzoom
	    set yzoom $dummy
	    set dummy $yZoomPos2
	    set yZoomPos2 $yZoomPos1
	    set yZoomPos1 $dummy
	}
	TprepareRestart
	set massstab [expr double($canvas_width)/abs($xneu-$xzoom)\
	    *$massstab]
	TSetZoomFenster_special
	TZoomMoveto
	setStatuszeile ""
	TRestartTrochoide
    }
}
#############################################################
proc TZoomMoveto {} {
    global massstab wc last_massstab xneu yneu
    global canvas_height canvas_width xzoom yzoom 0x 0y
    global xMoveto yMoveto xregion_ yregion_
    global yZoomPos1 xZoomPos1

	set xLinkerRand [expr $xMoveto*$xregion_]
	set xMoveto [expr 1./$xregion_*\
	    ($xLinkerRand+$xZoomPos1+$xzoom/$last_massstab*$massstab\
	    -$xzoom)]

	set yObererRand [expr $yMoveto*$yregion_]
	set yMoveto [expr 1./$yregion_*\
	    ($yObererRand+$yZoomPos1+$yzoom/$last_massstab*$massstab\
	    -$yzoom-$canvas_height)]

	$wc xview moveto $xMoveto
	$wc yview moveto $yMoveto

	set 0x [expr -$xzoom/$last_massstab*$massstab]
	set 0y [expr $canvas_height-$yzoom/$last_massstab*$massstab]
}
#############################################################
proc min {a b} {
    if {$a< $b} then {
	return $a
    } else {
	return $b
    }
}
#############################################################
proc max {a b} {
    if {$a> $b} then {
	return $a
    } else {
	return $b
    }
}
#############################################################
proc TSetMassstab {} {

    global massstab massstab_old last_massstab
    global last_massstab_old
    global last_xMoveto_old last_xMoveto 
    global last_yMoveto_old last_yMoveto
    global last_0x_old last_0x last_xMoveto xMoveto 0x
    global last_0y_old last_0y last_yMoveto yMoveto 0y
    global TSetMassstabAbbruch

    set last_xMoveto_old $last_xMoveto 
    set last_yMoveto_old $last_yMoveto 
    set last_massstab_old $last_massstab
    set last_massstab $massstab
    set massstab_old $massstab

    set last_0x_old $last_0x
    set last_0y_old $last_0y
    set last_xMoveto $xMoveto
    set last_yMoveto $yMoveto
    set last_0x $0x
    set last_0y $0y

    set TSetMassstabAbbruch "no"

    TCreateEntryButton " " {\
	set faktor [expr double($last_massstab)/double($massstab)]
	set massstab $last_massstab
	TChangeZoom $faktor
	set last_massstab $massstab
	if {$TSetMassstabAbbruch =="yes"} then {
	    set 0x $last_0x
	    set 0y $last_0y
	    set xMoveto $last_xMoveto
	    set yMoveto $last_yMoveto 
	    set last_xMoveto $last_xMoveto_old 
	    set last_yMoveto $last_yMoveto_old 
	    set last_massstab $last_massstab_old
	    set last_0x $last_0x_old
	    set last_0y $last_0y_old
	} } \
	{set massstab $massstab_old
	set TSetMassstabAbbruch "yes"} 6 \
	{"Massstab:" massstab}
     TShowSubwindow  {100} {40} {Massstab}
}
#############################################################
proc TSetFensterGroesser {} {

    global canvas_height canvas_width wc
    
    set canvas_height [expr $canvas_height+100]
    set canvas_width  [expr $canvas_width+100]
    
    $wc configure -height $canvas_height -width $canvas_width
    xyViewDefault
}
#############################################################
proc TSetFensterKleiner {} {

    global canvas_height canvas_width wc
    
    set canvas_height [expr $canvas_height-100]
    set canvas_width  [expr $canvas_width-100]
    
    $wc configure -height $canvas_height -width $canvas_width
    xyViewDefault
}
#############################################################
proc TSetGrafikGroesse {} {
    global canvas_height canvas_width xregion_ yregion_
    global canvas_height_old canvas_width_old

    set canvas_width_old $canvas_width
    set canvas_height_old $canvas_height

    TCreateEntryButton " " \
	{$wc configure -height $canvas_height -width $canvas_width
	xyViewDefault} \
	{set canvas_width $canvas_width_old
	 set canvas_height $canvas_height_old} 6 \
	{"Breite des Grafikfensters in Pixel:" canvas_width} \
	{"Hoehe des Grafikfensters in Pixel:" canvas_height}

    TShowSubwindow  {100} {40} {Fenstergroesse}
}
#############################################################
proc TCreateEntryButton {help befehl abbruch width args} {
 
    set t .toplevelpara
    destroy $t
    toplevel $t

    set i 0
    foreach line $args {
	set i [expr $i+1]
	set text [lrange $line 0 0]
	set auch_leerzeichen [string first " " $text]
	if {$auch_leerzeichen > -1} then {
	    set length [expr [string length $text]-2]
	    set text [string range $text 1 $length]
	}
	set var [lrange $line 1 1]

	frame $t.$i
	pack $t.$i -in $t -side top -fill x

	label $t.$i.l -text $text
	entry $t.$i.e -textvariable $var -width $width
	pack $t.$i.l -in $t.$i -side left
	pack $t.$i.e -in $t.$i -side right
	bind $t.$i.e <Return> "$befehl"
    }

    set i [expr $i+1]
    frame $t.$i
    pack $t.$i -in $t -side top -fill x

    label $t.$i.l -text " "

    if {$help != " "} then {
	button $t.$i.help -text Hilfe -foreground blue -command "$help"
    }

    button $t.$i.abbruch -text Abbruch -command "
	$abbruch 
	$befehl
	catch {wm withdraw .toplevelpara} 
    "
    button $t.$i.try -text Versuchen -command "$befehl"
    button $t.$i.ok -text OK -command "
	$befehl
	catch {wm withdraw .toplevelpara}
    "
    label $t.$i.r -text " "

    pack $t.$i.l -in $t.$i -side left -expand 1
    pack $t.$i.ok $t.$i.try $t.$i.abbruch -in $t.$i -side left
    if {$help != " "} then {
	pack $t.$i.help -in $t.$i -side left -expand 1
    }
    pack $t.$i.r -in $t.$i -side left -expand 1
}
##########################################################
proc TShowSubwindow {x y wtitle} {

    set t .toplevelpara
    set parentPosition [wm geometry .]
    set xstart [expr [string first "+" $parentPosition]+1]
    set xstring [string range $parentPosition $xstart end]
    set xend [expr [string first "+" $xstring]-1]
    set xpos [string range $xstring 0 $xend]
    set ystart [expr $xend+2]
    set ypos [string range $xstring $ystart end]
    
    set geometry "+[expr $xpos+$x]+[expr $ypos+$y]"
    wm geometry $t $geometry
    focus $t
    wm title $t $wtitle
    wm transient $t .
    wm group $t . 
}
#############################################################
proc T_Grafik {} {
    global canvas_height canvas_width wc xMax_ yMax_ xregion_ yregion_ Android
    global last_a_ a_ faktor_ massstab last_massstab 

    destroy .chscroll
    destroy .cvscroll
    destroy $wc
    
    set xregion_ [expr $canvas_width*20]
    set yregion_ [expr $canvas_height*20]

    if {$Android != 1} then {
        # Betriebssystem ist nicht Android
        scrollbar .chscroll -orient horiz -command "$wc xview"
        scrollbar .cvscroll -command "$wc yview"
        canvas $wc -relief sunken -borderwidth 2 -scrollregion \
    	"[expr -$xregion_/2] [expr -$yregion_/2] [expr $xregion_/2] [expr $yregion_/2]" \
    	-height $canvas_height -width $canvas_width \
    	-xscrollcommand ".chscroll set" -yscrollcommand ".cvscroll set" -background white
    
        pack .chscroll -in .c -expand yes -fill x -side bottom
        pack $wc -expand yes -fill both -padx 1 -pady 1 -in .c -side left
        pack .cvscroll -in .c -side right -expand yes -fill y
        bind .cvscroll <Any-Enter> {
            setStatuszeile "Senkrechtes Verschieben (Scrollen) der Darstellung im Fenster (Ggf. zentrieren mit 'Zoom: Eipassen')"
        }
        bind .cvscroll <Any-Leave> {
            setStatuszeile ""
        }
        bind .chscroll <Any-Enter> {
            setStatuszeile "Waagerechtes Verschieben (Scrollen) der Darstellung im Fenster (Ggf. zentrieren mit 'Zoom: Eipassen')"
        }
        bind .chscroll <Any-Leave> {
            setStatuszeile ""
        }
        bind $wc <Control-KeyPress-plus>  {scaleItems + %x %y}
        bind $wc <Control-KeyPress-minus> {scaleItems - %x %y}
    } else {
        # Betriebssystem ist Android
        
        canvas $wc -relief sunken -borderwidth 2 \
    	-height $canvas_height -width $canvas_width -background white -scrollregion \
    	"[expr -$xregion_/2] [expr -$yregion_/2] [expr $xregion_/2] [expr $yregion_/2]"

    	pack $wc -expand yes -fill both -padx 1 -pady 1 -in .c -side right
    	#bind $wc <Button-2>  {scaleItems + %x %y}
        #bind $wc <Double-2> {scaleItems - %x %y}
        #bind $wc <Button-1> {
        #                     set last_massstab $massstab
        #                     set last_a_ $a_
        #                     }
        #bind $wc <Button-3> {
        #                     set showGetriebe 0
        #                     TShowGetriebe
        #                     set a_ [expr $last_a_/($last_massstab/$massstab)]
        #                     #tk_messageBox -message "a_=$a_\nlast_a_=$last_a_\nlast_massstab=$last_massstab\nmassstab=$massstab"
        #                     set showGetriebe 1
        #                     TShowGetriebe
        #                     }
        #bind $wc <Any-Enter> {setStatuszeile "Zoom mit ..."
        #}
    }

    T_Grafik_special

}
####################################################################
proc moveItems { x y } {

    global xc yc $wc
    
    if { [info exists ::xc] } {
        $wc move all [expr {$x-$xc}] [expr {$y-$yc}]
    }
    set xc $x
    set yc $y
}

##################################################################
proc scaleItems { type x y } {

    global wc showGetriebe massstab faktor_ last_massstab
    
    set faktor_ [expr sqrt(2.0)]

    if { $type eq "+" } {
        set massstab [expr $massstab*$faktor_]
        $wc scale all 0 0 $faktor_ $faktor_
    } else {
        set massstab [expr $massstab/$faktor_]
        $wc scale all 0 0 [expr 1.0/$faktor_] [expr 1.0/$faktor_]
    }
    #tk_messageBox -message "last_massstab=$last_massstab\nmassstab=$massstab"
}
#################################################################
# Prozedur erst verlassen, wenn durch fehlermelderwartet*
# erzeugtes Fenster verlassen wurde

proc fehlerMelderWarten {} {
    global fehlermelderWartet statuszeile

    set j 0
    while {$j == 0} {
	after 1000
	if {$fehlermelderWartet == 0} then {
	    set j 1
	}
    }
    setStatuszeile " "
}
#################################################################
proc fehlermelder2 {fehlermeldung1 fehlermeldung2 {help nohelp} } {

    global fehlermelderWartet
    global statuszeile

	setStatuszeile "Programm  pausiert"

	set fehlermelderWartet 1
	set w .err

	destroy $w
	DSNewWindow "." $w "Dromeg: Fehlermelder" 100 40

	frame $w.f1
	frame $w.f2 
	pack $w.f1 $w.f2 -side top -in $w -fill x
	frame $w.f1.f1
	frame $w.f1.f2
	pack $w.f1.f1 $w.f1.f2 -in $w.f1 -fill x
	label $w.f1.f1.l1 -text "Folgender Fehler ist aufgetreten:" \
	    -foreground red
	pack $w.f1.f1.l1 -in $w.f1.f1 -side left
	label $w.f1.f2.l1 -text "$fehlermeldung1"
	label $w.f1.f2.l2 -text " "
	label $w.f1.f2.l3 -text "$fehlermeldung2"
	pack $w.f1.f2.l1 $w.f1.f2.l2 $w.f1.f2.l3 \
	    -in $w.f1.f2 -side top -anchor w

	frame $w.f2.f1 
	button $w.f2.b1 -text "Weiter" -command {
	    set fehlermelderWartet 0
	    destroy .err
	}

	if {$help != "nohelp"} then {
	    button $w.f2.b2 -text "Hilfe" -foreground blue -command "
		ThelpHelp $help 200 200
	    "
	    frame $w.f2.f2 
	    pack $w.f2.f2 -in $w.f2 -expand 1 -side right
	    pack $w.f2.b2 -in $w.f2 -side right
	}

	frame $w.f2.f3
	pack $w.f2.f1 -in $w.f2 -expand 1 -side left
	pack $w.f2.b1 -in $w.f2 -side left
	pack $w.f2.f3 -in $w.f2 -expand 1 -side right

	tkwait variable fehlermelderWartet
}
####################################################################
proc VfileDialog {w operation fileType dir} {

    # operation = open || save
    #	Type names		Extension(s)	Mac File Type(s)
    #
    #---------------------------------------------------------
    if {"$fileType" == "Getriebeparameter" } then {
	set types {
	    {"Complete-View-Datei"		  {.dcv} }
	    {"Getriebe- & Grafikparameter-Datei"  {.dgg} }
	    {"Getriebeparameter-Datei"		  {.dgp} }
	    {"All files"	    *}
	}
    } elseif {"$fileType" == "DXF" } then {
	set types {
	    {"DXF-Datei"		          {.dxf} }
	    {"All files"	    *}
	}
    } elseif {"$fileType" == "CSV" } then {
	set types {
	    {"CSV-Datei"		          {.csv} }
	    {"All files"	    *}
	}
    } else {
	set types {
	    {"Grafikparameter-Datei"	     {.def} }
	    {"All files"	    *}
	}
    }
    #if {[regexp {[a-zA-Z0-9_-]+\.dgg$} $file] == 1} then {
    #	 set postfix dgg
    #} elseif {[regexp {[a-zA-Z0-9_-]+\.def$} $file] == 1} then {
    #	 set postfix def
    #} else {
    #	 set postfix dgp
    #}
    if {$operation == "open"} {
	set file [tk_getOpenFile -filetypes $types -parent $w -initialdir $dir]
    } else {
	set file [tk_getSaveFile -filetypes $types -parent $w \
	    -initialfile dromeg -initialdir $dir -defaultextension .dat]
    }
    return $file
}
#################################################################
proc VGrafikeinstellungSpeichern {programmName typ {operation speichern}} {

    global a a_ iZ_M iZ_A iN_M iN_A iZ iN rR    
    global phi_ phi_grad gamma0_ gam0_grad a_massstab da pradi_ rG_ type_ 
    global showTrochMove showFelder showGestell ischritte_ iT

    global GetrParaDir
    global al1 al2 al3 al4 alkx alky phi1 kbf alz1 alz2 alzx alzy kbz dateiNamePostfix
    global al1ue al2ue al3ue al4ue xSb ySb xUe yUe cl1 cl3
    global dphi
    global dphi_df
    global showRast
    global showGang
    global showSelbst
    global showUeber
    global showKoppelk
    global showKSwBg
    global showFeld
    global showPunktMove
    global fillGang
    global zweiLagen
    global noMomentanPol
    global zweiLagenKoppel
    global eineLage zweiSchlag
    global showSchnabel showZsR showThales
    global al1Snabel al2Snabel al3Snabel al4Snabel
    global showZweiSchlagHodograph showZweischlagWinkelDifferenz
    global massstab xMoveto yMoveto 0x 0y wc
    global last_massstab last_xMoveto last_yMoveto last_0x last_0y
    global yZoomPos1 xZoomPos1 yZoomPos2 xZoomPos2 xneu yneu xregion_ yregion_
    global maus1 maus2 maus3 plotName

    set filename [speicherDir]
    if {[file isdirectory $filename] == 1} then {
	if {[file writable $filename] == 1} then {

# Programmspezifische Grafikeinstellungen abspeichern
	    set filename3 $filename
                  if {[string range $filename end end] == "/"} then {
	        append filename3 $programmName.def
                  } else {
                      append filename3 /$programmName.def
                  }
                  if {[string range $filename3 0 0] == "/" || [string range $filename3 1 1] == ":"} then {
                        set filenameX $filename3
                  } else {
                        set pwD [pwd]
                        set filenameX $pwD/$filename3
                  }

	    if {[file exists $filename3] == 1 \
	    && [file writable $filename3] == 0} then {
		fehlermelder2 \
"Die Grafikeinstellungen sollen in der Datei $filename3 gespeichert werden" \
"Sie haben keine Schreibberechtigung fuer die Datei $filenameX"
		fehlerMelderWarten
	    } else {
		if {$typ == "P"} then {
		    if {[info exists GetrParaDir] == 1} then {
			set dir $GetrParaDir
		    } else {
			set dir $filename
		    }
		    set file [VfileDialog "." $operation "Getriebeparameter" $dir]
		    if [string compare $file ""] {
			set dirTest [string last "/" $file]
			if {$dirTest >= 0} then {
			    set GetrParaDir [string range $file 0 $dirTest]
			}
			if {$operation == "speichern"} then {
			    VGetriebeparameterSpeichern $file append
			    if {[regexp {[a-zA-Z0-9_-]+\.dcv$} $file] == 1} then {
				VkueSpeichern $file
				VGrafikeinstellungSpeichern3 $file append
			    } elseif {[regexp {[a-zA-Z0-9_-]+\.dgg$} $file] == 1} then {
				VGrafikeinstellungSpeichern3 $file append
			    }
			} else {
			    source $file
                                              VupdateView
			    #VChangeGetrLaengen
			    #VStatus
			    #VBind
			}
		    }
		    return
		} else {
		    VGrafikeinstellungSpeichern3 $filenameX
		}
	    }

# allgemeine Grafikeinstellungen abspeichern
	    set filename2 $filename
	    append filename2 dromeg.def
	    if {[file exists $filename2] == 1 \
	    && [file writable $filename2] == 0} then {
                            if {[string range $filename2 0 0] == "/" || [string range $filename2 1 1] == ":"} then {
                                set filenameX $filename2
                            } else {
                                set pwD [pwd]
                                set filenameX $pwD/$filename2
                            }

		fehlermelder2 \
"Die Grafikeinstellungen sollen in der Datei $filenameX gespeichert werden" \
"Sie haben keine Schreibberechtigung fuer die Datei $filenameX"
		fehlerMelderWarten
	    } else {
		VGrafikeinstellungSpeichern2 $filename2
	    }
	} else {
	    fehlermelder2 \
"Die Grafikeinstellungen sollen im Verzeichnis $filename gespeichert werden" \
"Sie haben keine Schreibberechtigung fuer das Verzeichnis $filename" \
		dro-fgs4.hlp
	    fehlerMelderWarten
	}
    } else {
               if {[string range $filename 0 0] == "/" || [string range $filename 1 1] == ":"} then {
                                set filenameX $filename
                            } else {
                                set pwD [pwd]
                                set filenameX $pwD/$filename
                            }
	fehlermelder2 \
"Die Grafikeinstellungen sollen im Verzeichnis $filenameX gespeichert werden" \
"Das Verzeichnis $filenameX existiert nicht"
	fehlerMelderWarten
    }
    append filename dromeg.def
}
#############################################################
proc VGrafikeinstellungSpeichern2 {filename} {

    global canvas_height
    global canvas_width
    global plotName

    set Datei [open $filename w+]
	puts $Datei "set canvas_height $canvas_height"
	puts $Datei "set canvas_width $canvas_width"
	puts $Datei "set plotName $plotName"
    close $Datei
}
#############################################################
proc speicherDir {} {

    global env

    if {[info exists env(DROMEG)] == 1} then {
	regsub -all {\\} $env(DROMEG) {/} speicherPfad
	set last [expr [string length $speicherPfad]-1]
	if {[string range $speicherPfad $last $last] != "/"} then {
	    append speicherPfad "/"
	}
    } else {
	set speicherPfad "dat/"
    }
    return $speicherPfad
}
#############################################################
proc TexportDXF {} {

    set file [VfileDialog "." save "DXF" ""]
    if {$file != ""} then {
        TcreateDXF $file
    }
}
#######################################
proc dxfColorToRGB {color} {

    if {$color == "red"} then {
        set rgb "d00"
    } elseif {$color == "green"} then {
        set rgb "0d0"
    } elseif {$color == "blue"} then {
        set rgb "00d"
    } elseif {$color == "black"} then {
        set rgb "000"
    } elseif {$color == "brown"} then {
        set rgb "800"
    } elseif {$color == "darkgreen"} then {
        set rgb "080"
    } elseif {$color == "darkblue"} then {
        set rgb "008"
    } elseif {$color == "cyan"} then {
        set rgb "0dd"
    } elseif {$color == "orange3"} then {
        set rgb "ffa500"
    } elseif {$color == "orange"} then {
        set rgb "cd8500"
    } elseif {$color == "white"} then {
        set rgb "ddd"
    } elseif {$color == "gray70"} then {
        set rgb "aaa"
    } elseif {$color == "IndianRed"} then {
        set rgb "cd5c5c"
    } elseif {$color == "mediumvioletred"} then {
        set rgb "c71585"
    } elseif {$color == "violet"} then {
        set rgb "ee82ee"
    } else {
        tk_messageBox -message "neue Farbe fuer RGB = $color"
        set rgb "333"
    }

    return $rgb
}
##############################################################
proc dxfColorRGB {rgb} {

        if {$rgb == "d00"} then {
            set color red
        } elseif {$rgb == "0d0"} then {
            set color green
        } elseif {$rgb == "cd8500"} then {
            set color orange
        } elseif {$rgb == "ffa500"} then {
            set color orange3
        } elseif {$rgb == ""} then {
            set color green
        } elseif {$rgb == "00d"} then {
            set color blue
        } elseif {$rgb == "000"} then {
            set color black
        } elseif {$rgb == "800"} then {
            set color brown
        } elseif {$rgb == "080"} then {
            set color darkgreen
        } elseif {$rgb == "008"} then {
            set color darkblue
        } elseif {$rgb == "0dd"} then {
            set color cyan
        } elseif {$rgb == "ddd"} then {
            set color white
        } elseif {$rgb == "aaa"} then {
            set color gray70
        } elseif {$rgb == "cd5c5c"} then {
            set color IndianRed
        } elseif {$rgb == "c71585"} then {
            set color "mediumvioletred"
        } elseif {$rgb == "ee82ee"} then {
            set color "violet"
        } else {
            tk_messageBox -message "neue RGB-Farbe = $rgb"
            set color 0
        }
        return $color
}
###############################################################
proc dxfPolygon {wc dxfFile layer tag rgb xyT {line line} {rgbFill "-"}} {

#   geg.: rgbFill: color | "-"
#         "-"   ==> kein geschlossenes Polygon
#         color ==> geschlossenes Poloygon, die Farbe gibt die Farbe zum Fllen an

    set color [dxfColorRGB $rgb]
    if {$dxfFile == "no"} then {
        if {$rgbFill == "-"} then {
            # kein geschlossenes Polygon
            set Befehl "$wc create $line $xyT -tags $tag -fill $color"
        } else {
            # geschlossenes Polygon
            set fillcolor [dxfColorRGB $rgbFill]
            set Befehl "$wc create polygon $xyT -tags $tag -fill $fillcolor -outline $color"
        }
        #tk_messageBox -message "Befehle b=$Befehl"
        set Line [eval $Befehl]
        $wc addtag $tag withtag $Line
        return $Line
    } else {
        # Anzahl Punkte
	set j 0
	# i=1 --> x-Wert
	set i 0
	set x 0.0
	set y 0.0
	foreach koord $xyT {
	    incr i
	    if {$i == 1} then {
		set xOld $x
		set x $koord
	    } else {
		set i 0
		incr j
		set yOld $y
		set y $koord
		if {$j > 1} then {
		    # nur wenn Anfang- und Endpunkt bekannt ist
		    dxfLinie "" $dxfFile $layer $color $xOld $yOld $x $y ""
		}
	    }
	}
    }
}
#############################################################
proc dxfKreis {wc dxfFile layer color xMin yMin xMax yMax taG {fillColor ""}} {

    set return ""

    if {$dxfFile == "no"} then {
        if {$fillColor != ""} then {
            set return [$wc create oval $xMin $yMin $xMax $yMax -outline $color -fill $fillColor -tags $taG]
            $wc lower $taG
        } else {
            set return [$wc create oval $xMin $yMin $xMax $yMax -outline $color -tags $taG]
        }

    } else {
        set farbe [dxfSetColor $color]
        set layer [dxfSetLayer $layer $taG]
        set yMin [expr -1*$yMin]
        set yMax [expr -1*$yMax]
        
                    puts $dxfFile "0"
		    puts $dxfFile "CIRCLE"
		    # Layer
		    puts $dxfFile "8"
		    puts $dxfFile $layer
		    # Farbe (optional) 3=gruen
		    puts $dxfFile "62"
		    puts $dxfFile $farbe
		    # Mittelpunkt x-Koordinate
		    puts $dxfFile "010"
		    puts $dxfFile [expr ($xMax + $xMin)/2.]
		    # Mittelpunkt y-Koordinate
		    puts $dxfFile "20"
		    puts $dxfFile [expr ($yMax + $yMin)/2.]
		    # Mittelpunkt z-Koordinate
		    puts $dxfFile "30"
		    puts $dxfFile "0.0"
		    # Radius
		    puts $dxfFile "40"
		    set x [expr ($xMax - $xMin)/2.]
		    set y [expr ($yMax - $yMin)/2.]
		    puts $dxfFile [expr sqrt(($x*$x + $y*$y)/2.)]
    }
    return $return
}
##########################################################
proc dxfSetColor {color} {
    if {$color == "red"} then {
        set farbe 1
    } elseif {$color == "yellow"} then {
        set farbe 2
    } elseif {$color == "lightyellow"} then {
        set farbe 31
    } elseif {$color == "green"} then {
        set farbe 3
    } elseif {$color == "darkgreen"} then {
        set farbe 27
    } elseif {$color == "lightgreen"} then {
        set farbe 70
    } elseif {$color == "cyan"} then {
        set farbe 4
    } elseif {$color == "blue"} then {
        set farbe 5
    } elseif {$color == "lightblue"} then {
        set farbe 111
    } elseif {$color == "darkblue"} then {
        set farbe 154
    } elseif {$color == "magenta"} then {
        set farbe 6
    } elseif {$color == "black"} then {
        set farbe 7
    } elseif {$color == "grey"} then {
        set farbe 8
    } elseif {$color == "lightgrey"} then {
        set farbe 9
    } elseif {$color == "lightred"} then {
        set farbe 11
    } elseif {$color == "brown"} then {
        set farbe 15
    } elseif {$color == "orange"} then {
        set farbe 30
    } elseif {$color == "orange1"} then {
        set farbe 21
    } elseif {$color == "orange2"} then {
        set farbe 41
    } elseif {$color == "orange3"} then {
        set farbe 51
    } elseif {$color == "orange4"} then {
        set farbe 60
    } elseif {$color == "orange5"} then {
        set farbe 51
    } elseif {$color == "orange6"} then {
        set farbe 41
    } elseif {$color == "orange7"} then {
        set farbe 21
    } elseif {$color == "orange8"} then {
        set farbe 30
    } elseif {$color == "IndianRed"} then {
        # Farbe 13 ist dunkler und brauner als IndianRed
        set farbe 13
    } elseif {$color == "mediumvioletred"} then {
        # Farbe 222 ist dunkler als mediumvioletred
        set farbe 222
    } elseif {$color == "violet"} then {
        # Farbe 201 ist etwas dunkler als violet
        set farbe 201
    } elseif {[regexp {^[a-zA-Z]} $color] == 1} then {
        set farbe 255
        tk_messageBox -message "dxfSetColor: Farbe unbekannt $color"
    } else {
        set farbe $color
    }
    return $farbe
}
##############################################################
proc dxfEnd {dxfFile} {
    if {$dxfFile != "no"} then {
	    # DXF-Tail
            puts $dxfFile "0"
            puts $dxfFile "ENDSEC"
            puts $dxfFile "0"
            puts $dxfFile "EOF"
            close $dxfFile
     }

    return
}
##############################################################
proc dxfSetLayer {layer taG} {

    if {$layer == "-"} then {
        if {[string tolower $taG] == "t"} then {
            set layer 0
        } elseif {[string tolower $taG] == "s"} then {
            set layer 18
        } elseif {[string tolower $taG] == "rr"} then {
            set layer 16
        } elseif {[string tolower $taG] == "rg_"} then {
            set layer 17
        } elseif {[string tolower $taG] == "k"} then {
            set layer 15
        } elseif {[regexp {^[0-9]+$} $taG] == 1} then {
           # taG=GliedNummer
           set layer 20
        }
    }
    return $layer
}
##############################################################
proc dxfLinie {wc dxfFile layer color xA yA xE yE taG} {

    # layer  0 bis 9 == Trochoide
    #        11      == Gestell
    #        12      == Rastpolkurve
    #        13      == Gangpolkurve
    #        14      == BALLsche Kurve
    #        15      == Koppelkurvenpunkt + Glied
    #        16      == Rastpolkurvenpunkt + Glied
    #        17      == Gangpolkurvenpunkt + Glied
    #        19      == Steg
    #        20      == Getriebeglied
    #      21 bis 29 == Uebergangskurven

    set layer [dxfSetLayer $layer $taG]
    set farbe [dxfSetColor $color]

    if {$dxfFile == "no"} then {
        $wc create line $xA $yA $xE $yE -tag $taG -fill $color
    } else {
        set yA [expr -1*$yA]
        set yE [expr -1*$yE]

		    puts $dxfFile "0"
		    puts $dxfFile "LINE"
		    # Layer
		    puts $dxfFile "8"
		    puts $dxfFile $layer
		    # Farbe (optional) 3=gruen
		    puts $dxfFile "62"
		    puts $dxfFile $farbe
		    # Startpuntk x-Koordinate
		    puts $dxfFile "010"
		    puts $dxfFile "$xA"
		    # Startpuntk y-Koordinate
		    puts $dxfFile "20"
		    puts $dxfFile "$yA"
		    # Startpuntk z-Koordinate
		    puts $dxfFile "30"
		    puts $dxfFile "0.0"
		    # Endpuntk x-Koordinate
		    puts $dxfFile "11"
		    puts $dxfFile "$xE"
		    # Endpuntk y-Koordinate
		    puts $dxfFile "21"
		    puts $dxfFile "$yE"
		    # Endpuntk z-Koordinate
		    puts $dxfFile "31"
		    puts $dxfFile "0.0"
    }
}
#############################################################
if {[catch {toplevel .balloonhelp -class Balloonhelp   -borderwidth 1 -relief flat -background lightblue}]} then {
            # Source-Code wurde wahrscheinlich schon einmal geladen
} else {
   label .balloonhelp.arrow                -foreground white           -background black  ;# -bitmap info
      pack .balloonhelp.arrow              -side left -fill both
   label .balloonhelp.info                 -foreground white           -background black
      pack .balloonhelp.info               -side left -fill y

   wm overrideredirect .balloonhelp 1
   wm withdraw .balloonhelp
}
#############################################################
proc setStatuszeile {statusZeile} {

    global statuszeile Android
    
    set b .s.statuszeile

    if {$Android == 1} then {
        if {[string length $statusZeile] > 80} then {
            set end [string last " " [string range $statusZeile 0 75]]
            set statuszeile [string range $statusZeile 0 [expr $end-1]]
            .balloonhelp.info configure -text [string range $statusZeile [expr $end+1] 120]
            set x [expr [winfo rootx $b]+400]                        ;# justiert den Label
            set y [expr [winfo rooty $b]-[winfo height $b]]
            wm geometry .balloonhelp +$x+$y
            wm deiconify .balloonhelp
            raise .balloonhelp
        } else {
            set statuszeile [string range $statusZeile 0 80]
            #catch {destroy .balloonhelp}
            lower .balloonhelp
        }
    }  else {
        set statuszeile $statusZeile
    }
}
############################################################
proc round3 {x} {
    if {$x >= 0} then {
        set x [expr int(($x+0.0005)*1000.)/1000.]
    } else {
        set x [expr int(($x-0.0005)*1000.)/1000.]
    }
    return $x
}
#############################################################
#$wc create oval $xMin $yMin $xMax $yMax -outline $color -fill $fillColor -tags $taG
#$wc create polygon $xMin $yMin $xMax $yMax -outline $color -fill $fillColor -tags $taG
#$wc coords kUe$ni $xMin $yMin $xMax $yMax

# modifikation fuer Version 1.2B gegenber 1.2.1
global lineWidth
set lineWidth 0