##########################################################
#C  Unterprogramm zur Bestimmung der Koeffizienten  A(k), B(k), C(k)  
#C  und D(k) der kubischen-Spline-Funktion                             
#c  y = a*x**3 + b*x*x + c*x + d
#C                                                                     
      proc koeff {N X_ Y_ Y2_ A_ B_ C_ D_} {

          upvar $X_ X
          upvar $Y_ Y
          upvar $Y2_ Y2
          upvar $A_ A
          upvar $B_ B
          upvar $C_ C
          upvar $D_ D
#C
#c     dimension X(NMA),Y(NMA),Y2(NMA),A(NMA),B(NMA),C(NMA),D(NMA)
#c
#c Schrifttum: Helmut Spaeth
#c             Spline-Algorithmen zur Konstruktion glatter Kurven und Flaechen
#c             Oldenbourg Verlag Muenchen Wien 1973
#c
#c Gegeben: nma = Definierte Laenge der eindimensionalen Felder
#c            n = Anzahl der Stuetzstellen
#c            x = x-Werte der Funktion, fuer die der Spline gesucht ist
#c            y = y-Werte der Funktion, fuer die der Spline gesucht ist
#c           y2 = 2. Ableitung der Funktion y(x)
#c
#c Gesucht:   a = a (s.o)
#c            b = b (s.o)
#c            c = c (s.o)
#c            d = d (s.o)
#c
#      DO 10 K=1,N-1
        for {set K 1} {$K <= [expr $N-1]} {incr K} {
          set K1 [expr $K+1]
          set H1 [expr $X($K1)-$X($K)]
          set H2 [expr $Y($K1)-$Y($K)]
          set A($K) [expr ($Y2($K1)-$Y2($K))/(6.*$H1)]
          set B($K) [expr $Y2($K)/2.]
          set C($K) [expr $H2/$H1-$H1*($Y2($K1)+2.*$Y2($K))/6.]
          set D($K) $Y($K)
   #10 CONTINUE
        }
}
##########################################################
