proc func_schnabelspitze {phi kb} {
    
    global gam0 al1 al4 drad

#    set kb -1.
    set rdvw 1.

    set psi [expr [uebfk0 $kb $phi $rdvw]*$drad]
    set gam [expr $gam0*$drad]
 
    set phi [expr $phi*$drad]

    set tanphi [expr tan($phi)]
    set kla [expr 1-$tanphi/tan($gam)]
    set bruch [expr $al4/(1-$tanphi/tan($psi))]
    set f3 [expr $al1*cos($phi)*$kla-$bruch]
    return $f3
}
##############################################################
proc show_schnabelspitze {} {

    global showSchnabel showRast showGang
    global phi_schnabel kb_schnabel
    global drad gam0
    global p
    global pradi_ wc massstab
    global xGang yGang lgesRast lgesGang 
    
    if {$showSchnabel != 1} then {
	return
    }
    
    set rdvw 1.

    set lgesRast 0
    set lgesGang 0

# Rast- und Gangpolkurvenpunkt von Schnabelspitze berechnen
    set i 0
    while {$i < $phi_schnabel(0)} {
	incr i
	#set psi [expr [uebfk0 $kb_schnabel($i) $phi_schnabel($i) $rdvw]*$drad]
	#set gam [expr $gam0*$drad]
	#set phi [expr $phi_schnabel($i)*$drad]
	set psi [uebfk0 $kb_schnabel($i) $phi_schnabel($i) $rdvw]
	set gam $gam0
	set phi $phi_schnabel($i)
	VRastUGangpolkurvenpunkt $phi $psi $gam $showRast $showGang -9
    }

# Koppellage mit in Berechnung einbeziehen und Schnabelspitze plotten

    $wc delete schnabel

    set pHi [expr -1.*[steigung8_2p $p(2,1) $p(2,2) $p(3,1) $p(3,2)]]
    set cphi [expr cos($pHi)]
    set sphi [expr sin($pHi)]

    set j 0
    set i -9
    while {$j < $phi_schnabel(0)} {
	incr j
	set xSchn [expr $xGang($i,$j)*$cphi+$yGang($i,$j)*$sphi]
	set ySchn [expr -1.*$xGang($i,$j)*$sphi+$yGang($i,$j)*$cphi]
	set xa [expr $xSchn/1000+$p(2,1)]
	set ya [expr $ySchn/1000+$p(2,2)]
	if {[expr abs($xa)] < 100000000} then {
	    set xSchn [expr round($xa*$massstab)]
	}
	if {[expr abs($ya)] < 100000000} then {
	    set ySchn [expr round(-1.*$ya*$massstab)]
	}
	set Schnabel [$wc create oval [expr $xSchn-$pradi_*1.25] [expr $ySchn-$pradi_*1.25] \
		       [expr $xSchn+$pradi_*1.25] [expr $ySchn+$pradi_*1.25] \
		       -outline orange -fill yellow -tags schnabel.$j]

	$wc bind schnabel.$j <Any-Enter> "bindSchnabelSpitzenPunktEnter $wc $j"
	$wc bind schnabel.$j <Any-Leave> "bindSchnabelSpitzenPunktLeave $wc $j"
	$wc bind schnabel.$j <ButtonRelease-1> \
	     "bindSchnabelSpitzenPunktMouse1 $wc $j $xGang($i,$j) $yGang($i,$j)"
	$wc bind schnabel.$j <ButtonRelease-2> \
	     "bindSchnabelSpitzenPunktMouse2 $wc $j $xGang($i,$j) $yGang($i,$j)"
	$wc bind schnabel.$j <ButtonRelease-3> "bindSchnabelSpitzenPunktMouse3 $wc $j"
	$wc addtag schnabel withtag $Schnabel
    }
    
    $wc lower schnabel
    $wc lower koppeld
    $wc lower kBgA
    $wc lower kBgB
 }
##############################################################
proc bindSchnabelSpitzenPunktMouse1 {wc j x y} {
 
    global phi1 alkx alky mGetr cl1 p lges_p
    global phi_schnabel kb_schnabel showSchnabel statuszeile
    

    set alkx $x
    set alky $y

    VChangeGetrLaengen
    set showSchnabel 1
    show_schnabelspitze
    set statuszeile ""
}
##############################################################
proc bindSchnabelSpitzenPunktMouse2 {wc j x y} {
 
    global phi1 alkx alky mGetr cl1 p lges_p
    global phi_schnabel kb_schnabel showSchnabel statuszeile
    

    set phi1 $phi_schnabel($j)
    set alkx $x
    set alky $y
    set kbf(1) $kb_schnabel($j)

    set p(3,9) [expr -1.*abs($p(3,9))*$kbf(1)]
    if {$lges_p == 11} then {
	set p(6,9) [expr -1.*abs($p(6,9))*$kbf(1)]
    } elseif {$lges_p == 12} then {
	set p(7,9) [expr -1.*abs($p(7,9))*$kbf(1)]
    }
    VChangeGetrLaengen
    set showSchnabel 1
    show_schnabelspitze
    set statuszeile ""
}
##############################################################
proc bindSchnabelSpitzenPunktMouse3 {wc j} {
    
    global phi1 alkx alky mGetr cl1 p lges_p
    global phi_schnabel kb_schnabel showSchnabel statuszeile
    

    set phi1 $phi_schnabel($j)
    set kbf(1) $kb_schnabel($j)

    VChangeGetrLaengen
    set showSchnabel 1
    show_schnabelspitze
    set statuszeile ""
}
##############################################################
proc bindSchnabelSpitzenPunktEnter {wc j} {

    global statuszeile

    $wc itemconfigure schnabel.$j -width 2 -outline black
    set statuszeile "Schnabelspitze: 'nur' Koordinaten 'Rechte Maustaste', \
Koordinaten und Antriebswinkel: 'Linke Maustaste', 'nur' Antriebswinkel: \
'mittlere Maustaste'"
}
##############################################################
proc bindSchnabelSpitzenPunktLeave {wc j} {

    global statuszeile

    $wc itemconfigure schnabel.$j -width 1 -outline orange
    set statuszeile ""
}
############################################################
proc VisibilityWait {} {

      global statuszeile

      frame .wait
      pack .wait
      tkwait visibility .wait
      destroy .wait
}
##############################################################
proc phi_schnabelspitze {} {

    global cl1 mGetr al1 al2 al3 al4 
    global al1Snabel al2Snabel al3Snabel al4Snabel
    global dfgam dfpsi
    global p dphi
    global lges_phiP phiParallel
    global phi_schnabel kb_schnabel showSchnabel
    global statuszeile

    set al1Snabel $al1
    set al2Snabel $al2
    set al3Snabel $al3
    set al4Snabel $al4

    set statuszeile "Ermittle Schnabelspitzen-Erzeugungspunkt"
    VisibilityWait
    set statuszeile "Ermittle Schnabelspitzen-Erzeugungspunkt"
    VisibilityWait

    set eps 0.0001

    set showSchnabel 1

    if {$p(3,9) < 0} then {
	set kb +1.
    } else {
	set kb -1.
    }

    VAnUAbtriebParallel lges_phiP_p phiParallel_p
    set lges_df_p [VFeldAntriebswinkel \
	$kb $dphi dfphi_p kb_df_p plot_df_p phiParallel_p lges_phiP_p kjk_p]


# Startwinkel ermitteln

    set i 1
    set j 1
    while { $i < $lges_df_p} {
#	set di 2
	set di 1
#puts "i=$i"
	set f1 [func_schnabelspitze $dfphi_p($i) $kb_df_p($i)]
	set f2 $f1
	set phi $dfphi_p($i)
	while { [expr $f1*$f2 > 0 ] } { 
	    set phi1 $phi
	    set i [expr $i+$di]
#	    set phi $dfphi_p($i)

	    if {$i > $lges_df_p} then {
#		 set i [expr $i-$di+1]
#		set phi $dfphi_p($i)
	    
#		 if { $di == 1 } then {
		    set phi_schnabel(0) [expr $j-1]
		    set statuszeile ""
		    return
#		 }
#		set di 1
	    }
	    set phi $dfphi_p($i)

	    set f2 [func_schnabelspitze $dfphi_p($i) $kb_df_p($i)]
	    set kb $kb_df_p($i)
	    set phi2 $phi
#	    puts "phi1=$phi1, phi2=$phi2, f1=$f1, f2=$f2"
	}
	
	
	if { [schnabel_asymptote $i $di $lges_df_p dfphi_p kb_df_p] == 0 } {
	    set phi_schnabel($j) [regula_falsi $phi1 $phi2 $f1 $f2 $eps $kb]
	    puts "PhiSchnabel($j) $phi_schnabel($j)"
	    if {$phi_schnabel($j) != "error"} then {
		set kb_schnabel($j) $kb
		incr j
	    }
	}
    }
    set statuszeile ""
}
#######################################################################
# pruefen, ob Nullstelle beim ermitteln der Schnabelspitze Asymptote darstellt
proc schnabel_asymptote {i di lges dfphi_p_ kb_df_p_} {


    upvar $dfphi_p_ dfphi_p
    upvar $kb_df_p_ kb_df_p 

    if {$i <= [expr $di+1]} then {
	set j 1
    } else {
	set j [expr $i-$di]
    }
    set j_old $j
   
    set k 1
    set f($k) [func_schnabelspitze $dfphi_p($j) $kb_df_p($j)]
    incr j
    set k_old $k
    incr k
    set f($k) [func_schnabelspitze $dfphi_p($j) $kb_df_p($i)]
# Nullstelle suchen
    while { [expr $f($k)*$f($k_old)] > 0} {
	incr j
	incr k
	if {$j > $lges} then {
	    set j 1
	}
	set f($k) [func_schnabelspitze $dfphi_p($j) $kb_df_p($j)]
    }
# zweite Stuetzstelle hinter Nullstelle berechnen
    incr j
    incr k
    if {$j > $lges} then {
	set j 1
    }
    set f($k) [func_schnabelspitze $dfphi_p($j) $kb_df_p($j)]


    set k_start [expr $k-3]
# ggf. zweite Stuetzstelle vor Nullstelle berechnen (wenn noch nicht bekannt)
    if { $k_start < 1} then {
	set j [expr $j_old -1]
	if {$j < 1} then {
	    set j $lges
	}
	set f(0) [func_schnabelspitze $dfphi_p($j) $kb_df_p($j)]
    }
# Pruefen auf Asymptote
    if {$f($k) < 0} then {
#  Vorzeichen umkehren
	set k $k_start
	while {$k < [expr $k_start+4]} {

	    set f($k) [expr -$f($k)]
	    incr k
	}
    }

    set k1 $k_start
    set k2 [expr $k1+1]
    set k3 [expr $k2+1]
    set k4 [expr $k3+1]

    if { $f($k1) > $f($k2) } then {
	if { $f($k3) > $f($k4) } then {
# Asymptote gefunden
#puts "Asymptote"
	    return 1
	}
    }
#puts "keine Asymptote"
    return 0
}
#######################################################################
proc regula_falsi {phi1 phi2 f1 f2 eps kb} {

#    puts [min [expr abs($f1)] [expr abs($f2)]]
    
    set phi3 [expr $phi1-(($phi2-$phi1)*$f1)/($f2-$f1)]
    set f3_old [expr [func_schnabelspitze $phi3 $kb]+1]

    set i 0
    puts "Anfang: i=$i, Phi1=$phi1, f(Phi1)=$f1, Phi2=$phi2, f(Phi2)=$f2"
    set k 0
    while { [min [expr abs($f1)] [expr abs($f2)]] > $eps &&  $i < 1000} {
	incr i
	set phi3 [expr $phi1-(($phi2-$phi1)*$f1)/($f2-$f1)]
	set f3 [func_schnabelspitze $phi3 $kb]
	#puts "phi3=$phi3, f3=$f3"
	if { $f1*$f3 < 0} then {
	    set phi2 $phi3
	    set f2 $f3
	} else {
	    set phi1 $phi3
	    set f1 $f3
	}
#	 puts "phi1=$phi1, phi2=$phi2, f1=$f1, f2=$f2"
#	 puts "i=$i, f3=$f3, f3_old=$f3_old"
	if { [expr abs($f3_old)] < [expr abs($f3)] } then {
	    incr k
	    if { $k > 10 } then {
		return "error"
	    }
	}
	set f3_old $f3
    }
    puts "Ende: i=$i, Phi1=$phi1, f(Phi1)=$f1, Phi2=$phi2, f(Phi2)=$f2"
    

    if { [expr abs($f1)] < $eps } then {
	return $phi1
    } else {
	return $phi2
    }
}
