#######################################################################
#c Unterprogramm zum Ermitteln eines y-Wertes eines kubischen Splines,
#c wenn der x-Wert und die Spline-Koeffizienten gegeben sind

proc spline_a_interp {x_neu lges x_ acs_ bcs_ ccs_ dcs_ i_spline_ y_neu_ ya_neu_} {

	  upvar $x_ x
	  upvar $acs_ acs
	  upvar $bcs_ bcs
	  upvar $ccs_ ccs
	  upvar $dcs_ dcs
	  upvar $i_spline_ i_spline
	  upvar $y_neu_ y_neu
	  upvar $ya_neu_ ya_neu

#	 real*8 x_neu,x(*),acs(*),bcs(*),ccs(*),dcs(*),y_neu,ya_neu

#c geg.: x_neu,lges,x,acs,bcs,ccs,dcs,i_spline

#c x_neu   : x-Wert, zu dem ein y-Wert (y_neu) ermittelt werden soll
#c lges    : Anzahl der Spline-Funktionen
#c x()	   : Anfangs-x-Koordinaten einer jeden kubischen Funktion des Splines
#c acs(),bcs(),ccs(),dcs()  : Koeffizienten der Splines
#c i_spline:
#c     geg.: Nr. der kubischen Funktion, von der die Suche nach dem
#c	     Intervall beginnt, in dem sich x_neu befindet
#c     ges.: Nr. der kubischen Funktion, die den Wert y_neu geliefert hat
#c y_neu   : y-Wert, der zu dem gegebenen x-Wert (x_neu) gehrt
#c ya_neu  : Ableitung y', die zu dem gegebenen x-Wert (x_neu) gehrt
#c ierr    : Kennzahl
#c	     ierr=0 --> es trat kein Fehler auf
#c	     ierr=1 --> x_neu liegt auerhalb der Definition der Splines
#c....................................................................
#c Beispielhafter Aufruf:
#source cubicp.tcl
#source koeff.tcl
#source spline8_inte.tcl

#set Pi [expr 4.*atan(1.)]
#set drad [expr $Pi/180.]
#set dphi 30

#set i 1
#while {$i <= [expr (360+$dphi)/$dphi]} {
#    set j [expr ($i-1) * $dphi]
#    set x($i) [expr $j * $drad]
#    set y($i) [expr sin($x($i))]
#    puts "x($i)=$x($i), y($i)=$y($i)"
#    set lges $i
#    incr i
#}
#cubicp  $lges x y y2
#koeff $lges x y y2 acs bcs ccs dcs

#set dphi 10
#set i_spline 1
#set i 1
#while {$i <= [expr (360)/$dphi]} {
#    set x_neu [expr $i * $dphi * $drad]
#    spline8_interp $x_neu $lges x acs bcs ccs dcs i_spline y_neu
#    puts "i=$i, x=$x_neu, y=$y_neu, y_soll=[expr sin($x_neu)]"
#    incr i
#}
#c....................................................................
#	 real*8 xd,xd2,xd3


	set ierr 0
	if {$i_spline < 1 || $i_spline > $lges} then {
	    set i_spline 1
	}

#	do while (i_spline.ge.1.and.i_spline.le.lges)
	while {$i_spline >= 1 || $i_spline <= $lges} {
	    set i $i_spline

	    if {$x_neu < $x($i)} then {
		set i_spline [expr $i_spline - 1]
	    } elseif {$x_neu > $x([expr $i + 1])} then {
		set i_spline [expr $i_spline + 1]
	    } else {
		set xd [expr $x_neu - $x($i)]
		set xd2 [expr $xd * $xd]
		set xd3 [expr $xd2 * $xd]
		set y_neu [expr $acs($i) * $xd3 + $bcs($i) * $xd2 + $ccs($i) * $xd + $dcs($i)]
		set ya_neu [expr 3.*$acs($i)*$xd2+2.*$bcs($i)*$xd+$ccs($i)]

		return $ierr

	    }
#	end do
	}
	set ierr 1

	return $ierr
}
