#!/inko4/bin/wish -f

source schnabel.tcl
source cubicp.tcl
source koeff.tcl
source spline_a_inte.tcl
source spline_a2_inte.tcl
#source read-dcv-file.tcl

# Analyse von viergliedrigen Gelenkgetrieben
#############################################################
proc TZoomAll {} {

    global lges_p

    VSetMassstab $lges_p
    VModifyGetr all
    xyViewDefault
}
#############################################################
proc VSelbstberuehrungskurveAuto { {ausgangslage 1}  }	{

    global ShowFemanFortschritt
    global vSelbstberuehrungskurve
    global noWarnung
    global noMomentanPol
    global zusat cl1 cl3
    global phi1 phi2
    global DrehRichTung
    global lges_dieser_lauf
    global fillGang
    global dphi
    global wend_anz
    global autoUeBere
    global KueUberschreiben KueUberschreiben_old

    set KueUberschreiben_old  $KueUberschreiben
    set KueUberschreiben Ja
    set noWarnung_old $noWarnung
    set noWarnung Ja
    set ShowFemanFortschritt_old $ShowFemanFortschritt
    set dphi_old $dphi
    set wend_anz_old $wend_anz

    if {[info exists DrehRichTung] == 0} then {
	set DrehRichTung 1
    }
    set DrehRichTung_old $DrehRichTung
    set phi1_old $phi1
    set phi2_old $phi2

    set ShowFemanFortschritt Nein
    set vSelbstberuehrungskurve yes
    set dphi 1

    if {$zusat == "(umlauffaehig)" && $cl1 == " u" && $cl3 == " u"} \
    then {
# Doppelkurbeln
	VLiesDatei "dromeg-u.dat"
        VStarteUebergangskurve $ausgangslage 3 183 2 177 357 2
	 set wend_anz 180
    } elseif {$zusat == "(umlauffaehig)" && $cl1 == " u" && $cl3 == " s"} \
    then {
# Kurbelschwinge
	VLiesDatei "dromeg-u.dat"
        set autoUeBere 1
	set wend_anz 240
	VStarteUebergangskurve $ausgangslage 3 177 -2 357 183 -2
	if {$autoUeBere == 1} then {
	    set wend_anz [expr $wend_anz-$lges_dieser_lauf]
	    VVerfolgeUebergangskurve 
	}
    } elseif {$zusat == "(totalschwingfaehig)" && $cl1 == "is" && $cl3 == "is"}\
    then {
# Doppelinnenschwinge
	ThelpHelp dro-uei4.hlp 300 200
    } else {
	ThelpHelp dro-uea4.hlp 300 200
    }

    set vSelbstberuehrungskurve no
    set KueUberschreiben $KueUberschreiben_old
    set noWarnung $noWarnung_old
    set ShowFemanFortschritt $ShowFemanFortschritt_old
    set DrehRichTung $DrehRichTung_old
    set phi1 $phi1_old
    set phi2 $phi2_old
    set dphi $dphi_old
    set wend_anz $wend_anz_old

    if {$noMomentanPol == 1} then {
	VLiesDatei "dromeg-4.dat"
    } else {
	VLiesDatei "dromeg-6.dat"
    }
}
#############################################################
proc VVerfolgeUebergangskurve {} {

    global phi1 phi2
    global phi_1 phi_2
    global xUe yUe xSb ySb
    global lges_dieser_lauf
    global DrehRichTung
    global vSelbstberuehrungskurve
    global autoUeBere
    global al1 al2 al3 al4

    set lges $lges_dieser_lauf

# Kopie anlegen
    set i 0
    while {$i < $lges} {
	incr i
#	puts "i=$i, lges=$lges, phi1=$phi_1($i)"
	set xUe_old($i) $xUe(1,$i)
	set yUe_old($i) $yUe(1,$i)
	set xSb_old($i) $xSb(1,$i)
	set ySb_old($i) $ySb(1,$i)
    }

# Rueckwaerts speichern
    set xSb(0,0) 2
    set xUe(0,0) 2
    set i 0
    set j [expr $lges + 1]
    while {$i < $lges} {
	incr i
	set j [expr $j -1]
	set xUe(2,$i) $xUe_old($j)
	set yUe(2,$i) $yUe_old($j)
	set xSb(2,$i) $xSb_old($j)
	set ySb(2,$i) $ySb_old($j)
	set phi_1_old($i) $phi_1($j)
	set phi_2_old($i) $phi_2($j)
#	puts "i=$i, lges=$lges, phi1_old=$phi_1_old($i), phi2_old=$phi_2($i)"
    }

# Rueckwaerts Getriebe starten
    set autoUeBere 1
    set vSelbstberuehrungskurve yes
    set DrehRichTung [expr $DrehRichTung * (-1)]
    set lges_old $lges
    set i 0
    set maxV [min 10 lges_old]
    set lges_dieser_lauf 1
    while {$lges_dieser_lauf < 10 && $i < $maxV && $autoUeBere == "1"} {
	incr i
	set lges [expr $lges_old -$i]
	set phi1 $phi_1_old($lges)
	set phi2 $phi_2_old($lges)
	set xSb(2,0) $lges
	set xUe(2,0) $lges
	VChangeGetrLaengen
	set dphi2 [expr $phi_2_old($lges) - $phi_2_old([expr $lges-1])]
	VStarteGetriebeLauf 2 $dphi2
    }

# Asymptoten von Uebergangskurve entfernen
    set j 2
    set i 0
    while {$i < $j} {
	incr i
	set k 0
	set l 1
	while {$l < $xUe($i,0)} {
	    incr k
	    incr l
	    if {[expr $xUe($i,$k) * $xUe($i,$l)] < 0 || \
	    [expr $yUe($i,$k) * $yUe($i,$l)] < 0} then {
		set dx [expr $xUe($i,$k) * $xUe($i,$l)]
		set dy [expr $yUe($i,$k) * $yUe($i,$l)]
		set dl [expr $dx*$dx+$dy*$dy]
		set almax [max $al1 $al2]
		set almax [max $almax $al3]
		set almax [max $almax $al4]
		if {$dl > [expr $almax*$almax*100]} then {
		    set m 0
		    set l [expr $l - 1]
		    incr j
		    while {$l <  $xUe($i,0)} {
			incr m
			incr l
			set xUe($j,$m) $xUe($i,$l)
			set yUe($j,$m) $yUe($i,$l)
		    }
		    set xUe($i,0) $k
		    set xUe($j,0) $m
		    set xUe(0,0) $j
		}
	    }
	}
    }

# Asymptoten von Selbstberuehrungskurve entfernen
    set j 2
    set i 0
    while {$i < $j} {
	incr i
	set k 0
	set l 1
	while {$l < $xSb($i,0)} {
	    incr k
	    incr l
	    if {[expr $xSb($i,$k) * $xSb($i,$l)] < 0 || \
	    [expr $ySb($i,$k) * $ySb($i,$l)] < 0} then {
		set dx [expr $xSb($i,$k) * $xSb($i,$l)]
		set dy [expr $ySb($i,$k) * $ySb($i,$l)]
		set dl [expr $dx*$dx+$dy*$dy]
		set almax [max $al1 $al2]
		set almax [max $almax $al3]
		set almax [max $almax $al4]
		if {$dl > [expr $almax*$almax*100]} then {
		    set m 0
		    set l [expr $l - 1]
		    incr j
		    while {$l <  $xSb($i,0)} {
			incr m
			incr l
			set xSb($j,$m) $xSb($i,$l)
			set ySb($j,$m) $ySb($i,$l)
		    }
		    set xSb($i,0) $k
		    set xSb($j,0) $m
		    set xSb(0,0) $j
		}
	    }
	}
    }
}
#############################################################

proc VStarteUebergangskurve {ausgangslage phi1__1 phi2__1 dphi2__1 \
    phi1__2 phi2__2 dphi2__2} {


    global DrehRichTung
    global lges_dieser_lauf
    global phi1 phi2

	set lges_dieser_lauf 0
	if {$ausgangslage == 1} then {
	    set DrehRichTung 1
	    set phi1 $phi1__1
	    set phi1_stop [expr $phi1+15]
	   
	    while {$lges_dieser_lauf < "5" && $phi1 < $phi1_stop} {
		set phi1 [expr $phi1+abs($dphi2__1)]
		set phi2 $phi2__1
		set phi2_stop [expr $phi2+15]
		while {$lges_dieser_lauf < "5" && $phi2 < $phi2_stop} {
		    set phi2 [expr $phi2+$dphi2__1]
		    VChangeGetrLaengen
		    VStarteGetriebeLauf 1
		}
	    }
	} else {
	    set DrehRichTung -1
	    set phi1 $phi1__2
	    set phi1_stop [expr $phi1-15]
	    while {$lges_dieser_lauf < "5" && $phi1 > $phi1_stop} {
		set phi1 [expr $phi1-abs($dphi2__2)]
		set phi2 $phi2__2
		set phi2_stop [expr $phi2-15]
		while {$lges_dieser_lauf < "5" && $phi2 > $phi2_stop} {
		    set phi2 [expr $phi2-$dphi2__2]
		    VChangeGetrLaengen
		    VStarteGetriebeLauf 1
		}
	    }
	}
}
#############################################################
proc VGetriebeStep {dphi wend neu dphi2} {
    global cl1 cl3 getyp zusat mGetr d_minGetr d_maxGetr neFeman
    global al1 al2 al3 al4 phi1 phi2 phi_1 phi_2 ierr_schritt lges_u
    global iauto lges_dieser_lauf ischritte itausch neuer_tausch xSb
    global xUe eps180 wend_anz lges_dieser_lauf_all
    global al1ue al2ue al3ue al4ue
    global statuszeile lges_dieser_lauf_last KueUberschreiben

global p
#   phikrit 1 1 $mGetr $d_minGetr $d_maxGetr $cl1 $al1 $al2 $al3 $al4
    phikrit 1 0 $mGetr $d_minGetr $d_maxGetr $cl1 $al1 $al2 $al3 $al4

# geg.: wend phi_1(1) phi_2(1)
#	gam(i) ne (siehe analyse_programm)
#	iauto: iauto=1 --> viele schritte, iauto=0 --> 1 Schritt
    set iauto 1

    if {$neu == 1} then {
	 set lges_dieser_lauf_all 0
    }

    set lges_dieser_lauf 0
    set initialisiert 1
    set ischritte 0
    set ierr_schritt 0
    set itausch 0
    set neuer_tausch 0

    set phi_1(1) $phi1
    set phi_2(1) $phi2

    set ierr [VGetriebeIni2]
    if {$ierr == 0} then {
	set ischritte 1
	set lges_u 0
	if {$neu == "1"} then {
	    if {[string range [string toupper $KueUberschreiben] 0 0] == "J"} then {
		set xSb(0,0) 1
		set xUe(0,0) 1
	    } else {
		incr xSb(0,0)
		incr xUe(0,0)
		set xSb($xSb(0,0),0) 0
		set xUe($xUeb(0,0),0) 0
	    }
	    set al1ue $al1
	    set al2ue $al2
	    set al3ue $al3
	    set al4ue $al4
	}
	set phi_2(1) [set_winkel $phi_2(1) $cl1]
	VGetriebeStep2
	set phi_2(1) [set_winkel $phi_2(1) $cl1]

	.mbar.start configure -relief raised
	.mbar.stop configure -relief raised
	.mbar.zoom_i configure -relief raised
	.mbar.zoom_o configure -relief raised
	.mbar.zoom_l configure -relief raised
	VFrameWait

	set lges_dieser_lauf_last $lges_dieser_lauf
#	while {$iauto != 0}
	while {$iauto != 0 && $lges_dieser_lauf <= $wend_anz} {
	    set ierr \
		[VGetriebeStep1 $initialisiert $dphi $wend $neFeman \
		$eps180 $neu $dphi2]
	    VGetriebeStep2
	    if {$lges_dieser_lauf_last != $lges_dieser_lauf} then {
		incr lges_dieser_lauf_all
	    }
set statuszeile "Uebergangskurve: von ca. 180 Grad $lges_dieser_lauf_all Grad berechnet.    Abbruch durch STOP-Knopf"
	    set lges_dieser_lauf_last $lges_dieser_lauf
	}
    }
    set statuszeile "Uebergangskurve berechnet"
    return 0
}
###################################################################
proc VGetriebeStep1 {initialisiert dphi wend ne eps180 neu dphi2} {

    global p drad Pi statuszeile
    global phi_1 phi_2 phib iauto ischritte lges_dieser_lauf al1
    global ia ierr_schritt lges_u mGetr cl1 itausch global phi1 phi2
    global neuer_tausch phi1_alt phi2_alt gam xSb ySb
    global kbf ierr_schritt_old


# einen Schritt

	if {$lges_u > 1 && $initialisiert == 0} then {
puts "if 1"
#  Nur Kontrolle bis zur Schreibanweisung
	    set dpsi [expr $phi_2($lges_u)-$phi_2([expr $lges_u-1])]
	    set dphi_x [expr $phi_1($lges_u)-$phi_1([expr $lges_u-1])]

	    if {([expr abs($dpsi)] > [expr abs($dphi)*2.] && \
	    $itausch == 0 || \
	    [expr abs($dphi_x)] < [expr abs($dphi)*3./4.] && \
	    $itausch == 1) && \
	    [expr abs($dphi_x)-$dphi] < [exr $dphi/10.]} then {
# phi1 und phi2 vertauschen wenn
#			    - Schritt von phi2 zu gro und
#			    - zwischen den letzten beiden Berechnungen 
#			      kein Fehler aufgetreten ist
puts "if 2"

		set dphi_2 $phi_1([expr $lges_u-1])
		set dphi_1 $phi_2([expr $lges_u-1])
		set phi2_alt $dphi_2
		set phi1_alt $dphi_1
		set jdia 0
		VChangeGetrLaengen
#		    call change_getr(*1,p,nma_p,nvm_p,ie,nma_e \
#			nvm_e,re,nvm_re,ia,nma_a,nvm_a,ml \
#			phiver,cl1,dphi_1,dphi_2,jdia)
		set phi1 $dphi_1
		set phi2 $dphi_2
puts "dphi_2=$dphi2"
		if {$itausch == 0} then {
puts "if 3"
		    set itausch 1
		    if {[expr ($phi_2($lges_u)-$phi_2([expr $lges_u-1]))\
		    *$dphi] < 0} then {
			set dphi_ok [expr -1.*$dphi]
		    } else {
			set dphi_ok $dphi
		    }
		} elseif {$itausch == 1} then {
# phi1 und phi2 in ursprngliche Position zurck tauschen
puts "if 4"
		    set itausch 0
		    set dphi_ok $dphi
		}
		set neuer_tausch 1
	    } else {
puts "if 5"
		if {$itausch == 0} then {
puts "if 6"
		    set dphi_x $dphi
		} else {
#	dphi_x wird von oben bernommen
		}
		set dphi_2 $phi_2($lges_u)
		if {$neuer_tausch == 1} then {
puts "if 7"
		    set neuer_tausch 2
		} else {
puts "if 8"
		    set neuer_tausch 0
		}
	    }
	} else {
#puts "if 9"
	    set dphi_ok $dphi
	    set dphi_2 $phi_2($lges_u)
	    set neuer_tausch 0
	}
		
	if {$neu > 1 && $lges_u == 1 && $dphi2 != 0} then {
#puts "if lges_u=$lges_u, neu=$neu, dphi2=$dphi2"
		set dpsi $dphi2
	} elseif {$lges_u == 1 || $neuer_tausch >= 1} then {
	    set dpsi 0.
	} else {
	    set dpsi [expr $phi_2($lges_u)-$phi_2([expr $lges_u-1])]
	    if {$dpsi == 0} then {
		return 1
	    } elseif {$ierr_schritt == 0 && $ierr_schritt_old > 1} then {
		set dpsi [expr $dpsi/$ierr_schritt_old]
#puts "phi_1([expr $lges_u-1])=$phi_1([expr $lges_u-1]), phi_2([expr $lges_u-1])=$phi_2([expr $lges_u-1])]"
	    }
	}
#puts "phi_1($lges_u)=$phi_1($lges_u), phi_2($lges_u)=$phi_2($lges_u), ierr_schritt=$ierr_schritt"

	if {$dphi_ok == 0} then {
	    return 1
	}
	set phi1 [antr_schritt $lges_u $p(2,10) $dphi_ok \
		$ierr_schritt $neuer_tausch 1 $eps180]
	if {$p(3,9) < 0} then {
	    set kb 1
	} else {
	    set kb -1
	}

	set phi_neu $phib(2)
	set kbf(2) [kbvphi_2 2 $mGetr $kb $cl1]
	set p(2,10) $phi1
	if {$kbf(2) >= 0} then {
	    set p(3,10) [expr abs($p(3,10))]
	} else {
	    set p(3,10) [expr -1.*abs($p(3,10))] 
	}

#puts "phi2=$phi2, dphi_2=$dphi_2, dpsi=$dpsi neuer_tausch=$neuer_tausch"
	set phi2 [antr_schritt $lges_u $dphi_2 $dpsi \
		$ierr_schritt $neuer_tausch 2 $eps180]
	if {$p(6,9) < 0} then {
	    set kb 1
	} else {
	    set kb -1
	}

	if {$itausch == 1} then {set $phi_neu $phib(2)}
	set kbf(2) [kbvphi_2 2 $mGetr $kb $cl1]
	if {$ierr_schritt != 0} then {
	    puts "phi1=$phi1, phi2=$phi2"
	}
	set list [ausgangslage_m $phi1 $phi2 $kbf(2) $al1]
	set ierr [lrange $list 0 0]
	set erg [lrange $list 1 1]
	if {$ierr != 0} then {
	    set ierr_para 1
	} else {
		if {$lges_u > 2 && $ierr_schritt == 0} then {
		    set ia(1,2) [expr abs($erg)/$drad]
		    if {$ia(1,2) > 90} then {
			set ia(1,2) [expr 180-$ia(1,2)]
		    }
		    if {$ia(1,2) < 2} then {set ia(1,2) 2}
		} else {
		    set ia(1,2) 5
		}
		if {$iauto == 0} then {
		    edit_antrieb_g
		}
#	Speichern
		if {$ierr_schritt != 0 || $neuer_tausch == 1} then {
#		    call speichern(*1,name_dat,p,nma_p,nvm_p, \
#			ie,nma_e,nvm_e,re,nvm_re,gx,gy,ia,nma_a, \
#			nvm_a,ra,nvm_ra,i_d,nma_d,nvm_d,menuzeile,title\
#			ig,nma_g,nvm_g,dir,ik,nma_k,nvm_k,rk,1)
		    set lesetyp 0
		} else {
		    set lesetyp 1
		}

		if {$iauto == 0} then {
		    set idia 1
		} else {
		    set idia 0
		}
#		set ierr [analyse_programm " " $idia $lesetyp $ne]
		set ierr [VGetriebeIni2]
		if {$ierr != 0} then {
puts "VGetriebeStep1: no VModifyGetr"
#		    VModifyGetr all
		}
	}

# maximal 19 Fehlerhafte Schritte zulassen
	if {$ierr == 0} then {
	    set ierr_schritt_old $ierr_schritt
	    set ierr_schritt 0
	    incr lges_dieser_lauf
	} else {
	    set ierr_schritt_old $ierr_schritt
	    incr ierr_schritt
	}

#	if {$ierr_schritt <= 3 && $neuer_tausch != 1} then 
	if {$ierr_schritt <= 19 && $neuer_tausch != 1} then {
#puts "phi1=$phi1, phi2=$phi2"
	    if {$ierr == 0} then {
		set ischritte 1
	    } else {
		set ischritte 0
	    }

	    if {$dphi > 0} then {
		if {[expr $wend-$dphi/2.] < $phi_neu} then {
		    set iauto 0
puts "1: iauto=$iauto"
		    set ischritte 0
		}
	    } else {
		if {[expr $wend+$dphi/2.] > $phi_neu} then {
		    set iauto 0
puts "2: iauto=$iauto"
		    set ischritte 0
		}
	    }
#puts "lges_dieser_lauf=$lges_dieser_lauf"
VFrameWait
	    if {$lges_dieser_lauf == 5} then {
# prfen, ob ku identisch mit Gelenk A oder B ist
		set i 0
		set iok 0
		while {$i < $lges_dieser_lauf && $iok == 0} {
		    incr i
		    set iok 1
		    set steigung8 [expr $gam($i)*$drad]
		    set dl1 $p(2,9)
		    set dl2 $p(3,9)
		    set dl3 $p(3,10)
		    set dl4 $p(4,9)
		    set xs [expr $dl1*cos($phi_1($i)*$drad)]
		    set ys [expr $dl1*sin($phi_1($i)*$drad)]
		    set dx [expr $xSb(1,$i)/1000.]
		    set dy [expr $ySb(1,$i)/1000.]
		    set list [trans8_x_xs_st $xs $ys $steigung8 $dx $dy]
		    set dx [lrange $list 0 0]
		    set dy [lrange $list 1 1]
		    set eps1 [min [expr abs($dl1)] [expr abs($dl2)]]
		    set eps2 [min [expr abs($dl3)] [expr abs($dl4)]]
		    set eps [min $eps1 $eps2]
		    set unendlich [expr $eps*1000000.]
		    set eps [expr $eps/10000]
		    if {[expr abs($dy)] < $eps} then {
			if {[expr dabs($dx)] < $eps} then {
#		ku identisch Gelenk A
			    set iok 0
			} elseif {[expr abs($dx)-abs($dl2)] < $eps} \
			then {
#		ku identisch Gelenk B
			    set iok 0
			}
		    } elseif {[expr abs($dx)] > $unendlich} then {
			if {[expr abs($dy)] > $unendlich} then {
#		ku liegt im unendlichen
			    set iok 0
			}
		    }
		}
		if {$iok == 0} then {
		    set statuszeile "Uebergangskurvenpunkte sind mit \
einem Koppelgelenk identisch"
		    puts $statuszeile
		    set iauto 0
puts "3: iauto=$iauto"
		    set ischritte 0
		}
	    }
	} else {
	    set ischritte 0
	    set iauto 0
puts "4: iauto=$iauto"
	}
	set initialisiert 0
	return 0
}
#############################################################
proc VGetriebeStep2 {} {
    global ischritte neuer_tausch itausch phi1_alt phi2_alt lges_u
    global jtausch cl1 al1 al2 al3 al4 sbAl1 sbAl2 sbAl3 sbAl4
    global iauto dphi iStep2 drad xUe yUe
    global p xg1 yg1 xg1 xg2 phi_1 phi_2 gam gam2 xSb ySb x_ ip

    set clx $cl1
    if {$ischritte == 1} then {
	if {$neuer_tausch != 1} then {
	    incr lges_u
	    if {$lges_u == 1} then {
		set sbAl1 $al1
		set sbAl2 $al2
		set sbAl3 $al3
		set sbAl4 $al4
	    }
	}
#	    Gestellfest bei m-Getriebe
	set jtausch($lges_u) $itausch
	set phi_1($lges_u) $p(2,10)
	set phi_1($lges_u) [\
	    next_winkel $phi_1($lges_u) $phi1_alt $clx $dphi 1]
	set xg1($lges_u) $p(7,1)
	set yg1($lges_u) $p(7,2)
	set x5 $x_($ip(5,1))
	set y5 $x_($ip(5,2))
	set xg2($lges_u) $x_($ip(8,1))
	set yg2($lges_u) $x_($ip(8,2))
	set phi_2($lges_u) [expr atan2($y5-$p(1,2),$x5-$p(1,1))/$drad]
	set phi_2($lges_u) [set_winkel $phi_2($lges_u) $cl1]
	set phi_2($lges_u) \
	    [next_winkel $phi_2($lges_u) $phi2_alt $clx $dphi 2]
	if {$itausch == 1 && $iauto == 1 && $lges_u > 1} then {
#	Einzelschritte abbrechen, wenn Antriebsrichtung sich umkehrt
# (nur beim getauschten Getriebe mglich)
	    if {$neuer_tausch == 0} then {
		if {$dphi > 0} then {
		    if {$phi_2($lges_u) < $phi_2([expr $lges_u-1])} then {
			puts "phi_1($iStep2)=$phi_1($iStep2), \
phi_2($iStep2)=$phi_2($iStep2)]"
			set iauto 0
			set ischritte 0
			set lges_u [expr $lges_u-1]
puts "neuer_tausch=0, lges_u=lges_u-1=$lges_u"
			return
		    }
		} else {
		    if {$phi_2($lges_u) > $phi_2([expr $lges_u-1])} then {
			puts "phi_1($iStep2)=$phi_1($iStep2), \
phi_2($iStep2)=$phi_2($iStep2)]"
			set iauto 0
			set ischritte 0
			set lges_u [expr $lges_u-1]
puts "neuer_tausch=0, lges_u=lges_u-1=$lges_u"
			return
		    }
		}
	    }
	}
	set gam($lges_u) [expr atan2([expr $p(3,2)-$p(2,2)],\
	    [expr $p(3,1)-$p(2,1)])/$drad]
	set gam2($lges_u) [expr atan2([expr $p(6,2)-$p(5,2)],\
	    [expr $p(6,1)-$p(5,1)])/$drad]
	set xSb(1,$lges_u) [expr $x_($ip(11,1))*1000.]
	set ySb(1,$lges_u) [expr $x_($ip(11,2))*1000.]
	set xSb(1,0) $lges_u
	set xUe(1,0) $lges_u
	set list [trans8_x_xs_2p [expr $p(2,1)*1000.] [expr $p(2,2)*1000.] \
	    [expr $p(3,1)*1000.] [expr $p(3,2)*1000.] \
	    $xSb(1,$lges_u) $ySb(1,$lges_u)]
	set xUe(1,$lges_u) [lrange $list 0 0]
	set yUe(1,$lges_u) [lrange $list 1 1]
    }
}
#############################################################
# Ermitteln der Ausgangslage fr das m-Getriebe

proc ausgangslage_m {phi1 phi2 kb al1} {

    global p drad statuszeile

#	subroutine ausgangslage_m(*,phi1,phi2,kb,al1,
#     + 	     p,nma_p,nvm_p,zurueck,ie,nma_e,nvm_e,re,nvm_re,
#     + 	     ia,nma_a,nvm_a,ra,nvm_ra,dpi,drad,erg,idialog,ierr)

# geg.: alles bis auf erg
# ges.: p,erg,ierr
# Aufruf:  set list [ausgangslage_m ...]
#	   list = "$ierr $erg"


# phi1	      : 1. Ausgangswinkel (PhiA)
# phi2	      : 2. Ausganswinkel
# kb	      : Bewegungbereichskennzahl fr 2. Ausgangswinkel
# al1	      : Lnge des Gliedes 1
# p()	      : Feld mit Daten der Punkte und Winkel
#		(siehe Upro open_name_a)
# drad	      : siehe Upro grad_rad_d
# erg	      : Abweichung von Deck- bzw. Strecklage in Grad
# ierr	      : Kennzahl
#		ierr=0 --> es ist kein Fehler aufgetreten
#		ierr=1 --> es ist ein Fehler aufgetreten
#....................................................................
#.....................................................................
	set ierr 0

#	set p(5,10) $phi2

	set p(6,9) [expr abs($p(6,9))]
	if {$kb > 0} then {set p(6,9) [expr -1.*abs($p(6,9))]}

	set ie_p 2
	set p(2,1) [expr $al1*cos($phi1*$drad)/1000.]
	set p(2,2) [expr $al1*sin($phi1*$drad)/1000.]
#	 set p(2,10) [expr atan2($p(2,2),$p(2,1))/$drad]
	set p(2,10) $phi1
	set_zurueck $ie_p
#-VP	set ie_p [expr -1*$ie_p]
	set ie_p2 [VParametric $ie_p]
	if {$ie_p2 > 0} then {
	    set ie_p 5
	    set p(5,1) [expr $al1*cos($phi2*$drad)/1000.]
	    set p(5,2) [expr $al1*sin($phi2*$drad)/1000.]
#	    set p(5,10) [expr atan2($p(5,2),$p(5,1))/$drad]
	    set p(5,10) $phi2
	    set_zurueck $ie_p
#-VP	    set ie_p [expr -1*$ie_p]
	    set ie_p [VParametric $ie_p]
	    if {$ie_p < 0} then {
		set ierr 1
		set erg " "
		set statuszeile "Neue Getriebelage weist Fehler auf"
		puts $statuszeile
	    } else {
#	Antrieb
		set list [antr_ausg_lage]
		set ityp [lrange $list 0 0]
		set erg [lrange $list 1 1]
		if {$ityp > 0} then {
		    setz_decklage $erg 1
		} else {
		    set erg 0
		}
	    }
	} else {
	    set ierr 1
	    set erg " "
	    set statuszeile "Neue Getriebelage weist Fehler auf"
	    puts $statuszeile
	}
	return "$ierr $erg"
}
#############################################################
# Umrechnen eines Winkels in den vorgegebenen Winkelbereich

proc set_winkel {phi cl1} {
 
    global dpmax dpmin

    if {[string range $cl1 1 1] == "u"} then {
#umlaufende angetriebene Getriebe
	if {$cl1 == "2u"} then {
	    set difwinkel 720.
	    set maxwinkel 720.
	    set minwinkel 0.
	} else {
	    set difwinkel 360.
	    set maxwinkel 360.
	    set minwinkel 0.
	}
    } else {
	set difwinkel 360.
	set maxwinkel $dpmax
	set minwinkel $dpmin
    }

    while {$phi < $minwinkel} {
	set phi [expr $phi+$difwinkel]
    }
    while {$phi > $maxwinkel} {
	set phi [expr $phi-$difwinkel]
    }
    return $phi
}
#############################################################
# Ermitteln des Winkels phi, der in der nhe des Winkels phi2 liegt, so,
# da die Anzahl der Rotationen stimmt

proc next_winkel {phi phi2 cl1 dphi which} {

#	subroutine next_winkel(phi,phi2)

global dpmax dpmin kbf

# geg.: phi,phi2
# ges.: phi
# Aufruf: set phi [next_winkel ...]

# phi	geg.: Winkel in Grad
#	ges.: Phi+n*360 mit n=ganzer Zahl
# phi2	    : Winkel in Grad, in dessen Nhe phi zu liegen kommen soll
#................................................................
#................................................................
    if {[string range $cl1 1 1] == "u"} then {
#umlaufende angetriebene Getriebe
	if {$cl1 == "2u"} then {
	    set maxwinkel 720.
	} else {
	    set maxwinkel 360.
	}
	set maxwD2 [expr $maxwinkel/2.]

	while {$phi> $maxwinkel} {
	    set phi [expr $phi-$maxwinkel]
	}
	while {$phi < 0.} {
	    set phi [expr $phi+$maxwinkel]
	}

	while {$phi < [expr $phi2-$maxwD2]} {
	    set phi [expr $phi+$maxwinkel]
	}
	
	while {$phi > [expr $phi2+$maxwD2]} {
	    set phi [expr $phi-$maxwinkel]
	}
	return $phi
    } else {
# schwingend angetriebene Getriebe
#puts "dpmax=$dpmax, dpmin=$dpmin, phi=$phi"
	if {$phi > $dpmax} then {
	    set phi [expr $dpmax-$dphi]
	    set kbf($which) [expr -1.*$kbf($which)]
	} elseif {$phi < $dpmin} then {
	    set phi [expr $dpmin+$dphi]
	    set kbf($which) [expr -1.*$kbf($which)]
	}
	return $phi
    }
}
#############################################################
# Ermitteln der neuen Antriebswinkel

proc antr_schritt {lges phi_g dphi ierr ineu ilage eps} {

    global phi_1 phib phi_2

#	subroutine antr_schritt(lges,phi1,phi_g,dphi,dkb,phib,kb,ierr,
#    +		phi_1,ineu)

# geg.: lges,phi_g,dphi,ierr,phi_1,ineu,ilage,eps
# ges.: phi1 bzw. phi2 ,phib
# Aufruf: set phi1 [antr_schritt ...]

# lges:    Belegte Lnge des Feldes phi1
# phi1:    Antriebswinkel fr neue Lage
# phi_g:   Antriebswinkel der alten Lage
# dphi	   Differenzwinkel zwischen alter und neuer Lage
# phib()    Feld mit altem und neuen Antriebswinkel
# kb	   Bewegungbereichskennzahl
# ierr	   Kennzahl
#	   ierr=0  --> bei der Ermittlung des Antriebswinkel ist kein 
#		       Fehler aufgetreten
#	   ierr<>0 --> bei der Ermittlung des Antriebswinkels sind ierr
#		       Fehler aufgetreten
# phi_1()  Feld mit Antriebswinkeln
# ineu	   Kennzahl
#	   ineu=1 --> wie bei lges=1 liegt fr neuen Antriebswinkel 
#		      keine Information im Feld phi_1() vor
#	   ineu<>1 --> fr neuen Antriebswinkel liegt Information im 
#		      Feld phi_1() vor
# ilage    ilage=1: phi_1 ist gegegeben
#	   ilage=2: phi_2 ist gegegeben
# eps	   minimal erlaubte Abweichung von 180 Grad etc.
#....................................................................
#...................................................................
	if {$lges == 1 || $ineu == 1} then {
	    set phib(1) $phi_g
	    set phi1 [expr $phi_g+$dphi]
	} else {
	    if {$ilage == 1} then {
		set phi_x $phi_1($lges)
	    } else {
		set phi_x $phi_2($lges)
	    }
	    set phib(1) $phi_x
	    set phi1 [expr $phi_x+$dphi*($ierr+1)]
	}

# Winkel 0, 180, 360, 540, 720 Grad berspringen
	set test 0
	while {($test < $eps) && ($dphi != 0)} {
	    set test [expr fmod(abs($phi1)+$eps,180.)-$eps]
	    if {$test < $eps} then {
		set phi1 [expr $phi1+$dphi]
	    }
	}

	if {$dphi > 0} then {
	    set phib(2) $phi1
	} else {
	    set phib(2) $phib(1)
	    set phib(1) $phi1
	}
	return $phi1
}
#############################################################
proc VGetriebeInitialisieren {neu} {

global neFeman lges_u
# ges: ierr

    set ierr 0
    set iauto 0
    set list [VSam2Feman]
    set ierr [lrange $list 0 0]
    set neFeman [expr [lrange $list 1 1] -1]
    if {$ierr != 0} then {return $ierr}
    set ierr [VGetriebeIni2]
    if {$ierr != 0} then {
	VModifyGetr all
    }
    set lges_u 0
    return $ierr
}
############################################################
proc VGetriebeIni2 {} {

    global ra statuszeile Pi neFeman drad ischritte

    set list [antr_ausg_lage]
    set ityp [lrange $list 0 0]
    set erg [lrange $list 1 1]
    setz_decklage $erg 1
    edit_antrieb_g
    set erg $ra(1,1)
    while {$erg > $Pi} {
	set erg [expr $erg-2.*$Pi]
    }
    while {$erg < -$Pi}  {
	set erg [expr $erg+2.*$Pi]
    }

    if {[expr abs($erg)] > [expr $Pi/15.]} then {
	set ierr 1
	set statuszeile \
	    "Antriebswinkel ist zu gross ([expr $erg/$drad])"
	puts "$statuszeile"
	fehlermelder2 "Der Winkel zwischen der schwarzen\n \
und der einzelnen blauen Getriebestange ist zu gross" \
	    "Der Winkel ist groesser als 12 Grad ([expr abs($erg/$drad)])"
	set fehlermelderWartet 0
	tkwait variable fehlermelderWartet
    } else {
	set ierr [analyse_programm " " 1 0 $neFeman]
	VShowIterativeGetrModifikation
    }
    return $ierr
}
###########################################################
proc VShowIterativeGetrModifikation {} {
    global p x_ phi2 drad
	set p(5,1) $x_(11)
	set p(5,2) $x_(12)
	set phi2 [expr atan2($x_(12),$x_(11))/$drad]
	set p(5,10) $phi2
#-VP	set ie_p5 [VParametric -5]
	set ie_p5 [VParametric 5]
	if {$ie_p5 <= 0} then {
	    set ierr 1
	    set statuszeile "Fehler beim Aendern von Getriebeparametern"
	    puts $statuszeile
	}
}
###########################################################
# Abspeichern der Topologie fr das Programm FEMAN

proc speicher_feman_topologie {nx} {

#	subroutine speicher_feman_topologie(*,nr,i_absp,ia,nma_a,nvm_a,
#    +			p,nvm_p,ip,nma_p,nvm_ip,ie,nma_e,nvm_e,
#    +			idcb,ldcb,tabstring,lges,ierr,
#    +			ipara,nma_ipara,nvm_ipara)

global ie ia ip ipara p lges_e
global nvm_ip

# geg.: alles
# ges.: nrierr,ip (ipara)
#	Aufruf: set list [feman_antr ...]
#		list= $ierr $nr $l

# nr	      : Gleichungs-Nr.
# i_absp      : Kennzahl
#		i_absp=0 --> nur nr ermitteln, Daten nicht abspeichern
#		i_absp=1 --> Daten abspeichern
# ia	      : Integerfeld mit Daten fr Antrieb
#		(siehe Upro open_name_a)
# ip	      : INTEGER*2-Feld mit Zuordnung der Koordinaten-Nr. des 
#		Programms SAM zu Koordinaten-Nr des Programms FEMAN:
#		j=1 ... 2 -->
#		    ip(i,j) enthlt Koordinaten-Nr fr Programm FEMAN,
#		    wobei i die Punkt-Nr. und j die Koordinaten-Nr. des
#		    Programms SAM ist.
#		j=3 -->
#		    ip(i,j) enthlt Punkt-Nr. fr Programm SAM,
#		    wobei i die Koordinaten-Nr. fr Programm FEMAN ist
# nvm_ip      : Anzahl der Spalten des Feldes ip(,)
# ie()	      : INTEGER-Feld mit Daten der Elemente
#		(siehe Upro open_name_a)
# p()	      : Feld mit Daten der Punkte und Winkel
#		(siehe Upro open_name_a)
#		p(iele,5)=0 --> Element wurde noch nicht abgespeichert
#				Anschluelemente sind unbekannt
#		p(iele,5)=1 --> Element wurde noch nicht abgespeichert
#				Anschluelemente im Punkt 1 sind bekannt
#		p(iele,5)=2 --> Element wurde noch nicht abgespeichert
#				Anschluelemente im Punkt 2 sind bekannt
#		p(iele,5)=3 --> wie 1 und 2 zusammen
#		p(iele,5)=16 --> Element wurde schon abgespeichert
# lges	      : aktuelle Zeilen-Nr. der Datei
# ierr	      : Kennzahl
#		ierr=1 --> Element ist kein Stab
#		ierr=0 --> Es trat kein Fehler beim Abarbeiten dieses
#			   Upros auf
# ipara(,)    : Feld mit Punkt-Nr. des Programms SAM zum Ermitteln der
#		Parameter fr Programm FEMAN
#		ipara(i,3)=0 --> Parameter = Abstand der Punkte mit den
#				 Nummern ipara(i,1) und ipara(i,2)
#		ipara(i,3)<>0--> Parameter = Winkel zwischen der Geraden
#				 1 durch die Punkte mit den Nummern
#				 ipara(i,1) und ipara(i,2) und der 
#				 Geraden 2 durch die Punkte mit den 
#				 Nummern ipara(i,2) und ipara(i,3)
# nma_ipara:  : Anzahl der Zeilen des Feldes ipara(,)
# nvm_ipara:  : Anzahl der Spalten des Feldes ipara(,)
#............................................................
#..............................................................
	set nvm_ipara $nvm_ip
	set nma_ipara $nx
	set i 0
	while {$i < $lges_e} {
	    incr i
	    set p($i,5) 0.
	}

	set i 0
	while {$i < $nma_ipara} {
	    incr i
	    set j 0
	    while {$j < $nvm_ipara} {
		incr j
		set ipara($i,$j) 0
	    }
	}
	set list [feman_antr]
	set ierr [lrange $list 0 0]
	set nr [lrange $list 1 1]
	set l [lrange $list 2 2]
	if {$ierr != 0} then {return "$ierr $nr $l"}

	set i 0
	while {$i < $lges_e} {
	    incr i
	    if {$p($i,5) != 16.} then {
		set list [speicher_elem_f_feman $nr $l $i]
		set ierr [lrange $list 0 0]
		set nr [lrange $list 1 1]
		set l [lrange $list 2 2]
		if {$ierr != 0} then {return "$ierr $nr $l"}
	    }
	}

	return "$ierr $nr $l"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Abspeichern der angetriebenen Elemente fr das Programm FEMAN

proc feman_antr {} {

#	subroutine feman_antr(*,i_absp,nr,l,ia,nma_a,nvm_a,ie,nma_e,
#    +	   nvm_e,p,nvm_p,ip,nma_p,nvm_ip,idcb,ldcb,tabstring,lges,
#    +	   ipara,nma_ipara,nvm_ipara)

    global ie ia ip ipara p statuszeile lges_e
    global ie_p1 ie_p2 ie_w1 ie_w2

# geg.: alles
# ges.: nr l ierr
#	Aufruf: set list [feman_antr ...]
#		list= $ierr $nr $l

# i_absp      : Kennzahl
#		i_absp=0 --> nur nr ermitteln, Daten nicht abspeichern
#		i_absp=1 --> Daten abspeichern
# nr	      : Gleichungs-Nr.
# l	      : Zeilen-Nr. in de D-Matrix
# ia	      : Integerfeld mit Daten fr Antrieb
#		(siehe Upro open_name_a)
# nma_a       : Definerte Anzahl an Zeilen der Felder ia(),ra()
# nvm_a       : Definerte Anzahl an Spalten des Feldes ia()
# ie()	      : INTEGER-Feld mit Daten der Elemente
#		(siehe Upro open_name_a)
# nma_e       : Definerte Anzahl an Zeilen des Feldes ie()
# nvm_e       : Definerte Anzahl an Spalten des Feldes ie()
# ip	      : siehe Upro speicher_feman_topologie
# nmv_ip      : Anzahl der Spalten des Feldes ip(,)
# p()	      : Feld mit Daten der Punkte und Winkel
#		(siehe Upro open_name_a)
# nma_p       : Definerte Anzahl an Zeilen des Feldes p()
# nvm_p       : Definerte Anzahl an Spalten des Feldes p()
# idcb	      : Daten-Control-Block der geffneten TAB-Datei
# ldcb	      : definierte Lnge von idcb()
# tabstring   : Hilfsstring zum handhaben der TAB-Datei
# lges	      : aktuelle Zeilen-Nr. der Datei
# ipara(,)    : Feld mit Punkt-Nr. zum Ermitteln der PARAMETER
#		siehe Upro speicher_feman_topologie
# nma_ipara:  : Anzahl der Zeilen des Feldes ipara(,)
# nvm_ipara:  : Anzahl der Spalten des Feldes ipara(,)
#............................................................
#..............................................................

# Bestimmen des Antriebs

	set ierr 0
	set nr 1
	set l 1
	if {$ia(0,2) < 0} then {
# Deformationsparameter
	    set ian $ia(0,1)
	    if {$ian == 0} then {
		set statuszeile "Fehler: Definieren Sie zuerst\
 den Antrieb vollstndig"
		puts $statuszeile
		set ierr 1
		return "$ierr $nr $l"
	    }
	    if {$ie($ian,1) == 21} then {
#	Hinge
		find_elem_punkte_winkel $ian
		set ian_w1 $ie_w1
		set ian_w2 $ie_w2

		set iean1 0
		set iean2 0
		set i 0
		while {$i < $lges_e && ($iean1 == 0 || $iean2 == 0)} {
		    incr i
		    if {$i != $ian} then {
			find_elem_punkte_winkel $i
			if {$ie_w1 == $ian_w1 || $ie_w2 == $ian_w1} \
			then {
			    set iean1 $i
			    if {$ie_w1 == $ian_w1} then {
				set lage1 1
			    } else {
				set lage1 -1
			    }
			} elseif {$ie_w1 == $ian_w2 || \
			$ie_w2 == $ian_w2} then {
			    set iean2 $i
			    if {$ie_w1 == $ian_w2} then {
				set lage2 1
			    } else {
				set lage2 -1
			    }
			}
		    }
		}
		if {$iean1 == 0 || $iean2 == 0} then {
		    set statuszeile "Fehler: Antriebselement vom Typ \
Hinge ist noch nicht implemantiert"
		    puts $statuszeile
		    set ierr 1
		    return "$ierr $nr $l"
		}
		set i1 $ie($iean1,1)
		set i2 $ie($iean2,1)
		if {$i1 == 1 || $i1 == 2 || $i1 == 11} then {
		    find_elem_punkte_winkel $iean1
		    set list [speicher_feman_stab \
			$nr 2 $l -1. $iean1 $lage1]
		    set ierr [lrange $list 0 0]
		    set nr [lrange $list 1 1]
		    set l [lrange $list 2 2]
		    if {$ierr != 0} then {return "$ierr $nr $l"}
		    find_elem_punkte_winkel $iean2
		    set list [speicher_feman_stab \
			$nr 2 $l 1. $iean2 $lage2]
		    set ierr [lrange $list 0 0]
		    set nr [lrange $list 1 1]
		    set l [lrange $list 2 2]
		    if {$ierr != 0} then {return "$ierr $nr $l"}
		    set list [speicher_elem_f_feman $nr $l $iean1]
		    set ierr [lrange $list 0 0]
		    set nr [lrange $list 1 1]
		    set l [lrange $list 2 2]
		    if {$ierr != 0} then {return "$ierr $nr $l"}
		    set list [speicher_elem_f_feman $nr $l $iean2]
		    set ierr [lrange $list 0 0]
		    set nr [lrange $list 1 1]
		    set l [lrange $list 2 2]
		    if {$ierr != 0} then {return "$ierr $nr $l"}
		}
	    } elseif {$ie($ian,1) == 1 || $ie($ian,1) == 2 || \
	    $ie($ian,1) == 11} then {
# Lnge eines TRUSS, BEAM oder SLIDER-Elements ndern
		set list [speicher_elem_f_feman $nr $l -$ian]
		set ierr [lrange $list 0 0]
		set nr [lrange $list 1 1]
		set l [lrange $list 2 2]
		if {$ierr != 0} then {return "$ierr $nr $l"}
	    } else {
		set statuszeile "Fehler: Antriebsart noch nicht \
implementiert"
		puts $statuszeile
		set ierr 1
		return "$ierr $nr $l"
	    }
	} else {
# Positionsparameter
	    set ian $ia(0,1)
	    set i_test [expr fmod(int($p($ian,3)),8)]
	    if {$i_test >= 4} then {
		set i_test 4
	    } else {
		set i_test 0
	    }
	    if {$i_test == 4} then {	  
#	Positionsparameter Winkel
		set i 1
		set istop 0
		while {$i <= $lges_e && $istop == 0} {
		    if {$ie($i,1) == 1 || $ie($i,1) == 2 || \
		    $ie($i,1) == 11} then {
			find_elem_punkte_winkel $i
			if {$ie_w1 == $ian} then {
			    set lage 1
			    set istop 1
			} elseif {$ie_w2 == $ian} then {
			    set lage -1
			    set istop 1
			} else {
			    incr i
			}
		    } else {
			incr i
		    }
		}
		if {$istop == 1} then {
		    find_elem_punkte_winkel $i
		    set list [speicher_feman_stab \
			$nr 2 $l 1. $i $lage]
		    set ierr [lrange $list 0 0]
		    set nr [lrange $list 1 1]
		    set l [lrange $list 2 2]
		    if {$ierr != 0} then {return "$ierr $nr $l"}
		} else {
		    set statuszeile "Fehler: Antriebsart ist noch \
nicht implementiert"
		    puts $statuszeile
		    set ierr 1
		    return "$ierr $nr $l"
		}
	    } else {
		set statuszeile "Fehler: Antriebsart ist noch \
nicht implementiert"
		puts $statuszeile
		set ierr 1
		return "$ierr $nr $l"
	    }
	}
	return "$ierr $nr $l"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Abspeichern eines binren Stabelements fr das Programm FEMAN

proc speicher_feman_stab {nr k l fm iele lage} {

#	subroutine speicher_feman_stab(*,i_absp,nr,k,l,fm,iele,
#     +    ip,nma_p,nvm_ip,ie,nma_e,nvm_e,idcb,ldcb,tabstring,lges,ierr,
#     +    lage,ipara,nma_ipara,nvm_ipara)
	
    global ie ip ipara ie_p1 ie_p2 lxa itypa irow fmult

# geg.: alles
# ges.: nr,l,lges,ierr,ipara ?
# ges.: nr l ierr (ipara)
#	Aufruf: set list [speicher_feman_stab ...]
#		list= $ierr $nr $l

# i_absp      : Kennzahl
#		i_absp=0 --> nur nr ermitteln, Daten nicht abspeichern
#		i_absp=1 --> Daten abspeichern
# nr	      : Gleichungs-Nr.
# k	      : Typ des Formparameters
#		k=1  --> Lnge	(nur Abspeichern, wenn Lnge konstant
#				ist)
#		k=-1 --> wie k=1, aber ohne Prfung abspeichern
#		k=2  --> Winkel (abspeichern ohne Prfung)
# l	      : Zeilen-Nr. in de D-Matrix
# fm	      : Multiplikationsfaktor dieses Formparameters
# iele	      : Nr. des Elements (TRUSS, BEAM oder SLIDER), das
#		abgespeichert werden soll
# ip	      : siehe Upro speicher_feman_topologie
# nmv_ip      : Anzahl der Spalten des Feldes ip(,)
# ie()	      : INTEGER-Feld mit Daten der Elemente
#		(siehe Upro open_name_a)
# nma_e       : Definerte Anzahl an Zeilen des Feldes ie()
# nvm_e       : Definerte Anzahl an Spalten des Feldes ie()
# p()	      : Feld mit Daten der Punkte und Winkel
#		(siehe Upro open_name_a)
# nma_p       : Definerte Anzahl an Zeilen des Feldes p()
# nvm_p       : Definerte Anzahl an Spalten des Feldes p()
# idcb	      : Daten-Control-Block der geffneten TAB-Datei
# ldcb	      : definierte Lnge von idcb()
# tabstring   : Hilfsstring zum handhaben der TAB-Datei
# lges	      : aktuelle Zeilen-Nr. der Datei
# ierr	      : Kennzahl
#		ierr=1 --> Element ist kein Stab
#		ierr=0 --> Es trat kein Fehler beim Abarbeiten dieses
#			   Upros auf
# lage	      : Kennzahl
#		lage=1	--> Richtung des Elements ist ok
#		lage=-1 --> Richtung des Elements wird invertiert
# ipara(,)    : Feld mit Punkt-Nr. zum Ermitteln der PARAMETER
#		siehe Upro speicher_feman_topologie
# nma_ipara:  : Anzahl der Zeilen des Feldes ipara(,)
# nvm_ipara:  : Anzahl der Spalten des Feldes ipara(,)
#............................................................
#..............................................................
	set ierr 1
	if {$k == 1} then {
	    if {$ie($iele,1) == 2} then {
# Lnge nicht konstant
		set ierr 0
		return "$ierr $nr $l"
	    } elseif {$ie($iele,1) == 1 || $ie($iele,1) == 11} then {
		if {[expr fmod($ie($iele,2),1)] == 1} then {
# Lnge ist nicht konstant
		    set ierr 0
		    return "$ierr $nr $l"
		}
	    } else {
		return "$ierr $nr $l"
	    }
	} elseif {$k == 2 || $k == -1} then {
	} else {
	    return "$ierr $nr $l"
	}
# Topologie abspeichern
	set itypa($nr) $k
	set irow($nr) $l
	set fmult($nr) $fm
	find_elem_punkte_winkel $iele
	if {$lage == 1} then {
	    set lxa(1,$nr) $ip($ie_p1,1)
	    set lxa(2,$nr) $ip($ie_p1,2)
	    set lxa(3,$nr) $ip($ie_p2,1)
	    set lxa(4,$nr) $ip($ie_p2,2)
	} else {
	    set lxa(3,$nr) $ip($ie_p1,1)
	    set lxa(4,$nr) $ip($ie_p1,2)
	    set lxa(1,$nr) $ip($ie_p2,1)
	    set lxa(2,$nr) $ip($ie_p2,2)
	}

	incr nr
	if {$fm > 0} then {
	    if {$ipara($l,3) == 0} then {
# Abstand oder Winkel eines Elements
		if {$k == 2} then {
#	Winkel eines Elements zum Gestell
		    if {$lage == 1} then {
			set ipara($l,2) $ie_p1
			set ipara($l,3) $ie_p2
		    } else {
			set ipara($l,3) $ie_p1
			set ipara($l,2) $ie_p2
		    }
		} else {
#	Abstand
		    set ipara($l,1) $ie_p1
		    set ipara($l,2) $ie_p2
		}
	    } else {
# Winkel zwischen 2 Elementen
		if {$ie_p2 == $ipara($l,2)} then {
		    set ipara($l,1) $ie_p1
		} elseif {$ie_p1 == $ipara($l,2)} then {
		    set ipara($l,1) $ie_p2
		} else {
		    set izwi $ipara($l,2)
		    set ipara($l,2) $ipara($l,3)
		    set ipara($l,3) $izwi
		    if {$ie_p2 == $ipara($l,2)} then {
			set ipara($l,1) $ie_p1
		    } elseif {$ie_p1 == $ipara($l,2)} then {
			set ipara($l,1) $ie_p2
		    }
		}
	    }
	    incr l
	} else {
	    set ipara($l,2) $ie_p1
	    set ipara($l,3) $ie_p2
	}
	set ierr 0

	return "$ierr $nr $l"
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
proc fmod4 {i test} {
# i=1 : test auf gerade/ungerade --> i_test = 0 oder 1
# i=2 : test ob Bit 2 gesetzt ist --> i_test = 0, 1 oder 2(gesetzt)
	    if {$i == 1} then {
		set i_test [expr fmod(int($test),2)]
	    } else {
		set i_test [expr fmod(int($test),4)]
		if {$i_test == 2 || $i_test == 3} then {
		    set i_test 2
		}
	    }
	    return $i_test
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Abspeichern eines SAM-Elements als Zeile fr FEMAN und prfen,
# ob weitere Elemente zum gleichen Glied gehren. Wenn ja, fixierten
# Winkel abspeichern und Anschluelement markieren

proc speicher_elem_f_feman {nr l jele} {

#	subroutine speicher_elem_f_feman(*,i_absp,nr,l,jele,
#     + 		 p,nvm_p,ip,nma_p,nvm_ip,ie,nma_e,nvm_e,
#     + 		 idcb,ldcb,tabstring,lges,ierr,
#     + 		 ipara,nma_ipara,nvm_ipara)
	
    global ie ip ipara p ie_p1 ie_p2 ie_w1 ie_w2 lges_e

# geg.: alles
# ges.: nr,l,lges,ierr,ipara ?
# ges.: nr l ierr 
#	Aufruf: set list [speicher_elem_f_feman ...]
#		list= $ierr $nr $l

# i_absp      : Kennzahl
#		i_absp=0 --> nur nr ermitteln, Daten nicht abspeichern
#		i_absp=1 --> Daten abspeichern
# nr	      : Gleichungs-Nr.
# l	      : Zeilen-Nr. in de D-Matrix
# jele	      : Nr. des Elements (TRUSS, BEAM oder SLIDER), das
#		abgespeichert werden soll
#		jele<0 --> |jele|=Nr. des Elements, und Lnge dieses 
#			   Element ohne Kontrolle abspeichern
# ip	      : siehe Upro speicher_feman_topologie
# nmv_ip      : Anzahl der Spalten des Feldes ip(,)
# ie()	      : INTEGER-Feld mit Daten der Elemente
#		(siehe Upro open_name_a)
# nma_e       : Definerte Anzahl an Zeilen des Feldes ie()
# nvm_e       : Definerte Anzahl an Spalten des Feldes ie()
# p()	      : Feld mit Daten der Punkte und Winkel
#		(siehe Upro open_name_a)
#		p(jele,5)=0 --> Element wurde noch nicht abgespeichert
#				Anschluelemente sind unbekannt
#		p(jele,5)=1 --> Element wurde noch nicht abgespeichert
#				Anschluelemente im Punkt 1 sind bekannt
#		p(jele,5)=2 --> Element wurde noch nicht abgespeichert
#				Anschluelemente im Punkt 2 sind bekannt
#		p(jele,5)=3 --> wie 1 und 2 zusammen
#		p(jele,5)=16 --> Element wurde schon abgespeichert
# nma_p       : Definerte Anzahl an Zeilen des Feldes p()
# nvm_p       : Definerte Anzahl an Spalten des Feldes p()
# idcb	      : Daten-Control-Block der geffneten TAB-Datei
# ldcb	      : definierte Lnge von idcb()
# tabstring   : Hilfsstring zum handhaben der TAB-Datei
# lges	      : aktuelle Zeilen-Nr. der Datei
# ierr	      : Kennzahl
#		ierr=1 --> Element ist kein Stab
#		ierr=0 --> Es trat kein Fehler beim Abarbeiten dieses
#			   Upros auf
# ipara(,)    : Feld mit Punkt-Nr. zum Ermitteln der PARAMETER
#		siehe Upro speicher_feman_topologie
# nma_ipara:  : Anzahl der Zeilen des Feldes ipara(,)
# nvm_ipara:  : Anzahl der Spalten des Feldes ipara(,)
#............................................................
#..............................................................
	
	set ierr 1

	set iele [expr abs($jele)]
	if {$p($iele,5) == 16.} then {
	    set ierr 0
	    return "$ierr $nr $l"
	}
	if {$ie($iele,1) == 1} then {
	} elseif {$ie($iele,1) == 2} then { 
	} elseif {$ie($iele,1) == 11} then {
	} elseif {$ie($iele,1) == 10 || $ie($iele,1) == 0 || \
	$ie($iele,1) == 21} then {
#		kein Element oder Gestell-Linie oder HINGE
	    set ierr 0
	    return "$ierr $nr $l"
	} else {
	    set statuszeile "Fehler oder kein Fehler im Proc \
speicher_elem_f_feman"
	    puts $statuszeile
	    return "$ierr $nr $l"
	}

	find_elem_punkte_winkel $iele
	set iw(1) $ie_w1
	set iw(2) $ie_w2

	if {$jele > 0} then {
	    set k 1
	} else {
	    set k -1
	}
	set list [speicher_feman_stab $nr $k $l 1. $iele 1]
	set ierr [lrange $list 0 0]
	set nr [lrange $list 1 1]
	set l [lrange $list 2 2]
	if {$ierr != 0} then {
	    return "$ierr $nr $l"
	}
	
	foreach i {1 2} {
	    set i_test [fmod4 $i $p($iele,5)]
	    if {$i_test != $i && $iw($i) != 0} then { 
		set j 0
		while {$j < $lges_e} {
		    incr j
#			j ist ggf. Nr. eines Anschluelements
		    if {$j != $iele && ($ie($j,1) == 1 || \
		    $ie($j,1) == 2 || $ie($j,1) == 11)} then {
			find_elem_punkte_winkel $j
			set jw(1) $ie_w1
			set jw(2) $ie_w2
			foreach jj {1 2} {
#		    jj=Nr. des Winkels/Punktes des Anschluelements
			    if {$jw($jj) == $iw($i)} then {
				set i_test [fmod4 $jj $p($j,5)]
				if {$p($j,5) == 16.} then {
				} elseif {$i_test != $jj} then {
				    set p($j,5) [expr $p($j,5)+$jj]
				    if {$i == 1} then {
					set lage 1
				    } else {
					set lage -1
				    }
				    find_elem_punkte_winkel $iele
				    set list [speicher_feman_stab $nr \
					2 $l -1. $iele $lage]
				    set ierr [lrange $list 0 0]
				    set nr [lrange $list 1 1]
				    set l [lrange $list 2 2]
				    if {$ierr != 0} then {
					return "$ierr $nr $l"
				    }
				    if {$jj == 1} then {
					set lage 1
				    } else {
					set lage -1
				    }
				    find_elem_punkte_winkel $j
				    set list [speicher_feman_stab $nr \
					2 $l 1. $j $lage]
				    set ierr [lrange $list 0 0]
				    set nr [lrange $list 1 1]
				    set l [lrange $list 2 2]
				    if {$ierr != 0} then {
					return "$ierr $nr $l"
				    }
				}
			    }
			}
		    }
		}
	    }
	}

	set p($iele,5) 16.

	return "$ierr $nr $l"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
###########################################################

proc analyse_programm {name_dat idia lesetyp ne} {

# geg.: name_dat,idia
# ges.: ierr

# name_dat: Name der Datei mit Daten fr das Analyse-Programm
# idia	  : Kennzahl
#	    idia=0 --> Dialog unterdrcken
#	    iida=1 --> Auf Fehler im Dialog hinweisen
# ierr	  : Kennzahl
#	    ierr=0  --> es trat bei der Analyse kein Fehler auf
#	    ierr<>0 --> es trat bei der Analyse ein Fehler auf
# lesetyp : Kennzahl
#	    lesetyp=0 --> Getriebe aus Eingabefile bestimmen
#	    lesetyp=1 --> Geometry, Parameter und Antrieb aus
#			  COMMON-Block entnehmen, alles andere
#			  bleibt erhalten
#................................................................
#................................................................

	set ierr 0
# Programm FEMAN aufrufen
	    set ios [feman2 $name_dat 0 $lesetyp 0 $ne]

	    if {$ios == 0} then {return $ios}
			if {$ios == 1} then {
puts "Fehler beim Aufstellen der D-Matrix"
		} elseif {$ios == 2} then {
puts "Fehler bei der Berechnung der zweiten Ordnung"
		} elseif {$ios == 3} then {
			puts "Mechanismus festgelaufen"
		} elseif {$ios == 4} then {
			puts "Anfangslage nicht erreicht"
		} elseif {$ios == 5} then {
			puts "Abbruch oder unbenannter Fehler"
		} elseif {$ios == 6} then {
puts "Fehler in Eingabe, keine Berechnung"
		} elseif {$ios < 0} then {
puts "Matrixinvertierung nicht gelungen fuer Antriebsschritt Nr. -$ios"
		}
		set ierr 1
		set l_rueck 0
		if {$idia == 1} then {
puts "Es ist ein Fehler beim Analysieren des Algorithmus aufgetreten!"
		}
return	$ierr
}
###########################################################
proc VSam2Feman {} {
# ges: ierr nr
#      Aufruf: set list [VSamFeman]
#	       mit $list = "$ierr $nr"
# gesuchte globale variablen: nx nxc nvm_ip ip

    global lges_p nvm_ip ip nx nxc p ityp
    global statuszeile
    
    set ierr 0
    set nvm_ip 3
    set ityp(1) 4
    set ityp(2) 4
    set ityp(3) 3
    set ityp(4) 5
    set ityp(5) 5
    
# Bestimmen der vorlufigen Anzahl der (nicht fixierten) Koordinaten

    set i 0
    while {$i < $lges_p} {
	incr i
	set j 0
	while {$j < $nvm_ip} {
	    incr j
	    set ip($i,$j) 0
	}
    }

    set nx 0
    set nfix 0
    set i 0
    while {$i < $lges_p} {
	incr i
	if {$p($i,3) >= 8} then {
	    set nx [expr $nx+2]
	    if {[expr fmod(int($p($i,3)),2)] == 1} then {
		incr nfix
		set ip($i,1) $nfix
		set ip($nfix,3) $i
	    }
	    set test [expr fmod($p($i,3),4)]
	    if {$test == 2 || $test == 3} then {  
		incr nfix
		set ip($i,2) $nfix
		set ip($nfix,3) $i
	    }
	}
    }

# Alle beweglichen Koordinaten nummerieren
    set ik $nfix
    set i 0
    while {$i < $lges_p} {
	incr i
	if {$p($i,3) >= 8} then {
	    foreach j {1 2} {
		if {$ip($i,$j) == 0} then {
		    set ik [expr $ik+1]
		    set ip($i,$j) $ik
		    set ip($ik,3) $i
		}
	    }
	}
    }

    set nxc [expr $nx-$nfix]
    if {$ik != $nx} then {
	set ierr 1
	set statuszeile "Fehler: Sollanzahl der Koordinaten = $nxc \
Istanzahl der Koordinaten  = $ik"
	puts $statuszeile
    }
    set list [speicher_feman_topologie $nx]
    set ierr [lrange $list 0 0]
    set nr [lrange $list 1 1]
    set l [lrange $list 2 2]
    return "$ierr $nr"
}
###########################################################
proc feman2 {dsn iord lesetyp iprint ne} {

# geg.: dsn,iord,lesetyp,ipr
# ges.: ios

# dsn	 : Name des Files, der Eingabeparameter enthlt
#	   dsn=' ' --> Name im Dialog bestimmen
# iord	 : Kennzahl
#	   iord=-1 -->	    im Dialog, welche bertragungsfunktionen
#			    zu berechnen sind
#	   iord=0 ... 2 --> bertragungsfunktionen 0. bis iord.
#			    Ordnung bestimmen
# ios	 : Kennzahl
#	   ios=0 --> Es trat kein Fehler beim Abarbeiten dieses 
#		     Upros auf
#	   ios=1 --> Fehler beim Aufstellen der D-Matrix
#	   ios=2 --> Fehler bei der Berechnung der zweiten Ordnung
#	   ios=3 --> Mechanismus festgelaufen
#	   ios=4 --> Anfangslage nicht erreicht
#	   ios=5 --> Abbruch oder unbenannter Fehler
#	   ios=6 --> Fehler in Eingabe, keine Berechnung
#	   ios<0 --> Matrixinvertierung nicht gelungen fr Antriebs-
#		     schritt -ios
# iprint : Unit fr Protokoll bei lesetyp=1
# lesetyp:Kennzahl
#	  lesetyp=0 --> Getriebe aus Eingabefile bestimmen
#	  lesetyp=1 --> Geometry, Parameter und Antrieb aus 
#			COMMON-Block entnehmen, alles andere
#			bleibt erhalten
#.................................................................
#..................................................................

# Verfasser: Dr. Ir. A. J. Klein Breteler
#	     TU Delft, Niederlande
# Ergnzungen durch Volker Jaekel

  global ep ex de dc dinv ek fmult d1 x2 work i_a r_a x_
  global ityp itypa irow lxa lx ea xa xaa d2 xak
  global xl d ipivot
  global drad Pi lges_p nx nxc
  global name
  global ShowFemanFortschritt 
#	real*8 x2(nxcmax),work(nxcmax)
#	parameter(nma_a=1) 
#	parameter (ntmax=10,ncmax=8)  

  set nxmax lges_p 
  set nxcmax lges_p
#	set nx $nxmax
#	set nxc $nxcmax
  set emin 0.000000001
  set pmin 0.00001

  set ordn(1) nullter
  set ornd(2) erster
  set ornd(3) zweiter
  set stern **************************************
  set strich ----------------------------------------
  set ia_anz 1

#set izeile 0
  set ios 0
  if {$iord == -1} then {
      set ios_rueck 0
  } else {
      set ios_rueck 1
  }

# Eingabe des Mechanismus (Topologie und Geometrie)

  inmech_uegk $nx $nxc $ia_anz $ne

# Nr. der Gleichung fuer den Antrieb
  set m 1 

  set ier 0

  set nx0 [expr $nx-$nxc]
  set nvges [expr 2+($nx-$nx0)]
  set lges $i_a(1)

# Eingabe der Ordnung

# Initialisierung der Hauptschleife der Getriebelagen

  set lage 1
  set nlage 1
  set iter 0
  copy $nxc
  set ia_anz_gerechnet 0

# Anfang der Hauptschleife (Schritt des Antriebs und Korrektur der
# Koordinaten)

  set test "test"
  while {$test == "test"} {

    set ier [femech $nx $nxc $ne]
    if {$ier != 0} then {
	feprt  $nxc $ne
	set ios 1
	if {$ios_rueck != 0} then {
	    return $ios
	}
    }

    clear8 $nxc
    set i 0
    while {$i < $nxc} {
	incr i
#   set dinv(i,i) 1.0
	set dinv([expr ($i-1)*$nxc+$i]) 1.
    }

#	 call feprt(ipr,nx,nxc,dc,nemax,ne,ek)
#	 write(ipr,*) 'ex:',(ex(i),i=1,nxc)
    set igelg 1
    if {$igelg == 1} then {
	set ier [gelg $nxc $nxc $pmin]

#set iii 0
#set mm [expr $nxc*$nxc]
#while {$iii < $mm} {
#    incr iii
#    puts "dc($iii)=$dc($iii), dinv($iii)=$dinv($iii)"
#}

	if {$ier != 0} then {
	    set ios -$lage
	    if {$ios_rueck != 0} then {
		return "$ios"
	    }
	    puts "Matrixinvertierung nicht gelungen: Reihe=$ier \
in der Getriebestellung Nr. $lage"
	}
    } else {
#	    call gaumrs(nxc,dc,nxcmax,nxcmax,dinv,xl,marke,d,ipivot)
	call gaumrs(nxc,dc,nxc,nxc,dinv,xl,marke,d,ipivot)
	if {$marke == 0} then {
	    set ios -$lage
	    if {$ios_rueck != 0} then {
		return $ios
	    }
	    puts "Matrixinvertierung nicht gelungen: \
in der Getriebestellung Nr. $lage"
	}
	set i 0
	while {$i < $nxc} {
	    incr i
	    set j 0
	    while {$j < $nxc} {
		incr j
#		set dinv($i,$j) $xl($i,$j)
		set dinv([expr ($i-1)*$nxc+$j]) $xl($i,$j)
	    }
	}
    }

    set mode "Schritt"
    set i 0
    while {$i < $nxc} {
	incr i
	set de($i) [expr $ep($i)-$ex($i)]
	if {[expr abs($de($i))] > $emin} then {
	    set mode "Korrektur"
	}
    }

    if {$mode == "Schritt"} then {
	#write (ipr,1020) lage,ep(m),(x_(i),i=nx0+1,nx)
#	    if (iord.gt.1) call ordn2(nx,nxc,x,dinv,m,x2,work,ier,
#     + 		      ntmax,ncmax,nemax,
#     + 		      ne,ityp,itypa,irow,fmult,lxa,lx,d2,xak)
    
	if {$ier != 0} then {
	    set ios 2
	    if {$ios_rueck != 0} then {
		return $ios
	    }
#		call fehler2(*100,99999,0,
#     + 	 'bei der Berechnung der zweiten Ordnung',' ',' ')
	}
	if {$lage >= $nlage} then {

# Eingabe der Antriebsbewegung (ggf. der Weiterbewegung)

	    if {$ia_anz == 0} then {
		puts "Fehler: kein Dialogmodus moeglich"
	    } elseif {$ia_anz > $ia_anz_gerechnet} then {
		incr ia_anz_gerechnet
		set nlage [expr $nlage+$i_a($ia_anz_gerechnet)]
		set delta $r_a($ia_anz_gerechnet)
	    } else {
		VShowIterativeGetrModifikation
		VModifyGetr all
		break
	    }
	}
	VShowIterativeGetrModifikation
	if {$ShowFemanFortschritt == "Ja"} then {
	    VModifyGetr all
	}
	set de($m) $delta
	set ep($m) [expr $ep($m)+$delta]
	set jb $m
	set je $m
	set iter 0
	incr lage
    } elseif {$mode == "Korrektur"} then {
	incr iter
	set jb 1
	set je $nxc
	if {$iter > 50} then {
#		write(ipr,1020) lage,ep(m),(x_(i),i=nx0+1,nx)
	    if {$lage > 1} then {
		set ios 3
		if {$ios_rueck != 0} then {
		    return $ios
		}
		puts "Mechanismus festgelaufen"
	    } elseif {$lage == 1} then {
		set ios 4
		if {$ios_rueck != 0} then {
		    return ios
		}
		puts "Anfangslage nicht erreicht"
	    }
	}
    }

# Extrapolation der neuen Lage (TAYLOR): XC=XC+DINV*DE

    set i 0
    while {$i < $nxc} {
	incr i
	set dxc 0.
	set k [expr ($i-1)*$nxc]
	set j $jb
	while {$j <= $je} {	
	    set dxc [expr $dxc+$dinv([expr $j+$k])*$de($j)]
	    incr j
	}
	set x_([expr $nx0+$i]) [expr $x_([expr $nx0+$i])+$dxc]
    }
  }

  if {$ier != 0} then {
    set ios 6
    puts "Fehler in Eingabe, keine Berechnung"
  }
  if {$ier != 0} then {
    if {$ios == 0} then {set ios 5}
    return $ios
  } else {
    set ios 0
    return $ios
  }
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
proc edit_antrieb_g {} {
    global ra ia maxIfeman minWfeman drad

    if {$ra(1,1) >= 0} then {
	set ia(1,2) [expr ceil($ra(1,1)/$drad/$minWfeman)]
    } else {
	set ia(1,2) [expr -1.*floor($ra(1,1)/$drad/$minWfeman)]
    }
    if {$ia(1,2) > $maxIfeman} then {
	set ia(1,2) $maxIfeman
    } elseif {$ia(1,2) == 0} then {
	set ia(1,2) 1
    }
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 

proc inmech_uegk {nx nxc ia_anz ne} {

    global Pi x_ ep ra ia ip p i_a r_a ipara ek

    edit_antrieb_g

    set i 0
    while {$i < $ne} {
	incr i
	set ek($i) 0.
    }

# Koordinaten

set i 0
while {$i < $nx} {
    incr i
    set ipunkt $ip($i,3)
    if {$ip($ipunkt,1) == $i} then {
	set ikoor 1
    } else {
	set ikoor 2
    }
    set x_($i) $p($ipunkt,$ikoor)
}

# Parameter

set i 0
while {$i < $nxc} {
    incr i
    if {$ipara($i,3) == 0} then {
#    Abstand
	set dx [expr $p($ipara($i,1),1)-$p($ipara($i,2),1)]
	set dy [expr $p($ipara($i,1),2)-$p($ipara($i,2),2)]
	set de [expr sqrt($dx*$dx+$dy*$dy)]
    } else {
#    Winkel
	if {$ipara($i,1) == 0} then {
#	Winkel zwischen Element und Gestell
	    set dx [expr $p(ipara($i,3),1)-$p($ipara($i,2),1)]
	    set dy [expr $p(ipara($i,3),2)-$p($ipara($i,2),2)]
	    set de [expr atan2($dy,$dx)]
	} else {
#	Winkel zwischen zwei Elementen
	    set dx [expr $p($ipara($i,1),1)-$p($ipara($i,2),1)]
	    set dy [expr $p($ipara($i,1),2)-$p($ipara($i,2),2)]
	    set de [expr atan2($dy,$dx)]
	    set dx [expr $p($ipara($i,3),1)-$p($ipara($i,2),1)]
	    set dy [expr $p($ipara($i,3),2)-$p($ipara($i,2),2)]
#		    set de [expr atan2($dy,$dx)-$de]
	    set de [expr $de-atan2($dy,$dx)]
	}
	while {$de > 2.*$Pi} {
	    set de [expr $de-2.*$Pi]
	}
	while {$de < -2.*$Pi} {
	    set de [expr $de+2.*$Pi]
	}
    }

    set ep($i) $de
}

# Antrieb

    set ia_anz 1
    set i_a(1) $ia(1,2)
    set r_a(1) [expr $ra(1,1)/$ia(1,2)]

}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
proc atan3 {y x h} {

global Pi drad

set tpi [expr 2.*$Pi]
set dh [expr fmod(atan2($y,$x)-$h,$tpi)]
if {$dh > $Pi} then {set dh [expr $dh-$tpi]}
if {$dh <= -$Pi} then {set dh [expr $dh+$tpi]}
set atan3 [expr $h+$dh]
return $atan3
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
proc clear8 {n} {
global dinv

set i 0
while {$i < $n} {
incr i
set j 0
while {$j < $n} {
    incr j
#   set dinv($i,$j]) 0.
    set dinv([expr ($i-1)*$n+$j]) 0.
}
}
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
proc copy {nxc} {
global ep ex

    set i 0
    while {$i < $nxc} {
	incr i
	set ex($i) $ep($i)
    }
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
proc gelg {m n eps} {
global dc dinv 

# Aufruf: set ier2 [gelg ...]


set ier -1
if {$m <= 0} then {
    return $ier
} else {
    set ier 0
    set piv 0.
    set mm [expr $m*$m]
    set nm [expr $n*$m]

set l 0
while {$l < $mm} {
    incr l
    set tb [expr abs($dc($l))]
    if {[expr $tb-$piv] > 0} then {
	set piv $tb
	set i $l
    }
}
set tol [expr $eps*$piv]
set lst 1
set k 0
while {$k < $m} {
    incr k
    if {$piv <= 0} then {
	return $ier
    } else {
	if {$ier == 0} then {
	    if {[expr $piv-$tol] < 0} then {
		set ier [expr $k-1]
	    }
	}
    }
    set pivi [expr 1./$dc($i)]
    set j [expr ($i-1)/$m]
    set i [expr $i-$j*$m-$k]
    set j [expr $j+1-$k]
    set l $k
    while {$l <= $nm} {
	set ll [expr $l+$i]
	set tb [expr $pivi*$dinv($ll)]
	set dinv($ll) $dinv($l)
	set dinv($l) $tb
	set l [expr $l+$m]
    }
    if {[expr $k-$m] >= 0} then {
	break
    } else {
	set lend [expr $lst+$m-$k]
    }
    if {$j > 0} then {
	set ii [expr $j*$m]
	set l $lst
	while {$l <= $lend} {
	    set tb $dc($l)
	    set ll [expr $l+$ii]
	    set dc($l) $dc($ll)
	    set dc($ll) $tb
	    incr l
	}
    }
    set l $lst
    while {$l <= $mm} {
	set ll [expr $l+$i]
	set tb [expr $pivi*$dc($ll)]
	set dc($ll) $dc($l)
	set dc($l) $tb
	set l [expr $l+$m]
    }
    set dc($lst) $j
    set piv 0.
    incr lst
    set j 0
    set ii $lst
    while {$ii <= $lend} {
	set pivi [expr -1.*$dc($ii)]
	set ist [expr $ii+$m]
	incr j
	set l  $ist
	while {$l <= $mm} {
	    set ll [expr $l-$j]
	    set dc($l) [expr $dc($l)+$pivi*$dc($ll)]
	    set tb [expr abs($dc($l))]
	    if {[expr $tb-$piv] > 0} then {
		set piv $tb
		set i $l
	    }
	    set l [expr $l+$m]
	}
	set l $k
	while {$l <= $nm} {
	    set ll [expr $l+$j]
	    set dinv($ll) [expr $dinv($ll)+$pivi*$dinv($l)]
	    set l [expr $l+$m]
	}
	incr ii
    }
    set lst [expr $lst+$m]
}
if {[expr $m-1] < 0} then {
    set ier -1
    return $ier
} elseif {[expr $m-1] > 0} then {
    set ist [expr $mm+$m]
    set lst [expr $m+1]
    set i 2
    while {$i <= $m} {
	set ii [expr $lst-$i]
	set ist [expr $ist-$lst]
	set l [expr $ist-$m]
	set l [expr int($dc($l)+0.5)]
	set j $ii
	while {$j <= $nm} {
	    set tb $dinv($j)
	    set ll $j
	    set k $ist
	    while {$k <= $mm} {
		incr ll
		set tb [expr $tb-$dc($k)*$dinv($ll)]
		set k [expr $k+$m]
	    }
	    set k [expr $j+$l]
	    set dinv($j) [expr $dinv($k)]
	    set dinv($k) $tb
	    set j [expr $j+$m]
	}
	incr i
    }
}
return $ier
}
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Dieses Unterprogramm berechnet die Matrix DC und die Verformungen EX
# als Funktion der Koordinaten X eines willkrlichen Getriebes

proc femech {nx nxc ne} {

global x_ ex dc lx d1 ek fmult ityp itypa irow lxa

# Aufruf: set ier2 [femech ...]

set nx0 [expr $nx-$nxc]

# zuerst die Matrix DC mit Nullen auffllen
set i 0
while {$i < $nxc} {
    incr i
    set ex($i) 0.
    set k 0
    while {$k < $nxc} {
	incr k
#	set dc($i,$k) 0.
	set dc([expr ($i-1)*$nxc+$k]) 0.
    }
}

set k 1
while {$k <= $ne} {

# die Vektorkoeffizienten D1 einer Verformung (Nummer k) berechnen:

    set ktyp $itypa($k)
    set nl $ityp($ktyp)
    set i 0
    while {$i < $nl} {
	incr i
	set lx($i) $lxa($i,$k)
    }
    set e $ek($k)
    set ier2 $k
    switch $ktyp {
	1 {set list [d1l $nx $nl $e]}
	2 {set list [d1b $nx $nl $e]}
	3 {set list [d1h $nx $nl $e]}
	4 {set list [d1u $nx $nl $e]}
	5 {set list [d1v $nx $nl $e]}
    }
    set ier [lrange $list 0 0]
    if {$ier != 0} then {return $ier2}
    
    set e [lrange $list 1 1]

    set ii 0
    set ii2 1
    while {$ii < $nl} {
	incr ii
	incr ii2
	set d1($ii) [lrange $list $ii2 $ii2]
    }

    set ier2 0
    set ek($k) $e

# der Vektor D1 in die Matrix DC anordnen

    set ir $irow($k)
    set fm $fmult($k)
    set jb [expr ($ir-1)*$nxc]
    set i 0
    while {$i < $nl} {
	incr i
	set j [expr $lx($i)-$nx0]
	if {$j > 0} then {
	    set ii [expr $jb+$j]
	    set dc($ii) [expr $dc($ii)+$fm*$d1($i)]
	}
    }
    set ex($ir) [expr $ex($ir)+$fm*$e]
    incr k
}
return $ier2
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Dieses Unterprogramm berechnet die Koeffizienten des Kontinuitts-
# vektors erster Orndung D1K der Formparameter:
# LNGE EINES BINREN ELEMENTS

proc d1l {nx nl e} {
global x_ lx

# gesucht: $list = "$ier $e $d1k(1) $d1k(2) $d1k(3) $d1k(4)"

set rmin 0.000001

set ier -1
if {$nl != 4} then {return $ier}
set dx [expr $x_($lx(3))-$x_($lx(1))]
set dy [expr $x_($lx(4))-$x_($lx(2))]
set rl2 [expr $dx*$dx+$dy*$dy]
set rl [expr sqrt($rl2)]
if {$rl < $rmin} then {return $ier}
set e $rl
set d1k(1) [expr -1.*$dx/$rl]
set d1k(2) [expr -1.*$dy/$rl]
set d1k(3) [expr $dx/$rl]
set d1k(4) [expr $dy/$rl]
set ier 0
return "$ier $e $d1k(1) $d1k(2) $d1k(3) $d1k(4)"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Dieses Unterprogramm berechnet die Koeffizienten des Kontinuitts-
# vektors erster Orndung der Formparameter:
# WINKEL EINES BINREN ELEMENTS

proc d1b {nx nl e} {
global x_ lx

# gesucht: $list = "$ier $e $d1k(1) $d1k(2) $d1k(3) $d1k(4)"

set rmin 0.000001

set ier -1
if {$nl != 4} then {return $ier}
set dx [expr $x_($lx(3))-$x_($lx(1))]
set dy [expr $x_($lx(4))-$x_($lx(2))]
if {[expr abs($dx)] < 100000000 && \
[expr abs($dy)] < 100000000} then {
    set rl2 [expr $dx*$dx+$dy*$dy]
    set rl [expr sqrt($rl2)]
} else {
    set rl [max $dx $dy]
}
if {$rl < $rmin} then {return $ier}
set e [atan3 $dy $dx $e]
set d1k(1) [expr $dy/$rl2]
set d1k(2) [expr -1.*$dx/$rl2]
set d1k(3) [expr -1.*$dy/$rl2]
set d1k(4) [expr $dx/$rl2]
set ier 0
return "$ier $e $d1k(1) $d1k(2) $d1k(3) $d1k(4)"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Dieses Unterprogramm berechnet die Koeffizienten des Kontinuitts-
# vektors erster Orndung der Formparameter:
# WINKEL EINES HALBEN STABES   

proc d1h {nx nl e} {
global x_ lx

# gesucht: $list = "$ier $e $d1k(1) $d1k(2) $d1k(3)"

set ier -1
if {$nl != 3} then {return $ier}
set d1k(1) 0.
set d1k(2) 0.
set d1k(3) 1.
set e $x_($lx(3))
set ier 0
return "$ier $e $d1k(1) $d1k(2) $d1k(3)"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Dieses Unterprogramm berechnet die Koeffizienten des Kontinuitts-
# vektors erster Orndung der Formparameter:
# TERNR_U   

proc d1u {nx nl e} {
global x_ lx

# gesucht: $list = "$ier $e $d1k(1) $d1k(2) $d1k(3) $d1k(4) $d1k(5)"

set ier -1
if {$nl != 5} then {return $ier}
set b $x_($lx(3))
set sb [expr sin($b)]
set cb [expr cos($b)]
set dx [expr $x_($lx(4))-$x_($lx(1))]
set dy [expr $x_($lx(5))-$x_($lx(2))]
set d1k(1) [expr -1.*$cb]
set d1k(2) [expr -1.*$sb]
set d1k(3) [expr $dy*$cb-$dx*$sb]
set d1k(4) $cb 
set d1k(5) $sb 
set e [expr $dx*$cb+$dy*$sb]
set ier 0
return "$ier $e $d1k(1) $d1k(2) $d1k(3) $d1k(4) $d1k(5)"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Dieses Unterprogramm berechnet die Koeffizienten des Kontinuitts-
# vektors erster Orndung der Formparameter:
# TERNR_V   

proc d1v {nx nl e} {
global x_ lx

# gesucht: $list = "$ier $e $d1k(1) $d1k(2) $d1k(3) $d1k(4) $d1k(5)"

set ier -1
if {$nl != 5} then {return $ier}
set b $x_($lx(3))
set sb [expr sin($b)]
set cb [expr cos($b)]
set dx [expr $x_($lx(4))-$x_($lx(1))]
set dy [expr $x_($lx(5))-$x_($lx(2))]
set d1k(1) $sb
set d1k(2) [expr -1.*$cb]
set d1k(3) [expr -1.*$dx*$cb-$dy*$sb]
set d1k(4) [expr -1.*$sb]
set d1k(5) $cb 
set e [expr $dy*$cb-$dx*$sb]
set ier 0
return "$ier $e $d1k(1) $d1k(2) $d1k(3) $d1k(4) $d1k(5)"
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Dieses Unterprogramm druckt aus: die Matrix DC und die Verformungen EX
# als Funktion der Koordinaten X eines willkrlichen Getriebens

proc feprt {nxc ne} {
global	ek dc

puts "Der Vektor der Formparameter EX enthlt:"
set i 0
while {$i < $ne} {
incr i
lappend out "$ek($i), "
}
puts $out

return
puts "Die Matrix DC enthlt:"
set ii 0
while {$ii < $nxc} {
incr ii
set i 0
while {$i < $nxc} {
    incr i
    lappend out "$dc([expr $i+$ii*$nxc]), "
}
}
}
#############################################################
# Unterprogramm zur Ermittlung der Laufeigenschaft ebener vierglied-
# riger Gelenkgetriebe nach Grashof.
#
proc grash {k a1 a2 a3 a4 e} {

#     subroutine grash(*,k,m,a1,a2,a3,a4,e,d_min,d_max,idia,ierr)

# gegeben: k ,a1,a2,a3,a4,e
# gesucht: return "$ierr $m $d_min $d_max"
#
# k	= Kennzahl: K=1 => Viergelenkgetriebe
#		    K=2 => Kurbelschleife, Schwingschleife
#		    K=3 => Schubkurbel, Schubschwinge
# m	= Kennzahl der Laufeigenschaft: M=1 => umlauffaehig
#					M=2 => durchschlagfaehig
#					M=3 => totalschwingfaehig
#					M=4 => durchschlagend
# d_min   = Laenge des kuerzesten Getriebegliedes in mm
# d_max   = Laenge des laengsten Getriebegliedes in mm
# ierr	  = Kennzahl
#	    ierr=0  --> es trat kein Fehler auf
#	    ierr<>0 --> es trat ein Fehler auf
#.............................................................
#.............................................................
      set eps [expr ($a1+$a2+$a3+$a4)/10000./4.]

      set ierr 0
#
      set k 1

      if {$a1 <= 0. || $a2 < 0. || $a3 < 0. || $a4 < 0.} then {
	  set ierr 5
	  set statuszeile "Fehler: Mindestens eine Lnge ist negativ!"
	  puts $statuszeile
	  return "$ierr 0 0 0"
      }
      if {$a2 == 0 && $a3 == 0.} then {set k 2}
      if {$a3 == 0 && $a4 == 0.} then {set k 3}
#
# vier Drehgelenke
#
      if {$k == 1} then {

	  set d_max [max $a1 $a2] 
	  set d_max [max $d_max $a3]
	  set d_max [max $d_max $a4]
	  set d_min [min $a1 $a2]
	  set d_min [min $d_min $a3]
	  set d_min [min $d_min $a4]
	  set b1 [expr $d_max+$d_min]
	  set b2 [expr $a1+$a2+$a3+$a4-$b1]
	  set b3 [expr $a1+$a2+$a3+$a4-2.*$d_max]
	  if {$b3 <= 0.} then {
	      set ierr 9
	      set statuszeeile \
"Fehler: Die eingegebenen Gliedlngen ergeben kein Viergelenkgetriebe"
	      puts "statuszeile"
	      return "$ierr 0 0 0"
	  }
#
# Kurbelschleife, Schwingschleife
#
      } elseif {$k == 2} then {
	  if {[expr abs($e)] > [expr $a4+$a1]} then {
	      set ierr 22
	      set statuszeile \
"Fehler: Die eingegebenen Lngen sind nicht sinnvoll!"
	      puts $statuszeile
	      return "$ierr 0 0 0"
	  }
	  set d_max [max $a1 $a4]
	  set d_min [min $a1 $a4]
	  set b1 [expr $d_min+abs($e)]
	  set b2 $d_max
#
# Schubkurbel, Schubschwinge
#
      } elseif {$k == 3} then {
	  if {[expr abs($e)] > [expr $a1+$a2]} then {
	      set ierr 23
	      set statuszeile \
"Fehler: Die eingegebenen Lngen sind nicht sinnvoll!"
	      puts $statuszeile
	      return "$ierr 0 0 0"
	  }
	  set d_max [max $a1 $a2]
	  set d_min [min $a1 $a2]
	  set b1 [expr $d_min+abs($e)]
	  set b2 $d_max
      } else {
	  set ierr 23
	  set statuszeile \
	      "Fehler im proc Grashof: Parameter K < 1 oder K > 3"
	  puts $statuszeile
	  return "$ierr 0 0 0"
      }
#
# Bestimmung der Umlauffaehigkeit
#
      if {$b1 < $b2} then {
	set m 1
      } elseif {[expr abs($b1-$b2)] < $eps} then {
	set m 4
      } else {
	set m 3
      }
      return "$ierr $m $d_min $d_max"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
#
# Unterprogramm zur Ermittlung der Getriebebennung, der Bewegungs-
# moeglichkeiten der im Gestell gelagerten Glieder, falls erforder-
# lich der Start- bzw. Bewegungsbereichskennzahl KB.
#
proc geart {a1 a2 a3 a4 m d_min d_max kb} {

#   global cl1 cl3 getyp zusat

#     subroutine geart (*,k,a1,a2,a3,a4,e,kean,m,d_min,d_max,kb,
#    +		cl1,cl3,getyp,zusat)

#
# gegeben: k,kean,m,d_min,d_max
# Aufruf: set kb [geart ...]
#
# return1 = Sprung zum Programmende
#
# k	= Kennzahl: K=1 => Viergelenkgetriebe
#		    K=2 => Kurbelschleife, Schwingschleife
#		    K=3 => Schubkurbel, Schubschwinge
# kean	= Kennzahl: (nur von Bedeutung bei Kurbelschleifen, Schwing-
#		     schleifen)
#		    KEAN=0 ==> Schleifenglied ist das Abtriebsglied
#		    KEAN=1 ==> Schleifenglied ist das Antriebsglied
# m	= Kennzahl der Laufeigenschaft: M=1 => umlauffaehig
#					M=3 => totalschwingfaehig
#					M=4 => durchschlagend
# d_min   = Laenge des kuerzesten Getriebegliedes in mm
# d_max   = Laenge des laengsten Getriebegliedes in mm
# kb	= Bewegungsbereichskennzahl bzw. Startbewegungsbereichskennzahl
# cl1	= Bewegungsmoeglichkeit des Antriebsgliedes (*2)
# cl3	= Bewegungsmoeglichkeit des Abtriebsgliedes (*2)
# getyp = vollstaendige Getriebebenennung (*75)
# zusat = zusaetzliche Getriebebenennung bei Durchschlaggetrieben (*70)
#..........................................................
#.........................................................
      global helptext1

      set uml "durchschlagfaehige "
      set gt " "
      if {$m == 1} then {
	  set zusat "(umlauffaehig)"
      } elseif {$m == 3} then {
	  set zusat "(totalschwingfaehig)"
      } else {
	  set zusat "(durchschlagfaehig)"
      }
      set gt2 "Durchschlaggetriebe"
      set ad "versetzte"
#     if {$e == 0.} then {set ad "zentrische"}
#
      set k 1
      if {$k == 1} then {
#
# Getriebe mit 4 Drehgelenken
#
	  set cl1 " u"
	  if {$a2 == $d_min || $m == 3} then { set cl1 " s"}
#
	  set cl3 " s"
	  if {$a4 == $d_min && $m != 3} then { set cl3 " u"}
#
	  if {$a3 == $d_min && $m != 3} then {
	      set cl1 " s"
	      set cl3 " u"
	  }
#
	  if {$m != 1 && $cl3 == " s"} then {
	      set cl3 "is"
	      if {$a2 == $d_max} then {set cl3 "as"}
	  }
#
	  if {$m != 1 && $cl1 == " s"} then {
	      set cl1 "as"
	      if {$a4 == $d_max} then {set cl1 "is"}
	      if {$cl3 == "is" && $cl1 == "as" && $a1 == $d_max} then {
		  set cl1 "is"
		  set cl3 "as"
	      }
	  }
#
	  if {$m == 4 && ($a1 == $d_max && $a3 == $d_min)}\
	  then {
	      set cl1 "is"
	  }
#
	  if {$m == 4 && $cl1 == " u"} then {set cl1 "2u"}
	  if {$m == 4 && $cl3 == " u"} then {set cl3 "2u"}
#
	  if {$m == 1 || $m == 3} then {
	  } else {
# Benennung der Sondergetriebe
	      set gt " "
#
	      if {$a2 != $d_max} then {
		   if {$a4 != $d_max} then {
		   } else {
		      if {$a4 == $a3} then {
			  set kb -1
			  set cl1 " u"
			  set gt "Gallowaygetriebe 2. Art"
		      } elseif {$a4 == $a1} then {
			  set kb -1
			  set cl1 "is"
			  set cl3 " u"
			  set gt "Gallowaygetr. 2. Art mit schw. Antr."
		      }
		   }
	      } else {
		  if {$a1 == $a2 && $a2 == $a3 && $a3 == $a4} then {
		      set kb -1
		      set gt "Rautenkurbel"
		      set cl1 " u"
		      set cl3 " u"
		      set getyp $gt
		      return "$cl1 $cl3 $kb $getyp $zusat"
		  } else {
		      if {$a2 == $a3} then {
			  gt="Galloway-Getriebe 1. Art"
			  set cl1 "2u"
			  set cl3 " u"
			  if {$a2 == $a4} then {
			       set kb 1
			       set gt \
			       "$uml Antiparallelkurbel 1.Art (gegenl.)"
			       set cl1 " u"
			       set cl3 " u"
			  }
		      } elseif {$a2 == $a1} then {
			  set gt "Galloway-Getriebe 1. Art (Umkehr)"
			  set cl1 " u"
			  set cl3 "2u"
			  set kb -1
			  if {$a2 == $a4} then {
			       set kb 1
			       set gt \
			       "$uml Antiparallelkurbel 1.Art (gegenl.)"
			       set cl1 " u"
			       set cl3 " u"
			  }
		      }
		  }
		  set getyp $gt
		  tk_messageBox -message "2: getyp=$getyp\ngt=$gt"
		  return "$cl1 $cl3 $kb {$getyp} $zusat"
	      }
	      if {$a1 == $d_max && $a3 == $a1} then {
		  kb= 1
		  gt=uml//"Antiparallelkurbel 2.Art (gegenl.)"
		  set cl1 " u"
		  set cl3 " u"
	      }
	  }
	  if {$gt != " "} then {
	      set getyp $gt
	  } else {
	      if {[string range $cl1 1 1] == "u" && \
	      [string range $cl3 1 1] == "s"} then {
		  set gt "Kurbelschwinge"
		  set getyp $gt
		  return "$cl1 $cl3 $kb $getyp $zusat"
	      } elseif {[string range $cl1 1 1]  == "s" && \
	      [string range $cl3 1 1] == "u"} then {
		  set gt "Kurbelschw. mit schw. Antr."
		  set getyp $gt
		  return "$cl1 $cl3 $kb {$getyp} $zusat"
	      } else {
		  set gt1 "kurbel"
		  if {[string range $cl3 1 1]  == "s"} then {
		      set gt1 "schwinge"
		  }
		  if {$cl3 == "is"} then {
		      set gt1 "innenschwinge"
		  } elseif {$cl3 == "as"} then {
		      set gt1 "aussenschwinge"
		  }
		  if {$cl1 == $cl3} then {
		    set gt "Doppel$gt1"
		  } else {
		      if {$cl1 == "is"} then {set gt "Innen$gt1"}
		      if {$cl1 == "as"} then {set gt "Aussen$gt1"}
		  }
	      }
	      if {$m == 4} then {
		  set zusat "(durchschlagende $gt)"
		  set gt $gt2
	      }
	  }
	  set getyp $gt
	  return "$cl1 $cl3 $kb {$getyp} $zusat"
      } else {
	  set getyp "nicht implementiert"
      }
      return "$cl1 $cl3 $kb {$getyp} $zusat"
}
###################################################################
proc VSetHelpText1 {cl1 cl3} {

    global helptext1 al1 al2 al3 al4

# Feststellen, wann Getriebe Koppelpunktbahnen mit mindestens einem Selbstschnittpunkt
# aufweist
    set helptext1 "mAKS = 0"
    if {[string range $cl1 0 0] == "2"} then {
	set helptext1 "mAKS = 1"
    } elseif {$cl1 == "is" && $cl3 == "is"} then {
	set al1q [expr $al1*$al1]
	set al2q [expr $al2*$al2]
	set al3q [expr $al3*$al3]
	set al4q [expr $al4*$al4]
	if {$al4q > [expr $al1q+$al3q]} then {
	    set x1 [expr sqrt(($al4q-$al1q)*($al4q-$al3q))]
	    set x [expr 2.*$al1*$al3/$al4q*($al1*$al3-$x1)]
	    if {$al2q >= [expr $al4q-$al1q-$al3q+$x]} then {
		set helptext1 "mAKS = 1"
	    }
	}
    }
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
#
# Unterprogramm zur Ermittlung der "Verzweigungswinkel".
#
proc phikrit {k kean m d_min d_max cl1 a1 a2 a3 a4} {

#     subroutine phikrit (k,kean,m,d_min,d_max,cl1,a1,a2,a3,a4,phiver)

    global phiver

#     real*8 phiver(3)
#
# gegeben: k,kean,m,d_min,d_max,cl1
#
# k	= Kennzahl: K=1 => Viergelenkgetriebe
#		    K=2 => Kurbelschleife, Schwingschleife
#		    K=3 => Schubkurbel, Schubschwinge
# kean	= Kennzahl: (nur von Bedeutung bei Kurbelschleifen, Schwing-
#		     schleifen)
#		    KEAN=0 ==> Schleifenglied ist das Abtriebsglied
#		    KEAN=1 ==> Schleifenglied ist das Antriebsglied
# m	= Kennzahl der Laufeigenschaft: M=1 => umlauffaehig
#					M=2 => durchschlagfaehig
#					M=3 => totalschwingfaehig
#					M=4 => durchschlagend
# d_min   = Laenge des kuerzesten Getriebegliedes in mm
# d_max   = Laenge des laengsten Getriebegliedes in mm
# cl1	= Bewegungsmoeglichkeit des Antriebsgliedes
# phiver= Feld der Verzweigungswinkel in Grad
#.....................................................................
#.....................................................................
      if {$m == 1 || $m == 3} then {
	  set phiver(1) 5000.
	  set phiver(2) 5000.
	  set phiver(3) 5000.
	  return
      } elseif {$cl1 == "2u" || ($m == 2 && $cl1 == " u")} then {
	  set phiver(1) 0.
	  set phiver(2) 360.
	  set phiver(3) 720.
	  if {$k == 2 && $kean != 1} then {return} 
	  if {($a1 == $d_min && $a4 == $d_max) || \
	  ($a1 == $d_max && $a4 == $d_min) || ($kean == 1)} then {
	      if {$a1 == $a3 && $a2 == $a4} then {
		  phikrit2
	      } else {
		  set phiver(1) 180.
		  set phiver(2) 540.
		  set phiver(3) 900.
	      }
	  }
	  return
      } elseif {$cl1 == " u"} then {
	  phikrit2
      } elseif {$cl1 == "is" || ($k == 2 && $cl1 == "ss")} then {
#_vj	  phiver(1)= 0. ! Nur positive Winkel erlaubt
	  set phiver(1) 360.
      } else {
	  set phiver(1) 180.
      }
      set phiver(2)= 5000.
      set phiver(3)= 5000.
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
proc phikrit2 {} {
    global phiver

    set phiver(1) 0.
    set phiver(2) 180.
    set phiver(3) 360.
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
#
# Unterprogramm, dass den zu berechnenden Antriebswinkeln PHI die je-
# weils benoetigte Kennzahl KB ( im Feld KBF ) zuordnet.
# (Funktioniert nicht bei totalschwingfhigen Getrieben und nur mit
# Antrieb in mathematisch positiver Drehrichtung
#
proc kbvphi_2 {n m kb cl1} {

#     subroutine kbvphi_2 (n,m,phi,kbf,kb,phiver,cl1)

    global phib kbf phiver
#     real*8 phib(2)
#     integer*4 kbf(2)
#     real*8 phiver(3)
#
# gegeben: n,m,phib,kb,phiver,cl1
#
# n	= Anzahl der zu berechnenden Stuetzstellen
# m	= Kennzahl der Laufeigenschaft: M=1 => umlauffaehig
#					M=2 => durchschlagfaehig
#					M=3 => totalschwingfaehig
#					M=4 => durchschlagend
# phib	 = Feld der zu berechnenden Antriebswinkel PHI in Grad
# kbf	= Feld der benoetigten Kennzahlen KB
# kb	= Bewegungsbereichskennzahl bzw. Startbewegumgsbereichskennzahl
# phiver  = Feld der Verzweigungswinkel in Grad
# cl1	= Bewegungsmoeglichkeit des Antriebsgliedes
#

	set kbf(1) $kb
#
	set i 1
	while {$i < $n} {
	    incr i
	    set kbf($i) $kbf([expr $i-1])
	    if {$m == 4} then {
		if {$phib(1) == $phiver(1) && $i == 2} then {
 #
		} else {
		    if {[string range $cl1 1 1] == "u"} then {
			set iverz 0
			while {$iverz < 3} {
			    incr iverz
			    if {$phib([expr $i-1]) < $phiver($iverz) \
			    && $phib($i) >= $phiver($iverz)} then {
				set kbf($i) [expr -1.*$kbf($i)]
			    }
			}
		    } else {
			if {$phib([expr $i-1]) < $phiver(1) && \
			$phib(i) >= $phiver(1)} then {
			    set kbf($i) [expr -1.*$kbf($i)]
			}
			if {$phib([expr $i-1]) > $phiver(1) && \
			$phib(i) <= $phiver(1)} then {
			    set kbf($i) [expr -1.*$kbf($i)]
			}
		    }
		}
	   }
      }
#
      return $kbf($n)
}
#############################################################
proc VMaxMinAntriebswinkel {cl1 mGetr al1 al2 al3 al4} {

    global drad Pi

#ges.: dpmin dmpax

    if {[string range $cl1 1 1] == "u"} then {
# umlaufend
	if {[string range $cl1 0 0] == "2"} then {
	    set ium 2.
	} else {
	    set ium 1.
	}
	set dpmin 0.
	set dpmax [expr 360.*$ium]
    } else {
# schwingend
	set h1 [expr $al1*$al1-$al2*$al2-$al3*$al3+$al4*$al4]
	set h2 [expr 2.*$al2*$al3]
	set h3 [expr 2.*$al1*$al4]
	set h4 [expr ($h1+$h2)/$h3]
	if {$h4 > 1.} then {
	    set h4 1.
#	    puts "acos($h4)=acos(1)"
	} elseif {$h4 < -1.} then {
	    set h4 -1.
#	    puts "acos($h4)=acos(-1)"
	}
	set h5 [expr ($h1-$h2)/$h3]
	if {$h5 > 1.} then {
	    set h5 1.
#	    puts "acos($h5)=acos(1)"
	} elseif {$h5 < -1.} then {
	    set h5 -1.
#	    puts "acos($h5)=acos(-1)"
	}
	if {$mGetr != 3} then {
	    set dpmin [expr acos ($h4)]
	    set dpmax [expr acos ($h5)]
	} elseif {$cl1 == "is"} then {
	    set dpmax [expr acos ($h5)]
	} else {
	    set dpmin [expr acos ($h4)]
	}
 
	if {$cl1 == "is"} then {
	    set dpmin [expr -1.*$dpmax]
	} elseif {$cl1 == "as"} then {
	    set dpmax [expr 2.*$Pi-$dpmin]
	} else {
	    if {[info exists dpmax] == 0} then {
		puts "(Programm-)Fehler: cl1=$cl1, mGetr=$mGetr"
		set dpmax [expr 2.*$Pi-$dpmin]
	    }
	}

	set dpmin [expr $dpmin/$drad]
	set dpmax [expr $dpmax/$drad]
    }
    return "$dpmin $dpmax"
}
###############################################################
proc VAnUAbtriebParallel {lges_phiP_ phiParallel_} {
# Ermitteln des Antriebswinkels von Parallellagen des An- und des
# Abtriebgliedes

    global al1 al2 al3 al4 drad kbf mGetr cl1 cl3
    
    upvar $lges_phiP_ lges_phiP
    upvar $phiParallel_ phiParallel

    catch (unset phiParallel)
    set eps 0.0000001

    set lges_phiP(1) 0
    set lges_phiP(-1) 0
    foreach l13 "[expr $al3+$al1] [expr $al3-$al1]" {
	if {abs($l13) > $eps && $al2 < [expr $al4+$l13]} then {
	    set l13q [expr $l13*$l13]
	    set l1q [expr $al1*$al1]
	    set l2q [expr $al2*$al2]
	    set l3q [expr $al3*$al3]
	    set l4q [expr $al4*$al4]
	    set arg [expr ($l4q-$l2q+$l13q)/(2.*$al4*$l13)]
	    if {$arg > 1.} then {
		set arg 1.
	    } elseif {$arg < -1.} then {
		set arg -1.
	    }
	    set phiP [expr acos($arg)/$drad]

	    if {$mGetr == 1 && $cl1 == " u"} then {
		set phiPar [expr $kbf(1)*$phiP]
		VaddPhiParallel $phiPar lges_phiP phiParallel
	    } else {
		VaddPhiParallel $phiP lges_phiP phiParallel
#		set phiPar [expr -1.*$phiP]
#		VaddPhiParallel $phiPar lges_phiP phiParallel
		if {$cl1 == " s" && $cl3 == " u"} then {
#		    umlauffaehige Kurbelschwinge
		} else {
		    foreach i "1 -1" {
			set j 0
			set k [expr int(-1*$i)]
			while {$j < $lges_phiP($i)} {
			  incr j
			  if {$cl1 == "2u"} then {
			    set phiParallel($k,[expr $lges_phiP($i)+$j]) \
				[expr $phiParallel($i,$j)+360.]
			  } else {
			    set phiParallel($k,[expr $lges_phiP($k)+$j]) \
				[expr -1.*$phiParallel($i,$j)]
			  }
			}
			set lges_phiP($k) $j
		    }
		}
	    }
	}
    }
}
###############################################################
proc VaddPhiParallel {phi lges_phiP_ phiParallel_} {

    global kbf mGetr cl1 cl3 dpmax dpmin

    upvar $lges_phiP_ lges_phiP
    upvar $phiParallel_ phiParallel

    set eps 0.01

    if {$phi == 0.} then {return}
    if {$phi == 180.} then {return}
    if {$phi == 360.} then {return}
    if {$phi == 540.} then {return}
    if {$phi == 720.} then {return}

    if {$cl1 == "2u"} then {
       set for "$phi [expr $phi+180.] [expr $phi+360.] [expr $phi+540.]"
       set w360 720.
    } else {
	set for "$phi [expr $phi+180.]"
       set w360 360.
    }
    foreach phiPar180 $for {
	foreach phiPar "$phiPar180 [expr -1.*$phiPar180]" {
	    set phiP $phiPar
	    while {$phiP < $dpmin} {
		set phiP [expr $phiP+$w360]
	    }
	    while {$phiP > $dpmax} {
		set phiP [expr $phiP-$w360]
	    }
	    set phiPv $phiP

	    if {$cl1 == "2u"} then {
		while {$phiPv < 0} {
		    set phiPv [expr $phiPv+360.]
		}
		while {$phiPv > 360} {
		    set phiPv [expr $phiPv-360.]
		}
	    }
#puts "1: phiP=$phiP, phiPv=$phiPv"

	    if {$phiP > $dpmin} then {
		if {$mGetr == 1 && $cl1 == " u"} then {
		    set forEach $kbf(1)
		} else {
		    set forEach "1.0 -1.0"
		}
		foreach kb "$forEach" {
		    set psiP [uebfk0 $kb $phiP 1 yes]
		    set ikb [expr int($kb)]
		    while {$psiP < 0.} {
			set psiP [expr $psiP+360.]
			}
		    while {$psiP > 360.} {
			set psiP [expr $psiP-360.]
		    }
		    if {[expr abs($phiPv-$psiP)] < $eps} then {
			incr lges_phiP($ikb)
			set phiParallel($ikb,$lges_phiP($ikb)) $phiP
#puts "2: phiP=$phiP, phiPv=$phiPv"
		    }
		    set psiP [expr $psiP+180.]
		    while {$psiP < 0.} {
			set psiP [expr $psiP+360.]
		    }
		    while {$psiP > 360.} {
			set psiP [expr $psiP-360.]
		    }
		    if {[expr abs($phiPv-$psiP)] < $eps} then {
			incr lges_phiP($ikb)
			set phiParallel($ikb,$lges_phiP($ikb)) $phiP
#puts "3: phiP=$phiP, phiPv=$phiPv"
		    }
		}
	    }
	}
    }
}
###############################################################
proc VFeldAntriebswinkel {kb dphi_df dfphi_ kb_df_ plot_df_ phiParallel_ lges_phiP_ kjk__} {

    global dpmax dpmin cl1 drad
    global mGetr

    upvar $dfphi_ dfphi
    upvar $kb_df_ kb_df
    upvar $plot_df_ plot_df
    upvar $phiParallel_ phiParallel
    upvar $lges_phiP_ lges_phiP
    upvar $kjk__ kjk_

# gesucht: dfphi lges_df

#ipmax = 1 --> Phimax wird nur einmal berechnet

     set ipmax 1 
     set eps .1

     if {$ipmax == 1 && [string range $cl1 1 1] == "s"} then {
#	 Phimax ein mal berechnen
	 set dpmaxneu [expr ($dpmax-$dphi_df)]
     } else {
	set dpmaxneu [expr $dpmax]
     }
     set lges_df 1
     set dfphi(1) $dpmin
     set kb_df(1) $kb
     set plot_df(1) 1
# proc kbvphi_1 initialisieren durch kjk=0
     set kjk_ 0
     set dpmaxeps [expr $dpmaxneu+0.01*$dphi_df]
     while {$dfphi($lges_df) <= $dpmaxeps} {
	incr lges_df
	set dfphi($lges_df) \
	    [expr int($dfphi([expr $lges_df-1])+$dphi_df)]
	set kb_df($lges_df) \
	    [kbvphi_1 $lges_df dfphi $kb_df([expr $lges_df-1]) kjk_]
	set lges_df [VInsertParallelLage \
		$eps $lges_df dfphi kb_df plot_df phiParallel lges_phiP]
     }
#
# Berechnung der Winkel PHI fuer den Rueckschwingvorgang.
#
    if {[string range $cl1 1 1] == "s"} then {
	set dfphi($lges_df) $dpmax
#	incr lges_df
#	set dfphi($lges_df) $dpmaxneu
	set kb_df($lges_df) \
	    [kbvphi_1 $lges_df dfphi $kb_df([expr $lges_df-1]) kjk_]
	set lges_df [VInsertParallelLage \
		$eps $lges_df dfphi kb_df plot_df phiParallel lges_phiP]
	set dpmineps [expr ($dpmin-0.01*$dphi_df)]
	while {$dfphi($lges_df) >= $dpmineps} {
	    incr lges_df
	    set dfphi($lges_df) \
		[expr ceil($dfphi([expr $lges_df-1])-$dphi_df)]
	    set kb_df($lges_df) \
		[kbvphi_1 $lges_df dfphi $kb_df([expr $lges_df-1]) kjk_]
	    set lges_df [VInsertParallelLage \
		-$eps $lges_df dfphi kb_df plot_df phiParallel lges_phiP]
	}
	set dfphi($lges_df) $dpmin
    }
    set lges_df [expr $lges_df-1]

    return $lges_df

#   set i 0
#   while {$i < $lges_df} {
#	incr i
#	puts "dphi($i)=$dfphi($i), plot_df($i)=$plot_df($i),\
#kb_df=$kb_df($i)"
#   }
}
###############################################################
proc VInsertParallelLage {eps lges_df dfphi_ kb_df_ plot_df_ phiParallel_ lges_phiP_} {

    upvar $dfphi_ dfphi
    upvar $kb_df_ kb_df
    upvar $plot_df_ plot_df
    upvar $phiParallel_ phiParallel
    upvar $lges_phiP_ lges_phiP


    set kb $kb_df($lges_df)
    set ikb [expr int($kb)]
    set lge $lges_phiP($ikb)

    set plot_df($lges_df) $plot_df([expr $lges_df-1])

    set ii 0
    while {$ii < $lge} {
	incr ii
	set phI $phiParallel($ikb,$ii)
	if {$eps > 0} then {
	    set vergleich1 $dfphi($lges_df)
	    set vergleich2 $phI
	    if {$lges_df > 1} then {
		set vergleich4 $dfphi([expr $lges_df-1])
		set vergleich3 $phI
	    } else {
		set vergleich3 $dfphi($lges_df)
		set vergleich4 $phI
	    }
	} else {
	    set vergleich2 $dfphi($lges_df)
	    set vergleich1 $phI
	    if {$lges_df > 1} then {
		set vergleich3 $dfphi([expr $lges_df-1])
		set vergleich4 $phI
	    } else {
		set vergleich4 $dfphi($lges_df)
		set vergleich3 $phI
	    }
	}
	if {$vergleich1 >= $vergleich2} then {
	  if {$vergleich3 >= $vergleich4} then {
	    set tausch $dfphi($lges_df)
	    set dfphi($lges_df) [expr $phI-$eps]
	    set kb_df($lges_df) $kb
#puts "P1: dfphi($lges_df)=$dfphi($lges_df), lge=$lge, ikb=$ikb, eps=$eps"
	    incr lges_df
	    set dfphi($lges_df) \
		[expr $phI+$eps]
	    set kb_df($lges_df) $kb
	    set plot_df($lges_df) [expr $plot_df([expr $lges_df-1])+1]
#puts "P2: dfphi($lges_df)=$dfphi($lges_df), ikb=$ikb"
	    if {$eps > 0} then {
		set vergleich1 $dfphi($lges_df)
		set vergleich2 $tausch
	    } else {
		set vergleich2 $dfphi($lges_df)
		set vergleich1 $tausch
	    }
	    if {$vergleich1 < $vergleich2} then {
		incr lges_df
		set dfphi($lges_df) $tausch
		set kb_df($lges_df) $kb
		set plot_df($lges_df) $plot_df([expr $lges_df-1])
#puts "P3: dfphi($lges_df)=$dfphi($lges_df), ikb=$ikb"
	    }
	    if {$lge == 1} then {
		set lges_phiP($ikb) 0
	    } elseif {$ii == $lge} then {
		set lges_phiP($ikb) [expr $lge-1]
	    } else {
		set phiParallel($ikb,$ii) \
			$phiParallel($ikb,$lge)
		set lges_phiP($ikb) [expr $lge-1]
		break
	    }
	  }
	}
    }
    return $lges_df
}
###############################################################
#
# Unterprogramm, dass den zu berechnenden Antriebswinkeln PHI die je-
# weils benoetigte Kennzahl KB ( im Feld KBF ) zuordnet.
#
proc kbvphi_1 {i dfphi_ kb_df_im1 kjk__} {

    global phiver cl1 mGetr kjk_
    upvar $dfphi_ dfphi
    upvar $kjk__ kjk_

# gesucht: kb_df

#     subroutine kbvphi (lges_df,m,dfphi,kb_df,kb,phiver,cl1)
#
# gegeben: lges_df,m,dfphi,kb,phiver,cl1
#
# nm8	= definierte Laenge der eindimensionalen Felder
# lges_df     = Anzahl der zu berechnenden Stuetzstellen
# m	= Kennzahl der Laufeigenschaft: M=1 => umlauffaehig
#					M=2 => durchschlagfaehig
#					M=3 => totalschwingfaehig
#					M=4 => durchschlagend
# dfphi   = Feld der zu berechnenden Antriebswinkel PHI in Grad
# kb_df   = Feld der benoetigten Kennzahlen KB
# kb	= Bewegungsbereichskennzahl bzw. Startbewegumgsbereichskennzahl
# phiver  = Feld der Verzweigungswinkel in Grad
# cl1	= Bewegungsmoeglichkeit des Antriebsgliedes
#

	set im1 [expr $i-1]
	set kb_df_i $kb_df_im1
	if {$mGetr == 4} then {
	    if {$dfphi(1) == $phiver(1) && $i == 2} then {
	    } else {
		if {[string range $cl1 1 1] == "u"} then {
		    foreach k {1 2 3} {
			if {$dfphi($im1) < $phiver($k) } then {
			    if {$dfphi($i) >= $phiver($k)} then {
				set kb_df_i [expr -1.*$kb_df_i]
			    }
			}
		    }
		} else {
		    if {$dfphi($im1) < $phiver(1)} then {
			if {$dfphi($i) >= $phiver(1)} then {
			    set kb_df_i [expr -1.*$kb_df_i]
			}
		    } elseif {$dfphi($im1) > $phiver(1)} then {
			if {$dfphi($i) <= $phiver(1)} then {
			    set kb_df_i [expr -1.*$kb_df_i]
			}
		    }
		}
	    }
	}
	if {$kjk_ == 0} then {
	    if {$dfphi($i)-$dfphi($im1) <= 0.} then {
		set kb_df_i [expr -1.*$kb_df_im1]
		set kjk_ 1
	    }
	}
	return $kb_df_i
}
###############################################################
# ermitteln von phi2 eines Uebergangskurvenpunktes mit Naeherungsverfahren
# vergleiche mit upro VSelbstberuehrungskurve

proc calcUebergangskurvenpunkt {} {

     global kbf drad
     global phi1 phi2 al3 al4

     set psiB1 [uebfk0 $kbf(1) $phi1 1 no]
     set psiB2 [uebfk0 $kbf(1) $phi2 1 no]
     
     set phiB1 [expr $phi1*$drad]
     set phiB2 [expr $phi2*$drad]
     
     set xMi [expr $al4/2.]
     
     set i 0
     while {$i < 2} {
         incr i

         set tPsi [expr tan(($psiB1+$psiB2)/2.)]
         set tPhi [expr tan(($phiB2+$phiB1)/2.)]
         set tDelta [expr $tPsi-$tPhi]

         # Seite 156
         set bNvA 0.
         set mNvA [expr sin($phiB1)/cos($phiB1)]
         set mNvB [expr sin($psiB1)/cos($psiB1)]
         set bNvB [expr $al3*sin($psiB1)-$mNvB*($al4+$al3*cos($psiB1))]
         set xP20 [expr ($bNvA-$bNvB)/($mNvB-$mNvA)]
         set yP20 [expr $mNvA*$xP20+$bNvA]
         #set yP20b [expr $mNvB*$xP20+$bNvB]

         set xP20mMi [expr $xP20-$xMi]
         set tP [expr $tPsi+$tPhi]
         set z [expr $xP20mMi*$xP20mMi*($tDelta*$tDelta-$xMi*$xMi*$tP*$tP/($xP20mMi*$xP20mMi))]

         set p [expr 2./$z*$xMi*$xMi*$tDelta*$tDelta*$yP20]
         set q  [expr -1.*$xMi*$xMi/$z*($yP20*$yP20*$tP*$tP+$tDelta*$tDelta*$xP20mMi*$xP20mMi)]
         set pHalbe [expr $p/2.]
         tk_messageBox -message "xP20, yP20 = $xP20, $yP20,\ntDelta=$tDelta,\ntPhi=$tPhi\ntPsi=$tPsi\nphiB1=$phiB1\nphiB2=$phiB2"
         set sqrtPq [expr sqrt($pHalbe*$pHalbe-$q)]

         tk_messageBox -message "pHalbe=$pHalbe, sqrtPq=$sqrtPq"
         set yMiL(1) [expr -1.*$pHalbe+$sqrtPq]
         set yMiL(2) [expr -1.*$pHalbe-$sqrtPq]

         # Kontroll-Rechnung
         set yMi 283.57
         set yMiZeichnung $yMi
         set yP20mMi [expr $yP20-$yMi]
         set xD_1 [expr ($xMi*$xMi+$yMi*$yMi)/(1.+($yP20mMi*$yP20mMi/($xP20mMi*$xP20mMi)))]
         set xD_1d [expr sqrt($xD_1)-$xMi]
         set xD_2 [expr $xMi*$xMi*$tP*$tP/($tDelta*$tDelta)]
         set xD_2d [expr sqrt($xD_2)-$xMi]
         set xx1 [expr ($xMi*$xMi+$yMi*$yMi)*$tDelta*$tDelta]
         set xx2 [expr $xMi*$xMi*$tP*$tP*(1.+($yP20mMi*$yP20mMi/($xP20mMi*$xP20mMi)))]
         #set yMi_1r [expr $yMi*2*$xMi*$xMi*$tDelta*$tDelta*$yP20/($xP20mMi*$xP20mMi)-$yP20*$yP20*$xMi*$xMi*$tP*$tP/($xP20mMi*$xP20mMi)-
         set yMi_2 [expr sqrt(($p*$yMi+$q)*-1.)]

         set xD [expr $al4*$tPsi/$tDelta]
         set yD [expr $tPsi*$xD-$al4*$tPsi]

         set yMi $yMiL(1)
           set yP20mMi [expr $yP20-$yMi]
           set mMiP20 [expr $yP20mMi/$xP20mMi]
           set ri [expr sqrt($xMi*$xMi+$yMi*$yMi)]
           set yP20mMi_1 $yP20mMi
           set xD1 [expr $ri/sqrt(1.+$mMiP20*$mMiP20)+$xMi]
           set xD2 [expr -1.*$ri/sqrt(1.+$mMiP20*$mMiP20)+$xMi]
         set yMi $yMiL(2)
           set yP20mMi [expr $yP20-$yMi]
           set mMiP20 [expr $yP20mMi/$xP20mMi]
           set ri [expr sqrt($xMi*$xMi+$yMi*$yMi)]
           set yP20mMi_2 $yP20mMi
           set xD3 [expr $ri/sqrt(1.+$mMiP20*$mMiP20)+$xMi]
           set xD4 [expr -1.*$ri/sqrt(1.+$mMiP20*$mMiP20)+$xMi]
         tk_messageBox -message "xP20, yP20 = $xP20, $yP20\nxMi, yMi = $xMi, $yMiL(1)/$yMiL(2)\nri=$ri\nxP20mMi, yP20mMi=$xP20mMi, $yP20mMi_1/$yP20mMi_2\nxD=$xD=$xD1=$xD2=$xD3=$xD4\nxD_1=$xD_1, xD_2=$xD_2\nxD_1d=$xD_1d, xD_2d=$xD_2d\nxx1=$xx1, xx2=$xx2\nKontrolle P-Q-Formel: yMi_2=$yMi_2 (Sollwert: $yMiZeichnung)"
         #set ri1 [expr sqrt($al4*$al4/4.+$yMiL(1)*$yMiL(1))]
         #set ri2 [expr sqrt($al4*$al4/4.+$yMiL(2)*$yMiL(2))]

         set j 0
         while {$j < 2} {
             incr j

             set yMi $yMiL($j)
             set sqrtMi [expr sqrt($xMi*$xMi+$yMi*$yMi)]
             set deltaP20Mi [expr ($yP20-$yMi)/($xP20-$xMi)]
             set sqrtP20Mi [expr sqrt(1+$deltaP20Mi*$deltaP20Mi)]
             set phiG1($j) [expr 2*atan(-1.*$sqrtMi*$tDelta/($al4*$sqrtP20Mi))-$phiB1]
             set phiG2($j) [expr 2*atan($sqrtMi*$tDelta/($al4*$sqrtP20Mi))-$phiB1]
         }

         tk_messageBox -message "xP20, yP20 = $xP20, $yP20,\nphi1=$phi1,psi1=[expr $psiB1/$drad]\n xMi,yMi=$xMi,$yMiL(1)/$yMiL(2)\n\nphiB1=$phiB1\nphiB2=$phiB2\n\nphiG1(1)=$phiG1(1)\nphiG1(2)=$phiG1(2)\nphiG2(1)=$phiG2(1)\nphiG2(2)=$phiG2(2)\nxD=$xD, $xD1, $xD2, $xD4, $xD4\nyD=$yD"
     }

     return
}
###############################################################
# Unterprogramm zur Berechnung der Uebertragungsfunktionen nullter
# Ordnung fuer Kurbelschwingen, Doppelkurkeln, Doppelschwingen und
# der entsprechenden Durchschlaggetriebe.
#
proc uebfk0 {kb phi0 rdvw complete} {

    global Pi drad gam0 al1 al2 al3 al4

#     subroutine uebfk0 (*,*,ou,iu,kb,eps,phi0,drad,psi0,gam0,rdvw,abw)
#
# gegeben: kb,phi0,drad,rdvw
# gesucht: gam0, psi0
# Aufruf: set psi0 [uebfk0 ...]
#
# kb	= Bereichskennzahl
# eps	= Genauigkeit
# phi0	= vorgegebener Antreibswinkel PHI in grad
# drad	= Umrechnungsfaktor von Bogenma in Grad
#	  ( alpha in Grad = Alpha in Bogenma / drad )
# psi0	= Abtriebswinkel PSI in Grad
# gam0	= Koppelwinkel GAMMA in Grad
# rdvw	= Schrittweite bei der Bildung des Vergleichswertes:
#	  rdvw= 1. ==> Vorwaertsschwingvorgang
#	  rdvw=-1. ==> Rueckschwingvorgang
# abw	= Auseinanderklaffen der Glieder 2 und 3 bei ungenauer
#	  Berechnung
# complete = yes | no : 
#         no ==> nur Psi berechnen und im Bogenmass statt in Grad zurueck geben
#
      set eps [max $al1 $al2]
      set eps [max $eps $al3]
      set eps [expr [max $eps $al4]*0.000000001]
      set dphi [expr $phi0*$drad]
      set dsn [expr sin($dphi)]
      set dcs [expr cos($dphi)]
#
      set dt [expr $al4-$al1*$dcs]
      set du [expr $al1*$dsn]
      set dh1 [expr $al3*$al3-$al2*$al2]
      set dh2 [expr $al1*$al1+$al4*$al4]
      set dh3 [expr $al1*$al4]
      set da [expr ($dh1+$dh2)/(2.*$al3)]
      set dal1 [expr $dh3/$al3]
      set db [expr ($dh1-$dh2)/(2.*$al2)]
      set db1 [expr $dh3/$al2]
      set dv [expr $da-$dal1*$dcs]
      set dw [expr $db+$db1*$dcs]
#
      set dh1 [expr $dt*$dt+$du*$du]
      set diffv [expr $dv-$dt]
      set diffw [expr $dw-$dt]
#
      set dwv [expr $dh1-$dv*$dv]
      set dww [expr $dh1-$dw*$dw]
#
      if {$dwv >= 0. && $dww >= 0.} then {
      } else {
	  if {$dwv < 0.} then {set dwv 0.}
	  if {$dww < 0.} then {set dww 0.}
      }
      if {[expr abs($diffv)] < $eps} then {
	  if {[expr abs($du)] >= $eps && \
	  [expr abs($du+$kb*abs($du))] >= $eps} then {
	      set psi $Pi
	  } elseif {[expr abs($du)] >= $eps} then {
	      set psi [expr 2.*atan($dt/$du)]
	  } else {
	      if {[expr abs($dt)] < $eps} then {
		  if {$al1 != $al2 && $kb == 1} then {
		      set psi $Pi
		      if {$rdvw == -1} then {
			  set psi 0.
		      }
		  } else {
		      set psi  0.
		  }
	      } elseif {[expr abs($dt)] >= $eps} then {
		  set psi [expr acos(($al2*$al2-$al3*$al3-$dt*$dt)/\
			  (2.*$al3*$dt))]
	      }
	  }
      } else {
	    set dtp [expr ($du+$kb*sqrt($dwv))/$diffv]
	    set psi [expr 2.*atan($dtp)]
      }
      
      if {$complete == "no"} then {
          return $psi
      }
#
# Berechnung von Gamma.
#
      if {[expr abs($diffw)] < $eps} then {
	  if {[expr abs($du)] >= $eps && \
	  [expr abs($du+$kb*abs($du))] >= $eps} then {
	      set gam $Pi
	  } elseif {[expr abs($du)] >= $eps} then {
	      set gam [expr 2.*atan($dt/$du)]
	  } else {
	      if {[expr abs($dt)] < $eps} then {
		  if {$al1 != $al2 && $kb == 1} then {
		      set gam $Pi
		      if {$rdvw == -1} then {
			  set gam 0.
		      }
		  } else {
		      set gam 0.
		  }
	      } elseif {[expr abs($dt)] >= $eps} then {
		  set gam [expr acos(($al2*$al2-$al3*$al3+$dt*$dt)/\
			  (2.*$al2*$dt))]
	      }
	  }
      } else {
	  set dtg [expr ($du+$kb*sqrt($dww))/$diffw]
	  set gam [expr 2.*atan($dtg)]
      }
#
      set psi0 [expr $psi/$drad]
      set gam0 [expr $gam/$drad]
#
# Ueberpruefung ob Vektorpoligon geschlossen
#
      set softwaretest ja
      if {$softwaretest == "ja"} then {
	  set erg1 [expr $al1*$dcs+$al2*cos($gam)-$al3*cos($psi)-$al4]
	  set erg2 [expr $al1*$dsn+$al2*sin($gam)-$al3*sin($psi)]
	  set abw [expr sqrt($erg1*$erg1+$erg2*$erg2)]
#
	  if {$abw > 0.001} then {
	      set statuszeile "Bei Phi =$phi0 Grad ist die Berechnung ungenau! Klaffung: $abw mm"
	  }
      }
#
      return $psi0
}
#############################################################
proc VSchwingwinkelBegrenzung {} {

    global al1 al2 al3 al4 mGetr d_minGetr d_maxGetr kbf Pi
    global wc xregion_ yregion_ drad xkSwBgA ykSwBgA xkSwBgB ykSwBgB
    global xkSwBg ykSwBg xregion_

# Koppelfeste SchwingwinkelBegrenzungsgeraden im Punkt A

    set lista [VSchwingwinkelfeld $mGetr $al1 $al4 $al3 $al2 \
	    xkSwBgA ykSwBgA A]
# Koppelfeste SchwingwinkelBegrenzungsgeraden im Punkt B

    set listb [VSchwingwinkelfeld $mGetr $al3 $al4 $al1 $al2 \
	    xkSwBgB ykSwBgB B]

    set xkSwBg(0,0) 0
    if {$xkSwBgA(0,0) > 0} then {
	if {$xkSwBgB(0,0) > 0} then {
# Schwingwinkelbegrenzungsgeraden in A und B
	    set wMinA [lrange $lista 0 0]
	    set wMaxA [lrange $lista 1 1]
	    set wMinB [lrange $listb 0 0]
	    set wMaxB [lrange $listb 1 1]
	    set schnitt1 [s_schnitt_2g_solo 0. 0. $al2 0. $wMinA $wMaxB]
	    if {$schnitt1 == "Fehler"} then {return}
	    set schnitt3 [s_schnitt_2g_solo 0. 0. $al2 0. $wMaxA $wMinB]
	    if {$schnitt3 == "Fehler"} then {return}
	    set x1 [lrange $schnitt1 0 0]
	    set y1 [lrange $schnitt1 1 1]
	    set x3 [lrange $schnitt3 0 0]
	    set y3 [lrange $schnitt3 1 1]
#puts "y1=$y1, y2=$y2, y3=$y3, y4=$y4"
	    if {$mGetr == 1} then {
# Doppelkurbel
		set schnitt2 \
		    [s_schnitt_2g_solo 0. 0. $al2 0. $wMaxA $wMaxB]
		if {$schnitt2 == "Fehler"} then {return}
		set schnitt4 \
		    [s_schnitt_2g_solo 0. 0. $al2 0. $wMinA $wMinB]
		if {$schnitt4 == "Fehler"} then {return}
		set x2 [lrange $schnitt2 0 0]
		set y2 [lrange $schnitt2 1 1]
		set x4 [lrange $schnitt4 0 0]
		set y4 [lrange $schnitt4 1 1]
		set xkSwBg(1,1) $x4
		set ykSwBg(1,1) $y4
		set xkSwBg(1,2) $x3
		set ykSwBg(1,2) $y3
		set xkSwBg(1,3) $x2
		set ykSwBg(1,3) $y2
		if {[expr $y2*$y1] > 0} then {
# Feld wird durch 4 Schnittpunkt gebildet
		    set xkSwBg(1,4) $x1
		    set ykSwBg(1,4) $y1
		    set i 5
		} else {
# Feld liegt gegenueber dem 3. Schnittpunkt (Es wird durch 5 
# Schnittpunkte gebildet)

# alte Lsung funktioniert nicht mehr. Grund ist unbekannt!
# alte Lsung	    set ykSwBg(1,4) [expr $xregion_*sin(\
# alte Lsung		[expr ($wMaxB+180.)*$drad])]
# alte Lsung	    set xkSwBg(1,4) [expr $xregion_*cos(\
# alte Lsung		[expr ($wMaxB+180.)*$drad])+$al2]
# alte Lsung	    set ykSwBg(1,5) [expr $xregion_*sin(\
# alte Lsung		[expr ($wMinA+180.)*$drad])]
# alte Lsung	    set xkSwBg(1,5) [expr $xregion_*cos(\
# alte Lsung		[expr ($wMinA+180.)*$drad])]
		    set xkSwBg(1,1) $x4
		    set ykSwBg(1,1) $y4
		    set xkSwBg(1,2) $x3
		    set ykSwBg(1,2) $y3
		    set ykSwBg(1,3) [expr $xregion_*sin(\
			[expr ($wMaxA+180.)*$drad])]
		    set xkSwBg(1,3) [expr $xregion_*cos(\
			[expr ($wMaxA+180.)*$drad])]
		    set ykSwBg(1,4) [expr $xregion_*sin(\
			[expr ($wMaxB+180.)*$drad])]
		    set xkSwBg(1,4) [expr $xregion_*cos(\
			[expr ($wMaxB+180.)*$drad])+$al2]
		    set xkSwBg(1,5) $x1
		    set ykSwBg(1,5) $y1
		    set i 6
		}
		set xkSwBg(1,$i) $x4
		set ykSwBg(1,$i) $y4
		set xkSwBg(1,0) $i
#puts "$wMinA $wMaxA $wMinB $wMaxB"
#puts "y1=$y1 y2=$ykSwBg(1,2), y3=$y3, y4=$ykSwBg(1,2)"
		set xkSwBg(0,0) 1
	    } elseif {$mGetr == 3} then {
# Totalschwingfaehiges Getriebe

# Dreieck bei A
		set xkSwBg(1,1) 0.0
		set ykSwBg(1,1) 0.0
		if {[expr abs($wMinA)] < 90} then {
		    set bMinA [expr abs([expr $Pi-$wMinA*$drad])]
		} else {
		    set bMinA [expr abs([expr $wMinA*$drad])]
		}
		set bMaxA [expr -$bMinA]
		set xkSwBg(1,2) [expr $xregion_*cos($bMinA)]
		set ykSwBg(1,2) [expr $xregion_*sin($bMinA)]
		set xkSwBg(1,3) [expr -$xregion_]
		set ykSwBg(1,3) [expr $xregion_*sin($bMinA)]
		set xkSwBg(1,4) [expr -$xregion_]
		set ykSwBg(1,4) [expr $xregion_*sin($bMaxA)]
		set xkSwBg(1,5) [expr $xregion_*cos($bMaxA)]
		set ykSwBg(1,5) [expr $xregion_*sin($bMaxA)]
#		set xkSwBg(1,6) 0.0
#		set ykSwBg(1,6) 0.0
# unterer Teil des Viereck zwischen A und B
		set xkSwBg(1,6) 0.0
		set ykSwBg(1,6) 0.0
		set xkSwBg(1,7) $x1
		set ykSwBg(1,7) $y1
		set xkSwBg(1,8) $al2
		set ykSwBg(1,8) 0.0
# Dreieck bei B
		if {[expr abs($wMinB)] > 90} then {
		    set bMinB [expr abs([expr $Pi-$wMinB*$drad])]
		} else {
		    set bMinB [expr abs([expr $wMinB*$drad])]
		}
		set bMaxB [expr -$bMinB]
		set xkSwBg(1,9) [expr $xregion_*cos($bMinB)+$al2]
		set ykSwBg(1,9) [expr $xregion_*sin($bMinB)]
		set xkSwBg(1,10) [expr $xregion_+$al2]
		set ykSwBg(1,10) [expr $xregion_*sin($bMinB)]
		set xkSwBg(1,11) [expr $xregion_+$al2]
		set ykSwBg(1,11) [expr $xregion_*sin($bMaxB)]
		set xkSwBg(1,12) [expr $xregion_*cos($bMaxB)+$al2]
		set ykSwBg(1,12) [expr $xregion_*sin($bMaxB)]
# oberer Teil des Viereck zwischen A und B
		set xkSwBg(1,13) $al2
		set ykSwBg(1,13) 0.0
		set xkSwBg(1,14) $x3
		set ykSwBg(1,14) $y3
		set xkSwBg(1,15) 0.0
		set ykSwBg(1,15) 0.0
		set xkSwBg(1,0) 15
		set xkSwBg(0,0) 1
	    }
	}
    }
}
##################################################################
proc s_schnitt_2g_solo {x1 y1 x2 y2 winkel1 winkel2} {

    global drad

    set m1 [expr tan($winkel1*$drad)]
    set m2 [expr tan($winkel2*$drad)]
    set b1 [expr $y1-$m1*$x1]
    set b2 [expr $y2-$m2*$x2]
    set m2m1 [expr $m2-$m1]
    if {[expr abs($m2m1)] > 0.000000001} then {
	set xs [expr ($b1-$b2)/($m2m1)]
	set ys [expr ($b1*$m2-$b2*$m1)/($m2m1)]
	return "$xs $ys"
    } else {
	return "Fehler"
    }
}
#############################################################
proc VSchwingwinkelfeld {mGetr bl1 bl4 bl3 bl2 xkSwBg ykSwBg G} {

    global wc xregion_ drad wc d_minGetr d_maxGetr kbf Pi
    global al1 al2 al3 al4
    upvar $xkSwBg xkSwBgA
    upvar $ykSwBg ykSwBgA

    if {$mGetr == 4} then {
# SchwingwinkelBegrenzungsgeraden sind bei Durchschlaggetriebe nicht
# von interesse
	set xkSwBgA(0,0) 0
	return -
    }

    set list [geart $bl1 $bl4 $bl3 $bl2 $mGetr $d_minGetr \
	$d_maxGetr [expr -1.*$kbf(1)]]
    #set cl1 [string range $list 0 1]
    #set cl3 [string range $list 3 4]
    #VSetHelpText1 $cl1 $cl3
    set cl1 [string range $list 1 1]

    if {[string range $cl1 1 1] != "u"} then {
	set mue_exist 0
	set mueMax_exist 0
	set mueMin_exist 0
	if {$G == "A"} then {
# Gelenk A
	    set bl2p 0
	    if {[expr $al2+$al1] > [expr $al4+$al3]} then {
		set mueMax [expr -$kbf(1)*($Pi-[cosinusSatz \
		    [expr $al4+$al3] $al2 $al1])]
		set mueMax_exist 1
	    }
	    if {[expr abs($al2-$al1)] < [expr abs($al4-$al3)]} then {
		set mueMin [expr -$kbf(1)*($Pi-[cosinusSatz \
		    [expr $al4-$al3] $al2 $al1])]
		set mueMin_exist 1
	    }
	} else {
# Gelenk B
	    set bl2p $al2
	    if {[expr $al2+$al3] > [expr $al4+$al1]} then {
		set mueMax [expr -$kbf(1)*[cosinusSatz \
		    [expr $al4+$al1] $al2 $al3]]
		set mueMax_exist 1
	    }
	    if {[expr abs($al2-$al3)] < [expr abs($al4-$al1)]} then {
		set mueMin [expr -$kbf(1)*[cosinusSatz \
		    [expr $al4-$al1] $al2 $al3]]
		set mueMin_exist 1
	    }
	}
	if {$mGetr == 1 } then {
# umlaufend
	    if {$mueMax_exist == 1 && $mueMin_exist == 1} then {
	    set mue_exist 1
	    }
	} elseif {$mGetr == 3 } then {
# totalschwingend
	    if {$G == "A"} then {
# Gelenk A
		if {$mueMax_exist == 1} then {
# l1-l3: Aussen-Aussenschwinge oder Innen-Aussenschwinge
		    set mueMin [expr abs($mueMax)]
		    set mueMax [expr 2*$Pi-$mueMin]
		    set mue_exist 1
		} elseif {$mueMin_exist == 1} then {
# l1-l3: Innen-Aussenschwinge oder Innen-Innenschwinge
		    set mueMin [expr -abs($mueMin)]
		    set mueMax [expr -$mueMin]
		    set mue_exist 1
		}
	    } else {
# Gelenk B
#		if {[expr $al1+$al2] > [expr $al3+$al4]} then {
# l3 aussenschwingend
#		} else {
# l3 innenschwingend
#		}
		if {$mueMax_exist == 1} then {
# l3-l1: Aussen-Aussenschwinge oder Innen-Aussenschwinge
		    set mueMin [expr -abs($mueMax)]
		    set mueMax [expr -$mueMin]
		    set mue_exist 1
		} elseif {$mueMin_exist == 1} then {
# l3-l1: Innen-Aussenschwinge oder Innen-Innenschwinge
		    set mueMin [expr abs($mueMin)]
		    set mueMax [expr 2*$Pi-$mueMin]
		    set mue_exist 1
		}
	    }
	}

	if {$mue_exist == 1 && [expr abs($mueMax-$mueMin)] < $Pi} then {
	    set xkSwBgA(1,1) $bl2p
	    set ykSwBgA(1,1) 0
	    set xkSwBgA(1,2) [expr $xregion_*cos($mueMin)+$bl2p]
	    set ykSwBgA(1,2) [expr $xregion_*sin($mueMin)]
	    if {$mGetr == 3} then {
# Totalschwingfaehiges Getriebe: Dreieck in Richtung x-Achse verlaengern
		if {$xkSwBgA(1,2) > 0} then {
		    set vorz 1
		} else {
		    set vorz -1
		}
#		if {$G == "A"} then {set vorz [expr -1*$vorz]}
		set xkSwBgA(1,3) [expr $xregion_*$vorz+$bl2p]
		set ykSwBgA(1,3) [expr $xregion_*sin($mueMin)]
		set xkSwBgA(1,4) [expr $xregion_*$vorz+$bl2p]
		set ykSwBgA(1,4) [expr $xregion_*sin($mueMax)]
	    } elseif {$mGetr == 1} then {
# Umlauffaehiges Getriebe: Dreieck in Richtung y-Achse verlaengern
		if {$ykSwBgA(1,2) > 0} then {
		    set vorz 1
		} else {
		    set vorz -1
		}
		set xkSwBgA(1,3) [expr $xregion_*cos($mueMin)+$bl2p]
		set ykSwBgA(1,3) [expr $xregion_*$vorz]
		set xkSwBgA(1,4) [expr $xregion_*cos($mueMax)+$bl2p]
		set ykSwBgA(1,4) [expr $xregion_*$vorz]
	    }
	    set xkSwBgA(1,5) [expr $xregion_*cos($mueMax)+$bl2p]
	    set ykSwBgA(1,5) [expr $xregion_*sin($mueMax)]
	    set xkSwBgA(1,6) $bl2p
	    set ykSwBgA(1,6) 0
	    set xkSwBgA(1,7) \
		[expr $xregion_*cos([expr ($Pi+$mueMin)])+$bl2p]
	    set ykSwBgA(1,7) [expr $xregion_*sin([expr ($Pi+$mueMin)])]
	    if {$mGetr == 3} then {
# Totalschwingfaehiges Getriebe: Dreieck in Richtung x-Achse verlaengern
		set xkSwBgA(1,8) [expr -$xregion_*$vorz+$bl2p]
		set ykSwBgA(1,8) [expr $xregion_*sin([expr ($Pi+$mueMin)])]
		set xkSwBgA(1,9) [expr -$xregion_*$vorz+$bl2p]
		set ykSwBgA(1,9) [expr $xregion_*sin([expr ($Pi+$mueMax)])]
	    } elseif {$mGetr == 1} then {
# Umlauffaehiges Getriebe: Dreieck in Richtung y-Achse verlaengern
		set xkSwBgA(1,8) \
		    [expr $xregion_*cos([expr ($Pi+$mueMin)])+$bl2p]
		set ykSwBgA(1,8) [expr -$xregion_*$vorz]
		set xkSwBgA(1,9) \
		    [expr $xregion_*cos([expr ($Pi+$mueMax)])+$bl2p]
		set ykSwBgA(1,9) [expr -$xregion_*$vorz]
	    }
	    set xkSwBgA(1,10) \
		[expr $xregion_*cos([expr ($Pi+$mueMax)])+$bl2p]
	    set ykSwBgA(1,10) [expr $xregion_*sin([expr ($Pi+$mueMax)])]
	    set xkSwBgA(1,11) $bl2p
	    set ykSwBgA(1,11) 0
	    set xkSwBgA(0,0) 1
	    set xkSwBgA(1,0) 11

#puts "G=$G, mGetr=$mGetr, mueMin=[expr $mueMin/$drad], mueMax=[expr $mueMax/$drad]"
	    return "[expr $mueMin/$drad] [expr $mueMax/$drad]"
	} else {
	    set xkSwBgA(0,0) 0
	}
    }
    return -
}
############################################################
# Cosinus-Satz
proc cosinusSatz {a b c} {

    global drad

    set cosalpha [expr ($b*$b+$c*$c-$a*$a) / (2*$b*$c) ]
    return [expr acos($cosalpha)]
}
proc VpsiZa {psiZr_ lges_ dfphi_ psiZrA_} {

    upvar $psiZr_ psiZr
    upvar $lges_ lges
    upvar $dfphi_ dfphi
    upvar $psiZrA_ psiZrA

    cubicp  $lges dfphi psiZr y2
    koeff $lges dfphi psiZr y2 acs bcs ccs dcs
    set i_spline 1
    set i 0
    while {$i < $lges} {
	incr i
	spline_a_interp $dfphi($i) $lges dfphi acs bcs ccs dcs i_spline y_neu ya_neu
	set psiZrA($i) $ya_neu
	#puts "i=$i, dfphi($i)=$dfphi($i), psiZr($i)=$psiZr($i), y_neu=$y_neu, ya_neu=$ya_neu"
    }
}
#############################################################
proc VShowZweischlagHodograph {} {

    global showZweiSchlagHodograph showZweischlagWinkelDifferenz dateiNamePostfix wc massstab
    global DeltaPsiZ xk_df yk_df zwSHmasstab alz2  psiZ drad alzx alzy psiZr psiZrA
    global dfphi dpfhiOhneParallelLage lgesOhneParallelLage

    $wc delete geschw

    if {"$dateiNamePostfix" == "z"} then {
       if {$showZweiSchlagHodograph == 1} then {
	   set iz 1
	   while {$iz <= $lgesOhneParallelLage} {
	       #falsch set psiZr($iz) [expr $psiZ($item)*$drad]
	       set psiZr($iz) [expr $psiZ(1,$iz)*$drad]
	       incr iz
	   }
	   if {$showZweischlagWinkelDifferenz == 0} then {
	       # set lges [array size psiZr]
	       VpsiZa psiZr lgesOhneParallelLage dpfhiOhneParallelLage psiZrA
	   }
	   set iz 1
	   while {$iz <= $lgesOhneParallelLage} {
	       if {$showZweischlagWinkelDifferenz == 0} then {
		   set l [expr $alz2 + $psiZrA($iz)*$zwSHmasstab*300.]
	       } else {
		   #falsch set l [expr $alz2 + $DeltaPsiZ($item)*$zwSHmasstab]
		   set l [expr $alz2 + $DeltaPsiZ(1,$iz)*$zwSHmasstab]
	       }
	       #puts "iz=$iz, dfphi($iz)=$dfphi($iz), psiZr($iz)=$psiZr($iz), psiZrA($iz)=[expr $psiZrA($iz)*500.], $DeltaPsiZ(1,$iz)=DeltaPsiZ(1,$iz)"
	       #if {$l > $alz2} then {puts "l=$l, item=$item"}
	       set xzH_df(1,$iz) [expr $l*cos($psiZr($iz)) + $alzx]
	       set yzH_df(1,$iz) [expr $l*sin($psiZr($iz)) + $alzy]
	       set xzl_df(1,$iz) [expr $alz2*cos($psiZr($iz)) + $alzx]
	       set yzl_df(1,$iz) [expr $alz2*sin($psiZr($iz)) + $alzy]
	       $wc create line [expr round($xzH_df(1,$iz)/1000.*$massstab)] \
		   [expr round(-1*$yzH_df(1,$iz)/1000.*$massstab)] \
		   [expr round($xzl_df(1,$iz)/1000.*$massstab)] \
		   [expr round(-1*$yzl_df(1,$iz)/1000.*$massstab)] -tag geschw -fill lightgreen
	       incr iz
	   }
	   set j $xk_df(0,0)
	   set xzH_df(0,0) 1
	   set xzl_df(0,0) 1

	   set xzH_df(1,0) $lgesOhneParallelLage
	   set xzl_df(1,0) $lgesOhneParallelLage

	   VShowRastpolkurve xzH_df yzH_df ZweischlagHodo green green
	   VShowRastpolkurve xzl_df yzl_df ZweischlagBogen darkgreen darkgreen
       } else {
	   $wc delete ZweischlagHodo
	   $wc delete ZweischlagBogen
       }
    }
}
#############################################################
proc VKoppelpunktBahn {} {

    global al1 al2 lges_df alkx alky drad xk_df yk_df p alz1 alz2 kbz
    global dfgam dfphi maxFeldLine DeltaPsiZ psiZ
    global alzx alzy showZweiSchlagHodograph alzDistMax alzDistMin dateiNamePostfix
    global phiParallel dpfhiOhneParallelLage lgesOhneParallelLage
    global xk1_df yk1_df xk2_df yk2_df calcKue kbOhneParallelLage kb_df

    catch {unset DeltaPsiZ}

    set eps [expr atan2($alky,$alkx)]
    set alk [expr sqrt($alkx*$alkx+$alky*$alky)]

    set alk1 [expr -1.*$al2/10.]
    set alk2 [expr 9.*$al2/10.]

    set alzDistMaxQ 0
    set alzDistMinQ 1000000000000.

    set j_old 0
    set k_old 0
    set psiZ(0,0) 0
    #set psiZ(0) 0

    set j 1
    set i 0
    set k 0
    set iz 0
    while {$i < $lges_df} {
	incr i
	incr k
	incr iz
	set cont 0
	foreach parallellage [array names phiParallel] {
	   #puts "dfphi($i)=$dfphi($i), phiParallel($parallellage)=$phiParallel($parallellage), [expr $dfphi($i) - $phiParallel($parallellage)]"
	    set test [expr abs($dfphi($i) - $phiParallel($parallellage))]
	    if {[expr abs($test - 0.1)] < 0.01 || [expr abs($test + 0.1)] < 0.01} then {
# keine extra-Berechnung der Parallellage
		#puts "continue"
		set cont 1
		incr iz -1
	    }
	}
	if {$cont == 1} then {
	    incr k -1
	    continue
	}
	set dpfhiOhneParallelLage($k) $dfphi($i)
	set kbOhneParallelLage($k) $kb_df($i)
	set phi0 [expr $dfphi($i)*$drad]
	#puts "i=$i, k=$k, dfphi($i)=$dfphi($i), phi0=$phi0"
	set sinp [expr sin($phi0)]
	set cosp [expr cos($phi0)]
	set ge [expr $dfgam($i)*$drad+$eps]
	set sineg [expr sin($ge)]
	set coseg [expr cos($ge)]
	set xk_df($j,$k) [expr $alk*$coseg+$al1*$cosp]
	set yk_df($j,$k) [expr $alk*$sineg+$al1*$sinp]
	#puts "k=$k, Phi=$dpfhiOhneParallelLage($k), kb=$kbOhneParallelLage($k)"

	if {$calcKue == 1} then {
	    set g0 [expr $dfgam($i)*$drad]
	    set sin0g [expr sin($g0)]
	    set cos0g [expr cos($g0)]
	    set xk1_df($k) [expr $alk1*$cos0g+$al1*$cosp]
	    set yk1_df($k) [expr $alk1*$sin0g+$al1*$sinp]
	    set xk2_df($k) [expr $alk2*$cos0g+$al1*$cosp]
	    set yk2_df($k) [expr $alk2*$sin0g+$al1*$sinp]
	    #set D1 [expr $xk1_df($k)-$xk2_df($k)]
	    #set D2 [expr $yk1_df($k)-$yk2_df($k)]
	    #puts [expr $D1*$D1+$D2*$D2]
	}
	if {"$dateiNamePostfix" == "z"} then {
	     if {$showZweiSchlagHodograph == 1} then {
#Winkeldifferenz zwischen 2 Stuetzstellen des Abtriebswinkels des Zweischlags berechnen
	     # Abtriebswinkel des Zweischlags berechnen
		 set list [bere_zweischlag_m_punkt [expr $p(5,1)*1000] [expr $p(5,2)*1000] \
		    $alz2 $alz1 $xk_df($j,$k) $yk_df($j,$k) $kbz]
		 if { $k_old == 0} then {
		     set psiZ($j,$k) [expr atan2([expr [lrange $list 1 1]-[expr $p(5,2)*1000]],\
			 [expr [lrange $list 0 0]-[expr $p(5,1)*1000]])/$drad]
		     #set psiZ($iz) [expr atan2([expr [lrange $list 1 1]-[expr $p(5,2)*1000]],\
		     #	  [expr [lrange $list 0 0]-[expr $p(5,1)*1000]])/$drad]
		 } else {
		     set psiZ($j,$k) [expr [atan3 [expr [lrange $list 1 1]-[expr $p(5,2)*1000]] \
			 [expr [lrange $list 0 0]-[expr $p(5,1)*1000]] [expr $psiZ($j_old,$k_old)*$drad]] /$drad]
		     #set psiZ($iz) [expr [atan3 [expr [lrange $list 1 1]-[expr $p(5,2)*1000]] \
		     #	  [expr [lrange $list 0 0]-[expr $p(5,1)*1000]] [expr $psiZ([expr $iz-1])*$drad]] /$drad]
		 }
		 set DeltaPsiZ($j,$k) [expr $psiZ($j,$k) - $psiZ($j_old,$k_old)]
		 #set DeltaPsiZ($j,$k) [expr $psiZ($iz) - $psiZ([expr $iz-1])]
		 #puts "phi0=[expr $phi0/$drad], psiZ($j,$k)=$psiZ($j,$k), DeltaPsiZ($j,$k)=$DeltaPsiZ($j,$k)"
		 set j_old $j
		 set k_old $k
	     }
#Quadrat des minimalen und maximalen Abstands zum gestellfesten Gelenk des Zweischlags ermitteln
	     set xdiff [expr $xk_df($j,$k)-$alzx]
	     set ydiff [expr $yk_df($j,$k)-$alzy]
	     set diffQ [expr $xdiff*$xdiff+$ydiff*$ydiff]
	     if {$alzDistMaxQ < $diffQ } then {
		 set alzDistMaxQ $diffQ
	     }
	     if {$alzDistMinQ > $diffQ } then {
		 set alzDistMinQ $diffQ
	     }
	}
	if {$k > $maxFeldLine} then {
# maximale Feldlaenge fuers Plotten
	    set xk_df($j,0) $k
	    incr j
	    set xk_df($j,1) $xk_df([expr $j-1],$k)
	    set yk_df($j,1) $yk_df([expr $j-1],$k)
	    if {"$dateiNamePostfix" == "z"} then {
		if {$showZweiSchlagHodograph == 1} then {
		    #set DeltaPsiZ($j,1) $DeltaPsiZ([expr $j-1],$k)
		    set psiZ($j,1) $psiZ([expr $j-1],$k)
		}
	    }
	    set k 1
	}
    }

    incr k
    set xk_df($j,$k) $xk_df(1,1)
    set yk_df($j,$k) $yk_df(1,1)
    if {"$dateiNamePostfix" == "z"} then {
	if {$showZweiSchlagHodograph == 1} then {
	    set DeltaPsiZ(1,1) [expr $psiZ(1,1) - $psiZ($j_old,[expr $k_old-1])]
	    #set DeltaPsiZ(1,1) [expr $psiZ($iz) - $psiZ([expr $iz-1])]
	    while {$DeltaPsiZ(1,1) > 300} {
		# Winkel bereinigen: wieder aus dem Bereich um die 360 Grad
		# in den Bereich um 0 transferieren
		set DeltaPsiZ(1,1) [expr $DeltaPsiZ(1,1) -360]
	    }
	    #puts "DeltaPsiZ(1,1)=[expr $DeltaPsiZ(1,1)]"
	    #puts "psiZ($j_old,$k_old)=$psiZ($j_old,[expr $k_old-1]), psiZ(1,1)=$psiZ(1,1)"
	    set DeltaPsiZ($j,$k) $DeltaPsiZ(1,1)
	    set psiZ($j,$k) $psiZ(1,1)
	}
    }

    set xk_df(0,0) $j
    set xk_df($j,0) $k
    set lgesOhneParallelLage [expr $k-1]

    set alzDistMax [expr sqrt($alzDistMaxQ)]
    set alzDistMin [expr sqrt($alzDistMinQ)]

    return
}
#############################################################
proc VRastUGangpolkurvenpunkt {phi psi gamma calculateR calculateG i} {

    global drad xRast yRast xGang yGang al1 al4 lgesRast lgesGang

# calculateR = 1 --> neuen Rastpolkurvenpunkt berechnen
# calculateG = 1 --> neuen Gangpolkurvenpunkt berechnen

# gesucht: xRast(i,$lgesRast) yRast(i,$lgesRast)
#	   yGang(i,$lgesGang) yGang(i,$lgesGang)

	  set psir [expr $psi*$drad]
	  set phir [expr $phi*$drad]
#
	  set sinp [expr sin($psir)]
	  set cosp [expr cos($psir)]
	  set sinf [expr sin($phir)]
	  set cosf [expr cos($phir)]
	  set sinpf [expr $sinp*$cosf-$cosp*$sinf]
	  set cospf [expr $cosp*$cosf+$sinp*$sinf]
#
	  if {[expr abs($sinpf)] > 0.0000000001} then {
	      set daz [expr $al4*$sinp/$sinpf]

	      incr lgesRast
	      set xRast($i,$lgesRast) [expr $daz*$cosf]
	      set yRast($i,$lgesRast) [expr $daz*$sinf]

#	      if {$calculateG == 1 } then {
		  incr lgesGang

		  set gamr [expr $gamma*$drad]
#
		  set sing [expr sin($gamr)]
		  set cosg [expr cos($gamr)]
		  set cosfg [expr $cosf*$cosg+$sinf*$sing]
		  set sinfg [expr $sinf*$cosg-$cosf*$sing]
		  set cospf [expr $cosp*$cosf+$sinp*$sinf]
#
		  set daz [expr $daz-$al1]
		  set xGang($i,$lgesGang) [expr $daz*$cosfg]
		  set yGang($i,$lgesGang) [expr $daz*$sinfg]
#	      }
	  }
}
#############################################################
proc VUebertragungsfunktion {} {
    global mGetr d_minGetr d_maxGetr al1 al2 al3 al4 cl1 p
    global dphi_df dphi dpmin dpmax
    global kb_df dfphi dfgam dfpsi gam0 lges_df plot_df
    global xRast yRast xGang yGang lgesRast lgesGang
    global phiParallel lges_phiP kjk_

    if {$p(3,9) < 0} then {
	set kb +1.
    } else {
	set kb -1.
    }

    set lgesRast 0
    set lgesGang 0

    set list [VMaxMinAntriebswinkel $cl1 $mGetr $al1 $al2 $al3 $al4]
    set dpmin [lrange $list 0 0]
    set dpmax [lrange $list 1 1]
    VAnUAbtriebParallel lges_phiP phiParallel
#   phikrit 1 1 $mGetr $d_minGetr $d_maxGetr $cl1 $al1 $al2 $al3 $al4
    phikrit 1 0 $mGetr $d_minGetr $d_maxGetr $cl1 $al1 $al2 $al3 $al4
    set lges_df [VFeldAntriebswinkel \
	$kb $dphi_df dfphi kb_df plot_df phiParallel lges_phiP kjk_]

    set dphi_dfM2 [expr $dphi_df*2.]

    set i 0
    while {$i < $lges_df} {
	incr i

	if {[string range $cl1 1 1] == "s"} then {
	    if {$i <= [expr $lges_df/2]} then {
		set rdvw 1 
	    } else {
		set rdvw -1 
	    }
	} else {
	    set rdvw 1 
	}

	set dfpsi($i) [uebfk0 $kb_df($i) $dfphi($i) $rdvw yes]

	set dfgam($i) $gam0
#	VRastUGangpolkurvenpunkt $dfphi($i) $dfpsi($i) $dfgam($i) 1 1 1
#	puts "phi=$dfphi($i), xR=$xRast($lgesRast), yR=$yRast($lgesRast)"
    }
}
#############################################################
proc VBereRastpolKurve {} {
    global lgesRast lgesGang xRast yRast lges_df plot_df
    global dfphi dfgam dfpsi showRast showGang xGang yGang
    global maxFeldLine

    set i 1
    set nr 0
    set lgesRast 0
    set lgesGang 0
    while {$nr < $lges_df} {
	incr nr
	if {$nr > 1} then {
	    if {$plot_df($nr) != $plot_df([expr $nr-1])} then {
# Asymptote
		set xRast($i,0) $lgesRast
		set xGang($i,0) $lgesGang
		incr i 
		set lgesRast 0
		set lgesGang 0
		VRastUGangpolkurvenpunkt $dfphi($nr) $dfpsi($nr) \
		    $dfgam($nr) $showRast $showGang $i
	    } elseif {$lgesRast > $maxFeldLine || \
	    $lgesGang > $maxFeldLine} then {
# maximale Feldlaenge fuers Plotten
		VRastUGangpolkurvenpunkt $dfphi($nr) $dfpsi($nr) \
		    $dfgam($nr) $showRast $showGang $i
		set xGang($i,0) $lgesGang
		set xRast($i,0) $lgesRast
		incr i 
#		if {$showRast == 1} then {
		    set xRast($i,1) $xRast([expr $i-1],$lgesRast)
		    set yRast($i,1) $yRast([expr $i-1],$lgesRast)
#		}
#		if {$showGang == 1} then {
		    set xGang($i,1) $xGang([expr $i-1],$lgesGang)
		    set yGang($i,1) $yGang([expr $i-1],$lgesGang)
#		}
		set lgesRast 1
		set lgesGang 1
	    } else {
		VRastUGangpolkurvenpunkt $dfphi($nr) $dfpsi($nr) \
		    $dfgam($nr) $showRast $showGang $i
	    }
	} else {
	    VRastUGangpolkurvenpunkt $dfphi($nr) $dfpsi($nr) \
		    $dfgam($nr) $showRast $showGang $i
	}
    }
    if {$showRast == 1} then {
	incr lgesRast
	set xRast($i,$lgesRast) $xRast(1,1)
	set yRast($i,$lgesRast) $yRast(1,1)
	set xRast($i,0) $lgesRast
	set xRast(0,0) $i
    }
    if {$showGang == 1} then {
	incr lgesGang
	set xGang($i,$lgesGang) $xGang(1,1)
	set yGang($i,$lgesGang) $yGang(1,1)
	set xGang($i,0) $lgesGang
	set xGang(0,0) $i
    }
}
#############################################################
proc VShowRastpolkurve {x_Rast y_Rast tag farbe1 farbe2 {dxfFile "no"}} {
    global wc massstab
    upvar $x_Rast xRast
    upvar $y_Rast yRast

    if {$dxfFile == "no"} then {
        $wc delete $tag
    }

    set farbe $farbe1
    set layer "rr"
    set i 0
    while {$i < $xRast(0,0)} {
	incr i
	set j 0
	while {$j < $xRast($i,0)} {
	    incr j
	    set xR [expr round($xRast($i,$j)/1000.*$massstab)]
	    set yR [expr round($yRast($i,$j)/-1000.*$massstab)]
	    lappend xyR $xR
	    lappend xyR $yR
	}
	#set befehl "$wc create line $xyR -tags $tag -fill $farbe"

        if {$j > 1} then {
            #set Rast [eval $befehl]
            set rgb [dxfColorToRGB $farbe]
            dxfPolygon $wc $dxfFile $layer $tag $rgb $xyR
            #tk_messageBox -message "farbe=$farbe, rgb=$rgb"
        }

        unset xyR
	if {$i < $xRast(0,0)} then {
	    if {$xRast($i,$j) != $xRast([expr $i+1],1)} then {
		if {$farbe == $farbe1} then {
		    set farbe $farbe2
		} else {
		    set farbe $farbe1
		}
	    }
	}
    }
}
#############################################################
proc VShowGangpolkurve {x_Gang y_Gang tag farbe1 farbe2 line geschl {dxfFile "no"}} {

    global wc massstab xGang yGang p xRast yRast drad
    global ShowGangPolKurvenPunkte_ pradi_ lgesGang
    upvar $x_Gang xGang
    upvar $y_Gang yGang
    
    #tk_messageBox -message "VShowGangpolkurve"

    if {$dxfFile == "no"} then {
        $wc delete $tag
        if {$tag == "gang"} then {
            $wc delete "gpp"
        }
    }

    set pHi [expr -1.*[steigung8_2p $p(2,1) $p(2,2) $p(3,1) $p(3,2)]]
    set cphi [expr cos($pHi)]
    set sphi [expr sin($pHi)]

    set farbe $farbe1
    set layer "rg_"
    
    # Angaben fr Markierungskreise von Punkten der Gangpolkurve
    if {$tag == "gang"} then {
        set pradi $pradi_
        set radius 0.5
        set tagGPP "gpp"
        set layerGPP "gpp"
        
        set i 0
        set lges_gangpolkurvenPunkte 0
        while {$i < $xGang(0,0)} {
	    incr i
	    set lges_gangpolkurvenPunkte [expr $lges_gangpolkurvenPunkte + $xGang($i,0)]
        }
    }

    set i 0
    set markiere 1
    while {$i < $xGang(0,0)} {
	incr i
	set j 0
	while {$j < $xGang($i,0)} {
	    incr j
#	    puts "xGang($i,$j)=$xGang($i,$j), \
#yGang($i,$j)=$yGang($i,$j)"

	    set x [expr $xGang($i,$j)*$cphi+$yGang($i,$j)*$sphi]
	    set y [expr -1.*$xGang($i,$j)*$sphi+$yGang($i,$j)*$cphi]
	    set xa [expr $x/1000+$p(2,1)]
	    set ya [expr $y/1000+$p(2,2)]
	    if {[expr abs($xa)] < 100000000} then {
		set x [expr round($xa*$massstab)]
	    }
	    if {[expr abs($ya)] < 100000000} then {
		set y [expr round(-1.*$ya*$massstab)]
	    }

	    lappend xyG $x
	    lappend xyG $y
	    if {$tag == "gang"} then {
	        # Gangpolkurve zeichnen
    	        if {$ShowGangPolKurvenPunkte_ > 0} then {
	            # Gangpolkurvenpunkte markieren
        	    if {$markiere == 1} then {
        	        # Zaehler fuer Markierung neu starten
                        set markiere [expr int($lges_gangpolkurvenPunkte/$ShowGangPolKurvenPunkte_)]
                        if {$markiere == 0} then {
                            set markiere 1
                        }
                        #tk_messageBox -message "markiere=$markiere\nlges_gangpolkurvenPunkte=$lges_gangpolkurvenPunkte"

        	        dxfKreis $wc $dxfFile $layerGPP orange2 [expr $x-$pradi*$radius] [expr $y-$pradi*$radius] \
            		       [expr $x+$pradi*$radius] [expr $y+$pradi*$radius] $tagGPP orange2
                    } else {
                        incr markiere -1
                    }
        
                }
            }
	}
	if {$geschl == 0} then {
# Kurve ist ggf. nicht geschlossen
	    #set befehl "$wc create $line $xyG -tags $tag -fill $farbe"
	    #tk_messageBox -message "befehle a=$befehl"
	    if {$j > 1} then {
	        #tk_messageBox -message "2 tag=$tag"
	        #if {$dxfFile == "noX"} then {
                #    set Gang [eval $befehl]
                #} else {
                    #neu 2019
                    #tk_messageBox -message "3 tag=$tag"
                    set rgb [dxfColorToRGB $farbe]
                    set Gang [dxfPolygon $wc $dxfFile $layer $tag $rgb $xyG $line]
                #}
            }
	    unset xyG
	    if {$i < $xGang(0,0)} then {
		if {[info exists xGang([expr $i+1],1)] == 1} then {
		    if {$xGang($i,$j) != $xGang([expr $i+1],1)} then {
			if {$farbe == $farbe1} then {
			    set farbe $farbe2
			} else {
			    set farbe $farbe1
			}
		    }
		} else {
		    break
		}
	    }
	}
    }

    if {$geschl != 0} then {
# Kurve wird als geschlossen betrachtet
	#set befehl "$wc create polygon $xyG -tags $tag -fill $farbe1 -outline $farbe2"
	#set Gang [eval $befehl]
	set rgb [dxfColorToRGB $farbe1]
	set rgbFill [dxfColorToRGB $farbe2]
        set Gang [dxfPolygon $wc $dxfFile $layer $tag $rgb $xyG $line $rgbFill]
    }
    show_schnabelspitze
}
#############################################################
# Setzen der naheliegendsten Deck- oder Strecklage des Antriebs als
# letzte Antriebsschritt

proc setz_decklage {erg ian} {
global ra Pi


# geg.: erg,dpi,nma_r,nvm_ra,ian
# ges.: ra()

# erg	      : Ausgangslage des Antriebs des Getriebes
# dpi	      : Winkel Pi
# nma_a       : Definerte Anzahl an Zeilen der Felder ia(),ra()
# nvm_ra      : Definerte Anzahl an Spalten des Feldes ra()
# ra	      : Realfeld mit Daten fr Antrieb
#		(siehe Upro open_name_a)
# ian	: Nr. der auf den Bilschirm zu schreibenden Antriebszeile
#	  ian=0 --> alle Zeilen schreiben und
#		    ian=Nr. der letzten Zeile ermitteln
#...................................................................
#...................................................................
if {$erg >= 0.} then {
    if {$erg < [expr $Pi/2.]} then {
	set ra($ian,1) [expr -1.*$erg]
    } elseif {$erg < $Pi} then {
	set ra($ian,1) [expr $Pi-$erg]
    } elseif {$erg < [expr $Pi/2.*3.]} then {
	set ra($ian,1) [expr -1.*($erg-$Pi)]
    } else {
	set ra($ian,1) [expr 2.*$Pi-$erg]
    }
} else {
    set aerg [expr abs($erg)]
    if {$aerg < [expr $Pi/2.]} then {
	set ra($ian,1) [expr -1.*$erg]
    } elseif {$aerg < $Pi} then {
	set ra($ian,1) [expr -$Pi-$erg]
    } elseif {$aerg < [expr $Pi/2.*3.]} then {
	set ra($ian,1) [expr -($erg+$Pi)]
    } else {
	set ra($ian,1) [expr -2.*$Pi-$erg]
    }
}
}
#############################################################
# Berechnen der Lager des Punktes eines Zweischlags, der die beiden
# ste des Zweischlags verbindet

proc bere_zweischlag_m_punkt {pax pay al1 al2 pzx pzy akb} {

# geg.: pax,pay,pzx,pzy,abk,al1,al2
# ges.: bz_pmx,bz_pmy (in $list)

# pax,pay:  Koordinaten des Ausgangspunktes des Zweischlags
# pzx,pzy:  Koordinaten des Zielpunktes des Zweischlags
# akb:	    Kennzahl
#	    akb=1  --> Mittelpunkt liegt links von der Geraden
#		       Ausgangspunkt-Zielpunkt
#	    akb=-1 --> Mittelpunkt liegt rechts von der Geraden
#		       Ausgangspunkt-Zielpunkt
# al1:	    Abstand von Ausgangspunkt und Mittelpunkt des Zweischlags
# al2:	    Abstand von Zielpunkt und Mittelpunkt des Zweischlags
# bz_pmx,bz_pmy:  Koordinaten des Mittelpunktes des Zweischlags (der die
#	    beiden ste verbindet
#....................................................................
#....................................................................

set ierr 0
set h1 [expr $pzx-$pax]
set h2 [expr $pzy-$pay]
set h3 [expr $h1*$h1+$h2*$h2]
set h4 [expr $al1*$al1-$al2*$al2+$h3]
set h5 [expr $h3*4.*$al1*$al1-$h4*$h4]
if {$h5 >=0} then {
    set h5 [expr $akb*sqrt($h5)]
} elseif {$h5 < -0.000000001} then {
    puts "Fehler in bere_zweischlag_m_punkt: setze Wurzel aus $h5 = 0"
    set h5 0.
    set ierr 1
} else {
    set h5 0.
}
set h6 [expr ($h1*$h4-$h2*$h5)/(2*$h3)]
set h7 [expr ($h2*$h4+$h1*$h5)/(2*$h3)]
set bz_pmx [expr $pax+$h6]
set bz_pmy [expr $pay+$h7]

return "$bz_pmx $bz_pmy $ierr"
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Berechnen eines Punkts auf einer Geraden, wenn ein zweiter Punkt der
# Geraden, ihr Winkel und ein abstand zu einem dritten Punkt gegeben
# ist

proc bere_punkt_auf_gerade {kstart kziel abst1 winkel kb_g} {

global drad p ie_p
#..................................................................
#..................................................................
#real*8 akb,dx,dy,dm,dn,dp,dq

set eps_winkel 0.001

set akb $kb_g
if {[expr abs($winkel-90.)] < $eps_winkel} then {
    set p($ie_p,1) $p($kziel,1)
    set dx [expr $p($kziel,1)-$p($kstart,1)]
    set dy [expr $akb*sqrt($abst1*$abst1-$dx*$dx)+$p($kstart,2)]
    set p($ie_p,2) $dy
} elseif {[expr abs($winkel+90.)] < $eps_winkel} then {
    set p($ie_p,1) $p($kziel,1)
    set dx [expr $p($kziel,1)-$p($kstart,1)]
    set dy [expr -1.*$akb*sqrt($abst1*$abst1-$dx*$dx)+\
	$p($kstart,2)]
    set p($ie_p,2) $dy
} else {
    set dm [expr tan($winkel*$drad)]
    set dn [expr $p($kziel,2)-$dm*$p($kziel,1)]
    set dq [expr $p($kstart,2)-$dn]
    set dp [expr -1.*(2.*($p($kstart,1)+$dm*$dq)/(1.+$dm*$dm))]
    set dq [expr ($dq*$dq-$abst1*$abst1+$p($kstart,1)*\
	$p($kstart,1))/(1.+$dm*$dm)]
    set dx [expr $dp/-2.+$akb*sqrt($dp*$dp/4.-$dq)]
    set p($ie_p,1) $dx
    set p($ie_p,2) [expr $dm*$dx+$dn]
}
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Ermitteln des Minimalen Abstands zwischen dem Punkt kstart und
# einer Geraden durch den Punkt kziel

proc min_abst_punkt_gerade {kstart kziel winkel eps_winkel} { 
global drad p

# geg.: p,nma_p,nvm_p,winkel,eps_winkel,drad
# ges.: abst_min

#................................................................
#................................................................

if {[expr abs($winkel-90.)] < $eps_winkel || \
       [expr abs($winkel+90.)] < $eps_winkel} then {
    set abst_min [expr abs($p($kstart,1)-$p($kziel,1))]
} else {
    set dm [expr tan($winkel*$drad)]
    set dn [expr $p($kziel,2)-$dm*$p($kziel,1)]
    set abst_min [expr ($dm*$p($kstart,1)-$p($kstart,2)+$dn)/ \
    	      sqrt($dm*$dm+1)]
    set abst_min [expr abs($abst_min)]
}
return $abst_min
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Unterprogramm zum Berechnen des Schnittpunktes zweier Geraden

proc s_schnitt_2g {ie_p kstart kziel winkel1 winkel2} {

global p drad

# geg.: alles
# ges.: p()

#...................................................................
#...................................................................

set m1 [expr tan($winkel1*$drad)]
set m2 [expr tan($winkel2*$drad)]
set x1 $p($kstart,1)
set y1 $p($kstart,2)
set x2 $p($kziel,1)
set y2 $p($kziel,2)
set b1 [expr $y1-$m1*$x1]
set b2 [expr $y2-$m2*$x2]
set m2m1 [expr $m2-$m1]
if {[expr abs($m2m1)] > 0.000000001} then {
    set p($ie_p,1) [expr ($b1-$b2)/($m2m1)]
    set p($ie_p,2) [expr ($b1*$m2-$b2*$m1)/($m2m1)]
} else {
    puts "Fehler im proc s_schitt_2g: Geraden sind parallel"
}

}
#################################################################
# Unterprogramm zum transformieren eines Punktes aus dem Koordianten-
# system x',y' in das Koordinatensystem x,y (Siehe Mathematische Formeln
# Bartsch, Kapitel 4.1.1 [Analytische Geometrie der Ebene, die ver-
# schiedenen Koordinatensysteme] Abschnitt
# 'Drehung des rechtwinkligen Koordinatensystems um den Winkel Phi'
# Ist x1,y1<>0,0, so wird der Ursprung des x',y'-Koordinatensystems
# nicht in den Punkt x1,y1 verschoben
# -----

proc trans8_xs_x_2p {x1 y1 x2 y2 x y} {

#	subroutine trans8_xs_x_2p(x1,y1,x2,y2,x,y)

# geg.: x1,y1,x2,y2,x,y
# ges.: x,y

# x1	: x-Koordinate des Koordinatensystems x',y'
# y1	: y-Koordinate des Koordinatensystems x',y'
# x2	: x-Koordinate eines Punktes auf der positiven x-Achse
#	  des Koordinatensystems x',y'
# y2	: y-Koordinate eines Punktes auf der positiven x-Achse 
#	  des Koordinatensystems x',y'
# x	: x-Koordinate des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
# y	: y-Koordinate des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
#....................................................................
#....................................................................

	set list [dreh8_xs_x_2p $x1 $y1 $x2 $y2 $x $y]
	set x [lrange $list 0 0]
	set y [lrange $list 1 1]
	set x [expr $x+$x1]
	set y [expr $y+$y1]

	return "$x $y"
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Unterprogramm zum transformieren eines Punktes aus dem Koordianten-
# system x',y' in das Koordinatensystem x,y (Siehe Mathematische Formeln
# Bartsch, Kapitel 4.1.1 [Analytische Geometrie der Ebene, die ver-
# schiedenen Koordinatensysteme] Abschnitt 
# 'Drehung des rechtwinkligen Koordinatensystems um den Winkel Phi'
# Ist x1,y1<>0,0, so wird der Ursprung des x',y'-Koordinatensystems
# nicht in den Punkt x1,y1 verschoben
# -----

# Anwendungsbeispiel: Die Kraftkomponenten fx,fy liegen im gliedfesten
#		      Koordinatensystem x',y' vor und sollen in das
#		      gestellfeste Koordinatensystem x,y transformiert
#		      werden

proc dreh8_xs_x_2p {x1 y1 x2 y2 fx fy} {

#	subroutine dreh8_xs_x_2p(x1,y1,x2,y2,fx,fy)

# geg.: x1,y1,x2,y2,fx,fy
# ges.: fx,fy

# x1	: x-Koordinate des Koordinatensystems x',y'
# y1	: y-Koordinate des Koordinatensystems x',y'
# x2	: x-Koordinate eines Punktes auf der positiven x-Achse
#	  des Koordinatensystems x',y'
# y2	: y-Koordinate eines Punktes auf der positiven x-Achse 
#	  des Koordinatensystems x',y'
# fx	: x-Wert des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
# fy	: y-Wert des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
#....................................................................
#....................................................................

	set phi [steigung8_2p $x1 $y1 $x2 $y2]
	set list [dreh8_xs_x_st $phi $fx $fy]

	return $list
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Unterprogramm zum transformieren eines Punktes aus dem Koordianten-
# system x',y' in das Koordinatensystem x,y (Siehe Mathematische Formeln
# Bartsch, Kapitel 4.1.1 [Analytische Geometrie der Ebene, die ver-
# schiedenen Koordinatensysteme] Abschnitt
# 'Drehung des rechtwinkligen Koordinatensystems um den Winkel Phi'
# Ist x1,y1<>0,0, so wird der Ursprung des x',y'-Koordinatensystems
# in den Punkt x1,y1 verschoben

proc trans8_xs_x_st {x1,y1,steigung8,x,y} {

#	subroutine trans8_xs_x_st(x1,y1,steigung8,x,y)

# geg.: x1,y1,steigung8,x,y
# ges.: x,y

# x1	: x-Koordinate des Koordinatensystems x',y'
# y1	: y-Koordinate des Koordinatensystems x',y'
# steigung8: Winkel Phi zwischen der x-Achse des
#	      gedrehten x',y'-Koordinatensystems und dem x,y-System
# x	: x-Koordinate des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
# y	: y-Koordinate des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
#....................................................................
#....................................................................
	set list [dreh8_xs_x_st $steigung8 $x $y]
	set x [lrange $list 0 0]
	set y [lrange $list 1 1]
	set x [expr $x+$x1]
	set y [expr $y+$y1]

	return "$x $y"
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Unterprogramm zum drehen eines Punktes aus dem Koordianten-
# system x',y' in das Koordinatensystem x,y (Siehe Mathematische Formeln
# Bartsch, Kapitel 4.1.1 [Analytische Geometrie der Ebene, die ver-
# schiedenen Koordinatensysteme] Abschnitt 
# 'Drehung des rechtwinkligen Koordinatensystems um den Winkel Phi'
# Ist x1,y1<>0,0, so wird der Ursprung des x',y'-Koordinatensystems
# nicht in den Punkt x1,y1 verschoben
# -----

proc dreh8_xs_x_st {phi x y} {

#	subroutine dreh8_xs_x_st(phi,x,y)

# geg.: phi x y
# ges.: x,y

# phi	: Winkel Phi zwischen der x-Achse des
#	      gedrehten x',y'-Koordinatensystems und dem x,y-System
# x	: x-Koordinate des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
# y	: y-Koordinate des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
#....................................................................
#....................................................................
	set cphi [expr cos($phi)]
	set sphi [expr sin($phi)]
	set fxa $x
	set fya $y
	set x [expr $fxa*$cphi-$fya*$sphi]
	set y [expr $fxa*$sphi+$fya*$cphi]

	return	"$x $y"
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Unterprogramm zum transformieren eines Punktes aus dem Koordianten-
# system x,y in das Koordinatensystem x',y' (Siehe Mathematische Formeln
# Bartsch, Kapitel 4.1.1 [Analytische Geometrie der Ebene, die ver-
# schiedenen Koordinatensysteme] Abschnitt
# 'Drehung des rechtwinkligen Koordinatensystems um den Winkel Phi'
# Ist x1,y1<>0,0, so wird der Ursprung des x',y'-Koordinatensystems
# in den Punkt x1,y1 verschoben

proc trans8_x_xs_2p {x1 y1 x2 y2 x y} {

# geg.: x1,y1,x2,y2,x,y
# ges.: x,y  (in $list)

# x1	: x-Koordinate des Koordinatensystems x',y'
# y1	: y-Koordinate des Koordinatensystems x',y'
# x2	: x-Koordinate eines Punktes auf der positiven x-Achse
#	  des Koordinatensystems x',y'
# y2	: y-Koordinate eines Punktes auf der positiven x-Achse
#	  des Koordinatensystems x',y'
# x	: x-Koordinate des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
# y	: y-Koordinate des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
#....................................................................
#....................................................................

set phi [steigung8_2p $x1 $y1 $x2 $y2]
set cphi [expr cos($phi)]
set sphi [expr sin($phi)]
set xa [expr $x-$x1]
set ya [expr $y-$y1]
set x [expr $xa*$cphi+$ya*$sphi]
set y [expr -1.*$xa*$sphi+$ya*$cphi]

return "$x $y"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Unterprogramm zum transformieren eines Punktes aus dem Koordianten-
# system x,y in das Koordinatensystem x',y' (Siehe Mathematische Formeln
# Bartsch, Kapitel 4.1.1 [Analytische Geometrie der Ebene, die ver-
# schiedenen Koordinatensysteme] Abschnitt 
# 'Drehung des rechtwinkligen Koordinatensystems um den Winkel Phi'
# Ist x1,y1<>0,0, so wird der Ursprung des x',y'-Koordinatensystems
# in den Punkt x1,y1 verschoben

proc trans8_x_xs_st {x1 y1 steigung8 x y} {

# geg.: x1,y1,steigung8,x,y
# ges.: x,y (in $list)

# x1	: x-Koordinate des Koordinatensystems x',y'
# y1	: y-Koordinate des Koordinatensystems x',y'
# steigung8: Winkel Phi zwischen der x-Achse des
#	      gedrehten x',y'-Koordinatensystems und dem x,y-System
# x	: x-Koordinate des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
# y	: y-Koordinate des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
#....................................................................
#....................................................................

set xa [expr $x-$x1]
set ya [expr $y-$y1]
set cphi [expr cos($steigung8)]
set sphi [expr sin($steigung8)]
set x [expr $xa*$cphi+$ya*$sphi]
set y [expr -1.*$xa*$sphi+$ya*$cphi]

return "$x $y"
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Unterprogramm zum transformieren eines Punktes aus dem Koordianten-
# system x,y in das Koordinatensystem x',y' (Siehe Mathematische Formeln
# Bartsch, Kapitel 4.1.1 [Analytische Geometrie der Ebene, die ver-
# schiedenen Koordinatensysteme] Abschnitt 
# 'Drehung des rechtwinkligen Koordinatensystems um den Winkel Phi'
# Ist x1,y1<>0,0, so wird der Ursprung des x',y'-Koordinatensystems
# nicht in den Punkt x1,y1 verschoben
# -----

# Anwendungsbeispiel: Die Kraftkomponenten fx,fy liegen im gestellfesten
#		      Koordinatensystem x,y vor und sollen in das
#		      gliedfeste Koordinatensystem x',y' transformiert
#		      werden

proc dreh8_x_xs_2p {x1 y1 x2 y2} {

# geg.: x1,y1,x2,y2,x,y
# ges.: fx,fy (in $list)

# x1	: x-Koordinate des Koordinatensystems x',y'
# y1	: y-Koordinate des Koordinatensystems x',y'
# x2	: x-Koordinate eines Punktes auf der positiven x-Achse 
#	  des Koordinatensystems x',y'
# y2	: y-Koordinate eines Punktes auf der positiven x-Achse 
#	  des Koordinatensystems x',y'
# fx	: x-Wert des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
# fy	: y-Wert des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
#....................................................................
#....................................................................

set phi [steigung8_2p $x1 $y1 $x2 $y2]
set list [dreh8_x_xs_st $phi $fx $fy]

return $list
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Unterprogramm zum transformieren eines Punktes aus dem Koordianten-
# system x,y in das Koordinatensystem x',y' (Siehe Mathematische Formeln
# Bartsch, Kapitel 4.1.1 [Analytische Geometrie der Ebene, die ver-
# schiedenen Koordinatensysteme] Abschnitt 
# 'Drehung des rechtwinkligen Koordinatensystems um den Winkel Phi'

# Anwendungsbeispiel: Die Kraftkomponenten fx,fy liegen im gestellfesten
#		      Koordinatensystem x,y vor und sollen in das
#		      gliedfeste Koordinatensystem x',y' transformiert
#		      werden

proc dreh8_x_xs_st {steigung8 x y} {

# geg.: steigung,x,y
# ges.: x,y

# steigung8: Winkels zwischen der x-Achse des
#	      gedrehten x',y'-Koordinatensystems und dem x,y-System
# x	: x-Wert des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
# y	: y-Wert des zu transformierenden Punktes
#   geg.: vor der Transformation
#   ges.: nach der Transformation
#....................................................................
#....................................................................

set xa $x
set ya $y
set cphi [expr cos($steigung8)]
set sphi [expr sin($steigung8)]
set x [expr $xa*$cphi+$ya*$sphi]
set y [expr -1.*$xa*$sphi+$ya*$cphi]

return "$x $y"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Unterprogramm zum Berechnen eines Winkels einer durch 2 Punkte
# gegebenen Geraden

proc steigung8_2p {x1 y1 x2 y2} {

# geg.: x1,y1,x2,y2
# ges.: steigung8

# x1	 : x-Koordinate des Koordinatensystems x',y'
# y1	 : y-Koordinate des Koordinatensystems x',y'
# x2	 : x-Koordinate eines Punktes auf der positiven x-Achse 
#	  des Koordinatensystems x',y'
# y2	 : y-Koordinate eines Punktes auf der positiven x-Achse 
#	   des Koordinatensystems x',y'
# steigung8: Winkel zwischen der Geraden und der Waagerechten
#....................................................................
#....................................................................

set dx [expr $x2-$x1]
set dy [expr $y2-$y1]
set steigung8 [expr atan2($dy,$dx)]

return $steigung8
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Umrechnen von kartesischen in Polar-Koordinaten

proc kartesisch_polar {drad,xr,yr} {

global drad

# geg.: drad,xr,yr
# ges.: kp_ar,kp_wr (in $list)

# drad: Umrechnungfaktor von Grad in Bogenma
#	Winkel in Grad= Winkel in Bogenma / drad
# xr:	x-Koordinate
# yr:	y-Koordinate
# kp_ar:   Abstand
# kp_wr:   Winkel
#..............................................................
#..............................................................
set eps 0.000001

set kp_ar [expr sqrt($xr*$xr+$yr*$yr)]
if {[expr abs($yr)+abs($xr)] > $eps} then {
    set kp_wr [ecpr atan2($yr,$xr)]
} else {
    set kp_wr 0.
}
set kp_wr [expr $kp_wr/$drad]
return "$kp_ar $kp_wr"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Umrechnen von Polar-Koordinaten in Kartesische

proc polar_kartisisch {ar wr} {

global drad

# geg.: drad,ar,wr
# ges.: pk_xr,pk_yr (in $list)

# drad: Umrechnungfaktor von Grad in Bogenma
#	Winkel in Grad= Winkel in Bogenma / drad
# pk_xr:   x-Koordinate
# pk_yr:   y-Koordinate
# ar:	Abstand
# wr:	Winkel
#..............................................................
#..............................................................

set wb [expr $wr*$drad]
set pk_xr [expr $ar*cos($wb)]
set pk_yr [expr $ar*sin($wb)]
return "$pk_xr $pk_yr"
}
#############################################################
# Prfen, ob Lngen der Zweischlagglieder ok
proc VTestZweischlag { {zweischlagGlied 0}} {
#   zweischlagGlied=0: umbekannt
#		   =1: Glied alz1 gendert
#		   =2: Glied alz2 gendert
#		   =b: Glied alz1 und alz2  gendert

    global alzDistMax alzDistMin alz1 alz2

    set Return 0

    set diff [expr abs($alz1-$alz2)]
    set sum  [expr $alz1+$alz2]
    if {$sum <= [expr $alzDistMax*1.01]} then {
# Summe der Gliedlngen zu kurz
	#set Return 1
	set sum2 [expr abs($sum - $alzDistMax*1.01)]
	if {$zweischlagGlied == 1} then {
#	    hier eingreifen?
	    #puts "Glied 1 laenger?"
	    set alz1 [expr $alz1 + $sum2]
	} elseif {$zweischlagGlied == 2} then {
	    #puts "Glied 2 laenger?"
	    set alz2 [expr $alz2 + $sum2]
	} elseif {$zweischlagGlied == "b"} then {
	    #puts "beide Glieder laenger !!! alz1=$alz1, alz2=$alz2"
	    set alz1 [expr $alz1 + $sum2/2]
	    set alz2 [expr $alz2 + $sum2/2]
	    #set Return 0
	}
    }
    if {$diff >= [expr $alzDistMin*1.01]} then {
# Differenz der Gliedlngen zu kurz
	#set Return 2
	if {$zweischlagGlied == 1} then {
#	    hier eingreifen?
	    #puts "Glied 1 kuerzer?"
	    set alz1 [expr ($alz1 + ($diff-$alzDistMin))*1.01]
	} elseif {$zweischlagGlied == 2} then {
	    #puts "Glied 2 kuerzer?"
	    set alz2 [expr ($alz2 + ($diff-$alzDistMin))*1.01]
	} elseif {$zweischlagGlied == "b"} then {
	    #puts "beide Glieder kuerzer?"
	    if {$alz1 < $alz2} then {
		set alz1 [expr ($alz1 + ($diff-$alzDistMin))*1.01]
	    } else {
		set alz2 [expr ($alz2 + ($diff-$alzDistMin))*1.01]
	    }
	}
    }
    #puts "winkel = [cosinusSatz $alz1 $alz2 $diff]"

    return $Return
}
#############################################################
proc VChangeGetrLaengen {} {
    global al1 al2 al3 al4 phi1 phi2 kbf lges_p wc massstab
    global al1_alt al2_alt al3_alt al4_alt phi1_alt phi2_alt
    global al1Snabel al2Snabel al3Snabel al4Snabel
    global alz1 alz2 alzx alzy dateiNamePostfix kbz
    global p drad statuszeile sbAl1 sbAl2 sbAl3 sbAl4 lges_u
    global cl1 cl3 getyp zusat mGetr d_minGetr d_maxGetr
    global VChangeGetr_arbeitet runGetriebe alkx alky alx_alt aly_alt
    global showSchnabel $wc

    if {$lges_p >= 11} then {
        # Winkel Phi2 muss zwischen minimalem und maximalem Winkel liegen
        set list [VMaxMinAntriebswinkel $cl1 $mGetr $al1 $al2 $al3 $al4]
        set dpmin [lrange $list 0 0]
        set dpmax [lrange $list 1 1]
        set dpDelta [expr $dpmax-$dpmin]
        if {$dpDelta > 10} then {
            set dpDif 5
        } else {
            set dpDif [expr ($dpmax-$dpmin)/3.]
        }
        if {$phi2 < [expr $dpmin+1.]} then {
            set phi2 [expr $dpmin+$dpDif]
        }
        if {$phi2 > [expr $dpmax-1.]} then {
            set phi2 [expr $dpmax-$dpDif]
        }
    }

    set ierr 0
    set VChangeGetr_arbeitet 1

    set p(2,9) [expr $al1/1000.]
    set p(2,10) $phi1
#				    KB(ufkt)=-KB(m_uegk_a.dat)
    set p(3,9) [expr -$al2/1000.*$kbf(1)]
    set p(3,10) [expr $al3/1000.]
    set p(4,9) [expr $al4/1000.]

    if {$lges_p == 11} then {
	set p(5,9) [expr $al1/1000.]
	set p(6,9) [expr -$al2/1000.*$kbf(2)]
	set p(6,10) [expr $al3/1000.]
	set p(5,10) $phi2
	#tk_messageBox -message "lges_p=11\nphi1=$phi1\nphi2=$phi2"
    } elseif {$lges_p == 12} then {
	set p(5,9) [expr $al1/1000.]
	set p(7,9) [expr -$al2/1000.*$kbf(2)]
	set p(7,10) [expr $al3/1000.]
	set p(5,10) $phi2
	#tk_messageBox -message "lges_p=12\nphi1=$phi1\nphi2=$phi2"
    } else {
	set p(6,9) [expr $alkx/1000.]
	set p(6,10) [expr $alky/1000.]
	if { "$dateiNamePostfix" == "z" } then {
	    set p(5,9) [expr $alzx/1000.]
	    set p(5,10) [expr $alzy/1000.]
	    set p(7,9) [expr $alz2/1000.*$kbz]
	    set p(7,10) [expr $alz1/1000.]
	}
    }

# Zweischlaege fuer Winkelhalbierende Anpassen
    if {$lges_p >= 11} then {
	set i9 [expr $lges_p-2]
	set i10 [expr $lges_p-1]
	if {$p($i9,9) > 0} then {
	    set p($i9,9) [expr 1.5*$al1/1000.]
	} else {
	    set p($i9,9) [expr -1.5*$al1/1000.]
	}
	set p($i9,10) [expr -1.5*$al1/1000.]
	if {$p($i10,9) > 0} then {
	    set p($i10,9) [expr 1.5*$al3/1000.]
	} else {
	    set p($i10,9) [expr -1.5*$al3/1000.]
	}
	set p($i10,10) [expr -1.5*$al3/1000.]
    }
    if {$runGetriebe != 1} then {
# Getriebe wird nicht am Antriebsglied 1 angetrieben, deshalb muss
# das viergliedrige Grundgetriebe zur Sicherheit neu berechnet werden

	#puts "loesche Schnabelspitze"
              if {$showSchnabel == 1} then {
                  if {[expr abs($al1-$al1Snabel)] >= 0.1 \
                  || [expr abs($al2-$al2Snabel)] >= 0.1 || [expr abs($al3-$al3Snabel)] >= 0.1 \
                  || [expr abs($al4-$al4Snabel)] >= 0.1} then {
	        set showSchnabel 0
	        $wc delete schnabel
                  }
              } else {
                  set showSchnabel 0
	          $wc delete schnabel
              }

	set list [grash 1 $al1 $al2 $al3 $al4 0]
	set ierr [lrange $list 0 0]
	if {$ierr == 0} then {
	    set mGetr [lrange $list 1 1]
	    set d_minGetr [lrange $list 2 2]
	    set d_maxGetr [lrange $list 3 3]
	    set list [geart $al1 $al2 $al3 $al4 $mGetr $d_minGetr \
		$d_maxGetr [expr -1.*$kbf(1)]]
	    set cl1 [string range $list 0 1]
	    set cl3 [string range $list 3 4]
	    VSetHelpText1 $cl1 $cl3
	    set kb [lrange $list 2 2]
	    set getyp [lrange $list 3 3]
	    set zusat [lrange $list 4 4]
	    VUebertragungsfunktion
	    VBereRastpolKurve
	    VStatus2
	    if {$al1 != $sbAl1} then {set lges_u 0}
	    if {$al2 != $sbAl2} then {set lges_u 0}
	    if {$al3 != $sbAl3} then {set lges_u 0}
	    if {$al4 != $sbAl4} then {set lges_u 0}
	    if {$lges_p != 11} then {
		VKoppelpunktBahn
	    }
	    VSchwingwinkelBegrenzung
	} else {
	    set getyp "Fehler!"
	    set zusat " "
	    set cl1 " "
	    set cl3 " "
	    set al1 $al1_alt
	    set al2 $al2_alt
	    set al3 $al3_alt
	    set al4 $al4_alt
	    if {$lges_p != 11} then {
		set alkx $alkx_alt
		set alky $alky_alt
	    }
	    set phi1 $phi1_alt
	    set phi2 $phi2_alt
	    return
	}
    }

    set ie_p2 0
    set ie_p3 0
    set ie_p4 0
    set ie_p5 0
    set ie_p6 0
    set i 0
    while {$i < 5 && ($ie_p2 <= 0 || $ie_p3 <= 0 || $ie_p4 <= 0 || \
    $ie_p5 <= 0) || $ie_p6 <= 0} {
	incr i
	#set p_alt(4,1) p(4,1)
	set p(4,1) [expr $al4/1000.]
	set ie_p4 [VParametric -4]

	#set p_alt(2,1) p(2,1)
	#set p_alt(2,2) p(2,2)
	set p(2,1) [expr $al1/1000.*cos($phi1*$drad)]
	set p(2,2) [expr $al1/1000.*sin($phi1*$drad)]
	set ie_p2 [VParametric -2]

	set kb [expr -1.*$kbf(1)]
	set list [bere_zweischlag_m_punkt $p(2,1) $p(2,2) \
	    [expr $al2/1000.] [expr $al3/1000.] $p(4,1) $p(4,2) $kb]
	#set p_alt(3,1) p(3,1)
	#set p_alt(3,1) p(3,1)
	set p(3,1) [lrange $list 0 0]
	set p(3,2) [lrange $list 1 1]
	set ie_p3 [VParametric -3]
	if {[lrange $list 2 2] == 1} then {
	#   Fehler beim Berechnen des Zweischlags
	    set ie_p3 -3
	}

	if {$lges_p >= 11} then {
	    #set p_alt(5,1) p(5,1)
	    #set p_alt(5,1) p(5,1)
	    set p(5,1) [expr $al1/1000.*cos($phi2*$drad)]
	    set p(5,2) [expr $al1/1000.*sin($phi2*$drad)]
	    set ie_p5 [VParametric -5]

	    set kb [expr -1.*$kbf(2)]
	    set list [bere_zweischlag_m_punkt $p(5,1) $p(5,2) \
		[expr $al2/1000.] [expr $al3/1000.] $p(4,1) $p(4,2) $kb]
	    set i6 [expr $lges_p-5]
	    #set p_alt($i6,1) p($i6,1)
	    #set p_alt($i6,1) p($i6,1)
	    set p($i6,1) [lrange $list 0 0]
	    set p($i6,2) [lrange $list 1 1]
#-VP	    set ie_p6 [VParametric -6]
	    set ie_p6 [VParametric $i6]
	    if {[lrange $list 2 2] == 1} then {
	    #	Fehler beim Berechnen des Zweischlags
		set ie_p6 -$i6
	    }
	} else {
	    if {"$dateiNamePostfix" == "z"} then {
		set list [bere_zweischlag_m_punkt $p(5,1) $p(5,2) \
		    [expr $alz2/1000.] [expr $alz1/1000.] $p(6,1) $p(6,2) $kbz]
		#set p_alt(7,1) p(7,1)
		#set p_alt(7,1) p(7,1)
		set p(7,1) [lrange $list 0 0]
		set p(7,2) [lrange $list 1 1]
		set ie_p7 [VParametric -7]
		if {[lrange $list 2 2] == 1} then {
		#   Fehler beim Berechnen des Zweischlags
		    set ie_p7 -7
		}
		#set p_alt(5,1) p(5,1)
		#set p_alt(5,1) p(5,1)
		set p(5,1) [expr $alzx/1000.]
		set p(5,2) [expr $alzy/1000.]
		set ie_p5 [VParametric -5]
		if {[lrange $list 2 2] == 1} then {
		#   Fehler beim Berechnen des Zweischlags
		    set ie_p5 -5
		}
	    } else {
		set ie_p5 5
	    }
	    set list [trans8_xs_x_2p $p(2,1) $p(2,2) $p(3,1) \
		$p(3,2) [expr $alkx/1000.] [expr $alky/1000.]]
	    #set p_alt(6,1) p(6,1)
	    #set p_alt(6,1) p(6,1)
	    set p(6,1) [lrange $list 0 0]
	    set p(6,2) [lrange $list 1 1]
#-VP	    set ie_p6 [VParametric -6]
	    set ie_p6 [VParametric 6]
	}
    }

    VModifyGetr all

    if {$ie_p2 <= 0  || $ie_p3 <= 0 || $ie_p4 <= 0 || $ie_p5 <= 0 || \
    $ie_p6 <= 0} then {
	set ierr 1
	set statuszeile "Fehler beim Aendern von Getriebeparametern"
	puts $statuszeile
    }


set list [antr_ausg_lage]
set ityp [lrange $list 0 0]
set erg1 [lrange $list 1 1]

# Testen, ob Glied5 unterhalb des Gestells startet
#   if {$phi2 < 180. && $phi2 > 178.} then {
#	set p(5,10) [expr 360.-1.*$phi2]
#	set p(5,1) [expr $al1*cos($p(5,10)*$drad)]
#	set p(5,2) [expr $al1*sin($p(5,10)*$drad)]
#	set ie_p [VParametric -5]
#	set list [antr_ausg_lage]
#	set ityp [lrange $list 0 0]
#	set erg2 [lrange $list 1 1]
#
#	if {[expr abs($erg1)] < [expr abs($erg2)]} then {
###		write(ou,100) ' '
###100		   format(/,1x,'Lage von Phi wird',a,'bernommen!',/)
#	    set p(5,10) $phi2
#	    set p(6,9) $p(3,9)
#	    set p(5,1) [expr $al1*cos($p(5,10)*$drad)]
#	    set p(5,2) [expr $al1*sin($p(5,10)*$drad)]
#	    set ie_p [VParametric -5]
#	} else {
#		write(ou,100) ' nicht '
#	}
#	 VModifyGetr all
#   }
set al1_alt $al1
set al2_alt $al2
set al3_alt $al3
set al4_alt $al4
if {$lges_p != 11} then {
    set alkx_alt $alkx
    set alky_alt $alky
}
set phi1_alt $phi1
set phi2_alt $phi2
set VChangeGetr_arbeitet 0
}
#############################################################
proc VNormalizeGetr {} {
global al1 al2 al3 al4 alkx alky phi1 phi2 kbf
global p drad lges_p
global alz1 alz2 alzx alzy kbz dateiNamePostfix

set al1 [expr abs($p(2,9))*1000.]
set al2 [expr abs($p(3,9))*1000.]
set al3 [expr abs($p(3,10))*1000.]
set al4 [expr abs($p(4,9))*1000.]

if {"$dateiNamePostfix" == "z"} then {
# Viergliedriges Gelenkgetriebe mit Zweischlag
    set alz1 [expr abs($p(7,10))*1000.]
    set alz2 [expr abs($p(7,9))*1000.]
    set alzx [expr abs($p(5,9))*1000.]
    set alzy [expr abs($p(5,10))*1000.]
    if { $p(7,9) < 0 } then {
	set kbz -1
    } else {
	set kbz 1
    }
}

if {$lges_p != 11} then {
# viergliedriges Gelenkgetriebe mit Koppelpunkt
    set alkx [expr abs($p(6,9))*1000.]
    set alky [expr abs($p(6,10))*1000.]
}

##	if (idia.eq.1) Then
set phi1 [expr $p(2,10)]
while {$phi1 < 0.} {
set phi1 [expr $phi1+360.]
}

if {$p(3,9) > 0} then {
set kbf(1) -1.
} else {
set kbf(1) 1.
}

if {$lges_p >= 11} then {
    set phi2 [expr $p(5,10)]
    while {$phi2 < 0.} {
	set phi2 [expr $phi2+360.]
    }
    set i6 [expr $lges_p-5]
    if {$p($i6,9) > 0} then {
	set kbf(2) -1.
    } else {
	set kbf(2) 1.
    }
} else {
    set phi2 "0"
    set kbf(2) 1.
}
}
####################################################################
# Ermitteln der Ausgangslage des Antriebs

proc antr_ausg_lage {} {

global ia p ie

# geg.: ia,nma_a,nvm_a,p,nma_p,nvm_p,ie,nma_e,nvm_e
# ges.: ityp erg (in $list)

# ia	      : Integerfeld mit Daten fr Antrieb
#		(siehe Upro open_name_a)
# nma_a       : Definerte Anzahl an Zeilen der Felder ia(),ra()
# nvm_a       : Definerte Anzahl an Spalten des Feldes ia()
# p()	      : Feld mit Daten der Punkte und Winkel
#		(siehe Upro open_name_a)
# nma_p       : Definerte Anzahl an Zeilen des Feldes p()
# nvm_p       : Definerte Anzahl an Spalten des Feldes p()
# ie()	      : INTEGER-Feld mit Daten der Elemente 
#		(siehe Upro open_name_a)
# nma_e       : Definerte Anzahl an Zeilen des Feldes ie()
# nvm_e       : Definerte Anzahl an Spalten des Feldes ie()
# ityp	      : Kennzahl
#		ityp=0 --> Es konnte keine Ausgangslage ermittelt werd.
#		ityp=1 --> Ausgangslage in Rad ermittelt
#		ityp=2 --> Ausgangslage in m ermittelt
#.................................................................
#.................................................................
set ityp 0

set je [expr int($ia(0,1))]

if {$ia(0,2) > 0} then {
# Winkel oder Koordinate wird angetrieben
return "$ityp 0"
} elseif {$ia(0,2) < 0} then {
# Element als Antrieb
set je_t [expr int($ie($je,1))]
if {$je_t == 21} then {
#	HINGE
set list [erm_hinge_winkel_w $je]
set iok [lrange $list 0 0]
	set erg [lrange $list 1 1]
	if {$iok != 0} then {set ityp 1}
    } elseif {$je_t == 2 || $ie($je,2)%1 == 1 && \
    ($je_t == 1 || $je_t ==11) } then {
#	SLIDER etc.
    }
} else {
# kein Antrieb
}

return "$ityp $erg"
}
#ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Ermitteln des Winkel, den ein HINGE-Element aufweist
# (Das ist nur mglich, wenn beide Winkel des Elements nur einmal
# verwendet werden)

proc erm_hinge_winkel_w {je} {

global ie p drad Pi lges_e
global ie_p1 ie_p2 ie_w1 ie_w2

# geg.: je,ie,nma_e,nma_e,p,nma_p,nvm_p
# ges.: iok, winkel (in $list)

# je	      : Nr. des Hinge-Elements
# ie()	      : INTEGER-Feld mit Daten der Elemente
#		(siehe Upro open_name_a)
# nma_e       : Definerte Anzahl an Zeilen des Feldes ie()
# nvm_e       : Definerte Anzahl an Spalten des Feldes ie()
# p()	      : Feld mit Daten der Punkte und Winkel
#		(siehe Upro open_name_a)
# nma_p       : Definerte Anzahl an Zeilen des Feldes p()
# nvm_p       : Definerte Anzahl an Spalten des Feldes p()
# Winkel      : Wert des Winkels
# iok	      : Kennzahl
#		iok=1 --> winkel konnte ermittelt werden
#		iok=0 --> winkel konnte nicht ermittelt werden
#.................................................................
#.................................................................

set igef(1,1) 0
set igef(2,1) 0
  
set iok 0
set i 0
while {$i < $lges_e} {
    incr i
    if {$i != $je} then {
	find_elem_punkte_winkel $i
	set ie_w(1) $ie_w1
	set ie_w(2) $ie_w2
	foreach j {3 4} {
	    foreach k {1 2} {
		if {$ie($je,$j) == $ie_w($k)} then {
# Winkel wurde gefunden
		    if {$igef([expr $j-2],1) == 0} then {
#	Winkel wurde bisher nur einmal verwendet
			set igef([expr $j-2],1) $i
			set igef([expr $j-2],2) $k
		    } else {
#	Winkel wird mehrmals verwendet
			return "$iok 0"
		    }
		}
	    }
	}
    }
}
foreach i {1 2} {
    find_elem_punkte_winkel $igef($i,1)
    set list [winkel_von_element]
    set iok [lrange $list 0 0]
    set w($i) [lrange $list 1 1]
    if {$iok == 0} then {return "$iok 0"}
    if {$igef($i,2) == 2} then {
	set w($i) [expr $w($i)+$Pi]
    }
    while { $w($i) > [expr $Pi*2.]} {
	set w($i) [expr $w($i)-$Pi*2.]
    }
    while {$w($i) < 0.} {
	set w($i) [expr $w($i)+$Pi*2.]
    }
}
set winkel [expr $w(2)-$w(1)]
#	write(*,*) winkel,w(1),w(2), ' winkel'
set iok 1

return "$iok $winkel"
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Ermitteln des Winkels zur x-Achse eines Elements mit 2 Punkten

proc winkel_von_element {} {

global ie_p1 ie_p2 p

# geg.: ie_p1,ie_p2,p,nma_p,nvm_p
# ges.: iok w (in $list)

# ie_p1       : Nr. des 1. Punktes (ie_p1=0 --> Punkt nicht definiert
# p()	      : Feld mit Daten der Punkte und Winkel
#		(siehe Upro open_name_a)
# nma_p       : Definerte Anzahl an Zeilen des Feldes p()
# nvm_p       : Definerte Anzahl an Spalten des Feldes p()
# w	      : Winkel zwischen Element und x-Achse
# iok	      : Kennzahl
#		iok=0 --> Winkel ist nicht definiert
#		iok=1 --> Winkel konnte ermittelt werden
#................................................................
#.................................................................

set w 0.
set iok 0
if {$ie_p1 == 0} then {return "$iok 0"}
if {$ie_p2 == 0} then {return "$iok 0"}
set dx [expr $p($ie_p2,1)-$p($ie_p1,1)]
set dy [expr $p($ie_p2,2)-$p($ie_p1,2) ]
if {$dx == 0. && $dy == 0} then {return "$iok 0"}
set w [expr atan2($dy,$dx)]
set iok 1
return "$iok $w"
}
#cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
# Ermitteln der Punkte, die zu einem Element gehren

proc find_elem_punkte_winkel {je} {
global ie lges_e ie_p1 ie_p2 ie_w1 ie_w2

# geg.: je,ie, lges_e
# ges.: ie_p1,ie_p2,ie_w1,ie_w2

# je	      : Element-Nr.
# ie()	      : Feld mit Daten der Elemente, siehe Upro open_name_a
# nma_e       : Definerte Anzahl an Zeilen des Feldes ie()
# nvm_e       : Definerte Anzahl an Spalten des Feldes ie()
# ie_p1       : 1. Punkte des Elements (ie_p1=0 --> kein Punkt vorh.)
# ie_p2       : 2. Punkte des Elements (ie_p2=0 --> kein Punkt vorh.)
# ie_w1       : 1. Winkel des Elements (ie_w1=0 --> kein Winkel vorh.)
# ie_w2       : 2. Winkel des Elements (ie_w2=0 --> kein Winkel vorh.)
#.................................................................
#.................................................................

set jei [expr abs($je)]
if {$ie($jei,1) == 0 && $ie($jei,1) > 40} then {
# Element ist nicht definiert
    set ie_p1 0
    set ie_p2 0
    set ie_w1 0
    set ie_w2 0
} elseif {$ie($jei,1) <= 10} then {
# BEAM-Element etc.
    set ie_p1 $ie($jei,3)
    set ie_p2 $ie($jei,5)
    if {$ie($jei,1) == 10} then {
#	Gestell-Linie
	set ie_w1 0
	set ie_w2 0
    } else {
	set ie_w1 $ie($jei,4)
	set ie_w2 $ie($jei,6)
    }
} elseif {$ie($jei,1) <= 20} then {
# TRUSS-Element etc.
    set ie_p1 $ie($jei,3)
    set ie_p2 $ie($jei,4)
    set ie_w1 0
    set ie_w2 0
} else { 
# HINGE-Element etc.
    set ie_p1 0
    set ie_p2 0
    set ie_w1 $ie($jei,3)
    set ie_w2 $ie($jei,4)
}
}
####################################################################
proc set_zurueck {ie_p} {
global zurueck p

set ie_p [expr abs($ie_p)]

set zurueck(1) $p($ie_p,6)
set zurueck(2) $p($ie_p,7)
set zurueck(3) $p($ie_p,8)
set zurueck(4) $p($ie_p,9)
set zurueck(5) $p($ie_p,10)
}
####################################################################
# Parametric fr Punkte einschliesslich Kontrolle
proc VParametric {je_p} {
global zurueck p

set_zurueck $je_p

set ie_p [VParametricVor $je_p]
VParametricNach $je_p
return $ie_p
}
####################################################################
# Parametric fr Punkte ohne Kontrolle

proc VParametricVor {je_p} {
global ie lges_e ie_p1 ie_p2 ie_w1 ie_w2
global p lges_p zurueck drad
global iaender not_aender

# geg.: je_p,p,nma_p,nvm_p,ie,nma_e,nvm_e,zurck,re,nvm_re
# ges.: p()

# je_p	      : Nr. des Punktes
#		je_p<0 --> je_p=|je_p| und Dialog wird unterdrckt
#				       (Antwort ist immer ok)
#				       und Upro wird auf jeden Fall
#				       abgearbeitet
#				       ist je_p<0 so gilt:
#					    Upro fehlerfrei --> je_p>0
#					    Upro mit fehler --> je_p<0
# p()	      : Feld mit Daten der Punkte und Winkel, siehe Upro
#		open_name_a
# nma_p       : Definerte Anzahl an Zeilen des Feldes p()
# nvm_p       : Definerte Anzahl an Spalten des Feldes p()
# ie()	      : Feld mit Daten der Elemente, siehe Upro open_name_a
# nma_e       : Definerte Anzahl an Zeilen des Feldes ie()
# nvm_e       : Definerte Anzahl an Spalten des Feldes ie()
# zurueck()    : Feld mit folgendem Inhalt vor der letzten Eingabe:
#		zurueck(1)=p(je_p,6)
#		zurueck(2)=p(je_p,7)
#		zurueck(3)=p(je_p,8)
#		zurueck(4)=p(je_p,9)
#		zurueck(5)=p(je_p,10)
# re()	      : REAL-Feld mit Daten der Elemente, siehe Upro open_name_a
# nvm_r       : Definerte Anzahl an Spalten des Feldes re()
#....................................................................
#....................................................................

set iaender 0
set ie_p [expr abs($je_p)]

set eps 0.00000000001
set eps_winkel 0.001

#	p(i,5)=0 --> keine Information ber Punkt i
#	p(i,5)=1 --> Punkt i mu auf notwendige nderungen hin unter-
#		     sucht werden
#	p(i,5)=-1 -> Punkt i mu verschoben werden

if {$p($ie_p,1) == $p($ie_p,11)} then {
    if {$p($ie_p,2) == $p($ie_p,12)} then {
# Punkt wurde nicht verndert
	return $ie_p
    }
}

set i 0
while {$i < $lges_p} {
    incr i
    set p($i,5) 0
}

# Punktverschiebungen ermitteln

set p($ie_p,5) -1
set i 1
set ianf [expr $i+1]
while {$i <= $lges_p} {
     set iaender 0
     if {$p($i,5) != -1} then {

# ggf. mehr als nur einen weiteren Punkt beachten
	set jpunkt 0
	if {[expr abs($p($i,6))] >=  6} then {
	    if {$p($i,8) <= 0} then {
		set jpunkt [expr $jpunkt+1]
		set ipunkt($jpunkt) $p($i,10)
	    }
	}
	if {[expr abs($p($i,6))] == 7} then {
	    if {$p($i,7) <= 0} then {
		set jpunkt [expr $jpunkt+1]
		set ipunkt($jpunkt) $p($i,9)
	    }
	}

# Punkt i mu auf notwendige nderungen hin untersucht werden
	if {[expr abs($p($i,6))] > 1} then {
#	Punkt i mu verschoben werden
	    set iv [expr abs($p($i,7))]
	    if {$p($iv,5) == 0} then {
		set p($iv,5) 1
		if {$iv < [min $i $ianf]} then {
		    set ianf $iv
		}
	    } elseif {$p($iv,5) <= -1} then {
		set p($i,5) -1
		set iaender 1
	    }
	    if {[expr abs($p($i,6))] >= 3} then {
		if {[expr abs($p($i,6))] == 3} then {
		    set nelement $p($i,8)
		    find_elem_punkte_winkel $nelement
		    if {$ie_p1 == $p($i,7)} then {
			set jv [expr int($ie_p2)]
		    } else {
			set jv [expr int($ie_p1)]
		    }
		} else {
		    set jv [expr int(abs($p($i,8)))]
		}
		while {$jv != 0} {
		    if {$p($jv,5) == 1} then {
			if {$iaender == 1} then {
			    set p($jv,5) 0
			}
		    }
		    if {$p($jv,5) == 0} then {
			set p($jv,5) 1
			if {$jv <= [min $i $ianf]} then {
			    set ianf $jv
			}
		    } elseif {$p($jv,5) <= -1} then {
			set p($i,5) -1
			if {$p($iv,5) == 1} then {
			    set p($iv,5) 0
			    if {$iv <= [min $i $ianf]} \
			    then {
				set ianf $iv
			    }
			}
		    }
		    if {$jpunkt > 0} then {
			set jv [expr int($ipunkt($jpunkt))]
			set jpunkt [expr $jpunkt-1]
		    } else {
			set jv 0
		    }
		}
	    }
	}
     }
     if {$ianf <= $i} then {
	set i $ianf
     } else {
	set i [expr $i+1]
     }
     set ianf [expr $i+1]
}

set p($ie_p,5) 0

set iaender 0
set i 0
while {$i < $lges_p} {
    incr i
    if {$p($i,5) == -1} then {
	set iaender [expr $iaender+1]
    }
}

# Punktverschiebungen durchfhren

#	p(i,5)=0 --> Punkt i wurde verschoben bzw. braucht nicht ver-
#		     schoben zu werden
#	p(i,5)=1 --> Punkt i braucht nicht verschoben zu werden
#	p(i,5)=2 --> Punkt i wurde nicht verschoben
#	p(i,5)=3 --> Punkt i durfte nicht verschoben werden, da Rand-
#		     bedingungen verletzt wurden


set not_aender 0
set i 1
while {$iaender > 0 && $i <= $lges_p} {
    while {$i <= $lges_p && $p($i,5) != -1} {
	incr i
    }

    if {$i <= $lges_p} then {
# hier Punktverschiebungen notwendig
	if {[expr abs($p($i,6))] > 1} then {
	    set iv [expr abs($p($i,7))]
	    if {$p($iv,5) != -1} then {
# 1. Punkt ok
		if {[expr abs($p($i,6))] >= 3.} then {
		    if {[expr abs($p($i,6))] == 3} then {
			set nelement $p($i,8)
			find_elem_punkte_winkel $nelement
			if {$ie_p1 == $p($i,7)} then {
			    set jv [expr int($ie_p2)]
			} else {
			    set jv [expr int($ie_p1)]
			}
		    } else {
			set jv [expr int(abs($p($i,8)))]
		    }
		    if {$p($jv,5) != -1} then {
# 2. Punkt ok
			if {[expr abs($p($i,6))] == 3} then {
# Elementfeste Koordinaten
			    if {$p($i,6) == 3} then {
				set dx $p($i,9)
				set dy $p($i,10)
			    } else {
				set list [polar_kartisisch \
				    $drad $dx \
				    $dy $p($i,9) $p($i,10)]
				set p($i,9) [lrange $list 0 0]
				set p($i,10) [lrange $list 1 1]
			    }
			    find_elem_punkte_winkel $nelement
			    set nullpunkt $p($i,7)
			    if {$ie_p1 == $nullpunkt} then {
				set i_2 $ie_p2
			    } else {
				set i_2 $ie_p1
			    }
			    set list [trans8_xs_x_2p \
				$p($nullpunkt,1) \
				$p($nullpunkt,2) $p($i_2,1) \
				$p($i_2,2) $dx $dy]
			    set p($i,1) [lrange $list 0 0]
			    set p($i,2) [lrange $list 1 1]
			    if {[expr abs($p($i,1)-$p($i,11))] \
			    > $eps ||
			       [expr abs($p($i,2)-$p($i,12))] \
			    > $eps} then {
				set p($i,5) 0
			    } else {
				set p($i,5) 2
				set not_aender \
				    [expr $not_aender+1]
			    }
			    set i 1
			} elseif {[expr abs($p($i,6))] >= 4 &&\
+			   [expr abs($p($i,6))] <= 5} then {
# Versetzung oder Zweischlag
			    set kstart [expr int($p($i,7))]
			    set kziel [expr int($p($i,8))]
			    set abst1 [expr abs($p($i,9))]
			    set dx [expr $p($kstart,1) \
				-$p($kziel,1)]
			    set dy [expr $p($kstart,2) \
				-$p($kziel,2)]
			    set abst_z \
				[expr sqrt($dx*$dx+$dy*$dy)]
			    if {[expr abs($p($i,6))] == 5} \
			    then {
#	Versetzung
				set abst2 [expr sqrt($abst_z*\
				     $abst_z-$abst1*$abst1)]
			    } else {
				set abst2 [expr abs($p($i,10))]
			    }
			    if {$p($i,9) < 0} then {
				set akb -1
			    } else {
				set akb 1
			    }
			    if {$abst_z < \
			    [expr abs($abst1-$abst2)] || \
			    $abst_z > \
			    [expr abs($abst1+$abst2)]} then {
				set p($i,5) 3
				set i 1
				set not_aender \
				    [expr $not_aender+1]
			    } elseif {[expr abs($abst_z)] < \
			    $eps} then {
#		Anfangs- und Endpunkt der Versetzung fallen zusammen
				set p($i,5) 3
				set i 1
				set not_aender \
				    [expr $not_aender+1]
			    } else {
				set list [ \
				  bere_zweischlag_m_punkt \
				  $p($kstart,1) $p($kstart,2) \
				  $abst1 $abst2 $p($kziel,1) \
				  $p($kziel,2) $akb]
				set p($i,1) [lrange $list 0 0]
				set p($i,2) [lrange $list 1 1]
				if {[lrange $list 2 2] == 1 } then {
				#   Fehler beim Berechnen des Zweischlags
				    return -$ie_p
				}
				if {\
				[expr abs($p($i,1)-$p($i,11))] \
				> $eps ||
				[expr abs($p($i,2)-$p($i,12))] \
				> $eps} then {
				    set p($i,5) 0
				} else {
				    set p($i,5) 2
				    set not_aender \
					[expr $not_aender+1]
				}
				set i 1
			    }
			} elseif {[expr abs($p($i,6))] == 6} \
			then {
# Gerade
			    set kstart [expr int(abs($p($i,7)))]
			    set kziel [expr int(abs($p($i,8)))]
			    set abst1 [expr abs($p($i,9))]
			    if {$p($i,8) < 0} then {
#		Winkel durch 3. Punkt gegeben
				set kziel2 [expr int($p($i,10))]
				if {$p($kziel2,5) != -1} then {
#			3. Punkt ist ok
				    set winkel [expr \
					atan2($p($kziel2,2)- \
					$p($kziel,2),\
					$p($kziel2,1)- \
					$p($kziel,1))/$drad]
				} else {
#			3. Punkt ist nicht in Ordnung
				    set i [expr $i+1]
				    # goto 150
				    return -$ie_p
				}
			    } else {
				set winkel $p($i,10)
			    }
			    if {$p($i,9) < 0} then {
				set kb -1
			    } else {
				set kb 1
			    }
			    set abst_min [ \
				min_abst_punkt_gerade \
				$kstart $kziel $winkel \
				$eps_winkel $drad]
			    if {$abst1 < $abst_min} then {
				set p($i,5) 3
				set i 1
				set not_aender \
				    [expr $not_aender+1]
			    } else {
				bere_punkt_auf_gerade $i \
				   $kstart $kziel \
				   $abst1 $winkel $kb $drad
				if { \
				[expr abs($p($i,1)-$p($i,11))] \
				> $eps || \
				[expr abs($p($i,2)-$p($i,12))] \
				> $eps} then {
				    set $p($i,5)=0
				} else {
				    set p($i,5) 2
				    set not_aender \
					[expr $not_aender+1]
				}
				set i 1
			    }
			} elseif {[expr abs($p($i,6))] == 7} \
			then {
# Schnittpunkt
			    set kstart [expr int(abs($p($i,7)))]
			    set kziel [expr int(abs($p($i,8)))]
			    if {$p($i,8) < 0} then {
#		Winkel durch 2. Punkt auf 2. Gerade gegeben
				set kziel2 \
					[expr int($p($i,10))]
				if {$p($kziel2,5) != -1} then {
#			2. Punkt auf 2. Gerade ist ok
				    set winkel [expr \
					atan2($p($kziel2,2)- \
					$p($kziel,2),\
					$p($kziel2,1)- \
					$p($kziel,1))/$drad]
				} else {
#			2. Punkt auf 2. Gerade ist nicht in Ordnung
				    set i [expr $i+1]
				    # goto 150
				    return -$ie_p
				}
			    } else {
				set winkel $p($i,10)
			    }
			    if {$p($i,7) < 0} then {
#		Winkel durch 2. Punkt auf 1. Gerade gegeben
				    set kstart2 \
					[expr int($p($i,9))]
				if {$p($kstart2,5) != -1} then {
#			2. Punkt auf 1. Gerade ist ok
				    set winkel1 [expr atan2(\
				       $p($kstart2,2)-\
				       $p($kstart,2),\
				       $p($kstart2,1)-\
				       $p($kstart,1))/$drad]
				} else {
#			2. Punkt auf 1. Gerade ist nicht in Ordnung
				    set i [expr $i+1]
				    # goto 150
				    return -$ie_p
				}
			    } else {
				set winkel1 $p($i,9)
			    }
			    if {[expr abs($winkel1-$winkel)] \
			    < $eps_winkel} then {
				set p($i,5) 3
				set i 1
				set not_aender \
				    [expr $not_aender+1]
			    } else {
				s_schnitt_2g $i $kstart $kziel \
				    $winkel1 $winkel
				if {\
				[expr abs($p($i,1)-$p($i,11))] \
				> $eps || \
				[expr abs($p($i,2)-$p($i,12))] \
				> $eps} then {
				    set p($i,5) 0
				} else {
				    set p($i,5) 2
				    set not_aender \
					[expr $not_aender+1]
				}
				set i 1
			    }
			} else {
			    set i [expr $i+1]
			}
		    } else {
			set i [expr $i+1]
		    }
		} elseif {[expr abs($p($i,6))] == 2} then {
# punktfeste Koordinaten
		    if {$p($i,6) == 2} then {
			set dx $p($i,9)
			set dy $p($i,10)
		    } else {
			set list [polar_kartisisch $drad $dx \
			    $dy $p($i,9) $p($i,10)]
			set p($i,9) [lrange $list 0 0]
			set p($i,10) [lrange $list 1 1]
		    }
		    if {$p($i,8) != 0} then {
#	gedrehtes Koordinatensystem
			set steigung8 [expr $p($i,8)*$drad]
			set list [trans8_xs_x_st $p($iv,1) \
			    $p($iv,2) $steigung8 $dx $dy)]
			set dx [lrange $list 0 0]
			set dy [lrange $list 1 1]
		    } else {
			set p($i,1) [expr $p($iv,1)+$dx]
			set p($i,2) [expr $p($iv,2)+$dy]
		    }
		    if {[expr abs($p($i,1)-$p($i,11))] > $eps \
		    || [expr abs($p($i,2)-$p($i,12))] > $eps} \
		    then {
			set p($i,5) 0
		    } else {
			set p($i,5) 2
			set not_aender \
			    [expr $not_aender+1]
		    }
		    set i 1
		}
	    } else {
		set i [expr $i+1]
	    }
	} else {
	    set p($i,5) 0
	}
    }
#150	     continue
#	    write(*,*) idummy, p(11,1),p(11,2),p(9,1),p(9,2),' para'
}
return $ie_p
}
####################################################################
# Kontrolle der Parametric fr Punkte

proc VParametricNach {je_p} {
global ie lges_e ie_p1 ie_p2 ie_w1 ie_w2
global p lges_p zurueck drad
global iaender not_aender statuszeile
global fehlermelderWartet noWarnung

set ierr 0
set ie_p [expr abs($je_p)]

#	write(*,*) p(8,1),p(8,2),p(11,1),p(11,2),' para2'

if {$iaender != 0} then {
    if {$not_aender != 0} then {
	set not_aender 0
	set i 0
	while {$i < $lges_p} {
	    incr i
	    if {$p($i,5) == 3} then {
		set not_aender 1
		set ierr 1
	    }
	}
    }
#	    if {$not_aender != 0} then {
#		if {$je_p > 0} then {
#		    string='undo'
#		    call read_b('Was nun',*1,string,iw,rw,kk,icorr,0,
#     + 		 '1g,Ok,Undo,Zurck',0.,0.)
#		}
#	    }
    if {$ierr == 1} then {
	if {$je_p > 0 && $noWarnung == "Nein" } then {
	    fehlermelderParametric $je_p
	    fehlerMelderWarten
	}
	set statuszeile \
	    "Es ist ein Fehler im Parametricmodul aufgetreten (Schleifenabbruch durch Antippen von STOP)"
	puts $statuszeile

#		set dx $p($ie_p,1)
#		set dy $p($ie_p,2)
#
#		set i 0
#		while {$i < $lges_p} {
#		    incr i
#		    set p($i,1) $p($i,11)
#		    set p($i,2) $p($i,12)
#		}
#
##		if (string(:1).eq.'U') then
##		    set p($ie_p,1) $dx
##		    set p($ie_p,2) $dy
##		else
#		    set p($ie_p,6) $zurueck(1)
#		    set p($ie_p,7) $zurueck(2)
#		    set p($ie_p,8) $zurueck(3)
#		    set p($ie_p,9) $zurueck(4)
#		    set p($ie_p,10) $zurueck(5)
#		end if
    }
}

set i 0
while {$i < $lges_p} {
    incr i
    set p($i,5) 0
    set p($i,11) $p($i,1)
    set p($i,12) $p($i,2)
}

}
#################################################################
proc fehlermelderParametric {je_p} {

    global fehlermelderWartet
    global statuszeile

puts "je_p=$je_p"

	set statuszeile "Programm  pausiert"

	set fehlermelderWartet 1
	set w .err

	DSNewWindow "." $w "Dromeg: Fehlermelder" 100 40

	frame $w.f1
	frame $w.f2
	pack $w.f1 $w.f2 -side top -in $w -fill x
	frame $w.f1.f1
	frame $w.f1.f2
	pack $w.f1.f1 $w.f1.f2 -in $w.f1 -fill x
	label $w.f1.f1.l1 -text "Fehler im Parametric-Modul:" \
	    -foreground red
	pack $w.f1.f1.l1 -in $w.f1.f1 -side left
	label $w.f1.f2.l1 -text " "
	pack $w.f1.f2.l1 -in $w.f1.f2 -side left

	frame $w.f2.f1
	button $w.f2.b1 -text "Fehler zeigen" -command "
	    set fehlermelderWartet 0
	    faerbeFalschePunkte $je_p
	    destroy .err
	    fehlermelder2 \
	    \"Betrachten Sie die Punkte: Gruen - Lage ok; Rot - Lage nicht richtig bestimmt\" \
	    \"Die Aenderungen werden Rueckgaengig gemacht\"
	    faerbePunkte"
#	button $w.f2.b2 -text "Noch einmal versuchen" -command
	button $w.f2.b2 -text "Weiter" -command {
	    set fehlermelderWartet 0
	    faerbePunkte
	    destroy .err
	}
	frame $w.f2.f2
	pack $w.f2.f1 -in $w.f2 -expand 1 -side left
	pack $w.f2.b1 $w.f2.b2 -in $w.f2 -side left
	pack $w.f2.f2 -in $w.f2 -expand 1 -side right

	tkwait variable fehlermelderWartet
}
#################################################################
proc faerbePunkte {} {

    global lges_p p wc

    set i 0
    while {$i < $lges_p} {
	incr i
	set stift [string range $p($i,15) 0 0]
	if {$stift == 1} then {
	    $wc itemconfigure $i -fill brown
	} else {
	    $wc itemconfigure $i -fill white
	}
    }
}
#################################################################
proc faerbeFalschePunkte {je_p} {

    global lges_p p wc

    set i 0
    while {$i < $lges_p} {
	incr i
	set stift [string range $p($i,15) 0 0]
	if {$je_p == $i} then {
	    $wc raise $je_p
	    $wc itemconfigure $i -fill red
	} else {
	    $wc itemconfigure $i -fill green
	}
    }
}
#################################################################
proc DSNewWindow {w wn title x y} {
# w	Variable des Parent-Windows
# wn	Variable des Neuen Windows
# title Name des neuen Fensters
# x	Position des neune Fensters in x-Richtung
# y	Position des neune Fensters in y-Richtung 

    set parentPosition [wm geometry $w]
    set xstart [expr [string first "+" $parentPosition]+1]
    set xstring [string range $parentPosition $xstart end]
    set xend [expr [string first "+" $xstring]-1]
    set xpos [string range $xstring 0 $xend]
    set ystart [expr $xend+2]
    set ypos [string range $xstring $ystart end]
    set geometry "+[expr $xpos+100]+[expr $ypos+40]"

    toplevel $wn
    wm geometry $wn "$geometry"
    wm focus $wn
    wm title $wn $title
    wm transient $wn $w
    wm group $wn $w
}
#############################################################
proc VSetMassstab {ianz} {
global massstab last_massstab canvas_height canvas_width
global p lges_p xMax xMin yMax yMin
global al1 al2 al3 al4

set last_massstab $massstab

if {$ianz == 1} then {
    set xMax [expr [max $al2 [expr $al3+$al4] ] /1000]
    set xMin -$xMax
    set yMax [expr [max $al2 $al3] /1000]
    set yMin -$yMax

} else {

    set xMax $p(1,1)
    set xMin $p(1,1)
    set yMax $p(1,2)
    set yMin $p(1,2)

    set janz [min $ianz $lges_p]
    set i 1
    while {$i < $janz} {
    incr i
	set xMax [max $xMax $p($i,1)]
	set xMin [min $xMin $p($i,1)]
	set yMax [max $yMax $p($i,2)]
	set yMin [min $yMin $p($i,2)]
    }


}
set massstab_x [expr ($canvas_width-10)/($xMax-$xMin)]
set massstab_y [expr ($canvas_height-10)/($yMax-$yMin)]
set massstab [min $massstab_x $massstab_y]
}
#############################################################
proc VSetLgesP {jp typ} {
global p lges_p
set list [array names p]
if {[lsearch $list "$jp,1"] == -1} then {
if {$typ == "node"} then {set lges_p [max $lges_p $jp]}
foreach ele {1 2 3 4 5 6 7 8 9 10 11 12 13 14 15} {
    set p($jp,$ele) 0
}
}
}
#############################################################
proc VSetLgesE {jp} {
global ie re lges_e

set list [array names re]
if {[lsearch $list "$jp,1"] == -1} then {
set lges_e [max $lges_e $jp]
foreach ele {1 2 3 4} {
    set re($jp,$ele) 0
}
foreach ele {1 2 3 4 5 6 7 8 9 10} {
    set ie($jp,$ele) 0
}
}
}
#############################################################
proc VFuellPreSamFelder {} {
global ie re lges_e
global p lges_p

set jp 0
while {$jp < $lges_e} {
incr jp
set list [array names re]
if {[lsearch $list "$jp,1"] == -1} then {
    foreach ele {1 2 3 4} {
	set re($jp,$ele) 0
    }
    foreach ele {1 2 3 4 5 6 7 8 9 10} {
	set ie($jp,$ele) 0
    }
}
}

set jp 0
while {$jp < $lges_p} {
incr jp
set list [array names p]
if {[lsearch $list "$jp,1"] == -1} then {
    foreach ele {1 2 3 4 5 6 7 8 9 10 11 12 13 14 15} {
	set p($jp,$ele) 0
    }
}
}
}
#############################################################
# Unterprogramm zum Lesen eines Eingabedatensatzes

proc VLiesPreSam {presamfile} {

# ges.: p,lges_p,ie,re,lges_e,iok,gx,gy,ia,ra,i_d,title

# name	      : Name des Eingabedatensatzes
# p()	      : Feld mit Daten der Punkte und Winkel
#		p(*,1) = x-Koordinate
#		p(*,2) = y-Koordinate
#		p(*,3) = Kennzahl, p(*,3)=p1+2*p2+4*p3+8*p4
#			 p1=1 --> 1. Koordinate fix
#			 p2=1 --> 2. Koordinate fix
#			 p3=1 --> kein Punkt, sondern Winkel
#			 p4=1 --> kein Winkel, sondern Punkt
#		p(*,4) = Masse bzw. Massentrgheitsmoment
#		p(*,5) = Zwischenspeicher (fr Masse bzw.Massentrg-
#			 heitsmoment im Upro speicher bzw. fr
#			 Parametric
#		p(*,6) = Kennzahl fr Parametric
#			 |p(*,6)| =1 --> Raumfestes Koordinatensystem
#			 |p(*,6)| =2 --> Punktfestes Koordinatensystem
#			 |p(*,6)| =3 --> Elementfestes Koordinatensystem
#			 Vorzeichen='+' --> Kartesisch
#			 Vorzeichen='-' --> Polar
#			 |p(*,6)| =4 --> Eingabetyp Zweischlag
#			 |p(*,6)| =5 --> Eingabetyp Versetzung
#			 |p(*,6)| =6 --> Eingabetyp: Punkt auf
#					 Linearfhrung
#			 |p(*,6)| =7 --> Eingabetyp: Punkt im
#					 Schnittpunkt zweier Geraden
#		p(*,7) = fr Parametric
#			 2<=p(*,6)<=3	--> Punkt-Nr. des Nullpunkts
#					    des Koordinatensystems
#			 4<=p(*,6)<=5	--> Nr. des Anfanspunktes des
#					    Zweischlags
#			 p(*,6)=6	--> Nr. des Punkts mit festem
#					    Abstand zu Linearfhrung
#			 p(*,6)=7	--> Betrag= Nr. des Punkts auf
#						    1. Linearfhrung
#					  p(*,7)>0 --> Winkel der 1.
#						       L.-f. ist gegeben
#					  p(*,7)<0 --> 2. Punkt auf 1.
#						       L.-f. ist gegeben
#		p(*,8) = fr Parametric
#			 p(*,6)=2     --> Verdrehwinkel zum raumfesten
#					  Koordinatensystem in Grad
#			 p(*,6)=3     --> Element-Nr. fr Koordinaten-
#					  systems
#					  p(*,8)=-1 --> Element-Nr. ist
#							nicht bekannt
#			 4<=p(*,6)<=5 --> Nr. des Endpunktes des
#					  Zweischlags
#			 6<=p(*,6)<=7 --> Betrag= Nr. des Punkts auf
#						  (2.) Linearfhrung
#					  p(*,8)>0 --> Winkel der (2.)
#						       L.-f. ist gegeben
#					  p(*,8)<0 --> 2. Punkt auf (2.)
#						       L.-f. ist gegeben
#		p(*,9) = fr Parametric
#			 1<=p(*,6)<=3	--> x-Koordinate bzw. Abstand
#			 4<=p(*,6)<=5	--> Lnge des 1. Teil des
#					    Zweischlags
#					    Betrag=Vorzeichen
#						   des Bewegungsbereichs
#			 p(*,6)=6	--> Abstand zwischen beiden
#					    Punkten
#					    Betrag=Vorzeichen
#						   des Bewegungsbereichs
#			 p(*,6)=7	--> p(*,7)>0 --> Winkel der 1.
#							 Linearfhrung
#					    p(*,7)<0 --> 2. Punkt auf 1.
#							 Linearfhrung
#		p(*,10)= fr Parametric
#			 1<=p(*,6)<=3 --> y-Koordinate bzw. Winkel
#			 p(*,6)=4     --> Lnge des 2. Teil des
#					  Zweischlags
#			 6<=p(*,6)<=7 --> p(*,8)>0 --> Winkel der (2.)
#						       Linearfhrung
#					  p(*,8)<0 --> 2. Punkt auf (2.)
#						       Linearfhrung
#		p(*,11)= Kopie von p(*,1) fr UNDO in Parametric
#		p(*,12)= Kopie von p(*,2) fr UNDO in Parametric
#		p(*,13)= Spalte mit Kraft in x-Richtung oder Moment
#		p(*,14)= Spalte mit Kraft in y-Richtung von ik(),rk()
#		p(*,15)= Farbe fuer Punkte (vergl. ie(*,10))
# lges_p      : Grte Nr. eines vorkommenden Punktes
# ie()	      : INTEGER-Feld mit Daten der Elemente
#		ie(*,1) = Kennzahl
#			  ie(*,1)=1 --> Elementtyp ist BEAM
#			  ie(*,1)=2 --> Elementtyp ist SLIDER
#			  ie(*,1)=3 --> Elementtyp ist BELT
#			  ie(*,1)=4 --> Elementtyp ist GEAR
#			  ie(*,1)=10 --> Elementtyp ist Gestell-Linie
#			  ie(*,1)=11 --> Elementtyp ist TRUSS
#			  ie(*,1)=12 --> Elementtyp ist SENSOR
#			  ie(*,1)=13 --> Elementtyp ist SPRING
#			  ie(*,1)=14 --> Elementtyp ist DAMPER
#			  ie(*,1)=15 --> Elementtyp ist FRICTON
#			  ie(*,1)=21 --> Elementtyp ist HINGE
#			  ie(*,1)=22 --> Elementtyp ist ROTSPRING
#			  ie(*,1)=23 --> Elementtyp ist ROTDAMPER
#			  ie(*,1)=24 --> Elementtyp ist ROTFRICTON
#		ie(*,2) = Kennzahl
#			  ie(*,2)=1 --> 1. Parameter ist frei (RELEASE)
#		ie(*,3) = 1. Parameter des Elements
#		ie(*,4) = 2. Parameter des Elements
#		ie(*,5) = 3. Parameter des Elements
#			  (bei Gestell-Element 2. Parameter)
#		ie(*,6) = 4. Parameter des Elements
#		ie(*,7) = Nr. des Gliedes, zu dem das Element gehrt
#			  (wenn Gestell beim BELT-Element, dann = 0)
#			  (beim GEAR-Element ein Zahnrad, dann = 0)
#			  (beim SLIDER-Element = 0)
#		ie(*,8) = Nr. des Gliedes, zu dem das Element, mit dem
#			  der Anfangspunkt verbunden ist, gehrt
#			  (beim BELT-Element eine Zahnscheibe)
#			  (beim GEAR-Element ein Zahnrad)
#			  (beim SLIDER-Element der Teil der Linear-
#			  fhrung der mit dem Anfangsp., d. h. der
#			  Buchse verbunden ist)
#		ie(*,9) = Nr. des Gliedes, zu dem das Element, mit dem
#			  der Endpunkt verbunden ist, gehrt
#			  (beim BELT-Element eine Zahnscheibe)
#			  (beim GEAR-Element ein Zahnrad)
#			  (beim SLIDER-Element der Teil der Linear-
#			  fhrung der mit dem Endpunkt verbunden ist)
#		ie(*,10) = Farb-Nr. fr Element oder Glied
#			   beim Plotten (Glied geht vor Element)
#			   Farb-Nr=(Nr. der Farbe)*10+Linientyp-Nr.
#			   Nr. der Farbe=9 --> nicht plotten
#			   Farb-Nr.>=0 --> Farbe fr Glied
#			   Farb-Nr.<0  --> Farbe fr Element
#			   (beides ist also nicht immer mischbar,
#			   wenn Element- und Glied-Nr. sich gleich sind)
#			   nvm_e=-10 --> Farb-Nr. automatisch verteilen
# re()	      : REAL-Feld mit Daten der Elemente
#		re(*,1) = 5. (bzw. z. B. bei TRUSS 3.) Parameter des 
#			  Elements
#		re(*,2) = 6. (bzw. z. B. bei TRUSS 4.) Parameter des
#			  Elements
#		re(*,3) = 7. Parameter des Elements
#		re(*,4) = 8. Parameter des Elements
#			  (wird SLIDER durch BEAM mit RELEASE ersetzt,
#			  wird hier die Lnge des STange des SLIDER
#			  zwischengespeichert!)
# lges_e      : Grte Nr. eines vorkommende Element
# gx	      : Gravitation in x-Richtung
# gy	      : Gravitation in y-Richtung
# iok	      : Kennzahl
#		  iok=1 --> Daten gelesen
#		  iok=0 --> es wurden keine Daten eingelesen oder Daten
#			    sind Fehlerhaft
# ia	      : Integerfeld mit Daten fr Antrieb
#		ia(0,1) > 0	--> =Nr. des Positions- oder
#				     Deformationsparameters
#		ia(0,2)=Kennzahl
#			ia(0,2)=1  --> XINPUT, 1. Positionsparameter
#			ia(0,2)=2  --> XINPUT, 2. Positionsparameter
#			ia(0,2)=-1 --> EINPUT, 1. Deformationsparameter
#			ia(0,2)=-2 --> EINPUT, 2. Deformationsparameter
#			ia(0,2)=-3 --> EINPUT, 3. Deformationsparameter
#		ia(1 ... ,1)=Kennzahl
#			     ia(1 ... ,1)=1 --> constant
#			     ia(1 ... ,1)=2 --> linear
#			     ia(1 ... ,1)=3 --> sinq
#			     ia(1 ... ,1)=4 --> pol345
#			     ia(1 ... ,1)=5 --> anycurve
#			     ia(1 ... ,1)=0 --> hinter letzter belegung
#		ia(1 ... ,2)=number of steps
# ra	      : Realfeld mit Daten fr Antrieb
#		ra(*,1)=1. Real-Parameter 
#		ra(*,2)=2. Real-Parameter	  
#		ra(*,3)=3. Real-Parameter 
#		ra(*,4)=4. Real-Parameter
# ik	      : Integerfeld mit Daten ber Krfte bzw. Momente
#		ik(*,i) i=Spalte, deren Nummer in p(*,13) bzw. p(*,14)
#			steht
#			die Spalte enthlt Angaben darber, fr
#			wie viele Steps der entsprechende Gre
#			in der gleichen Spalte und Zeile des Feldes 
#			rk() gilt
# rk	      : Realfeld mit Daten ber Krfte bzw. Momente in N
#		bzw. Nm
# i_d	      : Itegerfeld mit Daten ber das Abspeichern
#		i_d(0,1)=belegte Anzahl an Zeilen
#		i_d(1 ... ,1)=Kennzahl
#			     i_d(*,1)=1 -->  position
#			     i_d(*,1)=2 -->  displacement
#			     i_d(*,1)=3 -->  velocities
#			     i_d(*,1)=4 -->  accelerations
#			     i_d(*,1)=5 -->  forces
#			     i_d(*,1)=6 -->  power
#			     i_d(*,1)=7 -->  Winkel
#			     i_d(*,1)=8 -->  Winkel-Geschwindigkeit
#			     i_d(*,1)=9 -->  Winkel-Beschleunigung
#			     i_d(*,1)=-1 -->  0-order deformation
#			     i_d(*,1)=-2 -->  1-order deformation
#			     i_d(*,1)=-3 -->  2-order deformation
#			     i_d(*,1)=-4 -->  element-stress
#			     i_d(*,1)=-5 -->  element-power
#		i_d(1 ... ,2)=Nr. des Punktes, des Winkels oder des
#			     Elements
#			     i_d(*,2)=-1 --> alle Punkte, Winkel oder
#					    Elemente
#			     i_d(*,2)=-2 --> alle bewegten Punkte
#			     i_d(*,2)=-3 --> alle bewegten Winkel
#			     i_d(*,2)=-4 --> alle fixierten Punkte
#			     i_d(*,2)=-5 --> alle fixierten Winkel

#		i_d(1 ... ,3)=Nr.
# title       : Titel der Datei
#.....................................................................
#.....................................................................
global ie re lges_e
global p lges_p 
global title gx gy ia ra statuszeile

set lges_e 0
set lges_p 0
if {[info exists ie] == 1} then {unset ie}
if {[info exists re] == 1} then {unset re}
if {[info exists p] == 1} then {unset p}
if {[info exists ia] == 1} then {unset ia}
if {[info exists ra] == 1} then {unset ra}

# Daten einlesen

set ierr 0
set GetrDatei [open $presamfile]

while { [gets $GetrDatei Zeile] >= 0} {
set iend [string last "*" $Zeile]
if {$iend != -1} then {
    set Zeile [string range $Zeile 0 [expr $iend-1]]
}
set keyword [string toupper [lrange $Zeile 0 0] ]

switch $keyword {
    "*ELE-FARBE" -
    "*GLIED-FARBE" {
	set jp [lrange $Zeile 1 1]
	VSetLgesE $jp
	set ist [lrange $Zeile 2 2]
	set ili [lrange $Zeile 3 3]
	if {$ist == "0"} then {
	    set ili 0
	} elseif {$ili == "0"} then {
	    set ili 1
	}
	if {$keyword == "*ELE-FARBE"} then {
	    set $ie($jp,10) [expr -($ist*10+$ili)]
	} else {
	    set ie($jp,10) "[expr ($ist*10+$ili)]"
	}
    }
    "*PUNKT-FARBE" {
	set jp [lrange $Zeile 1 1]
	VSetLgesE $jp
	set ist [lrange $Zeile 2 2]
	set ili [lrange $Zeile 3 3]
	set p($jp,15) "[expr ($ist*10+$ili)]"
    }
    "*GLIED" {
# *GLIED
	set jp [lrange $Zeile 1 1]
	VSetLgesE $jp
	set ie($jp,7) [lrange $Zeile 2 2]
	set ie($jp,8) [lrange $Zeile 3 3]
	set ie($jp,9) [lrange $Zeile 4 4]
    }
    "*RELEASE" {
	set j [lrange $Zeile 1 1]
	VSetLgesE $j
	set iw [lrange $Zeile 2 2]
	set drw [lrange $Zeile 3 3]
	if {$iw == "1"} then {
	    if {$drw != "0"} then {
#		SLIDER als Schubgelenk
		set ie($j,1) 2
		set re($j,1) $drw
	    } else {
#		BEAM oder TRUSS mit RELEASE ergibt Schubgelenk
		set ie($j,2) 1
	    }
	} else {
	    set ierr 1
	    set statuszeile \
"Kennwort *RELEASE fuer ELEMENT $jp: Parameter $iw ist unbekannt"
	}
    }
    "*GESTELL" {
# *GESTELL: gestellfester TRUSS
	set j [lrange $Zeile 1 1]
	VSetLgesE $j
	set ie($j,1) 10
	set ie($j,3) [lrange $Zeile 2 2]
	set ie($j,5) [lrange $Zeile 3 3]
	set ie($j,7) 0
    }
    "*NODE-PARA" {
# *NODE-PARA: NODE-Parametric vorhanden
	set jp [lrange $Zeile 1 1]
	VSetLgesP $jp "node"
	set p($jp,6) [lrange $Zeile 2 2]
	set p($jp,7) [lrange $Zeile 3 3]
	set p($jp,8) [lrange $Zeile 4 4]
#		if {[expr abs($p($jp,6))] != 2} then {set ierr 1}
	set p($jp,9) [lrange $Zeile 5 5]
	set p($jp,10) [lrange $Zeile 6 6]
    }
    "*" -
    " " {
# Kommentar
    }
    "TITLE" {
# TITLE
	set title [lrange $Zeile 1 end]
    }
    "NODE" {
# NODE
	set jp [lrange $Zeile 1 1]
	VSetLgesP $jp "node"
	set p($jp,1) [lrange $Zeile 2 2]
	set p($jp,2) [lrange $Zeile 3 3]
	set p($jp,3) 8.
	if {$p($jp,6) == 0} then {
	    set p($jp,6) 1
	    set p($jp,9) $p($jp,1)
	    set p($jp,10) $p($jp,2)
	}
	set p($jp,11) $p($jp,1)
	set p($jp,12) $p($jp,2)
    }
    "ANGLE" {
# ANGLE
	set jp [lrange $Zeile 1 1]
	VSetLgesP $jp "angle"
	if {$p($jp,6) == 0} then {
	    set p($jp,3) 4
	} else {
	    set p($jp,3) [expr $p($jp,3)+4.]
	}
    }
    "FIX" {
	set jp [lrange $Zeile 1 1]
	VSetLgesP $jp "fix"
	set iw [lrange $Zeile 2 2]
	if {$iw == 1} then {
#		... x-Koordinate fix
	    set p($jp,3) [expr $p($jp,3)+1]
	} elseif {$iw == 2} then {
#		... y-Koordinate fix
	    set p($jp,3) [expr $p($jp,3)+2]
	} else {
	    set ierr 1
	    set statuszeile \
"Kennwort FIX fr Punkt/Winkel $jp: Parameter $iw ist unbekannt"
	}
    }
    "MASS" {
# MASS
	set jp [lrange $Zeile 1 1]
	VSetLgesP $jp "mass"
	set p($jp,4) [lrange $Zeile 2 2]
    }
    "CFORCE" {
# Konstante KRAFT 
	set ierr 1
	    set statuszeile \
	       "Kennwort CFORCE wird nicht unterstuetzt"
    }
    "BEAM" -
    "TRUSS" -
    "SLIDER" -
    "HINGE" -
    "BELT" -
    "GEAR" -
    "SENSOR" {
# BEAM oder TRUSS oder SLIDER oder HINGE oder BELT oder GEAR oder SENSOR
	set j [lrange $Zeile 1 1]
	VSetLgesE $j
	switch $keyword {
	    "BEAM" {set ie($j,1) 1}
	    "TRUSS" {set ie($j,1) 11}
	    "SLIDER" {set ie($j,1) 2}
	    "HINGE" {set ie($j,1) 21}
	    "BELT" {set ie($j,1) 3}
	    "GEAR" {set ie($j,1) 4}
	    "SENSOR" {set ie($j,1) 12}
	}
	set ie($j,3) [lrange $Zeile 2 2]
	switch $keyword {
	    "TRUSS" -
	    "HINGE" {
		set ie($j,4) [lrange $Zeile 3 3]
		set re($j,1) [lrange $Zeile 4 4]
		set re($j,2) [lrange $Zeile 5 5]
	    }
	    "SENSOR" {
		set ie($j,4) [lrange $Zeile 3 3]
	    }
	    default {
		set ie($j,4) [lrange $Zeile 3 3]
		set ie($j,5) [lrange $Zeile 4 4]
		set ie($j,6) [lrange $Zeile 5 5]
		set re($j,1) [lrange $Zeile 6 6]
		set re($j,2) [lrange $Zeile 7 7]
		set re($j,3) [lrange $Zeile 8 8]
		set re($j,4) [lrange $Zeile 9 9]
		if {$keyword == "GEAR"} then {
		    set ierr 1
		    set statuszeile \
"Zaehnezahl von Zahnradpaar $j eventuell falsch ermittelt"
		}
	    }
	}
    }
    "GRAVITY" {
# GRAVITY
	set gx [lrange $Zeile 1 1]
	set gy [lrange $Zeile 2 2]
    }
    "EINPUT" -
    "XINPUT" {
	set ia(0,1) [lrange $Zeile 1 1]
	if {$keyword == "XINPUT"} then {
# XINPUT
	    set ia(0,2) [lrange $Zeile 2 2]
	} else {
# EINPUT
	    set ia(0,2) [expr -1*[lrange $Zeile 2 2]]
	}
	set j 0
	while { [gets $GetrDatei Zeile] >= 0} {
	    set end [string last "*" $Zeile]
	    if {$end != -1} then {
		set Zeile [string range $Zeile $end end]
	    }
	    set keyword [string toupper [lrange $Zeile 0 0] ]

	    switch $keyword {
		"ENDBLOC" {break}
		"CONSTANT" {
# CONSTANT
		    incr j
		    set ia($j,1) 1
		}
		"LINEAR" {
# LINEAR
		    incr j
		    set ia($j,1) 2
		}
		"SINQ" {
# SINQ
		    incr j
		    set ia($j,1) 3
		}
		"POL345" {
# POL345
		    incr j
		    set ia($j,1) 4
		}
		"ANYCURVE" {
# ANYCURVE
		    incr j
		    set ia($j,1) 5
		    set ierr 1
		    set statuszeile \
"Antriebsart ANYCURVE nicht implementiert"
		}
		default {
		    set ierr 1
		    set statuszeile \
"Kennwort $keyword unbekannt"
		}
	    }
	    set ra($j,1) [lrange $Zeile 1 1]
	    if {$ia($j,1) == 1} then {
# CONSTANT
		set ia($j,2) [lrange $Zeile 2 2]
	    } else {
		set ra($j,2) [lrange $Zeile 2 2]
		set ia($j,2) [lrange $Zeile 3 3]
	    }
	}
    }
    "FILE" {break}
    "" {}
    " " {}
    "ENDBLOC" {break}
    "TIMESTEP" -
    default {
	set ierr 1
	set statuszeile  "Kennwort $keyword unbekannt"
    }
    if {$ierr == 1} then {
	puts "Fehler: $statuszeile"
	break
    }
}
}
close $GetrDatei

VFuellPreSamFelder

    # Parametric vervollstndigen
    set i 0
    while {$i < $lges_p} {
        incr i
        if {$p($i,3) >= 8} then {
            if {$p($i,6) == 0} then {set p($i,6) 1}
        }
    }
}
###########################################################################################################################
proc TsetRadi {{update 1} {dxfFile no}} {

    global pradi_ pradi_old

    if {$update == 1} then {
        set pradi_old $pradi_
    }
    
    set dxfFile "no"
    TCreateEntryButton " "  {RepaintGetr $dxfFile} \
                       {set pradi_ $pradi_old} 6 \
                       {"Radius der Gelenke" pradi_}
}
###########################################################################################################################
proc TsetShowGangPolKurvenPunkte { {dxfFile no}} {

    global ShowGangPolKurvenPunkte_Old ShowGangPolKurvenPunkte_

    set ShowGangPolKurvenPunkte_Old ShowGangPolKurvenPunkte_

    set dxfFile "no"
    TCreateEntryButton " "  {RepaintGetr $dxfFile} \
                       {set ShowGangPolKurvenPunkte_ $ShowGangPolKurvenPunkte_Old} 6 \
                       {"Wie viele Punnkte der Gangpolkurve sollen mit einem Kreis markiert werden?" ShowGangPolKurvenPunkte_}
}
############################################################
proc RepaintGetr {dxfFile} {

    global pradi_ wc
    global xMoveto yMoveto

    T_Grafik
    VShowGetr $dxfFile 1.
    #xyViewDefault
    VModifyGetr all $dxfFile
    #VNormalizeGetr
    $wc xview moveto $xMoveto
    $wc yview moveto $yMoveto
    TRestartTrochoide
}
#############################################################
proc TPullDownMenu {} {

global canvas_height canvas_width massstab statuszeile
global showPunktMove showRast showGang showSelbst showUeber kueStatus
global wc Pi last_massstab lges_u showKoppelk xk_df yk_df showSchnabel
global xMoveto last_xMoveto yMoveto last_yMoveto 0x 0y
global last_0x last_0y xZoomPos1 yZoomPos1 xzoom yzoom xneu yneu
global lges_p DateiName xRast yRast xGang yGang xSb ySb xUe yUe
global zweiLagen eineLage zweiLagenKoppel noMomentanPol
global zweiSchlag
global al1ue al2ue al3ue al4ue
global al1 al2 al3 al4
global dromeg4Vers

set zoomIn [image create bitmap -file dromegzi.xbm]
set zoomOut [image create bitmap -file dromegzo.xbm]
set zoomLast [image create bitmap -file dromegzl.xbm]
set zoomAll [image create bitmap -file dromegza.xbm]
set bitmapStop [image create bitmap -file dromegsp.xbm]
set bitmapStart [image create bitmap -file dromegst.xbm]
set grafikFensterAendern [image create photo btimage_gif2 -file dromeggv.gif]

destroy .mbar
frame .mbar -relief raised -bd 2
pack .mbar -side top -fill x

menubutton .mbar.file -text Datei -underline 0 -menu .mbar.file.menu
menubutton .mbar.uegk -text Uebergangskurve -underline 0 -menu \
.mbar.uegk.menu
menubutton .mbar.analyse -text Getriebe-Darstellung -underline 0 -menu \
.mbar.analyse.menu
menubutton .mbar.grafik -text Grafik -underline 0 -menu \
.mbar.grafik.menu
menubutton .mbar.zoom -text Zoom -underline 0 -menu \
.mbar.zoom.menu
menubutton .mbar.help -text Hilfe -underline 0 -menu \
.mbar.help.menu

button .mbar.start -image $bitmapStart -underline 1 \
    -command {TRunGetriebe 2 1 1}
foreach i "2 3" {
    bind .mbar.start <ButtonPress-$i> \
	".mbar.start configure -relief sunken
	TRunGetriebe 2 1 $i"
    bind .mbar.start <ButtonRelease-$i> \
	".mbar.start configure -relief raised"
}
bind .mbar.start <Any-Enter> {
    set statuszeile "'linke Maustaste': langsam,\
'mittlere Maustaste': mittel, 'rechte Maustaste': schnell"
}
bind .mbar.start <Any-Leave> {
    set statuszeile ""
}
button .mbar.stop -image $bitmapStop -underline 1 -command \
    {TStopGetriebe}
foreach i "2 3" {
    bind .mbar.stop <ButtonPress-$i> {TStopGetriebe}
}
bind .mbar.stop <Any-Enter> {
    set statuszeile "'alle Maustasten': Animation oder auch \
Berechnung beenden"
}
bind .mbar.stop <Any-Leave> {
    set statuszeile ""
}
button .mbar.space -text " " -relief flat

button .mbar.zoom_a -image $zoomAll -underline 1 -command \
TZoomAll
bind .mbar.zoom_a <Any-Enter> {
    setStatuszeile "'linke Maustaste': Zoom: 'Einpassen: alles'"
}
bind .mbar.zoom_a <Any-Leave> {
    setStatuszeile ""
}

button .mbar.zoom_o -image $zoomOut -underline 1 -command \
TZoomOut
bind .mbar.zoom_o <Any-Enter> {
    set statuszeile "'linke Maustaste': raus Zoomen"
}
bind .mbar.zoom_o <Any-Leave> {
    set statuszeile ""
}
button .mbar.zoom_i -image $zoomIn -underline 1 -command \
TSetZoomFenster
bind .mbar.zoom_i <Any-Enter> {
    set statuszeile "'linke Maustaste': rein Zoomen (Rechteck aufziehen)"
}
bind .mbar.zoom_i <Any-Leave> {
    set statuszeile ""
}
button .mbar.zoom_l -image $zoomLast -underline 1 -command {TZoomLast}
bind .mbar.zoom_l <Any-Enter> {
    set statuszeile "'linke Maustaste': letzten Zoom wieder anzeigen"
}
bind .mbar.zoom_l <Any-Leave> {
    set statuszeile ""
}

button .mbar.gwindow_m -image $grafikFensterAendern  -underline 1 -command \
TSetFensterGroesser
bind .mbar.gwindow_m <ButtonPress-3> \
	TSetFensterKleiner
bind .mbar.gwindow_m <Any-Enter> {
    setStatuszeile "'linke Maustaste': Grafik-Fenster vergroessern, 'rechte Maustaste': verkleinern"
}
bind .mbar.gwindow_m <Any-Leave> {
    setStatuszeile ""
}
bind .mbar.gwindow_m <ButtonRelease-3> \
	".mbar.gwindow_m configure -relief raised"

pack .mbar.file .mbar.uegk .mbar.analyse .mbar.grafik .mbar.zoom .mbar.help \
    -side left
    
label .mbar.space2 -text "  " -relief flat

pack .mbar.gwindow_m .mbar.space2 .mbar.zoom_l .mbar.zoom_i .mbar.zoom_o .mbar.zoom_a .mbar.space \
    .mbar.stop .mbar.start -side right

menu .mbar.file.menu
#   .mbar.file.menu add command -label "Datei oeffnen" -command {
#	VDateiOeffnen
#   }
.mbar.file.menu add command -label "Hilfe zu diesem Menue" \
    -foreground blue -command {
    ThelpHelp "dro-mf-4.hlp"
}
.mbar.file.menu add separator
.mbar.file.menu add command -label "Speichern: Einstellungen" \
  -command "VGrafikeinstellungSpeichern dromeg-4 E"
.mbar.file.menu add command -label "Speichern: Getriebeparameter" \
  -command "VGrafikeinstellungSpeichern dro-p-4 P speichern"
.mbar.file.menu add command -label "Lesen: Getriebeparameter" \
  -command "VGrafikeinstellungSpeichern dro-p-4 P open"
.mbar.file.menu add separator
.mbar.file.menu add command -label "Export: DXF-Datei" \
    -command "TexportDXF"
.mbar.file.menu add separator
.mbar.file.menu add command -label "Postscript-Datei erstellen" \
    -command {VPostscript}
.mbar.file.menu add separator
.mbar.file.menu add command -label Exit -command {exit}

menu .mbar.uegk.menu
.mbar.uegk.menu add command -label "Hilfe zu diesem Menue" \
    -foreground blue -command {
    ThelpHelp "dro-mu-4.hlp"
}
.mbar.uegk.menu add separator
.mbar.uegk.menu add cascade -label \
	"Uebergangskurve automatisch bestimmen" \
	-menu .mbar.analyse.menu.auto
menu .mbar.analyse.menu
.mbar.analyse.menu add command -label "Hilfe zu diesem Menue" \
    -foreground blue -command {
    ThelpHelp "dro-ma-4.hlp"
}
.mbar.analyse.menu add separator
.mbar.analyse.menu add command -label "Trochoiden darstellen" -command {
    source dromeg-t.tcl
}
 .mbar.analyse.menu add separator
.mbar.analyse.menu add checkbutton \
  -label "Eine Lage ohne Momentanpol darstellen" \
  -variable noMomentanPol -command {
    if {$noMomentanPol == 0} then {
	set eineLage 1
	set zweiLagen 0
	set zweiSchlag 0
	set zweiLagenKoppel 0
	set showZsR 0
	VSetAnzahlLagen
    } else {
	set eineLage 0
	set zweiLagen 0
	set zweiSchlag 0
	set zweiLagenKoppel 0
	set showZsR 0
	VSetAnzahlLagen
    }
}
.mbar.analyse.menu add checkbutton -label "Eine Lage darstellen" \
-variable eineLage -command {
    if {$eineLage == 0} then {
	set zweiLagen 1
	set zweiSchlag 0
	set zweiLagenKoppel 0
	set noMomentanPol 0
	set showZsR 0
	VSetAnzahlLagen
    } else {
	set zweiLagen 0
	set zweiSchlag 0
	set zweiLagenKoppel 0
	set noMomentanPol 0
	set showZsR 0
	VSetAnzahlLagen
    }
}
.mbar.analyse.menu add checkbutton -label "Eine Lage mit zusaetzlichem Zweischlag" \
-variable zweiSchlag -command {
#     puts "0: zweiSchlag=$zweiSchlag"
     if {$zweiSchlag == 1} then {
	 set eineLage 0
	 set zweiLagen 0
	 set zweiLagenKoppel 0
	 set noMomentanPol 0
	 set showZsR 1
#	  puts "zweiSchag=$zweiSchlag"
	 VSetAnzahlLagen
    } else {
	 set eineLage 1
	 set zweiLagen 0
	 set zweiLagenKoppel 0
	 set noMomentanPol 0
	 set showZsR 0
#	  puts "2: zweiSchlag=$zweiSchlag"
	 VSetAnzahlLagen
    }
}
.mbar.analyse.menu add checkbutton -label "Zwei Lagen darstellen" \
-variable zweiLagen -command {
    if {$zweiLagen == 0} then {
	set eineLage 1
	set zweiSchlag 0
	set zweiLagenKoppel 0
	set noMomentanPol 0
	set showZsR 0
	VSetAnzahlLagen
    } else {
	set eineLage 0
	set zweiSchlag 0
	set zweiLagenKoppel 0
	set noMomentanPol 0
	set showZsR 0
	VSetAnzahlLagen
    }
}
.mbar.analyse.menu add checkbutton -label "Zwei Lagen & Koppel darstellen" \
-variable zweiLagenKoppel -command {
    if {$zweiLagenKoppel == 0} then {
	set zweiLagen 1
	set zweiSchlag 0
	set eineLage 0
	set noMomentanPol 0
	set showZsR 0
	VSetAnzahlLagen
    } else {
	set zweiLagen 0
	set zweiSchlag 0
	set eineLage 0
	set noMomentanPol 0
	set showZsR 0
	VSetAnzahlLagen
    }
}
menu  .mbar.analyse.menu.auto
 .mbar.analyse.menu.auto add command -label "Aufsteigend" \
	-command {VSelbstberuehrungskurveAuto 1}
 .mbar.analyse.menu.auto add command -label "Absteigend" \
	-command {VSelbstberuehrungskurveAuto 2}
#.mbar.analyse.menu add command -label \
#    "Getriebe fuer Uebergangskurvenermittelung" -command {
#    VLiesDatei "dromeg-u.dat"
#}
.mbar.uegk.menu add separator
.mbar.uegk.menu add command -label \
    "Uebergangskurvenpunkt ermitteln"  -command {VSelbstberuehrungspunkt}
    
.mbar.uegk.menu add command -label \
    "Test: Uebergangskurvenpunkt ermitteln" -command {calcUebergangskurvenpunkt}

.mbar.uegk.menu add command -label \
    "Uebergangskurve ermitteln" -command {VSelbstberuehrungskurve}

menu .mbar.grafik.menu
.mbar.grafik.menu add command -label "Hilfe zu diesem Menue" \
    -foreground blue -command {
    ThelpHelp "dro-mg-4.hlp"
}
.mbar.grafik.menu add separator
.mbar.grafik.menu add command -label "Grafikfenstergroesse" \
-command {TSetGrafikGroesse}
.mbar.grafik.menu add command -label "Schrittweiten" \
-command {TSetSchritte}
.mbar.grafik.menu add command -label "Radius der Gelenkpunkte" \
-command {TsetRadi}
.mbar.grafik.menu add command -label "Gliedfarben" \
-command {modifyGliedfarben}
.mbar.grafik.menu add command -label "Punktfarben" \
-command {modifyPunktfarben}
.mbar.grafik.menu add command -label "Punkte der Gangpolkurve durch Kreis markieren" \
-command {TsetShowGangPolKurvenPunkte}
.mbar.grafik.menu add separator

menuGrafik2

menu .mbar.zoom.menu
.mbar.zoom.menu add command -label "Hilfe zu diesem Menue" \
    -foreground blue -command {
    ThelpHelp "dro-mz-4.hlp"
}
.mbar.zoom.menu add separator
.mbar.zoom.menu add command -label "Einpassen: Alles" \
-command {
    VSetMassstab $lges_p
    VModifyGetr all
    xyViewDefault
}
.mbar.zoom.menu add command -label "Einpassen: Viergelenk" \
-command {
    VSetMassstab 1
    VModifyGetr all
    xyViewDefault
}
#.mbar.zoom.menu add command -label "Einpassen: Gangpolkurve" \
#-command {
#    VSetMassstab 6
#    VModifyGetr all
#    xyViewDefault
#}
.mbar.zoom.menu add separator
.mbar.zoom.menu add command -label "Zoom: Rechteck aufziehen" \
-command {TSetZoomFenster}
.mbar.zoom.menu add command -label "Zoom: Letzter Zoom" \
-command {TZoomLast}
.mbar.zoom.menu add command -label "Zoom: raus zoomen" \
-command TZoomOut
.mbar.zoom.menu add command -label "Zoom: Massstab aendern" \
-command {TSetMassstab}

     menu .mbar.help.menu
     .mbar.help.menu add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mh-4.hlp"
    }
    .mbar.help.menu add separator
    .mbar.help.menu add command -label "Grundsaetzliches" \
	-command {
	ThelpHelp "dro-gh-4.hlp"
    }
    .mbar.help.menu add command -label "Hinweise zur Bedienoberflaeche" \
	-command {
	ThelpHelp "dro-4.hlp"
    }
    .mbar.help.menu add command -label "Info" -command {
	ThelpVersion "DROMEG-4" $dromeg4Vers
    }
    .mbar.help.menu add command -label "Copyright" -command {
	ThelpCopyright "DROMEG-4"
    }
    .mbar.help.menu add command -label \
	"Erlaeuterungen zu Kurven" -command {
	ThelpHelp "dro-kh-4.hlp"
    }

tk_menuBar .mbar .mbar.file .mbar.uegk .mbar.analyse .mbar.grafik .mbar.help \
    .mbar.zoom .mbar.zoom_o .mbar.zoom_i
focus .mbar
}
################################################################
proc VmirrorKue {} {

    global xUe yUe al2 al1 al3

    if {$al1 == $al3} then {
	# symmetrische totalschwingfaehige Getriebe an y-Achse spiegeln
	set i $xUe(0,0)
	puts "spiegel Uebergangskurvenast=$i"
	set i1 [expr $i+1]
	set jmax $xUe($i,0)
	set j 0
	while {$j < $jmax} {
	    incr j
	    set xUe($i1,$j) [expr -1.*($xUe($i,$j)-$al2/2.)+$al2/2.]
	    set yUe($i1,$j) $yUe($i,$j)
	    #puts "xUe=$xUe($i1,$j), yUe=$yUe($i1,$j),	     xUe=$xUe($i,$j), yUe=$yUe($i,$j)"
	}
	incr xUe(0,0)
	set xUe($i1,0) $xUe($i,0)

	set anzMirror 2
    } else {
	set anzMirror 1
    }

    # totalschwingfaehige Getriebe an x-Achse spiegeln
    set i [expr $xUe(0,0)-$anzMirror]
    set anz 0
    while {$anz < $anzMirror} {
	incr anz
	incr i
	puts "spiegel Uebergangskurvenast=$i"
	set i1 [expr $i+$anzMirror]
	set jmax $xUe($i,0)
	set j 0
	while {$j < $jmax} {
	    incr j
	    set xUe($i1,$j) $xUe($i,$j)
	    set yUe($i1,$j) [expr -1.*$yUe($i,$j)]
	    #puts "xUe=$xUe($i1,$j), yUe=$yUe($i1,$j),	     xUe=$xUe($i,$j), yUe=$yUe($i,$j)"
	}
	incr xUe(0,0)
	set xUe($i1,0) $xUe($i,0)
    }
}
#############################################################
proc menuGrafik2 {} {

    global showPunktMove showRast showGang showSelbst showUeber
    global wc showKoppelk xk_df yk_df showSchnabel
    global lges_p xRast yRast xGang yGang xSb ySb xUe yUe
    global al1ue al2ue al3ue al4ue
    global al1 al2 al3 al4 cl1 cl3
    global dateiNamePostfix showZsR showZweiSchlagHodograph

    if {"$dateiNamePostfix" == "z"} then {
	set state normal
    } else {
	set state disabled
    }

    .mbar.grafik.menu delete 9 27

    .mbar.grafik.menu add command -label "Hodogramm-Mastab" \
    -command {TSetHodoMass} -state $state
    .mbar.grafik.menu add separator
    .mbar.grafik.menu add checkbutton -label "Rastpolkurve zeigen" \
    -variable showRast -command {
	if {$showRast == 0} then {
	    $wc delete rast
	} else {
	    VBereRastpolKurve
	    VShowRastpolkurve xRast yRast rast cyan blue
	}
    }
    .mbar.grafik.menu add checkbutton -label \
    "Selbstberuehrungskurve zeigen - nach separater Berechnung" \
    -variable showSelbst -command {
	if {$showSelbst == 1 && [expr abs($al1-$al1ue)] < 0.1 \
	&& [expr abs($al2-$al2ue)] < 0.1 && [expr abs($al3-$al3ue)] < 0.1 \
	&& [expr abs($al4-$al4ue)] < 0.1} then {
	    VShowRastpolkurve xSb ySb selbst green green
	} else {
	    $wc delete selbst
	}
    }

    .mbar.grafik.menu add checkbutton -label \
    "Koppelpunktbahn zeigen"  -variable showKoppelk -command {
	if {$showKoppelk == 0} then {
	    $wc delete Koppelk
	} else {
	    if {$lges_p != 11} then {
		VShowRastpolkurve xk_df yk_df Koppelk blue blue
                            #vortrag VShowRastpolkurve xk_df yk_df Koppelk blue blue
		VShowZweischlagHodograph
	    }
	}
    }

    .mbar.grafik.menu add checkbutton -label "Gangpolkurve zeigen" \
    -variable showGang -command {
	if {$showGang == 0} then {
	    $wc delete gang
	} else {
	    VBereRastpolKurve
	   VShowGangpolkurve xGang yGang gang orange orange3 line 0
                 #vortrag VShowGangpolkurve xGang yGang gang green3 darkgreen line 0
	}
    }

    .mbar.grafik.menu add checkbutton -label \
    "Uebergangskurve zeigen - nach separater Berechnung"  -variable showUeber -command {
	 if {$showUeber == 1 && [expr abs($al1-$al1ue)] < 0.1 \
	 && [expr abs($al2-$al2ue)] < 0.1 && [expr abs($al3-$al3ue)] < 0.1 \
	 && [expr abs($al4-$al4ue)] < 0.1} then {
	     VShowGangpolkurve xUe yUe ueber mediumvioletred mediumvioletred line 0
	 } else {
	     $wc delete ueber
	 }
    }
    if {($cl1 == "is" || $cl1 == "as") && ($cl3 == "is" || $cl3 == "as")} then {
	set stateKue "normal"
    } else {
	set stateKue "disabled"
    }
    .mbar.grafik.menu add command -label \
    "Uebergangskurve spiegeln" -state $stateKue -command {
	 if {$showUeber == 1 && [expr abs($al1-$al1ue)] < 0.1 \
	 && [expr abs($al2-$al2ue)] < 0.1 && [expr abs($al3-$al3ue)] < 0.1 \
	 && [expr abs($al4-$al4ue)] < 0.1} then {
	     VmirrorKue
	     VShowGangpolkurve xUe yUe ueber mediumvioletred mediumvioletred line 0
	 } else {
	     $wc delete ueber
	 }
    }
    .mbar.grafik.menu add checkbutton -label \
    "koppelfeste Schwingwinkel-Begrenzungsgeraden zeigen"  \
     -variable showKSwBg -command {
	VShowSchwingwinkel
    }
    .mbar.grafik.menu add checkbutton -label \
    "Feld der Schwingwinkel-Begrenzungsgeraden einfaerben"  \
     -variable showFeld -command {
	VShowSchwingwinkel
    }
    .mbar.grafik.menu add checkbutton -label \
    "Schnabelspitzen-Erzeugungspunkte zeigen und Berechnung" \
    -state normal -variable showSchnabel -command {
	if {$showSchnabel == 1} then {
	    phi_schnabelspitze
	    show_schnabelspitze
	} else {
	    $wc delete schnabel
	}
    }
    .mbar.grafik.menu add checkbutton -label "Getriebe dynamisch modifizieren" \
    -variable showPunktMove

    .mbar.grafik.menu add separator
    .mbar.grafik.menu add checkbutton -label "Zweischlag-Grenzkreise um gestellfestes Zweischlaggelenk zeigen" \
    -state $state -variable showZsR -command {VModifyGetr all}
    .mbar.grafik.menu add checkbutton -label "Thaleskreis ueber Gestell zeigen" \
    -variable showThales -command {VModifyGetr all}
    .mbar.grafik.menu add checkbutton -label "Hodogramm der Geschw. des mittleren Zweischlag-Gelenks zeigen" \
    -state $state -variable showZweiSchlagHodograph -command {
	VKoppelpunktBahn
	VModifyGetr all
    }
    .mbar.grafik.menu add checkbutton -label "Winkeldifferenz anstatt Geschw. des mittleren Zweischlag-Gelenks verwenden" \
    -state $state -variable showZweischlagWinkelDifferenz -command {
       VKoppelpunktBahn
       VModifyGetr all
     }
    .mbar.grafik.menu add separator
    .mbar.grafik.menu add command -label "Getriebe starten" \
    -command {TRunGetriebe 2 1 1}
    .mbar.grafik.menu add command -label "Getriebe anhalten" \
    -command {TStopGetriebe}
}
#############################################################
proc VSetAnzahlLagen {} {

    global zweiLagen eineLage zweiLagenKoppel noMomentanPol
    global zweiSchlag

    puts "zweiLagen=$zweiLagen eineLage=$eineLage zweiLagenKoppel=$zweiLagenKoppel"
    puts "noMomentanPol=$noMomentanPol zweiSchlag=$zweiSchlag"

    if {($eineLage == 0) && ($noMomentanPol == 0)} then {
	if { $zweiSchlag == 1} then {
	    VLiesDatei "dromeg-z.dat"
	    set state disabled
	} else {
	    if {$zweiLagen == 1} then {
		VLiesDatei "dromeg-u.dat"
		set state normal
	    } else {
		VLiesDatei "dromeg-k.dat"
		set state disabled
	    }
	}
    } else {
	if {$noMomentanPol == 1} then {
	    VLiesDatei "dromeg-4.dat"
	    set state disabled
	} else {
	    VLiesDatei "dromeg-6.dat"
	    set state disabled
	}
    }
#    .mbar.analyse.menu delete 11 12
#    .mbar.analyse.menu add command -label \
#	"Uebergangskurvenpunkt ermitteln" -state $state \
#	-command {VSelbstberuehrungspunkt}
#    .mbar.analyse.menu add command -label \
#	"Uebergangskurve ermitteln" -state $state -command {
#	VSelbstberuehrungskurve}
}
#############################################################
proc T_Grafik_special {} {
#    xyViewDefault
}
#############################################################
proc TSetZoomFenster_special {} {
    VModifyGetr all
}
#############################################################
proc VLiesDatei {name} {
global DateiName p lges_p wcf
global wc xregion_ yregion_ canvas_width canvas_height
global xMoveto yMoveto 0x 0y xzoom yzoom massstab alkx alky
global xMax xMin yMax yMin massstab al1 al2 al3 al4 phi1 phi2 kbf
global alz1 alz2 alzx alzy dateiNamePostfix
global showZsR kbz

set old_0x $0x
set old_0y $0y
set old_xMoveto $xMoveto
set old_yMoveto $yMoveto
if {[info exists xzoom] == 1} then {
    set old_xzoom $xzoom
    set old_yzoom $yzoom
}
set old_massstab $massstab
set old_al1 $al1
set old_al2 $al2
set old_al3 $al3
set old_al4 $al4
set old_phi1 $phi1
set old_kbf(1) $kbf(1)
if {$lges_p == 11} then {
    if {[info exists phi2] == 1} then {set old_phi2 $phi2}
} elseif {$lges_p == 12} then {
    if {[info exists phi2] == 1} then {set old_phi2 $phi2}
    set old_alkx $alkx
    set old_alky $alky
} else {
    set old_alkx $alkx
    set old_alky $alky
}
if { "$dateiNamePostfix" == "z"} then {
# viergliedriges Gelenkgetriebe mit Zweischlag
    set old_alz1 $alz1
    set old_alz2 $alz2
    set old_alzx $alzx
    set old_alzy $alzy
    set old_kbz $kbz
}

set DateiName $name
set dateiNamePostfix [string range $name 7 7]
if {[info exists p] == 1} then {
    unset p
}
#if {"$dateiNamePostfix" == "z"} then {
#    set showZsR 1
#}
menuGrafik2
T_Grafik
#puts "$DateiName"
VLiesPreSam $DateiName
VNormalizeGetr
#   VSetMassstab lges_p

    set 0x $old_0x
    set 0y $old_0y
    set xMoveto $old_xMoveto
    set yMoveto $old_yMoveto
    if {[info exists old_xzoom] == 1} then {
	set xzoom $old_xzoom
	set yzoom $old_yzoom
    }
    set massstab $old_massstab

    VShowGetr
#   xyViewDefault

    set wcf 0

    set al1 $old_al1
    set al2 $old_al2
    set al3 $old_al3
    set al4 $old_al4
    set phi1 $old_phi1
    set kbf(1) $old_kbf(1)
    if {$lges_p == 11} then {
	if {[info exists old_phi2] == 1} then {set phi2 $old_phi2}
    } elseif {$lges_p == 12} then {
	if {[info exists old_phi2] == 1} then {set phi2 $old_phi2}
	if {[info exists old_alkx] == 1} then {
	    set alkx $old_alkx
	    set alky $old_alky
	}
    } else {
	if {[info exists old_alkx] == 1} then {
	    set alkx $old_alkx
	    set alky $old_alky
	}
    }
    if { "$dateiNamePostfix" == "z"} then {
# viergliedriges Gelenkgetriebe mit Zweischlag
	if {[info exists old_alz1] == 1} then {
	    set alz1 $old_alz1
	    set alz2 $old_alz2
	    set alzx $old_alzx
	    set alzy $old_alzy
	    set kbz $old_kbz
	}
    }

    VChangeGetrLaengen
    VStatus
    VBind

#   set i 0
#   while {$i < $lges_p} {
#	incr i
#	set stift [string range $p($i,15) 0 0]
#	if {$stift == 1} then {
#	    $wc itemconfigure $i -fill brown
#	}
#   }
    faerbePunkte


    $wc xview moveto $xMoveto
    $wc yview moveto $yMoveto
}
#############################################################
proc VDateiOeffnen {} {
    global DateiName DateiName_old p lges_p

    set DateiName_old $DateiName

    TCreateEntryButton " " {unset p
	T_Grafik
	VLiesPreSam $DateiName
	VNormalizeGetr
	VSetMassstab lges_p
	VShowGetr
	VChangeGetrLaengen
	VStatus
	VBind
	xyViewDefault} {set DateiName $DateiName_old} 14 \
	{"Dateiname:" DateiName}
    TShowSubwindow  {100} {40} {Datei oeffnen}
}
#############################################################
proc TSetHodoMass {} {

    global zwSHmasstab zwSHmasstab_old

    set zwSHmasstab_old $zwSHmasstab

    TCreateEntryButton " " {VShowZweischlagHodograph} {set zwSHmasstab $zwSHmasstab_old}\
	6 \
	{"Hodogramm-Mastab:" zwSHmasstab}
    TShowSubwindow  {100} {40} {Hodogramm-Mastab}
}
#############################################################
proc TSetSchritte {} {

    global dphi dphi_old dphi_df dphi_df_old lges_p maus1 maus2 maus3
    global wc Pi

    set dphi_old $dphi
    set dphi_df_old $dphi_df

    TCreateEntryButton " " {VUebertragungsfunktion
	VBereRastpolKurve
	if {$lges_p != 11} then {
	    VKoppelpunktBahn
	}
	VModifyGetr all} {set dphi_df $dphi_df_old
	set dphi $dphi_old} 6 \
	{"Bewegung: Schrittweite in Grad (Minimum 1 Grad):" dphi} \
	{"Darstellung: Schrittweite in Grad (Minimum 1 Grad):" dphi_df} \
              {"Summand linke Maustaste bei   > oder <-Knopf:" maus1} \
              {"Summand mittler Maustaste bei > oder <-Knopf:" maus2} \
              {"Summand rechte Maustaste bei > oder <-Knopf:" maus3}
    TShowSubwindow  {100} {40} {Schritte je Stegumdrehung}
}
#############################################################
proc VSelbstberuehrungspunkt {} {
    global maxIfeman maxIfeman_old minWfeman minWfeman_old
    global vSelbstberuehrung
    global ShowFemanFortschritt ShowFemanFortschritt_old
    global zweiLagen eineLage zweiSchlag zweiLagenKoppel noMomentanPol showZsR 

     if {$zweiLagen == 0} then {
        set zweiLagen 1
        set eineLage 0
        set zweiSchlag 0
        set zweiLagenKoppel 0
        set noMomentanPol 0
        set showZsR 0
        VSetAnzahlLagen
        tk_messageBox -type ok -message "Waehlen Sie fr Phi1 und Phi2 sinnvolle Ausgangsparameter (so da das weie und das schwarze Glied nahezu den gleichen Winkel aufweisen."
    }
    
    set maxIfeman_old $maxIfeman
    set minWfeman_old $minWfeman
    set ShowFemanFortschritt_old $ShowFemanFortschritt
    set vSelbstberuehrung yes

    set ShowFemanFortschritt \
	[string toupper $ShowFemanFortschritt]
    if {[string range $ShowFemanFortschritt 0 0] == "J" ||
    [string range $ShowFemanFortschritt 0 0] == "Y"} then {
	set ShowFemanFortschritt Ja
	set minWfeman .1
    }

    TCreateEntryButton " " \
	{set ShowFemanFortschritt \
	    [string toupper $ShowFemanFortschritt]
	if {[string range $ShowFemanFortschritt 0 0] == "J" ||
	[string range $ShowFemanFortschritt 0 0] == "Y"} then {
	    set ShowFemanFortschritt Ja
	    set minWfeman .1
	}
	VStarteGetriebeIni
	set vSelbstberuehrung no} \
	{set maxIfeman $maxIfeman_old
	 set minWfeman $minWfeman_old
	 set ShowFemanFortschritt $ShowFemanFortschritt_old
	 set vSelbstberuehrung no} 6 \
	{"Maximale Anzahl Iterationsschritte:" maxIfeman} \
	{"Kleinster Winkel je Iterationsschritt in Grad:" minWfeman} \
	{"Zwischenschritte optisch Darstellen" ShowFemanFortschritt}

    TShowSubwindow  {100} {40} {Selbstberuehrungspunkt}
}
#############################################################
proc VSelbstberuehrungskurve {} {
    global maxIfeman maxIfeman_old minWfeman minWfeman_old
    global vSelbstberuehrungskurve dphi dphi_old wend_anz
    global wend_anz_old showSelbst showUeber
    global ShowFemanFortschritt noWarnung noWarnung_old
    global DrehRichTung DrehRichTung_old eps180 eps180_old
    global KueUberschreiben KueUberschreiben_old
    global zweiLagen eineLage zweiSchlag zweiLagenKoppel noMomentanPol showZsR 


    if {$zweiLagen == 0} then {
        set zweiLagen 1
        set eineLage 0
        set zweiSchlag 0
        set zweiLagenKoppel 0
        set noMomentanPol 0
        set showZsR 0
        VSetAnzahlLagen
        tk_messageBox -type ok -message "Waehlen Sie fr Phi1 und Phi2 sinnvolle Ausgangsparameter (so da das weie und das schwarze Glied nahezu den gleichen Winkel aufweisen."
    }

    set maxIfeman_old $maxIfeman
    set minWfeman_old $minWfeman
    set dphi_old $dphi
    set wend_anz_old $wend_anz
    set DrehRichTung_old $DrehRichTung
    set eps180_old $eps180
    set KueUberschreiben_old $KueUberschreiben
    set noWarnung_old $noWarnung

    set vSelbstberuehrungskurve yes
    set minWfeman 1.
    set KueUberschreiben Ja
    set noWarnung Ja
    if {$showSelbst == 0 && $showUeber == 0} then {
	set showSelbst 1
    }

    TCreateEntryButton {HelpSelbstBeruehrungsKurve} \
	{set ShowFemanFortschritt Nein
	VStarteGetriebeLauf 1
	set vSelbstberuehrungskurve no
	set KueUberschreiben $KueUberschreiben_old
	set noWarnung $noWarnung_old} \
	{set maxIfeman $maxIfeman_old
	 set minWfeman $minWfeman_old
	 set dphi $dphi_old
	 set eps180 $eps180_old
	 set KueUberschreiben $KueUberschreiben_old
	 set noWarnung $noWarnung_old
	 set wend_anz $wend_anz_old
	 set DrehRichTung $DrehRichTung_old
	 set vSelbstberuehrungskurve no} 6 \
	{"Schrittweite je Iterationsschritt von Phi1 in Grad:" dphi} \
	{"Drehrichtung fuer Phi1:" DrehRichTung} \
	{"Mindestabstand von Gestell-Lage in Grad" eps180} \
	{"Anzahl Iterationsschritte:" wend_anz} \
	{"Warnungen unterdruecken:" noWarnung} \
	{"Fuer Numeric: Maximale Anzahl Iterationsschritte:" maxIfeman}\
	{"Fuer Numeric: Kleinster Winkel je Iterationsschritt in Grad:" minWfeman}\
	{"Alte Uebergangskurve ueberschreiben" KueUberschreiben}

    TShowSubwindow  {100} {40} {Selbstberuehrungskurve}
}
#############################################################
# Hilfe beim Bestimmen der Uebergangskurve
proc HelpSelbstBeruehrungsKurve  {} {

    global cl1 cl3 zusat

    if {$zusat == "(umlauffaehig)" && $cl1 == " u" && $cl3 == " u"} \
    then {
# Hilfe bei Doppelkurbeln
	ThelpHelp dro-sbd4.hlp 300 200
    } elseif {$zusat == "(umlauffaehig)" && $cl1 == " u" && $cl3 == " s"}\
    then {
# Hilfe bei Kurbelschwinge
	ThelpHelp dro-sbk4.hlp 300 200
    } elseif {$zusat == "(umlauffaehig)" && $cl1 == " s" && $cl3 == " u"}\
    then {
# Hilfe bei Kurbelschwinge (Glied 1 schwingend)
	ThelpHelp dro-sbl4.hlp 300 200
    } elseif {$zusat == "(totalschwingfaehig)" && $cl1 == "is" && $cl3 == "is"}\
    then {
# Hilfe bei totalschwingfaehiger Doppelinnenschwinge
	ThelpHelp dro-sbi4.hlp 300 200
    } else {
# allgemeine Hilfe
	ThelpHelp dro-sba4.hlp 300 200
    }
}
#############################################################
proc TRunGetriebe {nr DrehRichtung geschw {delta 0} {filenamePrefix ""}} {
    global statuszeile runGetriebe p phi1 phi2 dphi lges_p cl1
    global dpmax dpmin cl1 kjk_ kbf mGetr pfeilButtonPress fixGelenkAThaleskreis
    global wc

    if {$runGetriebe == 1} then {
	return
    }
    if {$pfeilButtonPress != 0} then {
	return
    }
    set pfeilButtonPress 1

    set fixGelenkAThaleskreis 0

    if {[string range $cl1 1 1] == "u"} then {
	set dpmaxeps $dpmax
#	set dpmineps $dpmin
	set dpmineps 0
    } else {
	set dpmaxeps [expr $dpmax-0.01*$dphi]
	set dpmineps [expr $dpmin+0.01*$dphi]
    }

    set kjk_ 1

    set runGetriebe 1
    if {$lges_p >= 11 && $nr == 2} then {
	set phix $phi2
	set kb_alt $kbf(2)
    } else {
	set phix $phi1
	set kb_alt $kbf(1)
    }
    set kb_neu $kb_alt
    set phix2(2) $phix

    set i 0
    while {$runGetriebe == 1} {
	incr i
	if {$geschw > 0} then {
	    set phix [expr $phix+$DrehRichtung*$dphi*$geschw*$geschw]
        } else {
            set phix [expr $phix+$DrehRichtung*$delta]
        }
	if {$DrehRichtung > 0} then {
	    if {$dpmaxeps < $phix} then {
		if {[string range $cl1 1 1] == "u"} then {
		    set phix $dpmineps
		} else {
		    set phix $dpmaxeps
		    set DrehRichtung [expr -1*$DrehRichtung]
		    set kb_alt [expr -1*$kb_alt]
		}
	    }
	} else {
	    if {$dpmineps > $phix} then {
		if {[string range $cl1 1 1] == "u"} then {
		    set phix $dpmaxeps
		} else {
		    if {$cl1 == "2u"} then {
			set diffWin 720
		    } else {
			set diffWin 360
		    }
		    set phix [expr $phix + $diffWin]
		    if {$dpmineps > $phix || $dpmaxeps < $phix} then {
			set phix $dpmineps
			set DrehRichtung [expr -1*$DrehRichtung]
			set kb_alt [expr -1*$kb_alt]
		    }
		}
	    }
	}
	set phix2(1) $phix2(2)
	set phix2(2) $phix
	if {$mGetr != 1 || $cl1 == " s"} then {
	    if {$i > 1} then {set kb_neu [kbvphi_1 2 phix2 $kb_alt kjk_]}
	}
	if {$lges_p >= 11 && $nr == 2} then {
	    set phi2 $phix
	    set kbf(2) $kb_neu
	} else {
	    set phi1 $phix
	    set kbf(1) $kb_neu
	}
	set kb_alt $kb_neu

	VChangeGetrLaengen
	if {$delta > 0} then {
	    if {[info exist alpha] == 0} then {
	        set alpha 0
	        
	        if {$cl1 == "2u"} then {
	            set alphaMax 720
                } else {
	            set alphaMax 360
		}
            }
            set alphaG [expr int($alpha)]
            set null "0"
            if {$alpha < 10} then {
                $wc postscript -file "$filenamePrefix$null$null$null$alphaG.eps"
            } elseif {$alpha < 100} then {
                $wc postscript -file "$filenamePrefix$null$null$alphaG.eps"
            } elseif {$alpha < $alphaMax} then {
                $wc postscript -file "$filenamePrefix$null$alphaG.eps"
            } else {
                set runGetriebe 0
            }

            set alpha [expr $alpha + $delta]
	}
	if {$pfeilButtonPress != 1} then {
	    set runGetriebe 0
	}
    }
    set pfeilButtonPress 0
}
#############################################################
proc TStopGetriebe {} {
    global runGetriebe iauto autoUeBere runKue

    set autoUeBere 0
    set runGetriebe 0
    set iauto 0
    set runKue 0
}
#############################################################
proc VStarteGetriebeLauf {neu {dphi2 0} } {
    global vSelbstberuehrungskurve wend_anz dphi phi1
    global DrehRichTung
    global ShowFemanFortschritt

    if {$vSelbstberuehrungskurve == "yes"} then {
	set ShowFemanFortschritt_old $ShowFemanFortschritt
	set ShowFemanFortschritt Ja
	set ierr [VGetriebeInitialisieren $neu]
	set ShowFemanFortschritt $ShowFemanFortschritt_old

	if {$ierr == 0} then {
###?##	    wm withdraw .toplevelpara
	    VFrameWait

	    set wend [expr $phi1+$wend_anz*$dphi*$DrehRichTung]
	    VGetriebeStep [expr $dphi*$DrehRichTung] $wend $neu $dphi2
	}
    }
}
#############################################################
proc VStarteGetriebeIni {} {
    global vSelbstberuehrung

    if {$vSelbstberuehrung == "yes"} then {
	VGetriebeInitialisieren 1
    }
}
#############################################################
proc TCreateGestellGelenk {x y {dxfFile "no"}} {
    global pradi_ wc

    dxfLinie $wc $dxfFile Gestell brown [expr $x-$pradi_/2.] [expr $y+$pradi_] [expr $x-$pradi_*1.5] [expr $y+$pradi_*3] Gestell
    dxfLinie $wc $dxfFile Gestell brown [expr $x-$pradi_*2.5] [expr $y+$pradi_*3] [expr $x+$pradi_*2.5] [expr $y+$pradi_*3] Gestell
    dxfLinie $wc $dxfFile Gestell brown [expr $x+$pradi_*1.5] [expr $y+$pradi_*3] [expr $x+$pradi_/2.] [expr $y+$pradi_] Gestell
    dxfLinie $wc $dxfFile Gestell brown [expr $x-$pradi_*0.75] [expr $y+$pradi_*3] [expr $x-$pradi_*2.25] [expr $y+$pradi_*4.5] Gestell
    dxfLinie $wc $dxfFile Gestell brown [expr $x+$pradi_*0.25] [expr $y+$pradi_*3] [expr $x-$pradi_*1.25] [expr $y+$pradi_*4.5] Gestell
    dxfLinie $wc $dxfFile Gestell brown [expr $x+$pradi_*1.25] [expr $y+$pradi_*3] [expr $x-$pradi_*0.25] [expr $y+$pradi_*4.5] Gestell
    if {$dxfFile == "no"} then {
        $wc addtag "Knoten" withtag Gestell
    }
}
######################################################
proc xTrochoide {rG m phi a gamma0_} {
return [expr $rG*$m*cos($phi)+abs($a)*cos($m*$phi+$gamma0_)]
}
######################################################
proc yTrochoide {rG m phi a gamma0_} {
return [expr $rG*$m*sin($phi)+abs($a)*sin($m*$phi+$gamma0_)]
}
######################################################
proc VModifyGetr {what {dxfFile "no"}} {
    global wc p lges_p massstab wc showRast showGang xRast yRast
    global xGang yGang xSb ySb xUe yUe lges_u showSelbst showUeber
    global showKoppelk xk_df yk_df fillGang
    global zusat cl1 cl3 lges_dieser_lauf
    global al1ue al2ue al3ue al4ue al1 al2 al3 al4

    if {$dxfFile == "no"} then {
        set nr 0
        while {$nr < $lges_p} {
    	incr nr
    	set x [expr $p($nr,1)*$massstab]
    	set y [expr $p($nr,2)*-$massstab]
    	VerschiebeKnoten $wc $nr \
    	[expr $x-[xLiesKnotenMittelpunkt $wc $nr] ] \
    	[expr $y-[yLiesKnotenMittelpunkt $wc $nr] ]
        }
        if {$what == "all"} then {
    	$wc delete Gestell
    	VCreateGestell
        }
    }
    if {$showRast == 1} then {
	VShowRastpolkurve xRast yRast rast cyan blue $dxfFile
    }
    if {[info exists lges_dieser_lauf] == 0} then {
	set fillGang 0
    } elseif {$zusat == "(umlauffaehig)" && $cl1 == " u" && $cl3 == " u" \
    && $lges_dieser_lauf >160 && $lges_dieser_lauf < 190} then {
	if {[expr abs($al1-$al1ue)] < 0.1 \
	&& [expr abs($al2-$al2ue)] < 0.1 && [expr abs($al3-$al3ue)] \
	< 0.1 && [expr abs($al4-$al4ue)] < 0.1} then {
	    set fillGang 1
	} else {
	    set fillGang 0
	}
    } else {
	set fillGang 0
    }
    if {[expr abs($al1-$al1ue)] < 0.1 \
    && [expr abs($al2-$al2ue)] < 0.1 && [expr abs($al3-$al3ue)] \
    < .1 && [expr abs($al4-$al4ue)] < 0.1} then {
	set ueberOK 1
    } else {
	set ueberOK 0
    }

#   if {$showUeber == 1 && $lges_u > 1 && [expr abs($al1-$al1ue)] < 0.1 }
    if {$dxfFile == "no"} then {
        $wc delete ueber
    }
    if {$showUeber == 1 && $ueberOK == 1} then {
	 if {$fillGang == 0} then {
	     VShowGangpolkurve xUe yUe ueber mediumvioletred mediumvioletred line 0 $dxfFile
	 } else {
	     VShowGangpolkurve xUe yUe ueber violet mediumvioletred line 1 $dxfFile
	     if {$dxfFile == "no"} then {
	         $wc lower ueber
	     }
	 }
#   } else {
#	$wc delete ueber
    }
    if {$showGang == 1} then {
	if {$fillGang == 0} then {
	    VShowGangpolkurve xGang yGang gang orange orange3 line 0 $dxfFile
                  #vortrag VShowGangpolkurve xGang yGang gang green3 darkgreen line 0
	} else {
	    VShowGangpolkurve xGang yGang gang orange orange3 line 1 $dxfFile
                  #vortrag VShowGangpolkurve xGang yGang gang green3 darkgreen line 1
            if {$dxfFile == "no"} then {
	        $wc lower gang
	    }
	}
    }
    $wc delete selbst
    if {$showSelbst == 1 && $ueberOK == 1} then {
	VShowRastpolkurve xSb ySb selbst green green $dxfFile
#   } else {
#	$wc delete selbst
    }
    if {$showKoppelk == 1} then {
	if {$lges_p != 11} then {
                  #vortra VShowRastpolkurve xk_df yk_df Koppelk yellow yellow
	    VShowRastpolkurve xk_df yk_df Koppelk blue blue $dxfFile
	    VShowZweischlagHodograph
	}
    } else {
        if {$dxfFile == "no"} then {
	    $wc delete Koppelk
	}
    }

    if {$dxfFile == "no"} then {
        VShowKoppeldreieck $dxfFile
    }
    VShowThales $dxfFile
    VShowZweischlagRadi $dxfFile
    VShowSchwingwinkel $dxfFile
    # Aufruf des procs VKoppelpunktBahn zugefgt, weil Modifikation des Hodogramms
    # nicht funktioniert (11.9.2002)
    VKoppelpunktBahn

    VFrameWait
}
##################################################################
proc VShowThales {{dxfFile "no"}} {

    global wc massstab
    global  KnotenX KnotenY showThales al4 fixGelenkAThaleskreis

    $wc delete ThalesKreis

    if {"$showThales" == 1} then {
	set pradi [expr $al4/2/1000.*$massstab]
	#set Zweischlagradi [$wc create oval 0. -$pradi [expr $pradi*2] $pradi \
	#	       -outline darkgreen -tags ThalesKreis]
        set tag "ThalesKreis"
        set Zweischlagradi [dxfKreis $wc $dxfFile "-" darkgreen 0. -$pradi [expr $pradi*2] $pradi $tag]
	if {$dxfFile == "no"} then {
            $wc lower ThalesKreis
    	    $wc bind ThalesKreis <Any-Enter> {
    	        $wc itemconfigure ThalesKreis -width 2
    	        set statuszeile "'linke Maustaste': 'Gelenk A auf Thaleskreis legen', \
                    reche Maustaste:  'Gelenk B auf Thaleskreis legen'"
    	    }
    	    $wc bind ThalesKreis <Any-Leave> {
    	        $wc itemconfigure ThalesKreis -width 1
    	        set statuszeile " "
    	    }
    	    $wc bind ThalesKreis <ButtonPress-1> {
    	        set fixGelenkAThaleskreis 1
    	        berechneAaufThaleskreis A
    	        VChangeGetrLaengen
    	    }
    	    $wc bind ThalesKreis <ButtonPress-3> {
    	        set fixGelenkAThaleskreis 1
    	        berechneAaufThaleskreis B
    	        VChangeGetrLaengen
    	    }
	}
    }
}
##################################################################
proc VShowZweischlagRadi {{dxfFile "no"}} {

    global wc dateiNamePostfix alz1 alz2 massstab
    global  KnotenX KnotenY showZsR

    if {$dxfFile == "no"} then {
        $wc delete ZsRm alz1 alz2
        $wc delete ZsRp alz1 alz2
    }

    if {"$dateiNamePostfix" != "z"} then {
	return
    }

    if {$showZsR == 1} then {
#Radius im Gelenk 5
	set nr 5
	set pradi [expr ($alz1+$alz2)/1000.*$massstab]
	#set Zweischlagradi [$wc create oval [expr $KnotenX($nr)-$pradi] \
        #	       [expr $KnotenY($nr)-$pradi] \
	#	       [expr $KnotenX($nr)+$pradi] [expr $KnotenY($nr)+$pradi] \
	#	       -outline blue -fill lightblue -tags ZsRp]
        set tag "ZsRp"
        set Zweischlagradi [dxfKreis $wc $dxfFile "-" blue [expr $KnotenX($nr)-$pradi] [expr $KnotenY($nr)-$pradi] \
		       [expr $KnotenX($nr)+$pradi] [expr $KnotenY($nr)+$pradi] $tag lightblue]
	set pradi [expr abs($alz1-$alz2)/1000.*$massstab]
	set tag "ZsRp"
	#set Zweischlagradi [$wc create oval [expr $KnotenX($nr)-$pradi] \
	#	       [expr $KnotenY($nr)-$pradi] \
	#	       [expr $KnotenX($nr)+$pradi] [expr $KnotenY($nr)+$pradi] \
	#	       -outline blue -fill lightgrey -tags ZsRm]
        set Zweischlagradi [dxfKreis $wc $dxfFile "-" blue [expr $KnotenX($nr)-$pradi] [expr $KnotenY($nr)-$pradi] \
		       [expr $KnotenX($nr)+$pradi] [expr $KnotenY($nr)+$pradi] $tag lightgrey]
        if {$dxfFile == "no"} then {
        	$wc lower ZsRm
        	$wc lower ZsRp
        	$wc lower kBgA
        	$wc lower kBgB
        	$wc lower kBg
        }
    }
}
###################################################################
proc VShowSchwingwinkel {{dxfFile "no"}} {

    global wc showKSwBg xkSwBgA ykSwBgA xkSwBgB ykSwBgB
    global xkSwBg ykSwBg showFeld

    if {$dxfFile == "no"} then {
        $wc delete kBgA
        $wc delete kBgB
        $wc delete kBg
    }

    if {$showKSwBg == 1 || $showFeld == 1} then {
	if {$xkSwBg(0,0) == 0 && $showFeld == 1} then {
	    VShowGangpolkurve xkSwBgA ykSwBgA kBgA white white polygon 0
	    if {$dxfFile == "no"} then {
	        $wc itemconfigure kBgA -fill gray70
                  #vortrag $wc itemconfigure kBgA -fill white
	        $wc lower kBgA
	    }
	} elseif {$showKSwBg == 1} then {
	    VShowGangpolkurve xkSwBgA ykSwBgA kBgA white white line 0
	}
	if {$xkSwBg(0,0) == 0 && $showFeld == 1} then {
	    VShowGangpolkurve xkSwBgB ykSwBgB kBgB white white polygon 0
	    if {$dxfFile == "no"} then {
	        $wc itemconfigure kBgB -fill gray70
                  #vortrag $wc itemconfigure kBgB -fill white
	        $wc lower kBgB
	    }
	} elseif {$showKSwBg == 1} then {
	    VShowGangpolkurve xkSwBgB ykSwBgB kBgB black black line 0
	}
	if {$xkSwBg(0,0) != 0 && $showFeld == 1} then {
	    VShowGangpolkurve xkSwBg ykSwBg kBg gray70 #aaa polygon 0
                  #vortrag VShowGangpolkurve xkSwBg ykSwBg kBg white white polygon 0
	    if {$dxfFile == "no"} then {
                $wc itemconfigure kBg -fill gray70
                  #vortrag $wc itemconfigure kBg -fill white
	        $wc lower kBgA
	        $wc lower kBgB
	        $wc lower kBg
	    }
	}
    } else {
        if {$dxfFile == "no"} then {
	    $wc delete kBgB
	    $wc delete kBgA
	    $wc delete kBg
	}
    }
}
##################################################################
proc VShowKoppeldreieck {{dxfFile "no"}} {
    global lges_p p wc massstab

    if {$lges_p != 11} then {
        if {$dxfFile == "no"} then {
	    $wc delete koppeld
	}
	
	set layer "koppel"
	set rgb [dxfColorToRGB IndianRed]
	set tag koppeld

	set xy_koppel [expr $p(2,1)*$massstab]
        lappend xy_koppel [expr $p(2,2)*-1.*$massstab]
        
        lappend xy_koppel [expr $p(3,1)*$massstab]
        lappend xy_koppel [expr $p(3,2)*-1.*$massstab]
        
        lappend xy_koppel [expr $p(6,1)*$massstab]
        lappend xy_koppel [expr $p(6,2)*-1.*$massstab]

	#$wc create polygon $xy_koppel -tags koppeld -fill IndianRed -outline IndianRed
	dxfPolygon $wc $dxfFile $layer $tag $rgb $xy_koppel polygon $rgb

        if {$dxfFile == "no"} then {
            $wc lower koppeld
    	    $wc lower kBgA
    	    $wc lower kBgB
	}
    }
}
############################################################
proc VFrameWait {} {

    global framewait

    if {$framewait == 0} then {
	set framewait 1
	frame .wait
	pack .wait
	tkwait visibility .wait
	destroy .wait
	set framewait 0
    }
}
#############################################################
proc VCreateGestell {{dxfFile "no"}} {
    global p lges_p 
    global wc massstab

    set nr 0
    while {$nr < $lges_p} {
	incr nr
	set x [expr $p($nr,1)*$massstab]
	set y [expr $p($nr,2)*$massstab]
	if {([expr int($p($nr,3))]%4) == "3"} then {
	    TCreateGestellGelenk $x [expr -1.*$y] $dxfFile
	}
    }
}
#############################################################
proc befehlModifyPunktfarben {} {
    global  punktfarbe lges_p p

    #tk_messageBox -message gliedfarbe(1)=$gliedfarbe(1)
    
    set nr 0
    while {$nr < $lges_p} {
        incr nr
        set ist [string range $p($nr,15) 0 0]
        set ili [string range $p($nr,15) 1 1]
	switch $punktfarbe($nr) {
		black {set ili 1}
		red {set ili 2}
		yellow {set ili 3}
		green {set ili 4}
		cyan {set ili 5}
		magenta {set ili 6}
		blue {set ili 7}
		darkgrey {set ili 8}
		grey {set ili 8}
		brown {set ili 9}
	}
	set p($nr,15) "$ist$ili"
    }
    #tk_messageBox -message "befehlModifyGliedfarben ie(1,10)=$ie(1,10)"
    RepaintGetr "no"
}
#######################################################################
proc abbruchModifyPunktfarben {} {
    # do nothing
}
############################################################
proc modifyPunktfarben {} {
    global p lges_p punktfarbe

    set dxfFile "no"
    set klaAuf "{"
    set klaZu "}"

    # Gliedfarben anzeigen mit nderungsdialog

    set frage "TCreateEntryButton { } befehlModifyPunktfarben abbruchModifyPunktfarben 10"
    #set frage "TCreateEntryButton { } \"RepaintGetr $dxfFile\" abbruchModifyGliedfarben 10"

    set nr 0
    while {$nr < $lges_p} {
	incr nr
	set ili [string range $p($nr,15) 1 1]
        switch $ili {
	    1 {set punktfarbe($nr) black}
	    2 {set punktfarbe($nr) red}
	    3 {set punktfarbe($nr) yellow}
	    4 {set punktfarbe($nr) green}
	    5 {set punktfarbe($nr) cyan}
	    6 {set punktfarbe($nr) magenta}
	    7 {set punktfarbe($nr) blue}
	    8 {set punktfarbe($nr) darkgrey}
	    9 {set punktfarbe($nr) brown}
	}
        append frage " $klaAuf\"Farbe von Punkt($nr):\" punktfarbe($nr)$klaZu"
    }

    eval $frage
}
#############################################################
proc befehlModifyGliedfarben {} {
    global  gliedfarbe lges_e ie

    #tk_messageBox -message gliedfarbe(1)=$gliedfarbe(1)

    set nr 0
    while {$nr < $lges_e} {
        incr nr
        set ist [string range $ie($nr,10) 0 0]
        set ili [string range $ie($nr,10) 1 1]
	switch $gliedfarbe($nr) {
		black {set ili 1}
		red {set ili 2}
		yellow {set ili 3}
		green {set ili 4}
		cyan {set ili 5}
		magenta {set ili 6}
		blue {set ili 7}
		darkgrey {set ili 8}
		grey {set ili 8}
		brown {set ili 9}
	}
	set ie($nr,10) "$ist$ili"
    }
    #tk_messageBox -message "befehlModifyGliedfarben ie(1,10)=$ie(1,10)"
    RepaintGetr "no"
}
#######################################################################
proc abbruchModifyGliedfarben {} {
    # do nothing
}
############################################################
proc modifyGliedfarben {} {
    global ie lges_e gliedfarbe

    set dxfFile "no"
    set klaAuf "{"
    set klaZu "}"

    # Gliedfarben anzeigen mit nderungsdialog

    set frage "TCreateEntryButton { } befehlModifyGliedfarben abbruchModifyGliedfarben 10"
    #set frage "TCreateEntryButton { } \"RepaintGetr $dxfFile\" abbruchModifyGliedfarben 10"

    set nr 0
    while {$nr < $lges_e} {
	incr nr
        append frage " $klaAuf\"Gliedfarbe von Glied($nr):\" gliedfarbe($nr)$klaZu"
    }

    eval $frage
}
##############################################################
proc VShowGetr {{dxfFile "no"} {radius 1.}} {
    global ie re lges_e
    global p lges_p gliedfarbe
    global wc massstab
    
    #tk_messageBox -message "VShowGetr ie(1,10)=$ie(1,10)"

    set nr 0
    while {$nr < $lges_p} {
	incr nr
	set x [expr $p($nr,1)*$massstab]
	set y [expr $p($nr,2)*$massstab]
	Knoten $wc $x [expr -1.*$y] K$nr $dxfFile $radius
        if {$dxfFile == "no"} then {
        	if {$p($nr,15) > 0} then {
# Punkt-Farbe aendern
        	    set ist [string range $p($nr,15) 0 0]
        	    set ili [string range $p($nr,15) 1 1]
        	    if {$ist == 1} then {
        		$wc itemconfigure $nr -width 2
        	    }
        	    switch $ili {
        		1 {$wc itemconfigure $nr -outline black}
        		2 {$wc itemconfigure $nr -outline red}
        		3 {$wc itemconfigure $nr -outline yellow}
        		4 {$wc itemconfigure $nr -outline green}
        		5 {$wc itemconfigure $nr -outline cyan}
        		6 {$wc itemconfigure $nr -outline magenta}
        		7 {$wc itemconfigure $nr -outline blue}
        		8 {$wc itemconfigure $nr -outline white}
        		9 {$wc itemconfigure $nr -outline brown}
        	    }
        	}
	}
    }
    VCreateGestell $dxfFile

    set nr 0
    while {$nr < $lges_e} {
	incr nr
	switch $ie($nr,1) {
	    1 -
	    2 -
	    10 -
	    11 {
		set tag "L$ie($nr,3)$ie($nr,5)"
		set k1 "$ie($nr,3)"
		set k2 "$ie($nr,5)"
		#tk_messageBox -message "$tag=$tag"
		set x1 [expr $p($k1,1)*$massstab]
	        set y1 [expr -1.*$p($k1,2)*$massstab]
	        set x2 [expr $p($k2,1)*$massstab]
	        set y2 [expr -1.*$p($k2,2)*$massstab]
		set tagKante [Kante $wc $k1 $k2 $nr $tag $dxfFile $x1 $y1 $x2 $y2]
		if {$dxfFile == "no"} then {
        		if {$ie($nr,10) > 0} then {
# Glied-Farbe aendern
        		    set ist [string range $ie($nr,10) 0 0]
        		    set ili [string range $ie($nr,10) 1 1]
        		    if {$ist == 1} then {
        			$wc itemconfigure $tagKante -width 2
        		    }
        		    switch $ili {
        			1 {set gliedfarbe($nr) black}
        			2 {set gliedfarbe($nr) red}
        			3 {set gliedfarbe($nr) yellow}
        			4 {set gliedfarbe($nr) green}
        			5 {set gliedfarbe($nr) cyan}
        			6 {set gliedfarbe($nr) magenta}
        			7 {set gliedfarbe($nr) blue}
        			8 {set gliedfarbe($nr) darkgrey}
        			9 {set gliedfarbe($nr) brown}
        		    }
        		    $wc itemconfigure $tagKante -fill $gliedfarbe($nr)
        		}
		}
	    }
	}
    }
}
###############################################################
proc VStatusGliedlaengen {w i item} {

	 global al1 al2 al3 al4 alz1 alz2

# Gliedlaengen
	frame $w.f.l$i
	pack $w.f.l$i -fill x -in $w.f -side top -anchor n
	label $w.f.l$i.l1 -text "L" -bd 0
	pack $w.f.l$i.l1 -in $w.f.l$i -side left -anchor n
	label $w.f.l$i.l2 -text $i -bd 0
	pack $w.f.l$i.l2 -in $w.f.l$i -side left -anchor s
	label $w.f.l$i.l3 -text "=" -bd 0
	pack $w.f.l$i.l3 -in $w.f.l$i -side left -anchor n

	label $w.f.l$i.b2 -text ">" -relief raised
	pack $w.f.l$i.b2 -in $w.f.l$i -side right

	if {$i == 1 || $i == 3} then {
	    set thales 1
	} else {
	    set thales 0
	}

	bind $w.f.l$i.b2 <ButtonPress-1> "PfeilButtonPress $i 0 1 1 $thales"
	bind $w.f.l$i.b2 <ButtonPress-2> "PfeilButtonPress $i 0 1 2 $thales"
	bind $w.f.l$i.b2 <ButtonPress-3> "PfeilButtonPress $i 0 1 3 $thales"

	bind $w.f.l$i.b2 <ButtonRelease-1> "PfeilButtonRelease $i 0"
	bind $w.f.l$i.b2 <ButtonRelease-2> "PfeilButtonRelease $i 0"
	bind $w.f.l$i.b2 <ButtonRelease-3> "PfeilButtonRelease $i 0"

	switch $i {
	    1 {entry $w.f.l$i.e4 -textvariable al1 -width 8}
	    2 {entry $w.f.l$i.e4 -textvariable al2 -width 8}
	    3 {entry $w.f.l$i.e4 -textvariable al3 -width 8}
	    4 {entry $w.f.l$i.e4 -textvariable al4 -width 8}
	    5 {entry $w.f.l$i.e4 -textvariable alz1 -width 8}
	    6 {entry $w.f.l$i.e4 -textvariable alz2 -width 8}
	}

	pack $w.f.l$i.e4 -in $w.f.l$i -side right

	label $w.f.l$i.b1 -text "<" -relief raised
	pack $w.f.l$i.b1 -in $w.f.l$i -side right
	bind $w.f.l$i.b1 <ButtonPress-1> "PfeilButtonPress $i 0 -1 1 $thales"
	bind $w.f.l$i.b1 <ButtonPress-2> "PfeilButtonPress $i 0 -1 2 $thales"
	bind $w.f.l$i.b1 <ButtonPress-3> "PfeilButtonPress $i 0 -1 3 $thales"
	bind $w.f.l$i.b1 <ButtonRelease-1> "PfeilButtonRelease $i 0"
	bind $w.f.l$i.b1 <ButtonRelease-2> "PfeilButtonRelease $i 0"
	bind $w.f.l$i.b1 <ButtonRelease-3> "PfeilButtonRelease $i 0"

	switch $i {
	    1 {bind $w.f.l$i.e4 <Return> {
		  set al1 [expr double($al1)]
		  berechneAaufThaleskreis
		  VKontrolGetrParameter
	       }
	    }
	    2 {bind $w.f.l$i.e4 <Return> {
		  set al2 [expr double($al2)]
		  VKontrolGetrParameter
	       }
	    }
	    3 {bind $w.f.l$i.e4 <Return> {
		  set al3 [expr double($al3)]
		  berechneAaufThaleskreis
		  VKontrolGetrParameter
	       }
	    }
	    4 {bind $w.f.l$i.e4 <Return> {
		  set al4 [expr double($al4)]
		  VKontrolGetrParameter
	       }
	    }
	    5 {bind $w.f.l$i.e4 <Return> {
		  set alz1 [expr double($alz1)]
		  VKontrolGetrParameter
	      }
	    }
	    6 {bind $w.f.l$i.e4 <Return> {
		  set alz2 [expr double($alz2)]
		  VKontrolGetrParameter
	      }
	    }
	}

	set j 0
	bind $w.f.l$i.e4 <Any-Enter> "ConfigureEnterLeave $i $j $item 1 0"
	bind $w.f.l$i.e4 <Any-Leave> "ConfigureEnterLeave $i $j $item -1 0"
	bind $w.f.l$i.b1 <Any-Enter> "ConfigureEnterLeave $i $j $item 1 1"
	bind $w.f.l$i.b1 <Any-Leave> "ConfigureEnterLeave $i $j $item -1 1"
	bind $w.f.l$i.b2 <Any-Enter> "ConfigureEnterLeave $i $j $item 1 1"
	bind $w.f.l$i.b2 <Any-Leave> "ConfigureEnterLeave $i $j $item -1 1"

}
#############################################################
proc VStatusKoppelPunkt {w j item} {

    global wc
    global alkx alky alzx alzy

    destroy $w.f.d$j
    frame $w.f.d$j
    pack $w.f.d$j -fill x -in $w.f -side top -anchor n
    if {$j == 1 || $j == 3} then {
	set text x
    } else {
	set text y
    }
    label $w.f.d$j.l1 -text $text -bd 0
    pack $w.f.d$j.l1 -in $w.f.d$j -side left -anchor n
    if {$j <= 2} then {
	set text 2
    } else {
	set text 0
    }
    label $w.f.d$j.l2 -text $text -bd 0
    pack $w.f.d$j.l2 -in $w.f.d$j -side left -anchor s
    label $w.f.d$j.l3 -text "=" -bd 0
    pack $w.f.d$j.l3 -in $w.f.d$j -side left -anchor n

    label $w.f.d$j.b2 -text ">" -relief raised
    pack $w.f.d$j.b2 -in $w.f.d$j -side right
    bind $w.f.d$j.b2 <ButtonPress-1> "PfeilButtonPress $j 1 1 1"
    bind $w.f.d$j.b2 <ButtonPress-2> "PfeilButtonPress $j 1 1 2"
    bind $w.f.d$j.b2 <ButtonPress-3> "PfeilButtonPress $j 1 1 3"
    bind $w.f.d$j.b2 <ButtonRelease-1> "PfeilButtonRelease $j"
    bind $w.f.d$j.b2 <ButtonRelease-2> "PfeilButtonRelease $j"
    bind $w.f.d$j.b2 <ButtonRelease-3> "PfeilButtonRelease $j"

    if {$j == 1} then {
	entry $w.f.d$j.e4 -textvariable alkx -bd 1 -width 8
    } elseif {$j == 2} then {
	entry $w.f.d$j.e4 -textvariable alky -bd 1 -width 8
    } elseif {$j == 3} then {
	entry $w.f.d$j.e4 -textvariable alzx -bd 1 -width 8
    } else {
	entry $w.f.d$j.e4 -textvariable alzy -bd 1 -width 8
    }
    pack $w.f.d$j.e4 -in $w.f.d$j -side right -anchor n

    label $w.f.d$j.b1 -text "<" -relief raised
    pack $w.f.d$j.b1 -in $w.f.d$j -side right
    bind $w.f.d$j.b1 <ButtonPress-1> "PfeilButtonPress $j 1 -1 1"
    bind $w.f.d$j.b1 <ButtonPress-2> "PfeilButtonPress $j 1 -1 2"
    bind $w.f.d$j.b1 <ButtonPress-3> "PfeilButtonPress $j 1 -1 3"
    bind $w.f.d$j.b1 <ButtonRelease-1> "PfeilButtonRelease $j"
    bind $w.f.d$j.b1 <ButtonRelease-2> "PfeilButtonRelease $j"
    bind $w.f.d$j.b1 <ButtonRelease-3> "PfeilButtonRelease $j"
    bind $w.f.d$j.b1 <Any-Enter> "ConfigureEnterLeave 8 8 $item 1 1"
    bind $w.f.d$j.b1 <Any-Leave> "ConfigureEnterLeave 8 8 $item -1 1"
    bind $w.f.d$j.b2 <Any-Enter> "ConfigureEnterLeave 8 8 $item 1 1"
    bind $w.f.d$j.b2 <Any-Leave> "ConfigureEnterLeave 8 8 $item -1 1"

    bind $w.f.d$j.e4 <Return> {VKontrolGetrParameter}

    bind $w.f.d$j.e4 <Any-Enter> \
	"$wc itemconfigure $item -fill black"
    bind $w.f.d$j.e4 <Any-Leave> \
	"$wc itemconfigure $item -fill white"

}
#############################################################
proc VStatusBewegungsbereich {w i item} {

    global mGetr cl1 kbf wc kbz

    frame $w.f.k$i
    if { $i <= 2 } then {
	set text1 "Lage Gelenk B(Phi"
	set text2 $i
	set text3 ")="
    } else {
	set text1 "Lage Gelenk D"
	set text2 " "
	set text3 "="
    }
    pack $w.f.k$i -fill x -in $w.f -side top -anchor n
    label $w.f.k$i.l1 -text $text1 -bd 0
    pack $w.f.k$i.l1 -in $w.f.k$i -side left -anchor n
    label $w.f.k$i.l2 -text $text2 -bd 0
    pack $w.f.k$i.l2 -in $w.f.k$i -side left -anchor s
    label $w.f.k$i.l3 -text $text3 -bd 0
    pack $w.f.k$i.l3 -in $w.f.k$i -side left -anchor n
    if {$i <= 2} then {
	label $w.f.k$i.l4 -textvariable kbf($i) -bd 1 -width 3
    } else {
	label $w.f.k$i.l4 -textvariable kbz -bd 1 -width 3
    }
    pack $w.f.k$i.l4 -in $w.f.k$i -side left -anchor n

    bind $w.f.k$i.l4 <Any-Enter> \
	"$wc itemconfigure $item -fill black"
    bind $w.f.k$i.l4 <Any-Leave> \
	"$wc itemconfigure $item -fill white"
    if {$mGetr == 1 && $i == 2 && $cl1 == " u"} then {
    } else {
	$w.f.k$i.l4 configure -relief raised
	bind $w.f.k$i.l4 <ButtonPress-1> "KbButtonPress $i"
	bind $w.f.k$i.l4 <ButtonRelease-1> \
	    "$w.f.k$i.l4 configure -relief raised"
    }
}
#############################################################
proc VSetGetriebeLaengen {al1neu al2neu al3neu al4neu phi1neu} {

    global al1 al2 al3 al4 phi1 lges_p
    global eineLage set zweiLagen zweiSchlag zweiLagenKoppel noMomentanPol showZsR

    set al1 $al1neu
    set al2 $al2neu
    set al3 $al3neu
    set al4 $al4neu
    set phi1 $phi1neu
    if {$lges_p > 6} then {
        set eineLage 1
        set zweiLagen 0
	set zweiSchlag 0
	set zweiLagenKoppel 0
	set noMomentanPol 0
	set showZsR 0
	VSetAnzahlLagen
    }
    VChangeGetrLaengen

    return
}
#############################################################
proc VStatus {} {
    global al1 al2 al3 al4 phi1 phi2 kb kbf alkx alky
    global cl1 cl3 getyp zusat lges_p mGetr
    global pfeilButtonPress ie dateiNamePostfix helptext1 helptext2 helptext3 helptext4
    global wc wcf
#   global wc ww

    set w .c.f
    set wcf $w

    destroy $w.f
    destroy $w.f.k1
    destroy $w.fc
    destroy $w.fh

    frame $w.f
    pack $w.f -fill x -in $w -side top -anchor ne

    frame $w.f.typ2
    pack $w.f.typ2 -fill x -in $w.f -side top -anchor ne
    label $w.f.typ2.l1 -textvariable getyp -bd 0 \
	-justify left
    pack $w.f.typ2.l1 -fill x -in $w.f.typ2 -side left -anchor ne
    frame $w.f.typ3
    pack $w.f.typ3 -fill x -in $w.f -side top -anchor n
    #label $w.f.typ3.l1 -textvariable zusat -bd 0

    menubutton $w.f.typ3.l1 -textvariable zusat -menu $w.f.typ3.l1.menu -relief raised
    menu $w.f.typ3.l1.menu
    #$w.f.typ3.l1.menu add radiobutton -variable aFaktor -value 1. -label "Differenz=1."
    $w.f.typ3.l1.menu add cascade -label "umlauffaehig" -menu $w.f.typ3.l1.menu.typU
    $w.f.typ3.l1.menu add cascade -label "totalschwingfaehig" -menu $w.f.typ3.l1.menu.typT
    $w.f.typ3.l1.menu add cascade -label "durchschlagfaehig" -menu $w.f.typ3.l1.menu.typD

    pack $w.f.typ3.l1 -in $w.f.typ3 -side left -anchor n

    menu  $w.f.typ3.l1.menu.typU
    $w.f.typ3.l1.menu.typU add command -label "u-s = Kurbelschwinge" -command {VSetGetriebeLaengen 120. 355. 275. 500. 145.}
    $w.f.typ3.l1.menu.typU add command -label "u-u = Doppelkurbel" -command {VSetGetriebeLaengen 250. 350. 305. 200. 145.}
    $w.f.typ3.l1.menu.typU add command -label "s-s = Doppelschwinge" -command {VSetGetriebeLaengen 250. 145. 300. 200. 85.}

    menu  $w.f.typ3.l1.menu.typT
    $w.f.typ3.l1.menu.typT add command -label "as-is = Aussen-Innenschwinge" -command {VSetGetriebeLaengen 155. 260. 315. 205. 145.}
    $w.f.typ3.l1.menu.typT add command -label "as-as = Doppelaussenschwinge" -command {VSetGetriebeLaengen 200. 350. 140. 285. 145.}
    $w.f.typ3.l1.menu.typT add command -label "is-as = Doppelinnenschwinge" -command {VSetGetriebeLaengen 250. 200. 100. 380. 60.}

    menu  $w.f.typ3.l1.menu.typD
    $w.f.typ3.l1.menu.typD add command -label "as-is = Aussen-Innenschwinge" -command {VSetGetriebeLaengen 160. 150. 300. 290. 145.}
    $w.f.typ3.l1.menu.typD add command -label "is-is = Doppelinnenschwinge" -command {VSetGetriebeLaengen 200. 75. 250. 375. 145.}
    $w.f.typ3.l1.menu.typD add command -label "2u-as = Kurbelaussenschwinge" -command {VSetGetriebeLaengen 150. 300. 250. 200. 145.}
    $w.f.typ3.l1.menu.typD add command -label "2u-is = Kurbelinnenschwinge" -command {VSetGetriebeLaengen 150. 200. 250. 300. 145.}




    frame $w.f.typ1
    pack $w.f.typ1 -fill x -in $w.f -side top -anchor n
    label $w.f.typ1.l1 -text "Bewegung:" -bd 0
    label $w.f.typ1.l2 -textvariable cl1 -bd 0
    label $w.f.typ1.l3 -text "-" -bd 0
    label $w.f.typ1.l4 -textvariable cl3 -bd 0
    pack $w.f.typ1.l1 $w.f.typ1.l2 $w.f.typ1.l3 $w.f.typ1.l4 \
	-in $w.f.typ1 -side left -anchor n

    set i 1
    while {$i <= 4} {
    # Gliedlaengen
	if {$i <= 2} then {
	    set item [expr $i+1]
	} else {
	    set item $i
	}
	VStatusGliedlaengen $w $i $item
	incr i
    }

    if {$lges_p >= 11} then {
	set imax 2
    } else {
	set imax 1
    }
    set i 1
    while {$i <= $imax} {
# Phi1 und Phi2
	frame $w.f.p$i
	pack $w.f.p$i -fill x -in $w.f -side top -anchor n
	label $w.f.p$i.l1 -text "Phi" -bd 0
	pack $w.f.p$i.l1 -in $w.f.p$i -side left -anchor n
	label $w.f.p$i.l2 -text $i -bd 0
	pack $w.f.p$i.l2 -in $w.f.p$i -side left -anchor s
	label $w.f.p$i.l3 -text "=" -bd 0
	pack $w.f.p$i.l3 -in $w.f.p$i -side left -anchor n

	label $w.f.p$i.b2 -text ">" -relief raised
	pack $w.f.p$i.b2 -in $w.f.p$i -side right
	set j [expr $i+4]
	bind $w.f.p$i.b2 <ButtonPress-1> "TRunGetriebe $i 1 1"
	bind $w.f.p$i.b2 <ButtonPress-2> "TRunGetriebe $i 1 2"
	bind $w.f.p$i.b2 <ButtonPress-3> "TRunGetriebe $i 1 3"
	bind $w.f.p$i.b2 <ButtonRelease-1> "PfeilButtonRelease $j"
	bind $w.f.p$i.b2 <ButtonRelease-2> "PfeilButtonRelease $j"
	bind $w.f.p$i.b2 <ButtonRelease-3> "PfeilButtonRelease $j"

	switch $i {
	    1 {entry $w.f.p$i.e4 -textvariable phi1 -width 8}
	    2 {entry $w.f.p$i.e4 -textvariable phi2 -width 8}
	}
	pack $w.f.p$i.e4 -in $w.f.p$i -side right

	label $w.f.p$i.b1 -text "<" -relief raised
	pack $w.f.p$i.b1 -in $w.f.p$i -side right
	set j [expr $i+4]
	bind $w.f.p$i.b1 <ButtonPress-1> "TRunGetriebe $i -1 1"
	bind $w.f.p$i.b1 <ButtonPress-2> "TRunGetriebe $i -1 2"
	bind $w.f.p$i.b1 <ButtonPress-3> "TRunGetriebe $i -1 3"
	bind $w.f.p$i.b1 <ButtonRelease-1> "PfeilButtonRelease $j"
	bind $w.f.p$i.b1 <ButtonRelease-2> "PfeilButtonRelease $j"
	bind $w.f.p$i.b1 <ButtonRelease-3> "PfeilButtonRelease $j"

	bind $w.f.p$i.e4 <Return> VKontrolGetrParameter

	if {$i == 1} then {
	    set item 2
	} else {
	    set item 5
	}
	bind $w.f.p$i.e4 <Any-Enter> \
	    "$wc itemconfigure $item -fill black"
	bind $w.f.p$i.e4 <Any-Leave> \
	    "$wc itemconfigure $item -fill white"
	set j [expr $i+4]
	bind $w.f.p$i.e4 <Any-Enter> "ConfigureEnterLeave $j $j $item 1 0"
	bind $w.f.p$i.e4 <Any-Leave> "ConfigureEnterLeave $j $j $item -1 0"
	bind $w.f.p$i.b1 <Any-Enter> "ConfigureEnterLeave $j $j $item 1 1"
	bind $w.f.p$i.b1 <Any-Leave> "ConfigureEnterLeave $j $j $item -1 1"
	bind $w.f.p$i.b2 <Any-Enter> "ConfigureEnterLeave $j $j $item 1 1"
	bind $w.f.p$i.b2 <Any-Leave> "ConfigureEnterLeave $j $j $item -1 1"

 # Bewegungsbereich
	if {$i == 1} then {
	    set item 3
	} else {
	    set item 6
	}
	VStatusBewegungsbereich $w $i $item

# Koppelpunkt
#	if {$imax == 1} then
	if {$lges_p != 11} then {
	    foreach j "1 2" {
		VStatusKoppelPunkt $w $j 6
	    }
	}

	incr i
    }
    VStatus2

    if { "$dateiNamePostfix" == "z" } then {
	frame $w.f.zl1 -height 12
	pack $w.f.zl1 -fill x -in $w.f -side top -anchor n
	VStatusGliedlaengen $w 5 7
	VStatusGliedlaengen $w 6 7
	VStatusBewegungsbereich $w 3 7
	VStatusKoppelPunkt $w 3 5
	VStatusKoppelPunkt $w 4 5
    }

# Frame fuer Copyright
    frame $w.fc
    pack $w.fc -fill x -in $w -side bottom -anchor s
    label $w.fc.l1 -text "Copyright 99, 00, 02, 17:" -bd 0 -foreground blue
    label $w.fc.l2 -text "Volker Jaekel" -bd 0
    label $w.fc.l3 -text "Pfingstweide 4" -bd 0
    label $w.fc.l4 -text "D 35580 Wetzlar" -bd 0
    label $w.fc.l5 -text "Germany" -bd 0
    pack $w.fc.l5 $w.fc.l4 $w.fc.l3 $w.fc.l2 \
	-in $w.fc -side bottom
    pack $w.fc.l1 -in $w.fc -side bottom -anchor w


    #vortrag
    #showDCVfile $w.fc

    # Hinweisetext
     set helptext1 "mAKS = ?"
     set helptext2 "(minimale Anzahl"
     set helptext3 "Koppelkurven-"
     set helptext4 "Selbstschnittpunkte)"
     VSetHelpText1 $cl1 $cl3

     frame $w.fh
     pack $w.fh -fill x -in $w -side bottom -anchor s
     label $w.fh.l1 -textvariable helptext1 -bd 0 -foreground black
     label $w.fh.l2 -textvariable helptext2 -bd 0 -foreground black
     label $w.fh.l3 -textvariable helptext3 -bd 0 -foreground black
     label $w.fh.l4 -textvariable helptext4 -bd 0 -foreground black
     label $w.fh.l5 -text " "
     pack $w.fh.l5 $w.fh.l4 $w.fh.l3 $w.fh.l2 $w.fh.l1 -in $w.fh -side bottom
}
#############################################################
proc berechneAaufThaleskreis {{gelenk unbekannt}} {

    global fixGelenkAThaleskreis al1 al2 al3 al4 phi1 drad Thaleskreisgelenk

    if {$fixGelenkAThaleskreis == 1} then {
	if {$gelenk == "A"} then {
	    set Thaleskreisgelenk "A"
	} elseif {$gelenk == "B"} then {
	    set Thaleskreisgelenk "B"
	}
	if {$Thaleskreisgelenk == "B"} then {
	    if {$al3 < $al4} then {
		set psiX [expr acos($al3/$al4)/$drad]
		set x [expr sqrt($al4*$al4-$al3*$al3)]
		if {$x < [expr $al1 + $al2] && $al2 < [expr $al1 +$x] \
					    && $al1 < [expr $al2 +$x]  } then {
		    set phi1 [expr 90 - $psiX + [cosinusSatz $al2 $al1 $x]/$drad]
		} else {
		    set fixGelenkAThaleskreis 0
		}
	    }
	} else {
	    if {$al1 < $al4} then {
		set x [expr sqrt($al4*$al4-$al1*$al1)]
		if {$x < [expr $al3 + $al2] && $al2 < [expr $al3 +$x] \
					    && $al3 < [expr $al2 +$x]  } then {
		    set phi1 [expr acos($al1/$al4)/$drad]
		}
	    }
	}
    }
}
#############################################################
proc VStatus2 {} {

    global lges_p mGetr cl1 wcf

    set w $wcf
    if {$wcf == 0} then {
	#tk_messageBox -type ok -message "VStatus2"
	return
    }

    if {$lges_p >= 11} then {
	set imax 2
    } else {
	set imax 1
    }
    set i 0
    while {$i < $imax} {
	incr i
	if {$mGetr == 1 && $i == 2 && $cl1 == " u"} then {
	    $w.f.k$i.l4 configure -relief flat
	    bind $w.f.k$i.l4 <ButtonPress-1> ""
	    bind $w.f.k$i.l4 <ButtonRelease-1> ""
	} else {
	    $w.f.k$i.l4 configure -relief raised
	    bind $w.f.k$i.l4 <ButtonPress-1> "KbButtonPress $i"
	    bind $w.f.k$i.l4 <ButtonRelease-1> \
		"$w.f.k$i.l4 configure -relief raised"
	}
    }
}
#############################################################
proc VKontrolGetrParameter {} {

    global al1 al2 al3 al4 p lges_p phi1 phi2 drad

    set back1 [VTestChangeGetrParameterOk $phi1 $al1 $al2 $al3 $al4]
    if {$lges_p >= 11} then {
	set back2 [VTestChangeGetrParameterOk $phi2 $al1 $al2 $al3 $al4]
    } else {
	set back2 0
    }
    if {$back1 != 0 || $back2 != 0} then {
	if {$back2 != 0} then {
	  fehlermelder2 \
	    "Der gewaehlte Getriebeparameter fuer Phi2 ist nicht erlaubt" \
	    "Die Aenderungen werden Rueckgaengig gemacht"
	} elseif {$back1 == -1} then {
	  fehlermelder2 \
	    "Die gewaehlten Getriebeparameter sind nicht erlaubt\n
Aendern Sie den Winkel Phi1 oder\n
vergroessen Sie L1 oder L4 oder\n
verkleinern Sie L2 oder L3" \
	    "Die Aenderungen werden Rueckgaengig gemacht"
	} else {
	  fehlermelder2 \
	    "Die gewaehlten Getriebeparameter sind nicht erlaubt\n
Aendern Sie den Winkel Phi1 oder\n
verkleinern Sie L1 oder L4 oder\n
vergreossern Sie L2 oder L3" \
	    "Die Aenderungen werden Rueckgaengig gemacht"
	}
	fehlerMelderWarten
	set xal1 [expr $p(2,11)-$p(1,11)]
	set yal1 [expr $p(2,12)-$p(1,12)]
	set al1 [expr round(10000.*sqrt($xal1*$xal1+$yal1*$yal1))/10.]
	set xal2 [expr $p(3,11)-$p(2,11)]
	set yal2 [expr $p(3,12)-$p(2,12)]
	set al2 [expr round(10000.*sqrt($xal2*$xal2+$yal2*$yal2))/10.]
	set xal3 [expr $p(4,11)-$p(3,11)]
	set yal3 [expr $p(4,12)-$p(3,12)]
	set al3 [expr round(10000.*sqrt($xal3*$xal3+$yal3*$yal3))/10.]
	set xal4 [expr $p(4,11)-$p(1,11)]
	set yal4 [expr $p(4,12)-$p(1,12)]
	set al4 [expr round(10000.*sqrt($xal4*$xal4+$yal4*$yal4))/10.]

	set xal1 [expr $p(2,11)-$p(1,11)]
	set yal1 [expr $p(2,12)-$p(1,12)]
	set phi1 [expr atan2($yal1,$xal1)/$drad]
	if {$lges_p >= 11} then {
	    set xal5 [expr $p(5,11)-$p(1,11)]
	    set yal5 [expr $p(5,12)-$p(1,12)]
	    set phi2 [expr atan2($yal5,$xal5)/$drad]
	}
    }
    VChangeGetrLaengen
}
#############################################################
proc KbButtonPress {i} {
    global kbf mGetr cl1 p lges_p wcf kbz

    set w $wcf
    $w.f.k$i.l4 configure -relief sunken
    if {$i <= 2} then {
	set kbf($i) [expr -1*$kbf($i)]
	set p(3,9) [expr -1.*abs($p(3,9))*$kbf(1)]
    } else {
	set kbz [expr -1*$kbz]
	set p(7,9) [expr -1.*abs($p(7,9))*$kbz]
    }
    if {$mGetr == 1 && $i == 1 && $cl1 == " u"} then {
	set kbf(2) $kbf(1)
    }
    set p(3,9) [expr -1.*abs($p(3,9))*$kbf(1)]
    if {$lges_p == 11} then {
	set p(6,9) [expr -1.*abs($p(6,9))*$kbf(1)]
    } elseif {$lges_p == 12} then {
	set p(7,9) [expr -1.*abs($p(7,9))*$kbf(1)]
    }
    VChangeGetrLaengen
}
#############################################################
proc ConfigureEnterLeave {i j item enter changeStatus} {
    global ie wc gliedfarbe lges_e
    global pfeilButtonPress statuszeile

    set pfeilButtonPress 0

    if {$enter == 1} then {
	if {$i <= 4 || $j == 0} then {
	    $wc itemconfigure L$ie($i,3)$ie($i,5) -arrow both \
		-fill magenta
	}
	$wc itemconfigure $item -fill black
	if {$changeStatus == 1} then {
	    set statuszeile "'linke Maustaste': langsam,\
'mittlere Maustaste': mittel, 'rechte Maustaste': schnell"
	}
    } else {
	if {$i <= 4 || $j == 0} then {
	    $wc itemconfigure L$ie($i,3)$ie($i,5) -arrow none \
		-fill $gliedfarbe($i)
	}
	$wc itemconfigure $item -fill white
	if {$changeStatus == 1} then {
	    set statuszeile ""
	}
    }
}
#############################################################
proc PfeilButtonRelease {i {noGliedLaenge 1} } {

    global pfeilButtonPress wcf

    if {$wcf == 0} then {
	return
    }

    set pfeilButtonPress -1
    set w $wcf
    if {$noGliedLaenge == 0} then {
	$w.f.l$i.b2 configure -relief raised
	$w.f.l$i.b1 configure -relief raised
    } elseif {$i <= 4} then {
	$w.f.d$i.b2 configure -relief raised
	$w.f.d$i.b1 configure -relief raised
    } else {
	$w.f.p[expr $i-4].b2 configure -relief raised
	$w.f.p[expr $i-4].b1 configure -relief raised
    }
}
#############################################################
proc PfeilButtonPress {i noGliedLaenge up geschwindigkeit {aufThalesKreis 0}} {

    global pfeilButtonPress al1 al2 al3 al4 phi1 phi2 drad lges_p
    global VChangeGetr_arbeitet dphi_df runGetriebe wcf alkx alky
    global xk_df yk_df alkx alky alz1 alz2 dateiNamePostfix alzx alzy maus1 maus2 maus3

    if {$wcf == 0} then {
	set pfeilButtonPress 0
	#tk_messageBox -type ok -message "PfeilButtonPress"
	return
    }
    if {$pfeilButtonPress == 0} then {
	set pfeilButtonPress 1

	set w $wcf
	set j 0

	if {$up == 1} then {
	    if {$geschwindigkeit == 3} then {
                            set summand [expr $dphi_df*$maus3]
		set summand2 $maus3
	    } elseif {$geschwindigkeit == 2} then {
                            set beschl $maus2
                            set summand [expr $dphi_df*$maus2]
		set summand2 $maus2
	    } else {
		set summand [expr $dphi_df*$maus1]
		set summand2 $maus1
	    }
#	     if {$i <= 4} then
	     if {$noGliedLaenge == 0} then {
		$w.f.l$i.b2 configure -relief sunken
	    } elseif {$i <= 4} then  {
		$w.f.d$i.b2 configure -relief sunken
	    } else {
		$w.f.p[expr $i-4].b2 configure -relief sunken
	    }
	} else {
	    if {$geschwindigkeit == 3} then {
		set summand [expr -10.*$dphi_df]
		set summand2 -10.
	    } elseif {$geschwindigkeit == 2} then {
		set summand [expr -3.*$dphi_df]
		set summand2 -3.
	    } else {
		set summand [expr -1.*$dphi_df]
		set summand2 -1.
	    }
	    #if {$w == 0} then {
	    #	 tk_messageBox -type ok -message "PfeilButtonPress"
	    #}
		if {$noGliedLaenge == 0} then {
		    $w.f.l$i.b1 configure -relief sunken
		} elseif {$i <= 4} then  {
		    $w.f.d$i.b1 configure -relief sunken
		} else {
		    $w.f.p[expr $i-4].b1 configure -relief sunken
		}

	}

	while {$pfeilButtonPress == 1} {
	    set al1_old $al1
	    set al2_old $al2
	    set al3_old $al3
	    set al4_old $al4
	    set alkx_old $alkx
	    set alky_old $alky
	    set phi1_old $phi1
	    set phi2_old $phi2
	    if {"$dateiNamePostfix" == "z"} then {
		set alz1_old $alz1
		set alz2_old $alz2
		set alzx_old $alzx
		set alzy_old $alzy
	    }

	    if {$noGliedLaenge == 0} then {
		switch $i {
		    1 {
			  set al1 [expr $al1+$summand2]
			  if {$aufThalesKreis != 0} then {
			      berechneAaufThaleskreis
			  }
		      }
		    2 {set al2 [expr $al2+$summand2]}
		    3 {
			  set al3 [expr $al3+$summand2]
			  if {$aufThalesKreis != 0} then {
			      berechneAaufThaleskreis
			  }
		      }
		    4 {set al4 [expr $al4+$summand2]}
		    5 {set alz1 [expr $alz1+$summand]}
		    6 {set alz2 [expr $alz2+$summand]}
		}
	    } else {
		switch $i {
		    1 {set alkx [expr $alkx+$summand2]}
		    2 {set alky [expr $alky+$summand2]}
		    3 {set alzx [expr $alzx+$summand2]}
		    4 {set alzy [expr $alzy+$summand2]}
		    5 {set phi1 [expr $phi1+$summand]}
		    6 {set phi2 [expr $phi2+$summand]}
		}
	    }
	    set zurueck 0
	    if {$lges_p >= 11} then {
		set test "$phi1 $phi2"
	    } else {
		set test "$phi1"
	    }
	    foreach phix $test {
		set zurueck [VTestChangeGetrParameterOk $phix \
		    $al1 $al2 $al3 $al4]
		if {$zurueck != 0} then {
		    set al1 $al1_old
		    set al2 $al2_old
		    set al3 $al3_old
		    set al4 $al4_old
		    set alkx $alkx_old
		    set alky $alky_old
		    set phi1 $phi1_old
		    set phi2 $phi2_old
		    break
		}
	    }
	    if {"$dateiNamePostfix" == "z"} then {
		set zurueck [VTestZweischlag]
		if {$zurueck != 0} then {
		    set alz1 $alz1_old
		    set alz2 $alz2_old
		    set alzx $alzx_old
		    set alzy $alzy_old
		}
	    }
	    if {$VChangeGetr_arbeitet == 0} then {
		incr j
		if {($i == 5 || $i == 6) && $j > 5} then {
# Kennzeichnen, dass Getriebe nicht variiert wird, sondern nur der
# Antriebswinkel
		    set runGetriebe 1
		}
		if {$noGliedLaenge == 0 || "$dateiNamePostfix" == "z"} then {
		    VChangeGetrLaengen
		} else {
		    VChangeKoppelpunktLage
		}
		set runGetriebe 0
	    }
	}
	set pfeilButtonPress 0
    }
}
##################################################################
proc VChangeKoppelpunktLage {} {

    global wc p alkx alky massstab showKoppelk xk_df yk_df

    set p(6,9) [expr $alkx/1000.]
    set p(6,10) [expr $alky/1000.]
    set list [trans8_xs_x_2p $p(2,1) $p(2,2) $p(3,1) \
	$p(3,2) [expr $alkx/1000.] [expr $alky/1000.]]
    set p(6,1) [lrange $list 0 0]
    set p(6,2) [lrange $list 1 1]

    set x [expr $p(6,1)*$massstab]
    set y [expr $p(6,2)*-$massstab]
    VerschiebeKnoten $wc 6 \
    [expr $x-[xLiesKnotenMittelpunkt $wc 6] ] \
    [expr $y-[yLiesKnotenMittelpunkt $wc 6] ]

    VKoppelpunktBahn
    if {$showKoppelk == 1} then {
              VShowRastpolkurve xk_df yk_df Koppelk blue blue
	#vortrag VShowRastpolkurve xk_df yk_df Koppelk blue blue
	VShowZweischlagHodograph
    }
    VShowKoppeldreieck
    VFrameWait
}
#############################################################
proc VTestChangeGetrParameterOk {phix al1 al2 al3 al4} {

    global drad

# Wenn Getriebeparameter nicht erlaubt sind, ist
#     set ierr [VTestChangeGetrParameterOk $phix] == 1 oder -1
# ansonsen ist ierr = 0

    set eps 0.1

    set dx [expr $al4-$al1*cos([expr $phix*$drad])]
    set dy [expr $al1*sin([expr $phix*$drad])]
    set l4m1 [expr $dx*$dx+$dy*$dy]
    set dlp [expr $al2+$al3]
    set dlm [expr $al2-$al3]
    if {$l4m1 > [expr $dlp*$dlp-$eps]} then {
	return 1
    } elseif {$l4m1 < [expr $dlm*$dlm-$eps]} then {
	return 1
    } else {
	return 0
    }
}
#############################################################
proc VBind {} {
    global last_xMoveto xMoveto last_0x 0x last_massstab massstab
    global last_yMoveto yMoveto last_0y 0y xregion_ yregion_ phi1
    global wc xPosK yPosK showPunktMove p xK yK drad al1 al2 al3 al4
    global VChangeGetr_arbeitet xPos yPos xPosNeu yPosNeu lges_p
    global al1N al2N al3N
    global dateiNamePostfix


    bind .chscroll <ButtonRelease-1> {
	set last_xMoveto $xMoveto
	set last_0x $0x
	set last_massstab $massstab
	set list [.chscroll get]
	set xMoveto [lrange $list 0 0]
	$wc xview moveto $xMoveto
	set 0x [expr $0x-($xMoveto-$last_xMoveto)*$xregion_]
    }
    bind .cvscroll <ButtonRelease-1> {
	set last_yMoveto $yMoveto
	set last_0y $0y
	set last_massstab $massstab
	set list [.cvscroll get]
	set yMoveto [lrange $list 0 0]
	$wc yview moveto $yMoveto
	set 0y [expr $0y-($yMoveto-$last_yMoveto)*$yregion_]
    }
    $wc bind 2 <Any-Enter> {
	$wc itemconfigure 2 -width 2 -fill black
	set statuszeile "rotieren: 'Rechte Maustaste', \
verschieben: 'Linke Maustaste', L1 aendern: 'mittlere Maustaste'"
    }
    $wc bind 3 <Any-Enter> {
	$wc itemconfigure 3 -width 2 -fill black
	set statuszeile "verschieben: 'Linke Maustaste', \
'L2 bzw. L3 aendern: 'Mittlere bzw. rechte Maustaste'"
    }
    $wc bind 4 <Any-Enter> {
	$wc itemconfigure 4 -width 2 -fill black
	set statuszeile "verschieben: 'Linke oder rechte Maustaste'"
    }
    $wc bind 2 <Any-Leave> {
	$wc itemconfigure K2 -width 1 -fill white
	set statuszeile " "
    }
    $wc bind 3 <Any-Leave> {
	$wc itemconfigure K3 -width 1 -fill white
	set statuszeile " "
    }
    $wc bind 4 <Any-Leave> {
	$wc itemconfigure K4 -width 1 -fill white
	set statuszeile " "
    }
    foreach buttonPress \
    "<ButtonPress-1> <ButtonPress-2> <ButtonPress-3>" {
	$wc bind 2 $buttonPress {
	    set al1N $al1
	    set xPos %x
	    set yPos %y
	    ButtonPress3NodeX 2
	}
    }
    foreach buttonPress \
    "<ButtonPress-1> <ButtonPress-2> <ButtonPress-3>" {
	$wc bind 3 $buttonPress {
	    set al2N $al2
	    set al3N $al3
	    set xPos %x
	    set yPos %y
	    ButtonPress3NodeX 3
	}
    }
    foreach buttonPress "<ButtonPress-1> <ButtonPress-3>" {
	$wc bind 4 $buttonPress {
	    set xPos %x
	    set yPos %y
	    ButtonPress3NodeX 4
	}
    }
    $wc bind 2 <B1-Motion> {
	set xPosNeu %x
	set yPosNeu %y
	ButtonMotion3NodeX 2 al1 +
    }
    $wc bind 2 <B2-Motion> {
	set xPosNeu %x
	set yPosNeu %y
	ButtonMotion3NodeX 2 $al1 -
    }
    $wc bind 2 <B3-Motion> {
	set xPosNeu %x
	set yPosNeu %y
	ButtonMotion3NodeX 2 phi1 +
    }
    $wc bind 3 <B1-Motion> {
	set xPosNeu %x
	set yPosNeu %y
	ButtonMotion3NodeX 3 al3 +
    }
    $wc bind 3 <B2-Motion> {
	set xPosNeu %x
	set yPosNeu %y
	ButtonMotion3NodeX 3 $al2 al2P3
    }
    $wc bind 3 <B3-Motion> {
	set xPosNeu %x
	set yPosNeu %y
	ButtonMotion3NodeX 3 $al3 al3P3
    }
    foreach buttonPress "<B1-Motion> <B3-Motion>" {
	$wc bind 4 $buttonPress {
	    set xPosNeu %x
	    set yPosNeu %y
	    ButtonMotion3NodeX 4 $al4 -
	}
    }
    $wc bind 2 <ButtonRelease-1> {
	ButtonMotion3NodeX2 2 al1 +
    }
    $wc bind 2 <ButtonRelease-2> {
	ButtonMotion3NodeX2 2 $al1 -
    }
    $wc bind 2 <ButtonRelease-3> {
	ButtonMotion3NodeX2 2 phi1 +
    }
    $wc bind 3 <ButtonRelease-1> {
	ButtonMotion3NodeX2 3 al3 +
    }
    $wc bind 3 <ButtonRelease-2> {
	ButtonMotion3NodeX2 3 $al2 al2P3
    }
    $wc bind 3 <ButtonRelease-3> {
	ButtonMotion3NodeX2 3 $al3 al3P3
    }
    foreach buttonPress "<ButtonRelease-1> <ButtonRelease-3>" {
	$wc bind 4 $buttonPress {
	    ButtonMotion3NodeX2 4 $al4 -
	}
    }
    if {$lges_p == 11} then {
	VBindNo6
    } else {
	# viergliedriges Gelenkgetriebe mit Koppelpunkt
	VBind6
	if {"$dateiNamePostfix" == "z"} then {
	    # viergliedriges Gelenkgetriebe mit Zweischlag
	    VBindZeischlag
	}
    }
}
#############################################################
# Bind zufgen fr Zweischlag von viergliedriges Gelenkgetriebe
proc VBindZeischlag {} {

    global wc
    global xPosNeu yPosNeu xPos yPos alzxN alzyN alz1N alz2N
    global alz1 alz2 alzx alzy dateiNamePostfix

    $wc bind 5 <Any-Enter> {
	$wc itemconfigure 5 -width 2 -fill black
	set statuszeile "verschieben: 'Linke Maustaste',nur x-Achse: 'Mittlere Maustaste', nur y-Achse: 'rechte Maustaste'"
    }
    $wc bind 5 <Any-Leave> {
	$wc itemconfigure 5 -width 1 -fill white
	set statuszeile " "
    }
    foreach buttonPress \
	"<ButtonPress-1> <ButtonPress-2> <ButtonPress-3>" {
	$wc bind 5 $buttonPress {
	    set alzxN $alzx
	    set alzyN $alzy
	    set xPos %x
	    set yPos %y
	    ButtonPress3NodeX 5
	}
    }
    $wc bind 5 <B1-Motion> {
	    set xPosNeu %x
	    set yPosNeu %y
	    ButtonMotion3NodeX 5 alzx +
    }
    $wc bind 5 <B2-Motion> {
	    set xPosNeu %x
	    set yPosNeu %y
	    ButtonMotion3NodeX 5 alzx x
    }
    $wc bind 5 <B3-Motion> {
	    set xPosNeu %x
	    set yPosNeu %y
	    ButtonMotion3NodeX 5 alzx y
    }
    $wc bind 5 <ButtonRelease-1> {
	    ButtonMotion3NodeX2 5 alzx +
    }
    $wc bind 5 <ButtonRelease-2> {
	    ButtonMotion3NodeX2 5 alzx x
    }
    $wc bind 5 <ButtonRelease-3> {
	    ButtonMotion3NodeX2 5 alzx y
    }
    $wc bind 7 <Any-Enter> {
	$wc itemconfigure 7 -width 2 -fill black
	set statuszeile "verschieben: 'Linke Maustaste' nur ein Glied aendern: 'Mittlere bzw. rechte Maustaste'"
    }
    $wc bind 7 <Any-Leave> {
	$wc itemconfigure 7 -width 1 -fill white
	set statuszeile " "
    }
    foreach buttonPress \
	"<ButtonPress-1> <ButtonPress-2> <ButtonPress-3>" {
	$wc bind 7 $buttonPress {
	    set alz1N $alz1
	    set alz2N $alz2
	    set xPos %x
	    set yPos %y
	    ButtonPress3NodeX 7
	}
    }
    $wc bind 7 <B1-Motion> {
	    set xPosNeu %x
	    set yPosNeu %y
	    ButtonMotion3NodeX 7 alz1 +
    }
    $wc bind 7 <B2-Motion> {
	    set xPosNeu %x
	    set yPosNeu %y
	    ButtonMotion3NodeX 7 $alz1 alz1P7
    }
    $wc bind 7 <B3-Motion> {
	    set xPosNeu %x
	    set yPosNeu %y
	    ButtonMotion3NodeX 7 $alz2 alz2P7
    }
    $wc bind 7 <ButtonRelease-1> {
	    ButtonMotion3NodeX2 7 alz1 +
    }
    $wc bind 7 <ButtonRelease-2> {
	    ButtonMotion3NodeX2 7 $alz1 alz1P7
    }
    $wc bind 7 <ButtonRelease-3> {
	    ButtonMotion3NodeX2 7 $alz2 alz2P7
    }
}
#############################################################
proc VBind6 {} {

    global wc alkx alky
    global xPosNeu yPosNeu xPos yPos

    $wc bind 6 <Any-Enter> {
	$wc itemconfigure 6 -width 2 -fill black
	set statuszeile "verschieben: 'Linke Maustaste'"
    }
    $wc bind 6 <Any-Leave> {
	$wc itemconfigure 6 -width 1 -fill white
	set statuszeile " "
    }
    $wc bind 6 <ButtonPress-1> {
	set xPos %x
	set yPos %y
	ButtonPress3NodeX 6
    }
    $wc bind 6 <B1-Motion> {
	set xPosNeu %x
	set yPosNeu %y
	ButtonMotion3NodeX 6 $alkx $alky
    }
    $wc bind 6 <ButtonRelease-1> {
	ButtonMotion3NodeX2 6 $alkx $alky
    }
    $wc bind 5 <Any-Enter> ""
    $wc bind 5 <Any-Leave> ""
    foreach buttonPress "<ButtonPress-1> <ButtonPress-3>" {
	$wc bind 5 $buttonPress ""
    }
    foreach buttonPress "<B1-Motion> <B3-Motion>" {
	$wc bind 5 $buttonPress ""
    }
    foreach buttonPress "<ButtonRelease-1> <ButtonRelease-3>" {
	$wc bind 5 $buttonPress ""
    }
}
#############################################################
proc VBindNo6 {} {

    global wc
    global xPosNeu yPosNeu xPos yPos

    $wc bind 6 <Any-Enter> ""
    $wc bind 6 <Any-Leave> ""
    $wc bind 6 <B3-Motion> ""
    $wc bind 6 <ButtonPress-3> ""
    $wc bind 6 <ButtonRelease-3> ""

    $wc bind 5 <Any-Enter> {
	$wc itemconfigure 5 -width 2 -fill black
	set statuszeile "rotieren: 'Rechte oder linke Maustaste'"
    }
    $wc bind 5 <Any-Leave> {
	$wc itemconfigure 5 -width 1 -fill white
	set statuszeile " "
    }
    foreach buttonPress "<ButtonPress-1> <ButtonPress-3>" {
	$wc bind 5 $buttonPress {
	    set xPos %x
	    set yPos %y
	    ButtonPress3NodeX 5
	}
    }
    foreach buttonPress "<B1-Motion> <B3-Motion>" {
	$wc bind 5 $buttonPress {
	    set xPosNeu %x
	    set yPosNeu %y
	    ButtonMotion3NodeX 5 phi2 +
	}
    }
    foreach buttonPress "<ButtonRelease-1> <ButtonRelease-3>" {
	$wc bind 5 $buttonPress {
	    ButtonMotion3NodeX2 5 phi2 +
	}
    }
}
#############################################################
proc ButtonMotion3NodeX {i alx alx2} {
    global xPos yPos xPosK yPosK xK yK follow p wc xPosNeu yPosNeu
    global showPunktMove buttonMotion
    global VChangeGetr_arbeitet

    if {$buttonMotion != 1} then {
	    set buttonMotion 1
	    if {$alx == "phi1"} then {
		if {$showPunktMove == 1} then {
		    set dx [expr $xPosNeu-$xPos]
		    set dy [expr $yPosNeu-$yPos]
		    set xPos $xPosNeu
		    set yPos $yPosNeu
		    VerschiebeKnoten $wc $i $dx $dy
		} else {
		    VChangePhiInPunktA
		}
	    } elseif {$alx2 == "+"} then {
		set dx [expr $xPosNeu-$xPos]
		set dy [expr $yPosNeu-$yPos]
		set xPos $xPosNeu
		set yPos $yPosNeu
		VerschiebeKnoten $wc $i $dx $dy
	    } elseif {$alx2 == "x"} then {
		set dx [expr $xPosNeu-$xPos]
		set dy 0
		set xPos $xPosNeu
		VerschiebeKnoten $wc $i $dx $dy
	    } elseif {$alx2 == "y"} then {
		set dx 0
		set dy [expr $yPosNeu-$yPos]
		set yPos $yPosNeu
		VerschiebeKnoten $wc $i $dx $dy
	    } elseif {$alx2 == "al2P3"} then {
		VChangeAl2InPunktB 4
		if {$showPunktMove == 1} then {
		    set xPos $xPosNeu
		    set yPos $yPosNeu
		}
	    } elseif {$alx2 == "al3P3"} then {
		VChangeAl2InPunktB 2
		if {$showPunktMove == 1} then {
		    set xPos $xPosNeu
		    set yPos $yPosNeu
		}
	    } elseif {$alx2 == "alz1P7"} then {
		#if {[VTestZweischlag 1] == 0} then {
		    VChangeAl2InPunktB 5
		    if {$showPunktMove == 1} then {
			set xPos $xPosNeu
			set yPos $yPosNeu
		    }
		#}
	    } elseif {$alx2 == "alz2P7"} then {
		#puts "VTestZweischlag 2 alz2P7"
		#if {[VTestZweischlag 2] == 0} then {
		    VChangeAl2InPunktB 6
		    if {$showPunktMove == 1} then {
			set xPos $xPosNeu
			set yPos $yPosNeu
		    }
		#}
	    } elseif {$follow == "x"} then {
		set dx [expr $xPosNeu-$xPos]
		set xPos $xPosNeu
		set yPos $yPosNeu
		VerschiebeKnoten $wc $i $dx [expr -1.*$dx/$xK*$yK]
	    } else {
		set dy [expr $yPosNeu-$yPos]
		set xPos $xPosNeu
		set yPos $yPosNeu
		VerschiebeKnoten $wc $i [expr -1.*$dy*$xK/$yK] $dy
	    }

	    if {$showPunktMove == 1} then {
		ButtonMotion3NodeX2 $i $alx $alx2 1
	    }
	    set buttonMotion 0
    }
}
#############################################################
proc VChangePhiInPunktA {} {
    global p al1N al1 al2 al3 al4 xPosNeu yPosNeu xPos yPos
    global wc phi1 kbf drad massstab phi1N

# Bewegegungbreich nicht aendern!
	set kb [expr -1.*$kbf(1)]

	set al1N_old $al1N
	set dx [expr ($xPosNeu-$xPos)/$massstab*1000.]
	set dy [expr ($yPosNeu-$yPos)/$massstab*1000.]
	set winkel [expr \
	    atan2([expr $p(2,2)-$p(1,2)],[expr $p(2,1)-$p(1,1)])]

#	set alx $al1

	set dx [expr $dx+$al1*cos($winkel)]
	set dy [expr -$dy+$al1*sin($winkel)]
	set winkel [expr atan2($dy,$dx)]
	set phi1N $winkel
	set xp2 [expr $al1/1000.*cos($winkel)+$p(1,1)]
	set yp2 [expr $al1/1000.*sin($winkel)+$p(1,2)]
	set xalx [expr $xp2-$p(1,1)]
	set yalx [expr $yp2-$p(1,2)]
	set alxN [expr sqrt($xalx*$xalx+$yalx*$yalx)*1000.]

	set al1N $alxN
	set ierr [VTestChangeGetrParameterOk $phi1 \
	    $al1N $al2 $al2 $al4]
	if {$ierr != 0} then {
	    set al1N $al1N_old
	}

	set dx2 [expr $xp2*$massstab]
	set dy2 [expr $yp2*-$massstab]
	VerschiebeKnoten $wc 2 \
	    [expr $dx2-[xLiesKnotenMittelpunkt $wc 2] ] \
	    [expr $dy2-[yLiesKnotenMittelpunkt $wc 2] ]
}
#############################################################
proc VChangeAl2InPunktB {i} {

# Gelenk 3 (Punkt B):	 i=2 oder 4
# Gelenk 7 (Zweischlag): i=5 oder 6

    global p al2N al3N al1 al2 al3 al4 xPosNeu yPosNeu xPos yPos
    global wc phi1 kbf drad massstab kbz alz1 alz2 alz1N alz2N

# Bewegegungbreich nicht aendern!
	if { $i <= 4 } then {
	    set kb [expr -1.*$kbf(1)]
	    set gelenk 3
	    set al2N_old $al2N
	    set al3N_old $al3N
	} else {
	    set kb [expr -1.*$kbz]
	    set gelenk 7
	    set alz1N_old $alz1N
	    set alz2N_old $alz2N
	}

	set dx [expr ($xPosNeu-$xPos)/$massstab*1000.]
	set dy [expr ($yPosNeu-$yPos)/$massstab*1000.]
	set winkel [expr \
	    atan2([expr $p($gelenk,2)-$p($i,2)],[expr $p($gelenk,1)-$p($i,1)])]
	#puts "winkel=$winkel, alz1=$alz1, alz2=$alz2"
	if {$i == 4} then {
	    set alx $al3
	    set j 2
	} elseif  { $i == 2} then {
	    set alx $al2
	    set j 4
	} elseif  { $i == 5} then {
	    set alx $alz2
	    set j 6
	} else {
	    # $i == 6
	    set alx $alz1
	    set j 5
	}
	set dx [expr $dx+$alx*cos($winkel)]
	set dy [expr -$dy+$alx*sin($winkel)]
	set winkel [expr atan2($dy,$dx)]
	set xp3 [expr $alx/1000.*cos($winkel)+$p($i,1)]
	set yp3 [expr $alx/1000.*sin($winkel)+$p($i,2)]
	set xalx [expr $xp3-$p($j,1)]
	set yalx [expr $yp3-$p($j,2)]
	set alxN [expr sqrt($xalx*$xalx+$yalx*$yalx)*1000.]
	if {$i == 4} then {
	    set al2N $alxN
	    set ierr [VTestChangeGetrParameterOk $phi1 \
		$al1 $al2N $al3 $al4]
	    if {$ierr != 0} then {
		set al2N $al2N_old
	    }
	} elseif {$i == 2} then {
	    set al3N $alxN
	    set ierr [VTestChangeGetrParameterOk $phi1 \
		$al1 $al2 $al3N $al4]
	    if {$ierr != 0} then {
		set al3N $al3N_old
	    }
	} elseif  { $i == 5} then {
	    set alz1N $alxN
	} else {
	    # $i == 6
	    set alz2N $alxN
	}
	set dx3 [expr $xp3*$massstab]
	set dy3 [expr $yp3*-$massstab]
	VerschiebeKnoten $wc $gelenk \
	    [expr $dx3-[xLiesKnotenMittelpunkt $wc $gelenk] ] \
	    [expr $dy3-[yLiesKnotenMittelpunkt $wc $gelenk] ]
	puts "VChangeAl2InPunktB ende"
}
#############################################################
proc ButtonMotion3NodeX2 {i alx alx2 {AufrufAusButtonMotion3NodeX 0}} {
    global xPos yPos xPosK yPosK xK yK follow p phi1 phi2 drad
    global VChangeGetr_arbeitet massstab al1 al2 al3 al4 alkx alky
    global al2N al3N showPunktMove phi1N alzx alzy alz1 alz2 kbz kbf
    global alz1N alz2N dateiNamePostfix

	set VTestZweischlagGlied "b"
	if {$VChangeGetr_arbeitet == 0 || $AufrufAusButtonMotion3NodeX == 1} then {
	    if {$alx2 == "-"} then {
		if {$follow == "x"} then {
		    set dx [expr $xK+($xPos-$xPosK)/$massstab]
		    set alxN [expr $alx/$p($i,1)*$dx]
		} else {
		    set dy [expr $yK-($yPos-$yPosK)/$massstab]
		    set alxN [expr $alx/$p($i,2)*$dy]
		}
		switch $i {
		    2 {set al1 [expr round($alxN*10.)/10.]}
		    4 {set al4 [expr round($alxN*10.)/10.]}
		}
	    } elseif {$alx2 == "al2P3"} then {
		set al2 [expr round($al2N*10.)/10.]
	    } elseif {$alx2 == "al3P3"} then {
		set al3 [expr round($al3N*10.)/10.]
	    } elseif {$alx2 == "alz1P7"} then {
		if {[VTestZweischlag 1] == 0} then {
		    set VTestZweischlagGlied 1
		    set alz1 [expr round($alz1N*10.)/10.]
		    set dx [expr $xK+($xPos-$xPosK)/$massstab]
		    set dy [expr $yK-($yPos-$yPosK)/$massstab]
		    set list [trans8_x_xs_2p $p(5,1) $p(5,2) $p(6,1) $p(6,2) $dx $dy]
		    set ykbz [lrange $list 1 1]
		    if { $ykbz < 0 } then {
			set kbz -1
		    } else {
			set kbz 1
		    }
		}
	    } elseif {$alx2 == "alz2P7"} then {
		if {[VTestZweischlag 2] == 0} then {
		    set VTestZweischlagGlied 2
		    set alz2 [expr round($alz2N*10.)/10.]
		    set dx [expr $xK+($xPos-$xPosK)/$massstab]
		    set dy [expr $yK-($yPos-$yPosK)/$massstab]
		    set list [trans8_x_xs_2p $p(5,1) $p(5,2) $p(6,1) $p(6,2) $dx $dy]
		    set ykbz [lrange $list 1 1]
		    if { $ykbz < 0 } then {
			set kbz -1
		    } else {
			set kbz 1
		    }
		}
	    } else {
		set dx [expr $xK+($xPos-$xPosK)/$massstab]
		set dy [expr $yK-($yPos-$yPosK)/$massstab]

		switch $i {
		    2 {
			if {$alx == "phi1" && $showPunktMove != 1} then {
			    set phi1 [expr $phi1N/$drad]
			} else {
			    set phi1 [expr atan2($dy,$dx)/$drad]
			    if {$alx == "al1"} then {
				set al1 [expr round(\
				    sqrt($dx*$dx+$dy*$dy)*10000.)/10.]
			    }
			}
		      }
		    3 { set dx3 [expr $dx-$p(4,1)]
			set al3 [expr round(\
			    sqrt($dx3*$dx3+$dy*$dy)*10000.)/10.]
			set dx2 [expr $dx-$p(2,1)]
			set dy2 [expr $dy-$p(2,2)]
			set al2 [expr round(sqrt(\
			    $dx2*$dx2+$dy2*$dy2)*10000.)/10.]
			set list [trans8_x_xs_2p $p(4,1) $p(4,2) $p(2,1) $p(2,2) $dx $dy]
			set ykb [lrange $list 1 1]
			if { $ykb < 0 } then {
			    set kbf(1) -1
			} else {
			    set kbf(1) 1
			}
		      }
		    5 {
			if {$alx == "alzx"} then {
			    if {$alx2 == "x"} then {
				VKoppelpunktBahn
				if {[VTestZweischlag b] == 0} then {
				    set alzx [expr $dx*1000.]
				}
			    } elseif {$alx2 == "y"} then {
				VKoppelpunktBahn
				if {[VTestZweischlag b] == 0} then {
				    set alzy [expr $dy*1000.]
				}
			    } else {
			       VKoppelpunktBahn
			       if {[VTestZweischlag b] == 0} then {
				    set alzx [expr $dx*1000.]
				    set alzy [expr $dy*1000.]
			       }
			    }
			} else {
			    set phi2 [expr atan2($dy,$dx)/$drad]
			}
		      }
		    6 { set list [trans8_x_xs_2p [expr $p(2,1)*1000.] \
			    [expr $p(2,2)*1000.] [expr $p(3,1)*1000.] \
			    [expr $p(3,2)*1000.] \
			    [expr $dx*1000.] [expr $dy*1000.]]
			set alkx \
			    [expr round(10.*[lrange $list 0 0])/10.]
			set alky \
			    [expr round(10.*[lrange $list 1 1])/10.]
			VChangeKoppelpunktLage
		      }
		    7 {
			if {[VTestZweischlag b] == 0} then {
			    set dx2 [expr $dx-$p(6,1)]
			    set dy2 [expr $dy-$p(6,2)]
			    set alz1 [expr round(sqrt(\
				$dx2*$dx2+$dy2*$dy2)*10000.)/10.]
			    set dx2 [expr $dx-$p(5,1)]
			    set dy2 [expr $dy-$p(5,2)]
			    set alz2 [expr round(sqrt(\
				$dx2*$dx2+$dy2*$dy2)*10000.)/10.]
			    set list [trans8_x_xs_2p $p(5,1) $p(5,2) $p(6,1) $p(6,2) $dx $dy]
			    set ykbz [lrange $list 1 1]
			    if { $ykbz < 0 } then {
				set kbz -1
			    } else {
				set kbz 1
			    }
			}
		      }
		}
	    }

	    if { "$dateiNamePostfix" == "z" && $i >=5} then {
		if {[VTestZweischlag $VTestZweischlagGlied] == 0} then {
		    if {$i == 6} then {
			VParametric -6
		    } else {
			set list [bere_zweischlag_m_punkt $p(5,1) $p(5,2) \
			     [expr $alz2/1000.] [expr $alz1/1000.] $p(6,1) $p(6,2) $kbz]
			set p(7,10) [expr $alz1/1000.]
			set p(7,9) [expr $alz2/1000.*$kbz]
			set p(7,1) [lrange $list 0 0]
			set p(7,2) [lrange $list 1 1]
			set ie_p7 [VParametric -7]
			set p(5,9) [expr $alzx/1000.]
			set p(5,10) [expr $alzy/1000.]
			set p(5,1) [expr $alzx/1000.]
			set p(5,2) [expr $alzy/1000.]
			set ie_p5 [VParametric -5]
			if {[lrange $list 2 2] == 1} then {
			#   Fehler beim Berechnen des Zweischlags
			    set ie_p5 -5
			    set ie_p7 -7
			}
		    }
		    VModifyGetr all
		}
	    } elseif {$i != 6} then {
		VKontrolGetrParameter
		VChangeGetrLaengen
	    }
	}
}
#############################################################
proc ButtonPress3NodeX {i} {
    global xPos yPos xPosK yPosK xK yK follow p

	    set xPosK $xPos
	    set yPosK $yPos
	    set xK [expr $p($i,1)-$p(1,1)]
	    set yK [expr $p($i,2)-$p(1,2)]

	    if {$xK > $yK} then {
		set follow "x"
	    } else {
		set follow "y"
	    }
}
#############################################################
proc VkueSpeichern {filename} {

    global al1 al2 al3 al4 al1ue al2ue al3ue al4ue xUe yUe xSb ySb
    global showSelbst showUeber

    if {$showSelbst == 0 && $showUeber == 0} then {
	return
    }
    if {[expr abs($al1-$al1ue)] >= 0.1 \
    || [expr abs($al2-$al2ue)] >= 0.1 || [expr abs($al3-$al3ue)] >= 0.1 \
    || [expr abs($al4-$al4ue)] >= 0.1} then {
	return
    }

    set Datei [open $filename a+]
	puts $Datei "set al1ue $al1ue"
	puts $Datei "set al2ue $al2ue"
	puts $Datei "set al3ue $al3ue"
	puts $Datei "set al4ue $al4ue"

# Uebergangskurve abspeichern
	puts $Datei "set i 0"
	set imax $xUe(0,0)
	set i 0
	while {$i < $imax} {
	    incr i
	    puts $Datei "incr i"
	    set jmax $xUe($i,0)
	    set j 0
	    while {$j < $jmax} {
		incr j
		puts $Datei "set xUe(\$i,$j) $xUe($i,$j)"
		puts $Datei "set yUe(\$i,$j) $yUe($i,$j)"
	    }
	    puts $Datei "set xUe(\$i,0) $xUe($i,0)"
	}
	puts $Datei "set xUe(0,0) $xUe(0,0)"

# Selbstberuehrungskurve abspeichern
	puts $Datei "set i 0"
	set imax $xSb(0,0)
	set i 0
	while {$i < $imax} {
	    incr i
	    puts $Datei "incr i"
	    set jmax $xSb($i,0)
	    set j 0
	    while {$j < $jmax} {
		incr j
		puts $Datei "set xSb(\$i,$j) $xSb($i,$j)"
		puts $Datei "set ySb(\$i,$j) $ySb($i,$j)"
	    }
	    puts $Datei "set xSb(\$i,0) $xSb($i,0)"
	}
	puts $Datei "set xSb(0,0) $xSb(0,0)"
    close $Datei
}
#############################################################
proc VGrafikeinstellungSpeichern3 {filename {append "no"}} {

    global dphi
    global dphi_df
    global showRast
    global showGang
    global showSelbst
    global showUeber
    global showKoppelk
    global showKSwBg
    global showFeld
    global showPunktMove
    global fillGang
    global zweiLagen
    global noMomentanPol
    global zweiLagenKoppel
    global eineLage zweiSchlag
    global showSchnabel showZsR showThales
    global al1Snabel al2Snabel al3Snabel al4Snabel
    global showZweiSchlagHodograph showZweischlagWinkelDifferenz
    global massstab xMoveto yMoveto 0x 0y
    global last_massstab last_xMoveto last_yMoveto last_0x last_0y
    global yZoomPos1 xZoomPos1 yZoomPos2 xZoomPos2 xneu yneu xregion_ yregion_
    global maus1 maus2 maus3 plotName 

    if {$append == "append"} then {
	set mod "a+"
    } else {
	set mod "w+"
    }
    set Datei [open $filename $mod]
              puts $Datei "set maus1 $maus1"
              puts $Datei "set maus2 $maus2"
              puts $Datei "set maus3 $maus3"
              puts $Datei "set plotName $plotName"
	puts $Datei "set dphi $dphi"
	puts $Datei "set dphi_df $dphi_df"
	puts $Datei "set showRast $showRast"
	puts $Datei "set showGang $showGang"
	puts $Datei "set showSelbst $showSelbst"
	puts $Datei "set showUeber $showUeber"
	puts $Datei "set showKoppelk $showKoppelk"
	puts $Datei "set showKSwBg $showKSwBg"
	puts $Datei "set showFeld $showFeld"
	puts $Datei "set showPunktMove $showPunktMove"
	puts $Datei "set fillGang $fillGang"
	#if {$noMomentanPol == "1"} then {
	#    puts $Datei "set eineLage 0"
	#    puts $Datei "set noMomentanPol 1"
	#} else {
	#    puts $Datei "set eineLage 1"
	#    puts $Datei "set noMomentanPol 0"
	#}
	puts $Datei "set eineLage $eineLage"
	puts $Datei "set noMomentanPol $noMomentanPol"
	puts $Datei "set zweiLagen $zweiLagen"
	puts $Datei "set zweiSchlag $zweiSchlag"
	puts $Datei "set zweiLagenKoppel $zweiLagenKoppel"
	puts $Datei "set showSchnabel $showSchnabel"
              if {$showSchnabel == 1} then {
                  puts $Datei "set al1Snabel $al1Snabel"
                  puts $Datei "set al2Snabel $al2Snabel"
                  puts $Datei "set al3Snabel $al3Snabel"
                  puts $Datei "set al4Snabel $al4Snabel"
              }
	puts $Datei "set showZsR $showZsR"
	puts $Datei "set showThales $showThales"
	puts $Datei "set showZweiSchlagHodograph $showZweiSchlagHodograph"
	puts $Datei "set showZweischlagWinkelDifferenz $showZweischlagWinkelDifferenz"
	if {$append == "append"} then {
	    puts $Datei VSetAnzahlLagen
                  if {$showSchnabel == 1} then {
                      puts $Datei "phi_schnabelspitze"
                      puts $Datei "show_schnabelspitze"
                  }
	}
	# Zoom abspeichern
	#puts $Datei "set massstab $massstab"
	#puts $Datei "set xMoveto $xMoveto"
	#puts $Datei "set yMoveto $yMoveto"
	#puts $Datei "set 0x $0x"
	#puts $Datei "set 0y $0y"
	#puts $Datei "set last_massstab $last_massstab"
	#puts $Datei "set last_xMoveto $last_xMoveto"
	#puts $Datei "set last_yMoveto $last_yMoveto"
	#puts $Datei "set last_0x $last_0x"
	#puts $Datei "set last_0y $last_0y"
	#puts $Datei "set yZoomPos1 $yZoomPos1"
	#puts $Datei "set xZoomPos1 $xZoomPos1"
	#puts $Datei "set yZoomPos2 $yZoomPos2"
	#puts $Datei "set xZoomPos2 $xZoomPos2"
	#puts $Datei "set xneu $xneu"
	#puts $Datei "set yneu $yneu"
	#puts $Datei "set xregion_ $xregion_"
	#puts $Datei "set yregion_ $yregion_"
	#puts $Datei "xyViewDefault"
    close $Datei
}
#############################################################
proc schnabelpitze1 {} {
    set nr 0
    while {$nr < $lges_df} {
	incr nr
	$dfphi($nr)
	$dfpsi($nr) \
	if {$nr > 1} then {
	    if {$plot_df($nr) != $plot_df([expr $nr-1])} then {
# Asymptote
		set xRast($i,0) $lgesRast
		set xGang($i,0) $lgesGang
		incr i
		set lgesRast 0
		set lgesGang 0
	    }
s_schnitt_2g ie_p kstart kziel winkel1 winkel2
	}
    }
}
#############################################################
proc VGetriebeparameterSpeichern {filename {append "no"}} {

    global al1
    global al2
    global al3
    global al4
    global phi1
    global kbf
    global alkx
    global alky
    global alz1
    global alz2
    global alzx
    global alzy
    global dateiNamePostfix
    global kbz

    set Datei [open $filename w+]
	puts $Datei "set al1 $al1"
	puts $Datei "set al2 $al2"
	puts $Datei "set al3 $al3"
	puts $Datei "set al4 $al4"
	puts $Datei "set phi1 $phi1"
	puts $Datei "set kbf(1) $kbf(1)"
	puts $Datei "set alkx $alkx"
	puts $Datei "set alky $alky"
	if {"$dateiNamePostfix" == "z"} then {
	    puts $Datei "set alz1 $alz1"
	    puts $Datei "set alz2 $alz2"
	    puts $Datei "set alzx $alzx"
	    puts $Datei "set alzy $alzy"
	    puts $Datei "set kbz $kbz"
	    puts $Datei "set dateiNamePostfix \"z\""
	    if {$append != "append"} then {
		#puts $Datei "VLiesDatei dromeg-z.dat"
		puts $Datei VSetAnzahlLagen
	    }
	} else {
	    puts $Datei "set dateiNamePostfix \"?\""
	    #puts $Datei "VLiesDatei dromeg-6.dat"
	    if {$append != "append"} then {
		#puts $Datei "VLiesDatei dromeg-z.dat"
		puts $Datei VSetAnzahlLagen
	    }
	}
    close $Datei
}
#############################################################
proc TcreateDXF {dxfFile {radius 1.}} {

#  file="no" --> kein DXF-File erstellen, sondern Bildschirmausgabe

    #set dxfFile [open c:/temp/dromeg-t.dxf w]
    if {$dxfFile != "no"} then {
        set dxfFile [open "$dxfFile" w]

	# DXF-Header
	puts $dxfFile "0"
	puts $dxfFile "SECTION"
	puts $dxfFile "2"
	puts $dxfFile "ENTITIES"

	#set wc ""
    }
    
    # Farbe im DXF-File nicht korrekt bei Getrieben mit vielen Gliedern
    VShowGetr $dxfFile $radius
    VModifyGetr all $dxfFile
    
    
    
    dxfEnd $dxfFile

}
############################################################
proc VupdateView {} {
	VChangeGetrLaengen
	VStatus
	VBind
}
#############################################################
global pradi_
global wc wcf Pi drad xMax_ yMax_ massstab al1 al2 al3 al4 alkx alky
global statuszeile showPunktMove kueStatus
global canvas_height canvas_width ischritte_ iT
global last_massstab xMoveto yMoveto 0x 0y last_0x last_0y
global DateiName lges_p x maxIfeman minWfeman
global cl1 cl3 getyp zusat wend_anz dphi dphi_df lges_df
global VChangeGetr_arbeitet runGetriebe pfeilButtonPress
global showRast showGang showSelbst showUeber framewait showKoppelk
global sbAl1 sbAl2 sbAl3 sbAl4 maxFeldLine buttonMotion showKSwBg
global xkSwBgA xkSwBgB xkSwBg plotName
global ShowFemanFortschritt zweiLagen eineLage zweiLagenKoppel
global zweiSchlag
global DrehRichTung eps180 noMomentanPol fillGang showFeld
global noWarnung autoUeBere KueUberschreiben
global al1ue al2ue al3ue al4ue
global phi_schnabel showSchnabel dateiNamePostfix
global alz1 alz2 alzx alzy dateiNamePostfix kbz showZsR showThales
global fixGelenkAThaleskreis showZweiSchlagHodograph zwSHmasstab showZweischlagWinkelDifferenz
global calcKue epsMinZahl
global maus1 maus2 maus3
global dromeg4Vers
global plotName
global showGetriebe
global ShowGangPolKurvenPunkte_
global getriebeTyp_

set getriebeTyp_ "Gelenkgetriebe"
set showGetriebe 1
set ShowGangPolKurvenPunkte_ 0
set plotName dromeg.eps
set dromeg4Vers 1.3.5
set maus1 1
set maus2 2
set maus3 3
set epsMinZahl 1e-300
set calcKue 0
set zwSHmasstab 10.0
set showZweiSchlagHodograph 1
set showZweischlagWinkelDifferenz 1
set fixGelenkAThaleskreis 0
set showThales 0
set showZsR 0
set kbz -1
set phi_schnabel(0) 0
set showSchnabel 0
set autoUeBere 0
set fillGang 0
#set eps180 2 (schlecht fr phi(berechnen) in der Nhe vo 180 Grad)
set eps180 .2
set xMoveto .35
set yMoveto .35
set showPunktMove 1
set kueStatus "not ok"
set Pi [expr 4.*atan(1.)]
set drad [expr $Pi/180.]
set iT 180
set ischritte_ 180
set xMax_ [expr (100)+10]
set yMax_ [expr (100)+10]
set massstab 100
set last_massstab 20
set pradi_ 5
set maxIfeman 15
set minWfeman 1.
set noWarnung Nein
set KueUberschreiben Ja
set cl1 " "
set cl3 " "
set getyp " "
set zusat " "
set dphi 1
set wend_anz 180
set dphi_df 5
set VChangeGetr_arbeitet 0
set runGetriebe 0
set pfeilButtonPress 0
set wcf 0
set framewait 0
set lges_df 0
set showRast 0
set showGang 1
set showSelbst 0
set showUeber 1
set showKoppelk 1
set sbAl1 0
set sbAl2 0
set sbAl3 0
set sbAl4 0
set maxFeldLine 2222
set buttonMotion 0
set showKSwBg 1
set xkSwBgA(0,0) 0
set xkSwBgB(0,0) 0
set xkSwBg(0,0) 0
set ShowFemanFortschritt Ja
set zweiLagen 0
set zweiSchlag 0
set noMomentanPol 0
set zweiLagenKoppel 0
set eineLage 1
set DrehRichTung 1
set showFeld 1
set al1ue 0
set al2ue 0
set al3ue 0
set al4ue 0
set dateiNamePostfix " "


source dromeg-b.tcl

# dromeg-4.def einlesen

    set filename [speicherDir]
    append filename dromeg-4.def
    if {[file exists $filename] == 1} then {
	source $filename
    }

if {$noMomentanPol == "1"} then {
    set DateiName dromeg-4.dat
} elseif {$zweiLagenKoppel == "1"} then {
    set DateiName dromeg-k.dat
} elseif {$zweiLagen == "1"} then {
    set DateiName dromeg-u.dat
} else {
    set DateiName dromeg-6.dat
}

set wc .canvas

# dromeg.def einlesen

if {[info exists canvas_height] == 0} then {
    set filename [speicherDir]
    append filename dromeg.def
    if {[file exists $filename] == 1} then {
	source $filename
    } else {
	#set canvas_height 350
	set canvas_height 500
              #set canvas_height 650
	set canvas_width 630
              #set canvas_width 860
	set plotName c:/temp/dromeg.eps
	#set canvas_width 400
    }
}

set 0x [expr $canvas_width/2.]
set 0y [expr $canvas_height/2.]
set last_0x 0x
set last_0y 0y
destroy .c
destroy .cvscroll
destroy .chscroll
destroy $wc
destroy .d
destroy .s

TPullDownMenu
wm title . \
    "DROMEG-4 Version $dromeg4Vers (Freeware)"
#wm geometry . +10+5
wm geometry . +1+1
frame .c
pack .c -expand yes -fill both -padx 1 -pady 1

frame .c.f
pack .c.f -expand yes -fill y -in .c -side left

T_Grafik

frame .s -background black
pack .s -in . -expand yes -fill x
label .s.statuszeile -textvariable statuszeile \
    -background black -foreground white
pack .s.statuszeile -in .s -fill x -side left
set statuszeile "Hier erscheinen Hinweise zur Programmbedienung \
   (z. B. wenn Sie den Mauszeiger ueber einen aktiven Punkt legen)"

frame .d
pack .d -expand yes -fill both -padx 1 -pady 1

VLiesPreSam $DateiName
VNormalizeGetr
VSetMassstab lges_p
VShowGetr
xyViewDefault

# start: fuer Vorfuehrung:
set al1 120.
set al2 355.
set al3 275.
set al4 500.
set phi1 145
set alkx 225
set alky 325
#set showKSwBg 0
# ende: fuer Vorfuehrung:

# dro-4-4.def einlesen

    set filename [speicherDir]
    append filename dro-p-4.def
    if {[file exists $filename] == 1} then {
	source $filename
    }
set showSchnabel_old $showSchnabel
VChangeGetrLaengen
set showSchnabel $showSchnabel_old
puts "showSchnabel=$showSchnabel"
if {$showSchnabel  != 0} then {
    phi_schnabelspitze
}

VStatus
VBind
TZoomOut

focus $wc

#trace variable phi1 w TraceProc
#trace variable phi2 w TraceProc
proc TraceProc {VarName ElemName Operation} {
    upvar $VarName v
    puts "$VarName=$v"
}
#tk_dialog
#V1.3.3 keine Modifikation gegenueber V1.2, nur Anpassung fuer dromeg-t
#V1.3.4 keine Modifikation gegenueber V1.3.3, nur Anpassung fuer dromeg-t
#V1.3.5: Icons fuer "Zoom All" und "Grafik einpassen" zugefuegt, Koppelkurve=blau statt gelb
#        Bugfix Uebergangskurve automatisch ermitteln fr nicht u-s, nicht u-u
#        Korrektur von Phi(2), so dass er innerhalb des zulaessigen Bereichs liegt
#        Export von DXF-Dateien zugefgt

#proc VShowGangpolkurve
