#!/inko4/bin/wish -f
# Analyse von Trochoiden
######################################################

if {[file exists dromeg-b.tcl] == 1} then {
    #tk_messageBox -message "pwd=[pwd]"
    source dromeg-b.tcl
} else {
    tk_messageBox -message "Error:\n\n  -  Entweder ist die Installation nicht in Orndung\n  - oder Sie rufen das Program von einem falschen Verzeichnis auf\n     Im richtige Verzeichnis muss das Unterverzeichnis\n    'dromeg-v1.3.5' liegen."
    exit
}
######################################################
proc xTrochoide {rG m phi a gamma0_} {
return [expr $rG*$m*cos($phi)+abs($a)*cos($m*$phi+$gamma0_)]
}
######################################################
proc yTrochoide {rG m phi a gamma0_} {
return [expr $rG*$m*sin($phi)+abs($a)*sin($m*$phi+$gamma0_)]
}
######################################################
proc createTrochoide {wc iN Pi {dxf no}} {

    global a_ rG_ m_ gamma0_ massstab a_massstab
    global xyT iT dPhi ischritte_ umdr_ showTrochoide

    set a_massstab [expr $a_/$massstab]
    
    set umdr_ [expr int($umdr_)]
    if {$dxf == "no"} then {
        $wc delete "trochoide$umdr_"
    }
    #   set iT 180
    set dPhi [expr 2*$Pi/$iT]
    set phi  [expr $umdr_*2*$Pi]
    set xyT [xTrochoide $rG_ $m_ -$phi $a_ $gamma0_]
    lappend xyT [yTrochoide $rG_ $m_ -$phi $a_ $gamma0_]
    set i 0
    while {$i<$iT} {
        set phi [expr $phi+$dPhi]
        lappend xyT [xTrochoide $rG_ $m_ -$phi $a_ $gamma0_]
        lappend xyT [yTrochoide $rG_ $m_ -$phi $a_ $gamma0_]
        incr i 1
    }
    if {$umdr_==0} {
        set rgb1 d
    } elseif {$umdr_==4} {
        set rgb1 8
    } else {
        set rgb1 0
    }
    if {$umdr_==1} {
        set rgb2 d
    } elseif {$umdr_==5} {
        set rgb2 8
    } else {
        set rgb2 0
    }
    if {$umdr_==2} {
        set rgb3 d
    } elseif {$umdr_==6} {
        set rgb3 8
    } else {
        set rgb3 0
    }
        #set Befehl \
        #"$wc create line $xyT -tags trochoide$umdr_ \
        #    -fill #$rgb1$rgb2$rgb3"
        #set Line [eval $Befehl]
    #set Line [dxfPolygon $wc $dxf $umdr_ $rgb1$rgb2$rgb3 "$xyT"]
    set tag "trochoide$umdr_"
    set Line [dxfPolygon $wc $dxf "Trochoide" $tag $rgb1$rgb2$rgb3 $xyT]
    #if {$dxf == "no"} then {
    #    $wc addtag "Trochoide" withtag $Line
    #    #set showTrochoide 1
    #}
}
###################################################
proc recreateTrochoide {{dxf no}} {

    global iN wc Pi umdr_

    set abs_iN $iN
    set i 0
    while {$i<$abs_iN} {
        set umdr_ [expr int($i)]
        createTrochoide $wc $i $Pi $dxf
        incr i
    }
}
######################################################
proc modifyTrochoide {wc m_dum iN gamma0 Pi} {

    global a_ phi_ m_ rG_
    global xyT iT dPhi iN_alt a_massstab massstab umdr_
    global showGetriebe
    
    set a_massstab [expr $a_/$massstab]
    
    set abs_iN [expr abs($iN)]
    if {[info exists iN_alt]==0} {set iN_alt 0}
    if {$abs_iN>$iN_alt} {
        while {$iN_alt<$abs_iN} {
            set umdr_ [expr int($iN_alt)]
            createTrochoide $wc $iN_alt $Pi
            incr iN_alt 1
        }
    } elseif {$abs_iN<=$iN_alt} {
        while {$iN_alt>=$abs_iN} {
            set iN_alt [expr int($iN_alt)]
            $wc delete "trochoide$iN_alt"
            incr iN_alt -1
        }
    }
    set umdr_ 0
    while {$umdr_<$abs_iN} {
    set phi [expr $umdr_*2*$Pi]
    set xyT [xTrochoide $rG_ $m_ -$phi $a_ $gamma0]
    lappend xyT [yTrochoide $rG_ $m_ -$phi $a_ $gamma0]
    set i 0
    while {$i<$iT} {
        set phi [expr $phi+$dPhi]
        lappend xyT [xTrochoide $rG_ $m_ -$phi $a_ $gamma0]
        lappend xyT [yTrochoide $rG_ $m_ -$phi $a_ $gamma0]
        incr i 1
    }
    set Befehl "$wc coords trochoide$umdr_ $xyT"
    set Line [eval $Befehl]
    incr umdr_ 1
    }
    set xt [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0]
    set yt [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0]
    
    if {$showGetriebe != 0} then {
        VerschiebeKnoten $wc 4 [expr $xt-[xLiesKnotenMittelpunkt $wc 4] ] \
    		   [expr $yt-[yLiesKnotenMittelpunkt $wc 4] ]
    }
    
TmodifyThickness
}
######################################################
proc bewegeGetriebe {wc phi_dum rG_dum rR m_dum a_dum gamma0_ Pi \
    Richtung geschw} {

    global a_ phi_ m_ iZ iN rS
    global rG_ rUe_ phi_grad showFelder
    global irunMaxI ischritte_ irunMaxI irunStep
    global TShowSonder

    if {$irunMaxI != 0} then {return}

    if {$iZ > 0} then {
        set signiZ 1
    } else {
        set signiZ -1
    }

    set i $ischritte_
    set dphi [expr 2*$Pi/$i*$Richtung]
    set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
    set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
    set xP [expr $signiZ*$rR*cos($phi_)]
    set yP [expr $signiZ*$rR*sin($phi_)]
    set xG [expr $rG_*$m_*cos($phi_)]
    set yG [expr $rG_*$m_*sin($phi_)]
    set irunMaxI 100000
    set irunStep 0
    while {$irunStep<$irunMaxI} {
        incr irunStep 1
        #setStatuszeile "irunMaxI=$irunMaxI, irunStep=$irunStep,---------------------"
        set phi_ [expr $phi_+$dphi*$geschw]
        set phi_grad [expr $phi_/$Pi*180.]
        set xneu [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set yneu [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set xPneu [expr $signiZ*$rR*cos($phi_)]
        set yPneu [expr $signiZ*$rR*sin($phi_)]
        set xGneu [expr $rG_*$m_*cos($phi_)]
        set yGneu [expr $rG_*$m_*sin($phi_)]
        set dx [expr $xneu-$x]
        set dy [expr $yneu-$y]
        set dxP [expr $xPneu-$xP]
        set dyP [expr $yPneu-$yP]
        set dxG [expr $xGneu-$xG]
        set dyG [expr $yGneu-$yG]
        set x $xneu
        set y $yneu
        set xP $xPneu
        set yP $yPneu
        set xG $xGneu
        set yG $yGneu
        VerschiebeKnoten $wc 4 $dx $dy
        VerschiebeKnoten $wc 3 $dxG $dyG
        VerschiebeKnoten $wc 2 $dxP $dyP
        $wc move gang $dxG $dyG
        $wc move ball $dxG $dyG
        set dummy 1
        while {$dummy<=$rUe_(0)} {
            $wc move kUe$dummy $dxG $dyG
            $wc move kUefill$dummy $dxG $dyG
            set dummy [expr $dummy+1]
        }
        if {[expr $iZ/2.] != [expr int($iZ/2.)]} then {
          if {$showFelder == 1 || $TShowSonder != 0} then {
                # Kreis "sonderfall" soll verschoben werden
                $wc coords sonderfall [expr $xG-$rS] [expr $yG-$rS] [expr $xG+$rS] [expr $yG+$rS]
          }
        }
        t_wait bewegeGetriebe
        if {$irunMaxI == 0} then {
            TStopTrochoide
            set irunStep 0
            break
        }
    }

    TmodifyThickness
    set irunStep 0
    #t_wait bewegeGetriebe
}
######################################################
proc modifyGetriebe {wc rR} {

    global phi_ rG_ m_ gamma0_ a_ rB_ rUe_ iZ iN massstab rS showFelder
    global showGetriebe
    global TShowBall TShowGang TShowUeber TShowSonder TShowRast TShowKK
    global phi_grad Pi

    set return ""
    #if {$showGetriebe == 0} then {
    #    return
    #}

    if {$iZ > 0} then {
         set signiZ 1
    } else {
         set signiZ -1
    }
    
    #set phi_ [expr $phi_grad*$Pi/180.]

    set xR [expr $signiZ*abs($rR)*cos($phi_)]
    set yR [expr $signiZ*abs($rR)*sin($phi_)]
    set xG [expr $rG_*$m_*cos($phi_)]
    set yG [expr $rG_*$m_*sin($phi_)]
    set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
    set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
    
    if {$showGetriebe != 0 || $TShowRast != 0} then {
        $wc coords rast [expr -$rR] [expr -$rR] $rR $rR
    }

    if {$showGetriebe != 0} then {
        VerschiebeKnoten $wc 2 [expr $xR-[xLiesKnotenMittelpunkt $wc 2] ] [expr $yR-[yLiesKnotenMittelpunkt $wc 2] ]

        VerschiebeKnoten $wc 3 [expr $xG-[xLiesKnotenMittelpunkt $wc 3] ] [expr $yG-[yLiesKnotenMittelpunkt $wc 3] ]

        VerschiebeKnoten $wc 4 [expr $x-[xLiesKnotenMittelpunkt $wc 4] ] [expr $y-[yLiesKnotenMittelpunkt $wc 4] ]
        $wc delete gestell
        set return [TCreateGestellRast]
    }
    #if {$showGetriebe != 0 || $TShowKK != 0} then {
    #    VerschiebeKnoten $wc 4 [expr $x-[xLiesKnotenMittelpunkt $wc 4] ] [expr $y-[yLiesKnotenMittelpunkt $wc 4] ]
    #}

    if {$showGetriebe != 0 || $TShowGang != 0} then {
        $wc coords gang [expr $xG-$rG_] [expr $yG-$rG_] [expr $xG+$rG_] [expr $yG+$rG_]
    }
    if {$showGetriebe != 0 || $TShowBall != 0} then {
        #tk_messageBox -message "showGetriebe=$showGetriebe != 0 || TShowBall=$TShowBall != 0"
        $wc coords ball [expr $xG-$rB_] [expr $yG-$rB_] [expr $xG+$rB_] [expr $yG+$rB_]
    }
    if {$showGetriebe != 0 || $TShowUeber != 0} then {
        set iU 1
        while {$iU<=$rUe_(0)} {
    	    $wc coords kUe$iU [expr $xG-$rUe_($iU)] [expr $yG-$rUe_($iU)] \
    	    [expr $xG+$rUe_($iU)] [expr $yG+$rUe_($iU)]
    	    if {$showGetriebe != 0} then {
    	        $wc coords kUefill$iU [expr $xG-$rUe_($iU)] [expr $yG-$rUe_($iU)] \
    	        [expr $xG+$rUe_($iU)] [expr $yG+$rUe_($iU)]
    	    }
    	    set iU [expr $iU+1]
        }
    }
    if {[expr $iZ/2.] != [expr int($iZ/2.)]} then {
      if {$showFelder == 1 || $TShowSonder != 0} then {
        # Kreis "sonderfall" soll verschoben werden
        # Radius berechnen
        #tk_messageBox -message "Kreis 'sonderfall' soll verschoben werden"
        set rS [expr abs($iZ+$iN)*$massstab]
        $wc coords sonderfall [expr $xG-$rS] [expr $yG-$rS] [expr $xG+$rS] [expr $yG+$rS]
      }
    }
    TmodifyThickness
    return $return
}
###############################################################
proc calculatePara {iZ_dummy iN_dummy rR} {
global i_ m_ rG_ iZ iN 

if {$iZ<0 && $iN>0} {
if {abs($iZ)<=abs($iN)} then {
    set iZ [expr -($iN+1)]
}
set rR [expr -abs($rR)]
} else {
set rR [expr abs($rR)]
}

set i_ [expr $iZ/$iN]
set m_ [expr $i_+1]
set rG_ [expr $rR*$iN/$iZ]
}
##########################################################
proc setGetriebetyp {iZ iN} {
# Variable iTyp_ mit Namen des Getriebetyps belegen
global iTyp_ 
if {$iZ >0 && $iN >0} {
set iTyp_ Epitrochoide
} elseif {$iZ >0 && $iN <0} {
set iTyp_ Peritrochoide
} elseif {$iZ <0 && $iN >0} {
set iTyp_ Hypotrochoide
} else {
set iTyp_ "nicht definiert"
}
TLowerKurven
}
######################################################
proc calculateKueKb {dxfFile wc iN iZ Pi rR} {
# Durchmesser von Kue und Kb ermitteln
global m_ rG_ rUe_ rB_ m_ phi_ gamma0_ rB_massstab massstab
global ns0_ ns_ nsUe_ type_ iN_M iZ_M a_massstab
global showFelder showFelderOld nW_ kUeArray rS rS_M
global Android
global TShowUeber TShowSonder

# Mittelpunkt der Uebergangskreise berechnen
set xG [expr $rG_*$m_*cos($phi_)]
set yG [expr $rG_*$m_*sin($phi_)]

set i [expr $iZ/$iN]
if {$iZ >0} {
# Epitrochoide oder Peritrochoide
    set niMax [expr int($iZ/2)]
} else {
# Hypotrochoide
    set niMax [expr int(abs(2*$iN+$iZ)/2)]
}

# Alle Uebergangskreise ni berechnen
set ni [expr $niMax+1]
if {$showFelderOld == 0} then {
    # showFelderOld wird nirgendwo gesetzt
    set ni_old 0
} elseif {$dxfFile == "no"} then {
    set ni_old $rUe_(0)
} else {
    set ni_old 0
}
set rUe_(0) [expr $ni-1]
# nicht mehr benoetigte Uebergangskreise entfernen
#tk_messageBox -message "[array names kUeArray]\nrUe_(0)=$rUe_(0)"
#if {$showFelder == 0} then {
    # alle Uebergangskurven lschen
    set rUeMax 0
#} else {
    # nur die ueberzaehligen Uebergangskurven lschen
#    set rUeMax $rUe_(0)
#}
foreach dummy [array names kUeArray] {
    if {$dummy >= $rUeMax} {
        if {$dxfFile == "no"} then {
            #tk_messageBox -message "kUe$dummy"
            $wc delete "kUe$dummy"
            $wc delete "kUefill$dummy"
        }
    }
}
#set dummy $ni_old
#while {$dummy>$rUe_(0)} {
#    if {$dxfFile == "no"} then {
#        $wc delete "kUe$dummy"
#        $wc delete "kUefill$dummy"
#    }
#    set dummy [expr $dummy-1]
#}

# Ballscher Kreis
set rB_ [round3 [expr abs($rG_/$m_)]]
set rB_massstab [expr $rB_/$massstab]

#if {$showFelder == 0} then {
#    set dummy $rUe_(0)
#    while {$dummy>0} {
#         if {$dxfFile == "no"} then {
#             $wc delete "kUe$dummy"
#             $wc delete "kUefill$dummy"
#         }
#         set dummy [expr $dummy-1]
#    }
#    #set rUe_(0) 0
#    #return
#}

while {$ni>1} {
    set ni [expr $ni-1]
    if {$iN<0} {
      set signiN -1
    } else {
      set signiN 1
    }
    set gamma0 [expr -$signiN*$i*$Pi*(0.5-$ni/$iZ)]
    #tk_messageBox -message "gamma0=$gamma0, -$signiN*$i*$Pi=[expr -$signiN*$i*$Pi], 0.5-$ni/$iZ=[expr 0.5-$ni/$iZ]"
    if {$iZ >0 && $iN >0} {
# Epitrochoide
        set PhiMin [expr $Pi/$m_*($i/2-$ni/$iN)]
        set PhiMax [expr -$ni*$Pi/$iZ+$Pi/2]
        set Phi1 [expr $PhiMin+($PhiMax-$PhiMin)/4]
        #tk_messageBox -message "gamma0=$gamma0\nPhiMin=$PhiMin\nPhiMax=$PhiMax\nPhi1=$Phi1\nPi/m=[expr $Pi/$m_]\n(i/2-ni/iN)=[expr ($i/2-$ni/$iN)]"
    } elseif {$iZ >0 && $iN <0} {
# Peritrochoide
        set Phi1 [expr $Pi/(2*$iZ*$ni)]
    } elseif {$iZ <0 && $iN >0} {
# Hypotrochoide
        if { [expr abs($iZ/$iN)] < 2 } {
            set Phi1 [expr $Pi/4]
        } else {
            set PhiMin [expr -$ni*$Pi/$iZ+$Pi/2]
            set PhiMax [expr $Pi/$m_*($i/2-$ni/$iN)]
#	    set Phi1 [expr $PhiMin+($PhiMax-$PhiMin)*3/4]
            set Phi1 [expr $PhiMax-($PhiMax-$PhiMin)/4]
            #tk_messageBox -message "Phi1=$Phi1, PhiMin=$PhiMin, PhiMax=$PhiMax\n[expr $Pi/$m_] * [expr $i/2-$ni/$iN], i/2=[expr $i/2], ni/i=[expr $ni/$iN]\nPi/m=[expr $Pi/$m_],ni/in=[expr $ni/$iZ]\n$ni*$Pi/$iZ=[expr $ni*$Pi/$iZ]"
        }
    }
    set Phi2 $Phi1
    set Phi1 -1
#set nn 0
    while { [expr abs($Phi1-$Phi2)]>0.000001} {
      set Phi1 $Phi2
      set tanm [expr tan($m_*$Phi1+$gamma0)]
      set tanp [expr tan($Phi1)]
      set Nenner [expr $m_*$m_*(1+$tanm*$tanm)-1-$tanp*$tanp]
      set Phi2 [expr $Phi1-($m_*$tanm-$tanp)/$Nenner]
      #tk_messageBox -message "Phi1=$Phi1\nPhi2=$Phi2\ntanm=$tanm\ntanp=$tanp\Nenner=$Nenner"
      #if {$iZ <0 && $iN >0} {
      #    tk_messageBox -message "tanm=$tanm, tanp=$tanp, Nenner=$Nenner, gamma0=$gamma0, m*Phi1=[expr $m_*$Phi1], Phi2=$Phi2\nPhi1=$Phi1, zaehler=[expr $m_*$tanm-$tanp]"
      #}
#set nn [expr $nn+1]
    }
    set cosm [expr cos($m_*$Phi2+$gamma0)]
    if { [expr abs($cosm)]<0.0001 && [expr abs($Phi2)]>0.0001} {
        set sinm [expr sin($m_*$Phi2+$gamma0)]
        set rUe_($ni) [round3 [expr abs($rG_*sin($Phi2)/$sinm)]]
        #tk_messageBox -message "1 rUe=[expr abs($rG_*sin($Phi2)/$sinm)]\nrG*sin(Phi2)=[$rG_*sin($Phi2)]\nsinm=$sinm\ncosm=$cosm"
    } else {
#        set rUe_($ni) [expr abs(-($rR+$rG_)*cos($Phi2)/$cosm)]
        if {$iZ > 0} then {
            set signiZ 1
        } else {
            set signiZ -1
        }
        set rUe_($ni) [round3 [expr abs(-($signiZ*$rR+$rG_)*cos($Phi2)/$cosm)]]
        #tk_messageBox -message "2 rUe=[expr abs((5.+1.)*cos($Phi2)/$cosm)]\ncosm=$cosm\ncos(Phi2)=[expr cos($Phi2)]\nPhi1=$Phi1\nPhi2=$Phi2\ntanm=$tanm\ntanp=$tanp\Nenner=$Nenner"
    }

    set xMin [expr $xG-$rUe_($ni)]
    set yMin [expr $yG-$rUe_($ni)]
    set xMax [expr $xG+$rUe_($ni)]
    set yMax [expr $yG+$rUe_($ni)]
    #if {$ni > $ni_old} then {
    if {$showFelder == 1 || $TShowUeber != 0} then {
        set mi $ni
        while {$mi > 4} {
             set mi [expr $mi - 4]
        }
        #tk_messageBox -message createOval
        if {$dxfFile == "no" && $TShowUeber == 0} then {
            dxfKreis $wc $dxfFile [expr 20+$ni] orange$mi $xMin $yMin $xMax $yMax \
                kUefill$ni orange$mi
            set kueColor brown

            #$wc addtag "kUeALL" withtag kUe$ni
            $wc lower kUefill$ni
        } else {
            set kueColor orange$mi
        }
        dxfKreis $wc $dxfFile [expr 20+$ni] blue $xMin $yMin $xMax $yMax kUe$ni ""
        if {$TShowUeber == 2} then {
            catch {$wc itemconfigure kUe$ni -dash {2 4}}
        }

        set kUeArray($ni) 1
    }
    #} else {
    #    if {$dxfFile == "no"} then {
    #        $wc coords kUe$ni $xMin $yMin $xMax $yMax
    #        $wc coords kUefill$ni $xMin $yMin $xMax $yMax
    #    }
    #}

    if {$dxfFile == "no"} then {
        if {$Android != 1} then {
            $wc bind kUe$ni <Any-Enter> \
                "TBindUeIn $ni $wc"
            $wc bind kUe$ni <Any-Leave> \
                "TBindUeOut $ni $wc"
            set befehl "$rUe_($ni)"
            $wc bind kUe$ni <Button-1> \
                "setAkUe $rUe_($ni) $wc $Pi"
            $wc bind kUe$ni <Button-3> \
                "setAkUe $rUe_($ni) $wc $Pi"
        }
    }
}
# Sonderfall: Kreis um Mittelpunkt des umlaufenden Rades und durch Mittelpunkt des feststehenden Rades
$wc delete sonderfall
if {[expr $iZ/2.] != [expr int($iZ/2.)] && $iZ_M > 1} then {
    # Sonderfall soll ermittelt werden
    #tk_messageBox -message "iZ=$iZ, iN=$iN, iN_M=$iN_M, iZ_M=$iZ_M"
    # Radius berechnen
    set rS [expr abs($iZ+$iN)*$massstab]
    set rS_M "Radius = [expr abs($iZ+$iN)]"
    if {$showFelder == 1 || $TShowSonder != 0} then {
      dxfKreis $wc $dxfFile 19 magenta [expr $xG-$rS] [expr $yG-$rS] [expr $xG+$rS] [expr $yG+$rS] sonderfall ""
    }
    if {$showFelder == 1 || $TShowSonder == 2} then {
        # gepunktet
        catch {$wc itemconfigure sonderfall -dash {2 4}}
    }
    # gestrichelt
    #$wc itemconfigure -dash {6 4}
} else {
    set rS_M "existiert nicht"
}
menuMbarGrafikMenuKurven

set nW_ [expr 2*$iZ_M]

# Anzahl Schnittpunkte
if {($type_ == "Epitrochoide") || \
($type_ == "Hypotrochoide" && [expr $iZ_M/$iN_M] > 2)} then {
    set ns0_ [expr ($iN_M-1)*$iZ_M]
} else {
    set ns0_ [expr (abs($iN_M-$iZ_M)-1)*$iZ_M]
}
#set ns_ [expr $ns0_+$iZ_M]
set ns_ [expr $ns0_+abs($iZ_M)]
set i 1
while {$i < $rUe_(0)} {
#   set nsUe_($i) [expr abs(int($ns0_+(1+ 2* $i)*$iZ))]
    set nsUe_($i) [expr int(abs($ns0_+(1+ 2* $i)*abs($iZ)))]
    set i [expr $i+1]
}
set i $rUe_(0)
if {$i >0} then {
    if {$iZ_M%2 == 0} then {
#       set nsUe_($i) [expr abs(int([expr $ns0_+2* $i*$iZ]))]
        set nsUe_($i) [expr int(abs([expr $ns0_+2* $i*abs($iZ)]))]
    } else {
#       set nsUe_($i) [expr abs(int($ns0_+(1+ 2* $i)*$iZ))]
        set nsUe_($i) [expr int(abs($ns0_+(1+ 2* $i)*abs($iZ)))]
    }
}

T_KueStatus
TSetSchnittBlue
}
#########################################################
proc TSetSchnittBlue {} {
global type_ iZ_M iN_M a_massstab rUe_ massstab showFelder
global rB_massstab wc showSingleFeld rG_

#if {$showFelder== 0} then {
#    return
#}
#tk_messageBox -message "start TSetSchnittBlue"

#if {$showFelder != 0} then {
    set i $rUe_(0)
    while {$i>0} {
        .c.f.ns.u$i configure -foreground black
        set i [expr $i-1]
    }
    .c.f.ns.s1 configure -foreground black
    .c.f.ns.s2 configure -foreground black
#}
#Anzahl an Schnittpunkten blau einfaerben
set faerben "not ok"
if {($type_ == "Epitrochoide") || \
    ($type_ == "Hypotrochoide" && [expr $iZ_M/$iN_M] > 2)} then {
    #if {$showFelder != 0} then {
        if {[expr abs($a_massstab)]<=$iN_M} then {
            #if {$showFelder != 0} then {
                .c.f.ns.s1 configure -foreground Red
                set faerben "ok"
                if {$showFelder != 0} then {
                  if {$showSingleFeld == 1} then {
                    #if {[expr abs($rG_/$massstab)]>[expr abs($a_massstab)]} then {
                        # Feld der BALLschen Kurve ggf. umfaerben (sichtbar)
                        $wc itemconfigure ball -outline red -fill GreenYellow
                        # Feld der 1. Uebergangs-Kurven ggf. umfaerben (unsichtbar)
                        $wc itemconfigure kUefill1 -outline white -fill white
                    #} else {
                    #    # Feld der BALLschen Kurve ggf. umfaerben (unsichtbar)
                    #    $wc itemconfigure ball -outline yellow -fill yellow
                    #    tk_messageBox -message "okokxxx"
                    #}
                  }
                }
            #}
        } else {
            if {$showFelder != 0} then {
                if {$showSingleFeld == 1} then {
                    # Feld der BALLschen Kurve ggf. umfaerben (unsichtbar)
                    $wc itemconfigure ball -outline yellow -fill yellow
                    # Feld der Uebergangs-Kurven ggf. umfaerben (unsichtbar)
                    set i $rUe_(0)
                    while {$i>0} {
                        $wc itemconfigure kUefill$i -outline white -fill white
                        $wc lower kUe$i
                        incr i -1
                    }
                    if {[expr abs($a_massstab)] <= [expr abs($rUe_(1)/$massstab)]} then {
                        # Feld der 1. Uebergangs-Kurven ggf. umfaerben (sichtbar)
                        $wc itemconfigure kUefill1 -outline orange1 -fill orange1
                    }
                }
            }
            #tk_messageBox -message "start faerben TSetSchnittBlue, faerben=$faerben"
            set i $rUe_(0)
            while {$i>0} {
            	if {[expr abs($rUe_($i)/$massstab)]<[expr abs($a_massstab)]} then {
            	    if {$faerben == "not ok"} then {
                            .c.f.ns.u$i configure -foreground Red
                            set faerben "ok"
                            if {$showSingleFeld == 1} then {
                            #    tk_messageBox -message "i=$i"
                                 set ni [expr $i+1]
                                 if {$ni > $rUe_(0)} then {
            	                 # Punkt liegt auerhalb der aeusseren Uebergangskurve.
                                     # Also aeusserste Uebergangskurve einfaerben
                                     set ni $i
                                 }
                                 set mi $ni
                                 while {$mi > 4} {
                                       set mi [expr $mi - 4]
                                 }
            	             # Feld der Uebergangskurve ggf. umfaerben (sichtbar)
            	             $wc itemconfigure kUefill$ni -outline orange$mi -fill orange$mi
                            }
                        }
            	    break
            	}
            	incr i -1
            }
            #tk_messageBox -message "beende faerben TSetSchnittBlue"
        }
        if {$faerben == "not ok"} then {
            .c.f.ns.s2 configure -foreground Red
        }
    #}
    if {[expr abs($a_massstab)]>[expr abs($rB_massstab)] && \
    [expr abs($a_massstab)]<$iN_M } then {
        .c.f.w.l4 configure -foreground Red
        .c.f.w.l2 configure -foreground black
        #if {$showSingleFeld == 1} then {
        #    $wc itemconfigure ball -outline red -fill GreenYellow
        #}
    } else {
        .c.f.w.l4 configure -foreground black
        .c.f.w.l2 configure -foreground Red
        #if {$showSingleFeld == 1} then {
        #    $wc itemconfigure ball -outline yellow -fill yellow
        #}
    }
} else {
    # Peritrochoide
    #if {$showFelder != 0} then {
        if {[expr abs($a_massstab)]>=$iN_M} then {
            .c.f.ns.s1 configure -foreground Red
            set faerben "ok"
            if {$showFelder != 0} then {
                #if {$showSingleFeld == 1} then {
                #    # # Feld der BALLschen Kurve ggf. umfaerben (sichtbar)
                #    $wc itemconfigure ball -outline red -fill GreenYellow
                #}
                if {$showSingleFeld == 1} then {
                        # Feld der BALLschen Kurve ggf. umfaerben (sichtbar)
                        $wc itemconfigure ball -outline red -fill GreenYellow
                        # Feld der 1. Uebergangs-Kurven ggf. umfaerben (unsichtbar)
                        $wc itemconfigure kUefill1 -outline lightgrey -fill lightgrey
                }
            }
        } else {
            if {$showFelder != 0} then {
                #if {$showSingleFeld == 1} then {
                #    # # Feld der BALLschen Kurve ggf. umfaerben (unsichtbar)
                #    $wc itemconfigure ball -outline white -fill white
                #}
                if {$showSingleFeld == 1} then {
                    # Feld der BALLschen Kurve ggf. umfaerben (unsichtbar)
                    $wc itemconfigure ball -outline white -fill white
                    # Feld der Uebergangs-Kurven ggf. umfaerben (unsichtbar)
                    set i $rUe_(0)
                    while {$i>0} {
                        $wc itemconfigure kUefill$i -outline lightgrey -fill lightgrey
                        $wc lower kUe$i
                        incr i -1
                    }
                    if {[expr abs($a_massstab)] > [expr abs($rUe_(1)/$massstab)]} then {
                        # Feld der 1. Uebergangs-Kurven ggf. umfaerben (sichtbar)
                        $wc itemconfigure kUefill1 -outline orange1 -fill orange1
                    }
                }
            }
            #tk_messageBox -message "start faerben TSetSchnittBlue, faerben=$faerben"
            set i $rUe_(0)
            while {$i>0} {
            	if {[expr abs($rUe_($i)/$massstab)]>[expr abs($a_massstab)]} then {
            	    if {$faerben == "not ok"} then {
                            .c.f.ns.u$i configure -foreground Red
                            set faerben "ok"
                            if {$showSingleFeld == 1} then {
                            #    tk_messageBox -message "i=$i"
                                 #set ni [expr $i+1]
                                 set ni $i
                                 if {$ni > $rUe_(0)} then {
            	                 # Punkt liegt auerhalb der aeusseren Uebergangskurve.
                                     # Also aeusserste Uebergangskurve einfaerben
                                     #set ni $i
                                     set ni [expr $i-1]
                                 }
                                 set mi $ni
                                 while {$mi > 4} {
                                       set mi [expr $mi - 4]
                                 }
            	             # Feld der Uebergangskurve ggf. umfaerben (sichtbar)
            	             $wc itemconfigure kUefill$ni -outline orange$mi -fill orange$mi
                            }
                    }
            	    break
            	}
            	incr i -1
            }
            #tk_messageBox -message "Ende faerben TSetSchnittBlue, faerben=$faerben"
        }
        if {$faerben == "not ok"} then {
            .c.f.ns.s2 configure -foreground Red
        }
    #}
    if {[expr abs($a_massstab)]<[expr abs($rB_massstab)] && \
    [expr abs($a_massstab)]>$iN_M } then {
        .c.f.w.l4 configure -foreground Red
        .c.f.w.l2 configure -foreground black
        #if {$showSingleFeld == 1} then {
        #    $wc itemconfigure ball -outline red -fill GreenYellow
        #}
    } else {
        .c.f.w.l4 configure -foreground black
        .c.f.w.l2 configure -foreground Red
        #if {$showSingleFeld == 1} then {
        #    $wc itemconfigure ball -outline white -fill white
        #}
    }
}
#tk_messageBox -message "beende TSetSchnittBlue"
}
#########################################################
proc setAkUe {wert wc Pi} {

    global a_ m_ iN rG_
    global phi_ gamma0_

    set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
    set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
    if {[expr abs($x)]>[expr abs($y)]} then {
    set steigung_old [expr $y/$x]
    } else {
    set steigung_old [expr $x/$y]
    }
    
    set a_ $wert
    
    set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
    set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
    if {[expr abs($x)]>[expr abs($y)]} then {
    set steigung [expr $y/$x]
    } else {
    set steigung [expr $x/$y]
    }
    
    if {[expr $steigung_old*$steigung] < 0} then {
    #Gamma0 aenderte sich um 180 Grad
    set a_ -$a_
    }
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    TSetSchnittBlue
}
#############################################################
proc TBindUeOut {ni wc} {
global statuszeile

$wc itemconfigure kUe$ni -width 1
setStatuszeile " "
}
#############################################################
proc TBindUeIn {ni wc} {
global statuszeile

$wc itemconfigure kUe$ni -width 2
setStatuszeile "'Linke Maustaste' verlegt erzeugenden Punkt auf diese Uebergangskurve"
}
#############################################################
proc TZoomAll {} {

    global massstab a_massstab canvas_height canvas_width
    global last_massstab rB_massstab rUe_ iZ iN a_

    TprepareRestart

	    set last_massstab $massstab
	    set width [min $canvas_height  $canvas_width]
	    set a [max [expr abs($rB_massstab)] [expr abs($a_massstab)]]
	    if {$rUe_(0)>0} then {
	        set a [max $a [expr abs($rUe_(1))/$massstab]]
	        set a [max $a [expr abs($rUe_($rUe_(0)))/$massstab]]
	    }
	    set massstab [expr ($width-10)/2./(abs($iZ+$iN)+$a)]
	    set a_ [expr $a_massstab*$massstab]
	    TSetI
	    xyViewDefault

    TRestartTrochoide
}
############################################################
proc TshowGrafikWithModifiedWidth {} {

    global wc showGetriebe showGestell showGestellRast

    #foreach item "rast gang ball t rR rG_ K S Trochoide Gestell gestell" {
    #    $wc delete $item
    #}
    destroy $wc
    T_Grafik
    T_Bind $wc    
    TshowGrafik
    
    set showGetriebe 1
    set showGestell 1
    set showGestellRast 1
}
#############################################################
proc T_Grafik_special {} {
    xyViewDefault
}
#############################################################
proc TSetZoomFenster_special {} {
    global a_ a_massstab massstab

    set a_ [expr $a_massstab*$massstab]
    TSetI
}
#############################################################
proc TShowSingleFeldeinteilung {} {

    global showSingleFeld rUe_ wc
    
    #tk_messageBox -message "showSingleFeld=$showSingleFeld"

    TShowFeldeinteilung

    set i $rUe_(0)
    while {$i>0} {
        $wc lower kUe$i
        incr i -1
    } 
}
################################################################################
proc TShowFeldeinteilung2 {} {

    global showFelder showOnlyKurven TShowBall TShowGang TShowUeber TShowSonder TShowRast TShowKK

    if {$showFelder == 0} then {
        incr showFelder
    } else {
        set showFelder 0
    }

    set showOnlyKurven 0
    set TShowBall 0
    set TShowGang 0
    set TShowUeber 0
    set TShowSonder 0
    set TShowRast 0
    set TShowKK 0

    TShowFeldeinteilung
}
#############################################################
proc TShowKurven {} {

    global showFelder
    global showOnlyKurven TShowBall TShowGang TShowUeber TShowSonder TShowRast TShowKK

    set showFelder 0
    if {$TShowBall > 0} then {
        set showOnlyKurven 1
    } elseif {$TShowGang > 0} then {
        set showOnlyKurven 1
    } elseif {$TShowUeber > 0} then {
        set showOnlyKurven 1
    } elseif {$TShowSonder > 0} then {
        set showOnlyKurven 1
    } elseif {$TShowRast > 0} then {
        set showOnlyKurven 1
    } elseif {$TShowKK > 0} then {
        set showOnlyKurven 1
    } else {
        set showOnlyKurven 0
    }
    TShowFeldeinteilung
}
#############################################################
proc TShowFeldeinteilung3 {} {

    global showOnlyKurven TShowBall TShowGang TShowUeber TShowSonder TShowRast TShowKK

    set showOnlyKurven 0
    set TShowBall 0
    set TShowGang 0
    set TShowUeber 0
    set TShowSonder 0
    set TShowRast 0
    set TShowKK 0

    TShowFeldeinteilung
}
#############################################################
proc TShowFeldeinteilung {} {

    global kueStatus wc iN iZ Pi rR m_ gamma0_ showFelder xG yG rB_ showSingleFeld
    global showOnlyKurven TShowBall TShowGang TShowUeber TShowSonder

    set kueStatus "not ok"

    if {$showOnlyKurven == 1} then {
        # keine Felder einfaerben
        if {$TShowBall >= 1} then {
            # nur BALLsche Kurve ohne Ring erzeugen
            #tk_messageBox -message "BALLsche Kurve ohne Ring"
            catch {$wc delete ball}
            dxfKreis $wc "no" 14 red [expr $xG-$rB_] [expr $yG-$rB_] \
                [expr $xG+$rB_] [expr $yG+$rB_] ball ""
            if {$TShowBall == 2} then {
                catch {$wc itemconfigure ball -dash {2 4}}
            }
        }
    } elseif {$showFelder == 0} then {
        # showFelderOld wird nicht als globale Variable weitergegeben
        set showFelderOld 1
        $wc delete ball
	$wc delete sonderfall
	set showSingleFeld 0
    } else {
        # showFelderOld wird nicht als globale Variable weitergegeben
        set showFelderOld 0
        # BALLsche Kurve mit Ring erzeugen
        #tk_messageBox -message "BALLsche Kurve mit Ring, kurve=$kurve"

        catch {$wc delete ball}
        dxfKreis $wc "no" 14 red [expr $xG-$rB_] [expr $yG-$rB_] \
        [expr $xG+$rB_] [expr $yG+$rB_] ball GreenYellow
    }

    TPullDownMenuUpdate

    TStatusFelder

    calculateKueKb "no" $wc $iN $iZ $Pi $rR
    modifyGetriebe $wc $rR
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    setGetriebetyp $iZ $iN
    
    TLowerKurven
    return ok
}
#############################################################
proc TShowTrochoide {} {

    global wc showTrochoide iTyp_ showFelder

    #set showTrochoide 0
    destroy $wc
    T_Grafik

    T_Bind $wc

    TshowGrafik

    if {$showTrochoide == 1} then {
        #recreateTrochoide no
    } else {
        $wc delete "Trochoide"
    }
    #if {$iTyp_ == "Hypotrochoide"} then {
        #$wc lower rG_
        #$wc lower rR
    #}

    TLowerKurven
}
#############################################################
proc TShowGetriebeUmrisse {} {

    global wc showGestell showGestellRast

    set showGestell 0
    set showGestellRast 0
    destroy $wc
    T_Grafik
    T_Bind $wc    
    TshowGrafik
    $wc delete "Gestell"
    $wc delete "gestell"
    $wc lower rG_
    $wc lower rR
    TLowerKurven
    menuMbarGrafikMenuKurven
}
################################################################
proc TShowGetriebe {} {

    global kueStatus wc iN iZ Pi rR m_ gamma0_  xG yG rB_ showGetriebe
    global lineWidth showGestell showGestellRast
    global TShowGang TShowRast TShowKK

    set kueStatus "not ok"

    if {$showGetriebe == 0} then {
	TStopTrochoide

	set showGestell 0
	set showGestellRast 0
	TShowGestell
	TShowGestellRast
	
	#Knoten $wc $x $y t $dxfFile
        #Kante $wc 1 2 rR rr $dxfFile 0 0 $xP $yP
        #Kante $wc 2 3 rG_ rg_ $dxfFile $xP $yP $xG $yG
        #Kante $wc 3 4 K k  $dxfFile $xG $yG $x $y

        $wc delete rR
        $wc delete rr
        $wc delete rG_
        $wc delete rg_
        if {[info exists TShowKK] == 1 && $TShowKK != 0} then {
            # Erzeugenden Punkt zeigen
        } else {
            $wc delete t
        }
        $wc delete k
        $wc delete K
        if {[info exists TShowRast] == 1 && $TShowRast != 0} then {
            # -Rastpolkurve zeigen
        } else {
            $wc delete rast
        }
        if {[info exists TShowGang] == 1 && $TShowGang != 0} then {
            # Gangpolkurve zeigen
        } else {
            $wc delete gang
        }
    } else {
        set lineWidth 0
        #TshowGrafik
        TcreateDXF "no"
        TshowGrafikWithModifiedWidth
        set TShowGang 0
        set TShowRast 0
        set TShowKK 0
    }
    menuMbarGrafikMenuKurven

    return ok
}
##############################################################
proc TupdateGetriebe {} {
 
    global wc

    destroy $wc
    T_Grafik
    T_Bind $wc
    TshowGrafik
    TsetRadiusAchsen 0
}
#############################################################
proc TsetRadiusAchsen {{update 1}} {

    global wc iN Pi
    global pradi_ pradi_old
    
    if {$update == 1} then {
        set pradi_old $pradi_
    }
    
    TCreateEntryButton " " TupdateGetriebe {set pradi_ $pradi_old} 6 \
	{"Radius der Radachsen" pradi_}
}
#############################################################
proc TChangeGeschwindigkeit2 {} {

    global ischritte_ igeschw_
    
    TStopTrochoide
    set ischritte_ [expr int($ischritte_/$igeschw_)]
    destroy .toplevelpara
    TRunTrochoide -1 1
}
#############################################################
proc TChangeGeschwindigkeit {} {

    global ischritte_ ischritte_old igeschw_

    set ischritte_old $ischritte_
    set igeschw_ 2

    TCreateEntryButton " " TChangeGeschwindigkeit2 \
        {set ischritte_ $ischritte_old} 6 \
	{"Getriebegeschwindigkeit: (1=nicht_aendern, 2=verdoppeln, 0.5=halbieren)" igeschw_}
    TShowSubwindow  {100} {40} {Getriebegeschwindigkeit}
}
#############################################################
proc TSetSchritte {} {

    global ischritte_ ischritte_old iT iT_old
    global wc iN Pi

    set ischritte_old $ischritte_
    set iT_old $iT

    TCreateEntryButton " " {createTrochoide $wc $iN $Pi
	TSetI} {set iT $iT_old
	set ischritte_ $ischritte_old} 6 \
	{"Bewegung: Anzahl Schritte je Stegumdrehung:" ischritte_} \
	{"Darstellung: Anzahl Schritte je Stegumdrehung:" iT}
    TShowSubwindow  {100} {40} {Schritte je Stegumdrehung}
}
#############################################################
proc TSetRr {} {
    global iZ iN rR wc Pi m_ gamma0_ 

    calculatePara $iZ $iN $rR
    calculateKueKb "no" $wc $iN $iZ $Pi $rR
    modifyGetriebe $wc $rR
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    setGetriebetyp $iZ $iN
    return ok
}
#############################################################
proc TLowerKurven {} {
    global wc type_ iZ iN rUe_ pradi_ rB_ rG_ rR

    if {$type_ == "Epitrochoide"} then {
#	if {[expr abs($iZ)] > [abs($iN)]} then {
	    $wc lower ball
	    $wc lower gang
	    $wc lower rast
	    set kurve 1
	    while {$kurve <= $rUe_(0)} {
		$wc lower kUefill$kurve
		set kurve [expr $kurve+1]
            }
#	} else {
#       }
    } elseif {$type_ == "Peritrochoide"} then {
	set kurve $rUe_(0)
        while {$kurve > 0} {
	    $wc lower kUefill$kurve
            set kurve [expr $kurve-1]
        }
	$wc lower rast
        set diff [expr $rG_-2*(abs($rG_)-abs($rR))]
	set kurve $rUe_(0)
        while {$kurve > 0} {
            if {([expr abs($rUe_($kurve))] < $diff)  ||  \
            ([expr abs($rUe_($kurve))] > [expr abs($rR)/2.])} then {
		$wc lower kUefill$kurve
	    }
	    set kurve [expr $kurve-1]
        }
	$wc lower gang
	$wc lower ball
    } else {
	if {[expr abs($iZ/$iN)] <2} then {
	set kurve 1
        while {$kurve <= $rUe_(0)} {
	    $wc lower kUefill$kurve
            set kurve [expr $kurve+1]
        }
	    $wc lower gang
	    $wc lower rast
	    $wc lower ball
	} else {
	    $wc lower ball
	    $wc lower gang
	    $wc lower rast
	    set kurve 1
	    while {$kurve <= $rUe_(0)} {
		$wc lower kUefill$kurve
		set kurve [expr $kurve+1]
	    }
	}
    }
    if {$pradi_ >= $rB_} then {
	$wc raise ball
    }
    $wc lower rr-
    $wc lower rg_-
    
    $wc raise sonderfall
}

#############################################################
proc TSetType {} {

    global type_ typeOld_ rG_ rR a_ a_massstab massstab wc
    global iZ iN m_ gamma0_ wc rR Pi iZ_A iN_A showFelder

     if {$type_ == "Peritrochoide"} then {
        if {$iN_A < $iZ_A} then {
 	    set dummy $iN_A
 	    set iN_A $iZ_A
 	    set iZ_A $dummy
        } elseif {$iN_A == $iZ_A} then {
	    set iN_A [expr $iN_A-1]
        }
    } elseif {$type_ == "Hypotrochoide"} then {
        if {$iN_A > $iZ_A} then {
	    set dummy $iN_A
	    set iN_A $iZ_A
	    set iZ_A $dummy
        } elseif {$iN_A == $iZ_A} then {
	    set iZ_A [expr $iZ_A-1]
	}
    } elseif {$type_ == "DoppelteErzeugung"} then {
        set iN [expr -1*($iZ+$iN)]
        set iN_A [expr abs($iN)]
        if {$typeOld_ == "Hypotrochoide"} then {
            set type_ "Hypotrochoide"
            #tk_messageBox -message "a_massstab=$a_massstab\nrR=$rR\nrG_=$rG_"
            #set a_massstab [expr ($rR-$rG_)/$a_massstab*$rG_]
            set a_massstab [expr ($iZ_A-$iN_A)/$a_massstab*$iN_A]
            set a_ [expr $a_massstab*$massstab]
        } elseif {$typeOld_ == "Peritrochoide"} then {
            set type_ "Epitrochoide"
            #set a_massstab [expr ($iZ_A-$iN_A)/$a_massstab*$iN_A]
            set a_massstab [expr ($iZ_A+$iN_A)/$a_massstab*$iN_A]
            set a_ [expr $a_massstab*$massstab]
        } else {
            set type_ "Peritrochoide"
            set a_massstab [expr ($iZ_A-$iN_A)/$a_massstab*$iN_A]
            set a_ [expr $a_massstab*$massstab]
        }
        set iN_A [expr int($iN_A)]
        calculatePara $iZ $iN $rR
        calculateKueKb "no" $wc $iN $iZ $Pi $rR
        modifyGetriebe $wc $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
        setGetriebetyp $iZ $iN
    }

    set typeOld_ $type_
    
    set showFelderOld $showFelder
    set showFelder 0
    TShowFeldeinteilung

    set showFelder $showFelderOld
    TShowFeldeinteilung


    TSetI 
}
#############################################################
proc TRunTrochoide {Richtung geschw} {
    global iZ iN m_ gamma0_ wc rR Pi rG_ a_ phi_ statuszeile
    global RichtungBackup geschwBackup
    global Android

    set RichtungBackup $Richtung
    set geschwBackup $geschw

    setStatuszeile \
	    "Getriebe anhalten mit 'STOP'-Taste"
    if {$Android != 1} then {
        $wc bind Trochoide <Button-3> { TStopTrochoide }
        $wc bind Trochoide <Button-2> { TStopTrochoide }
        $wc bind Trochoide <Button-1> { TStopTrochoide }
    }

    bewegeGetriebe $wc phi_ $rG_ $rR $m_ $a_ $gamma0_ $Pi $Richtung \
	$geschw
    calculatePara $iZ $iN $rR
    modifyGetriebe $wc $rR
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    return ok
}
#############################################################
proc TStopTrochoide {} {
    global wc irunMaxI statuszeile

#   setStatuszeile "'Rechte Maustaste' startet Getriebe im \
#Uhrzeigersinn, 'Linke Maustaste' im Gegenuhrzeigersinn"
    set irunMaxI 0
#   $wc bind Trochoide <Button-1> { TRunTrochoide -1 1}
#   $wc bind Trochoide <Button-3> { TRunTrochoide +1 1}
}
#############################################################
proc TLeaverRrGKorTrochoide {ibind wc} {
    global pradi_ statuszeile rR rG_ rB_ type_

#    set tag [$wc gettags current]
    set tag $ibind
    $wc itemconfigure [lrange $tag 0 0] -width 1
    $wc raise Knoten
    if {$pradi_ >= $rB_} then {
	$wc raise ball
    }
    set tag2 [string tolower [lrange $tag 0 0] ] 
    $wc itemconfigure $tag2 -arrow none
    if {$type_ == "Hypotrochoide"} then {
        if {$tag2 == "rg_"} then {
            $wc lower $tag2
        } elseif {$tag2 == "rr"} then {
            $wc lower $tag2
        }
    }
    if {$tag2 != "k"} then {$wc lower $tag2-}
    
    setStatuszeile " "

    if {$ibind == "rR" || $ibind == "rG_"} then {
        #TSetrRrGwidth2
        if {$type_ != "Hypotrochoide"} then {
            $wc raise rG_
            $wc raise rR
        }  elseif {$ibind == "rR"} then {
            $wc raise rrHypo
        }
    }
}
#############################################################
#proc TSetrRrGwidth2 {} {
#    global rR rG_  wc
#
#    if {$rR < $rG_} then {
#	$wc raise rr
#	$wc itemconfigure rr -width 2
#    } else {
#	$wc raise rg_
#	$wc itemconfigure rg_ -width 2
#    }
#}
#############################################################
proc TRaiserRrGKorTrochoide {ibind wc} {
    global statuszeile
    set tag $ibind
    $wc itemconfigure [lrange $tag 0 0] -width 2 
    #tk_messageBox -message "ibind=$ibind"
    if {$ibind == "Trochoide"} then {
        setStatuszeile "Das ist die Trochoide"
    }
    $wc raise [string tolower [lrange $tag 0 0] ]
    $wc itemconfigure [string tolower [lrange $tag 0 0] ] \
 	    -arrow last
}
#############################################################
proc TEnterrRrGKorTrochoide {ibind wc} {
        global irunMaxI statuszeile
#        set tag [$wc gettags current]
        TRaiserRrGKorTrochoide $ibind $wc
        if {$ibind == "rR"} then {
            setStatuszeile "'Linke Maustaste' vergroessert Radius des feststehenden Rades, 'Rechte Maustaste' verkleinert ihn"
        } elseif {$ibind == "rG_"} then {
            setStatuszeile "'Linke Maustaste' vergroessert Radius des umlaufenden Rades, 'Rechte Maustaste' verkleinert ihn"
        } elseif {$ibind == "K"} then {
            setStatuszeile "'Linke/Rechte Maustaste' vergroessert/verkleinert Abstand 'Trochoiden-Punkt' - 'Mittelpunkt umlaufendes Rad'"
        } elseif {$irunMaxI > 0} then {
#	    setStatuszeile \
	    "'Rechte oder Linke Maustaste' halten Getriebe an"
	} else {
#           setStatuszeile "'Rechte Maustaste' startet Getriebe im \
Uhrzeigersinn, 'Linke Maustaste' im Gegenuhrzeigersinn"
	}
}
#############################################################
proc T_KueStatus {} {
    global  rUe_ massstab Pi wc ww kueStatus Android

    set w $ww.ue
    set kueStatus "ok"

    destroy $w.f.k1
    destroy $w.f
    destroy $w.fc

    frame $w.f
    pack $w.f -fill x -in $w -side top

    set i 1
    while {$i <= $rUe_(0)} {
        set rkUe [expr $rUe_($i)/$massstab]
        frame $w.f.k$i
        pack $w.f.k$i -fill x -in $w.f -side top -anchor n
        label $w.f.k$i.l1 -text "r" -bd 0
        pack $w.f.k$i.l1 -in $w.f.k$i -side left -anchor n
        label $w.f.k$i.l2 -text "Ue$i" -bd 0
        pack $w.f.k$i.l2 -in $w.f.k$i -side left -anchor s
        label $w.f.k$i.l3 -text "=" -bd 0
        pack $w.f.k$i.l3 -in $w.f.k$i -side left -anchor n
        label $w.f.k$i.l4 -text $rkUe
        pack $w.f.k$i.l4 -in $w.f.k$i -side right
        if {$Android == 1} then {
	        $w.f.k$i.l4 configure -relief raised
        }

        bind $w.f.k$i <Any-Enter> \
	    "TBindUeIn $i $wc
	    if {$Android == 0} then {
	        $w.f.k$i.l4 configure -relief raised
	    }"
        bind $w.f.k$i <Any-Leave> \
	    "TBindUeOut $i $wc
	    if {$Android == 0} then {
	        $w.f.k$i.l4 configure -relief flat
	    }"
       bind $w.f.k$i.l4 <Button-1> \
	    "TprepareRestart
            setAkUe $rUe_($i) $wc $Pi
            TRestartTrochoide"

        set i [expr $i+1]
    }

    T_SchnittStatus $ww
}
#############################################################
proc T_SchnittStatus {ww} {
    global ns0_ ns_ nsUe_ rUe_

    set w $ww.ns

    destroy $w.nsl1
    #tk_messageBox -message "$w.nsl1"
    if {[catch {label $w.nsl1 -text "Anzahl Selbstschnitt-"}]} then {
        return
    }
    pack $w.nsl1 -in $w -side top -anchor w

    destroy $w.f
    frame $w.f
    pack $w.f -fill x -in $w -side top

    destroy $w.l2
    label $w.l2 -text "punkte"
    pack $w.l2 -in $w.f -side left

    set i $rUe_(0)
    while {$i >= 1} {
        destroy $w.u$i
        label $w.u$i -text "$nsUe_($i)" -bd 0
        pack $w.u$i -in $w.f -side right
        destroy $w.k$i
        label $w.k$i -text "," -bd 0
        pack $w.k$i -in $w.f -side right
        set i [expr $i-1]
    }

    destroy $w.s2
    label $w.s2 -textvariable ns_ -bd 0
    pack $w.s2 -in $w.f -side right
    destroy $w.l3
    label $w.l3 -text "," -bd 0
    pack $w.l3 -in $w.f -side right
    destroy $w.s1
    label $w.s1 -textvariable ns0_ -bd 0
    pack $w.s1 -in $w.f -side right

    bind $ww.ns <Any-Enter> {
    setStatuszeile "Variation der Anzahl der Selbstschnittpunkte der Trochoide. Die rote Zahl ist die aktuelle Anzahl"
    }
    bind $ww.ns <Any-Leave> {
        setStatuszeile ""
    }
}
#############################################################
proc TSetI {} {
    global iN_A iZ_A iZ iN type_ rR rG_ massstab iZ_M iN_M
    global wc gamma0_ Pi m_ a_ a_massstab

# Uebersetzung: Bruch kuerzen
    set iN_M $iN_A
    set iZ_M $iZ_A
    set try "ok"
    set i 1
    while {$try == "ok"} {
        set i [expr $i+1]
        if {($i <= $iN_M) && ($i <= $iZ_M)} then {
            if {$iN_M%$i == 0} then {
        	if {$iZ_M%$i == 0} then {
        	    set iZ_M [expr $iZ_M/$i]
        	    set iN_M [expr $iN_M/$i]
        	    set i 1
        	}
            }
        } else {
            set try "not ok"
        }
    }

# Vorzeichen behaftete Uebersetzung ermitteln
    if {$type_ == "Epitrochoide"} then {
	set iZ [expr double($iZ_M)]
	set iN [expr double($iN_M)]
    } elseif {$type_ == "Peritrochoide"} then {
	set iN [expr double(-$iN_M)]
	set iZ [expr double($iZ_M)]
    } else {
	set iN [expr double($iN_M)]
	set iZ [expr double(-$iZ_M)]
    }

#Getriebegroesse ermitteln
    set rR [expr $iZ_M*$massstab]

    calculatePara $iZ $iN $rR
    calculateKueKb "no" $wc $iN $iZ $Pi $rR
    modifyGetriebe $wc $rR
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    setGetriebetyp $iZ $iN

}
############################################################
proc TShowGestellRast {} {

    global wc showGestellRast

    if {$showGestellRast == 1} then {
	#TCreateGestellGelenk
	TCreateGestellRast
    } else {
 	#$wc delete "Gestell"
 	$wc delete "gestell"
    }
}
#############################################################
proc TShowGestell {} {
    global wc showGestell

    if {$showGestell == 1} then {
	TCreateGestellGelenk
	#TCreateGestellRast
    } else {
 	$wc delete "Gestell"
 	#$wc delete "gestell"
    }
}
#############################################################
proc TCreateGestellGelenk {{dxfFile "no"}} {
    global pradi_ wc lineWidth

    if {$lineWidth == 0} then {
        set pradi $pradi_
    } else {
        set pradi [expr $pradi_*2.]
    }

    dxfLinie $wc $dxfFile 11 brown [expr -$pradi/2.] $pradi \
	[expr -$pradi*1.5] [expr $pradi*3] Gestell
    dxfLinie $wc $dxfFile 11 brown [expr -$pradi*2.5] [expr $pradi*3] \
	[expr $pradi*2.5] [expr $pradi*3] Gestell
    dxfLinie $wc $dxfFile 11 brown [expr $pradi*1.5] [expr $pradi*3] \
	[expr $pradi/2.] $pradi Gestell
    dxfLinie $wc $dxfFile 11 brown [expr -$pradi*0.75] [expr $pradi*3] \
	[expr -$pradi*2.25] [expr $pradi*4.5] Gestell
    dxfLinie $wc $dxfFile 11 brown [expr $pradi*0.25] [expr $pradi*3] \
	[expr -$pradi*1.25] [expr $pradi*4.5] Gestell
    dxfLinie $wc $dxfFile 11 brown [expr $pradi*1.25] [expr $pradi*3] \
	[expr -$pradi*0.25] [expr $pradi*4.5] Gestell
    if {$dxfFile == "no"} then {
        $wc addtag "Knoten" withtag Gestell
    }
}
#############################################################
proc TCreateGestellRast {{dxfFile "no"}} {
    global pradi_ wc type_ showGestell rR Pi lineWidth

    if {$lineWidth == 0} then {
        set pradi $pradi_
    } else {
        set pradi [expr $pradi_*2.]
    }

    if {$type_ == "Epitrochoide" || $type_ == "Peritrochoide"} then {
	set sign 1.
    } else {
	set sign -1.
    }

    set delta [expr 1.5*$pradi_]
    set y2 [expr $rR*cos(45.*$Pi/180.)]
    set x2 [expr -$y2]
    set y1 [expr $y2-$pradi_/2.]
    set x1 [expr -sqrt($rR*$rR-$y1*$y1)]
    set y3 [expr $y2+$pradi_/2.]
    if {[catch {set x3 [expr -sqrt($rR*$rR-$y3*$y3)]}]} then {
        tk_messageBox -message "Error: Please check Definition of Trochoide"
    }
    if {$showGestell == 1} then {
        dxfLinie $wc $dxfFile 11 brown $x2 $y2 \
    	[expr $x2+$sign*$delta] [expr $y2-$sign*$delta] gestell
        dxfLinie $wc $dxfFile 11 brown $x1 $y1 \
    	[expr $x1+$sign*$delta] [expr $y1-$sign*$delta] gestell
        dxfLinie $wc $dxfFile 11 brown $x3 $y3 \
    	[expr $x3+$sign*$delta] [expr $y3-$sign*$delta] gestell
    
        if {$dxfFile == "no"} then {
            $wc addtag "Knoten" withtag gestell
        }
    }
    return ok
}
#################################################################
proc VkueSpeichern {file} {
     # dummy-Unterprogramm
}
#############################################################
proc VGrafikeinstellungSpeichern3 {filename {append "no"}} {

    global showTrochMove
    global showFelder
    global showGestell showTrochoide showGestellRast showSingleFeld pradi_
    global ischritte_ 
    global iT statuszeile plotName
    
    setStatuszeile "Einstellungen wurden gespeichert in der Datei '$filename'"

    if {$append == "append"} then {
	set mod "a+"
    } else {
	set mod "w+"
    }
    set Datei [open $filename $mod]
	puts $Datei "set showTrochMove $showTrochMove"
	puts $Datei "set showFelder $showFelder"
	puts $Datei "set showSingleFeld $showSingleFeld"
	puts $Datei "set showGestell $showGestell"
	puts $Datei "set showGestellRast $showGestellRast"
	puts $Datei "set ischritte_ $ischritte_"
	puts $Datei "set iT $iT"
	#puts $Datei "set showTrochoide $showTrochoide"
	if {[info exists plotName] == 1} then {
	    puts $Datei "set plotName \"$plotName\""
	}
	if {[info exists pradi_] == 1} then {
	    puts $Datei "set pradi_ $pradi_"
	}
    close $Datei
}
#############################################################
proc VGetriebeparameterSpeichern  {filename {append "no"}} {

    global phi_ phi_grad gamma0_ gam0_grad a_ da pradi_ iZ iN iZ_A iN_A
    global rG_ rR type_ a_massstab

    set Datei [open $filename w+]
	puts $Datei "set phi_ $phi_"
	puts $Datei "set phi_grad $phi_grad"
	puts $Datei "set gamma0_ $gamma0_"
	puts $Datei "set gam0_grad $gam0_grad"
	puts $Datei "set a $a_"
	puts $Datei "set a_massstab $a_massstab"
	puts $Datei "set da $da"
	puts $Datei "set pradi_ $pradi_"
	puts $Datei "set iZ $iZ"
	puts $Datei "set iN $iN"
	puts $Datei "set iZ_A $iZ_A"
	puts $Datei "set iN_A $iN_A"
	puts $Datei "set rG_ $rG_"
	puts $Datei "set rR $rR"
	puts $Datei "set type_ $type_" 
    close $Datei
}
############################################################
proc VupdateView {} {

    global a a_ iZ_M iZ_A iN_M iN_A iZ iN rR
    global wc m_ gamma0_ Pi 

    set a_ $a
    set iZ_M $iZ_A
    set iN_M $iN_A

    calculatePara $iZ $iN $rR

    calculateKueKb "no" $wc $iN $iZ $Pi $rR
    modifyGetriebe $wc $rR
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    setGetriebetyp $iZ $iN


}
#############################################################

#############################################################
proc TexportCSV {} {

    set file [VfileDialog "." save "CSV" ""]
    if {$file != ""} then {
        TcreateCSV $file semikolon
    }
}
#############################################################
proc TexportCSVkomma {} {

    set file [VfileDialog "." save "CSV" ""]
    if {$file != ""} then {
        TcreateCSV $file komma
    }
}
#############################################################
proc TcreateCSV {file trenner} {

    global xyT

    #set csvFile [open c:/temp/dromeg-t.csv w]
    set csvFile [open $file w]
	puts $csvFile "x;y"
	set i 0
	foreach koord $xyT {
	    incr i
	    if {$i == 1} then {
		set x $koord
	    } else {
		set i 0
		set y $koord
		if {$trenner == "komma"} then {
		    regsub -all {[.]} "$x;$y" "," koordinaten
		} else {
		    set koordinaten "$x,$y"
		}
		puts $csvFile $koordinaten
	    }
	}
    close $csvFile
    return
}
#############################################################
proc TcreateDXF {dxfFile} {

#  file="no" --> kein DXF-File erstellen, sondern Bildschirmausgabe

    global xyT rR rG_ m_ phi_ gamma0_ a iN iZ Pi rB_ wc xG yG
    global rUe_
    global showGetriebeUmrisse
    global showOnlyKurven TShowGang TShowRast TShowKK showGetriebe

    #set dxfFile [open c:/temp/dromeg-t.dxf w]
    if {$dxfFile != "no"} then {
        set dxfFile [open "$dxfFile" w]

	# DXF-Header
	puts $dxfFile "0"
	puts $dxfFile "SECTION"
	puts $dxfFile "2"
	puts $dxfFile "ENTITIES"

	#set wc ""
    }

    set xP [expr $rR*cos($phi_)]
    set yP [expr $rR*sin($phi_)]
    set xG [expr $rG_*$m_*cos($phi_)]
    set yG [expr $rG_*$m_*sin($phi_)]
    set y [yTrochoide $rG_ $m_ $phi_ $a $gamma0_]
    set x [xTrochoide $rG_ $m_ $phi_ $a $gamma0_]

    #tk_messageBox -message "showGetriebe=$showGetriebe"
    if {$showGetriebe == 1} then {
        Knoten $wc 0 0 rR $dxfFile
        Knoten $wc $xP $yP rG_ $dxfFile 0.5
        Knoten $wc $xG $yG K $dxfFile
        Knoten $wc $x $y t $dxfFile
        #Knoten $wc $x $y t $dxfFile
        Kante $wc 1 2 rR rr $dxfFile 0 0 $xP $yP
        
        # 2013 fr Hypotrochoide
        Kante $wc 1 3 rrHypo rR $dxfFile 0 0 $xG $yG

        Kante $wc 2 3 rG_ rg_ $dxfFile $xP $yP $xG $yG
        Kante $wc 3 4 K k  $dxfFile $xG $yG $x $y
        #Kante $wc 1 3 S s $dxfFile 0 0 $xG $yG

	TCreateGestellRast $dxfFile
	TCreateGestellGelenk $dxfFile
     }

     # Plotte Trochoide
     recreateTrochoide $dxfFile

     # Farbfestlegung
     set colorRast2 lightgrey
     set colorGang2 yellow
     if {$showGetriebeUmrisse == 1} then {
         set colorRast1 black
         set colorGang1 black
     } else {
         set colorRast1 $colorRast2
         set colorGang1 $colorGang2
     }
     if {$showGetriebe == 1 || $TShowRast != 0} then {
	# Rastpolkurve
	if {$TShowRast != 0} then {
	    # Rastpolkurve nicht mit Farbe fuellen
	    if {$dxfFile == "no"} then {
	        catch {$wc delete rast}
	    }
	    dxfKreis $wc $dxfFile 12 $colorRast1 [expr -$rR] [expr -$rR] $rR $rR rast ""
	} else {
	    # Rastpolkurve  mit Farbe fuellen
	    if {$dxfFile == "no"} then {
	        catch {$wc delete rast}
            }
	    dxfKreis $wc $dxfFile 12 $colorRast1 [expr -$rR] [expr -$rR] $rR $rR rast $colorRast2
	}
	if {$dxfFile == "no"} then {
            $wc lower rast
            $wc lower einengung
            $wc lower einengungBall
            if {$TShowRast == 2} then {
                catch {$wc itemconfigure rast -dash {2 4}}
            }
        }
     }

     if {$showGetriebe == 1 || $TShowGang != 0} then {
	# Gangpolkurve
        set xG [expr $rG_*$m_*cos($phi_)]
        set yG [expr $rG_*$m_*sin($phi_)]
        if {$TShowGang != 0} then {
            # Gangpolkurve nicht mit Farbe fuellen
            if {$dxfFile == "no"} then {
                catch {$wc delete gang}
            }
            dxfKreis $wc $dxfFile 13 $colorGang1 [expr $xG-$rG_] [expr $yG-$rG_] \
            [expr $xG+$rG_] [expr $yG+$rG_] gang ""
        } else {
            # Gangpolkurve  mit Farbe fuellen
            if {$dxfFile == "no"} then {
                catch {$wc delete gang}
            }
            dxfKreis $wc $dxfFile 13 $colorGang1 [expr $xG-$rG_] [expr $yG-$rG_] \
            [expr $xG+$rG_] [expr $yG+$rG_] gang $colorGang2
        }
        if {$TShowGang == 2} then {
            if {$dxfFile == "no"} then {
                catch {$wc itemconfigure gang -dash {2 4}}
            }
        }
        if {$dxfFile == "no"} then {
            $wc lower gang
            $wc lower einengung
            $wc lower einengungBall
        }
     }

     if {$showGetriebe == 1} then {
        calculateKueKb $dxfFile $wc $iN $iZ $Pi $rR
        # BALLsche Kurve
        if {$dxfFile != "no"} then {
            catch {$wc delete ball}
        }
        dxfKreis $wc $dxfFile 14 red [expr $xG-$rB_] [expr $yG-$rB_] \
        [expr $xG+$rB_] [expr $yG+$rB_] ball GreenYellow

        # TShowGestell
	# modifyGetriebe
     }

     dxfEnd $dxfFile

    return
}
#############################################################
proc TdxfGestell {dxfFile} {

    global pradi_ lineWidth

    set taG ""

    if {$lineWidth == 0} then {
        set pradi $pradi_
    } else {
        set pradi [expr $pradi_*2.]
    }

    dxfLinie "" $dxfFile 11 brown [expr -$pradi/2.] $pradi \
	[expr -$pradi*1.5] [expr $pradi*3] $taG
    dxfLinie "" $dxfFile 11 brown [expr -$pradi*2.5] [expr $pradi*3] \
	[expr $pradi*2.5] [expr $pradi*3] $taG
    dxfLinie "" $dxfFile 11 brown [expr $pradi*1.5] [expr $pradi*3] \
	[expr $pradi/2.] $pradi $taG
    dxfLinie "" $dxfFile 11 brown [expr -$pradi*0.75] [expr $pradi*3] \
	[expr -$pradi*2.25] [expr $pradi*4.5] $taG
    dxfLinie "" $dxfFile 11 brown [expr $pradi*0.25] [expr $pradi*3] \
	[expr -$pradi*1.25] [expr $pradi*4.5] $taG
    dxfLinie "" $dxfFile 11 brown [expr $pradi*1.25] [expr $pradi*3] \
	[expr -$pradi*0.25] [expr $pradi*4.5] $taG
    return
}
##############################################################
# Liniendicke vorgeben
proc TmodifyThickness {} {

    global wc iZ iN
    global lineWidth

    if {$lineWidth == 0} then {
        set width 1
    } else {
        set width 2
    }
    
    if {$iZ >0} {
    # Epitrochoide oder Peritrochoide
        set niMax [expr int($iZ/2)]
    } else {
    # Hypotrochoide
        set niMax [expr int(abs(2*$iN+$iZ)/2)]
    }
    
    # Alle Uebergangskreise ni berechnen
    set ni [expr $niMax+1]
    
    while {$ni>1} {
        set ni [expr $ni-1]
        $wc itemconfigure kUe$ni -width $width
    }
    $wc itemconfigure rast -width $width
    $wc itemconfigure gang -width $width
    $wc itemconfigure ball -width $width
    $wc itemconfigure t -width $width
    $wc itemconfigure rR -width $width
    $wc itemconfigure rG_ -width $width
    $wc itemconfigure K -width $width
    $wc itemconfigure S -width $width
    $wc itemconfigure Trochoide -width $width
    $wc itemconfigure Gestell -width $width
    $wc itemconfigure gestell -width $width
}
############################################################
proc TshowGrafik {} {

    global wc a_ a_massstab massstab m_ iN gamma0_ Pi showFelder

    set dxfFile "no"

    TcreateDXF $dxfFile

    #set showFelderOld $showFelder
    #set showFelder 0
    TShowFeldeinteilung
    #set showFelder $showFelderOld

    $wc lower gang
    $wc lower rast
    TLowerKurven
    TSetType
    TSetI

    #Vorfuehrung#set a_massstab 1.5
    set a_ [expr $a_massstab*$massstab]
    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    TSetSchnittBlue

    focus $wc
    $wc lower rast
    $wc lower gang
    $wc lower einengung
    $wc lower einengungBall
    TLowerKurven
}
#############################################################
proc T_Bind {wc} {
    global rB_ rG_ a_ m_ iN gamma0_ Pi statuszeile gam0_grad
    global phi_ a_massstab massstab iN_A iZ_A Pi showTrochMove
    global showFelder
    global xMoveto last_xMoveto 0x last_0x xregion_
    global yMoveto last_yMoveto 0y last_0y yregion_
    global last_massstab rS rS_M
    global Android

    if {$Android == 1} then {
        return
    }

    foreach ibind {rR rG_ K Trochoide} {
        $wc bind $ibind <Any-Enter> "TEnterrRrGKorTrochoide $ibind $wc"
        $wc bind $ibind <Any-Leave> "TLeaverRrGKorTrochoide $ibind $wc"
    }
#   $wc bind Trochoide <Button-1> { TRunTrochoide -1 1}
#   $wc bind Trochoide <Button-3> { TRunTrochoide +1 1}

    $wc bind rast <Any-Enter> {
        $wc itemconfigure rast -width 2
        setStatuszeile "'Rand des feststehenden Rades' = Rastpolkurve"
    }
    $wc bind rast <Any-Leave> {
        $wc itemconfigure rast -width 1
    }
    $wc bind gang <Any-Enter> {
        $wc itemconfigure gang -width 2
        setStatuszeile "'Linke Maustaste' verlegt erzeugenden Punkt auf den 'Rand des umlaufenden Rades' = Gangpolkurve"
    }
    $wc bind gang <Any-Leave> {
        $wc itemconfigure gang -width 1
#        TSetrRrGwidth2
        setStatuszeile " "
    }
    $wc bind gang <Button-1> {
        TprepareRestart
        set a_ [expr $rG_]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TRestartTrochoide
    }
    $wc bind gang <Button-3> {
        TprepareRestart
        set a_ [expr $rG_]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TRestartTrochoide
    }

    $wc bind sonderfall <Any-Enter> {
        $wc itemconfigure sonderfall -width 2
        #setStatuszeile "'Linke Maustaste' verlegt erzeugenden Punkt auf Kreis durch Mittelpunkt des stehenden Rades"
        setStatuszeile "'Linke Maustaste': Sonderfall einer Trochoide mit Mehrfachschnittpunkt(en) ohne Selbstberhrungspunkte."
    }
    $wc bind sonderfall <Any-Leave> {
        $wc itemconfigure sonderfall -width 1
#        TSetrRrGwidth2
        setStatuszeile " "
    }
    $wc bind sonderfall <Button-1> {
        if {$rS_M != "existiert nicht"} then {
            TprepareRestart
            set a_ $rS
            #if {$showFelder==1} then {
                TSetSchnittBlue
            #}
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
            TRestartTrochoide
        }
    }
    $wc bind sonderfall <Button-3> {
        if {$rS_M != "existiert nicht"} then {
            TprepareRestart
            set a_ $rS
            #if {$showFelder==1} then {
                TSetSchnittBlue
            #}
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
            TRestartTrochoide
        }
    }

    $wc bind ball <Any-Enter> {
        $wc itemconfigure ball -width 2
        setStatuszeile "'Linke Maustaste' verlegt \
erzeugenden Punkt auf die BALLsche Kurve"
    }
    $wc bind ball <Any-Leave> {
        $wc itemconfigure ball -width 1
        setStatuszeile " "
    }
$wc bind t <Any-Enter> {
        $wc itemconfigure t -width 2
        setStatuszeile "Mit 'Linker' bzw. 'rechter Maustaste' kann der \
 die Trochoide erzeugende Punkt bewegt werden"
    }
    $wc bind t <Any-Leave> {
        $wc itemconfigure t -width 1
        setStatuszeile " "
    }
    $wc bind t <ButtonPress-1> {
        set xPos %x
        set yPos %y
        set xPosT $xPos
        set yPosT $yPos
    }
    $wc bind t <B1-Motion> {
        VerschiebeKnoten $wc 4 [expr %x-$xPos] [expr %y-$yPos]
        set xPos %x
        set yPos %y
        if {$showTrochMove == 1} then {
            set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
            set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
            set xG [expr $rG_*$m_*cos($phi_)]
            set yG [expr $rG_*$m_*sin($phi_)]
            set dx [expr $xPos-$xG-( $xPosT-$x)]
            set dy [expr $yPos-$yG-($yPosT-$y)]
            set winkel_alt [expr atan2(($y-$yG),($x-$xG))]
            set winkel_neu [expr atan2($dy,$dx)]
            set gamma0_ [expr $gamma0_+($winkel_neu-$winkel_alt)]
            set gam0_grad [expr $gamma0_*180./$Pi]
            set a_ [expr sqrt($dx*$dx+$dy*$dy)]
            set a_massstab [expr $a_/$massstab]
            TSetSchnittBlue
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
           set xPosT $xPos
           set yPosT $yPos
        }
    }
    $wc bind t <ButtonRelease-1> {
        set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set dx [expr $xPos-$xG-( $xPosT-$x)]
        set dy [expr $yPos-$yG-($yPosT-$y)]
        set xG [expr $rG_*$m_*cos($phi_)]
        set yG [expr $rG_*$m_*sin($phi_)]
        set winkel_alt [expr atan2(($y-$yG),($x-$xG))]
        set winkel_neu [expr atan2($dy,$dx)]
        set gamma0_ [expr $gamma0_+($winkel_neu-$winkel_alt)]
        set gam0_grad [expr $gamma0_*180./$Pi]
        set a_ [expr sqrt($dx*$dx+$dy*$dy)]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    }
    $wc bind t <ButtonPress-3> {
        set xPos %x
        set yPos %y
        set xPosT $xPos
        set yPosT $yPos
        set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set xG [expr $rG_*$m_*cos($phi_)]
        set yG [expr $rG_*$m_*sin($phi_)]
        set xR [expr $x-$xG]
        set yR [expr $y-$yG]
#        set gamma [expr atan2(($y-$yG),($x-$xG))]
        if {$yR > [expr $xR]} then {
                set follow "x"
        } else {
                set follow "y"
        }
    }
    $wc bind t <B3-Motion> {
        if {$follow == "x"} then {
            set dx [expr %x-$xPos]
            VerschiebeKnoten $wc 4 $dx [expr $dx/$xR*$yR]
        } else {
            set dy [expr %y-$yPos]
            VerschiebeKnoten $wc 4 [expr $dy*$xR/$yR] $dy
        }
        set xPos %x
        set yPos %y

        if {$showTrochMove == 1} then {
            set dx [expr $xPos-$xG-[expr $xPosT-$x]]
            set dy [expr $yPos-$yG-[expr $yPosT-$y]]
            set a_ [expr sqrt($dx*$dx+$dy*$dy)]
            set a_massstab [expr $a_/$massstab]
            TSetSchnittBlue
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        }
    }
    $wc bind t <ButtonRelease-3> {
        set dx [expr $xPos-$xG-[expr $xPosT-$x]]
        set dy [expr $yPos-$yG-[expr $yPosT-$y]]
        set a_ [expr sqrt($dx*$dx+$dy*$dy)]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    }
    $wc bind ball <Button-1> {
        TprepareRestart
        set a_ [expr $rB_]
        set a_massstab [expr $a_/$massstab]
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TSetSchnittBlue
        TRestartTrochoide
    }
    $wc bind ball <Button-3> {
        TprepareRestart
        set a_ [expr $rB_]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TRestartTrochoide
    }
    $wc bind rG_ <Button-1> {
        set iN_A [expr $iN_A+1]
        TSetI
        calculatePara $iZ $iN $rR
        calculateKueKb "no" $wc $iN $iZ $Pi $rR
        modifyGetriebe $wc $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        setGetriebetyp $iZ $iN
    }
    $wc bind rG_ <Button-3> {
        if {$iN_A>1} {
	    set iN_A [expr $iN_A-1]
            TSetI
	    calculatePara $iZ $iN $rR
       	    calculateKueKb "no" $wc $iN $iZ $Pi $rR
            modifyGetriebe $wc $rR
	    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
            setGetriebetyp $iZ $iN
        }
    }
    $wc bind rR <Button-1> {
        set iZ_A [expr $iZ_A+1]
        TSetI
        modifyGetriebe $wc $rR
        calculatePara $iZ $iN $rR
        calculateKueKb "no" $wc $iN $iZ $Pi $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    }
    $wc bind rR <Button-3> {
        if {$iZ_A>1} {
	    set iZ_A [expr $iZ_A-1]
            TSetI
            modifyGetriebe $wc $rR
	    calculatePara $iZ $iN $rR
            calculateKueKb "no" $wc $iN $iZ $Pi $rR
	    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
            setGetriebetyp $iZ $iN
        }
    }
    $wc bind K <Button-1> {
        set da [expr $a_*0.1]
        set a_ [expr $a_+$da]
        set a_massstab [expr $a_/$massstab]
        #if {$showFelder==1} then {
            TSetSchnittBlue
        #}
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    }
    $wc bind K <Button-3> {
        set da [expr $a_*0.1]
        set a_ [expr $a_-$da]
        set a_massstab [expr $a_/$massstab]
        #if {$showFelder==1} then {
            TSetSchnittBlue
        #}
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    }
    #tk_messageBox -message yyyy
    if {$Android != 1} then {
        bind .chscroll <ButtonRelease-1> {
    	set last_xMoveto $xMoveto
    	set last_0x $0x
    	set last_massstab $massstab
    	set list [.chscroll get]
            set xMoveto [lrange $list 0 0]
            $wc xview moveto $xMoveto
    	set 0x [expr $0x-($xMoveto-$last_xMoveto)*$xregion_]
    	#tk_messageBox -message list=$list
        }
        #tk_messageBox -message xxxx
        bind .cvscroll <ButtonRelease-1> {
    	set last_yMoveto $yMoveto
    	set last_0y $0y
    	set last_massstab $massstab
    	set list [.cvscroll get]
            set yMoveto [lrange $list 0 0]
            $wc yview moveto $yMoveto
    	set 0y [expr $0y-($yMoveto-$last_yMoveto)*$yregion_]
        }
    }
}
#############################################################
proc T_Status {w} {
    global type_ iZ_A iN_A iN iZ iZ_M iN_M rB_massstab rUe_ a_massstab
    global rB_ wc m_  gamma0_ Pi ww phi_ gamma0_ rG_ phi_grad gam0_grad
    global showFelder statuszeile RichtungBackup geschwBackup aFaktor

    set ww $w
    frame $ww.t
    pack $ww.t -fill x -in $w -side top -anchor n

    label $ww.t.l1 -text "TYP:"
    pack $ww.t.l1 -in $ww.t -side left

    menubutton $ww.t.m -text "?" -menu $ww.t.m.menu -relief raised
    pack $ww.t.m -in $ww.t -side right
    menu $ww.t.m.menu
    $ww.t.m.menu add radiobutton -label Epitrochoide \
	-variable type_ -value Epitrochoide -command TSetType
    $ww.t.m.menu add radiobutton -label Peritrochoide \
	-variable type_ -value Peritrochoide -command TSetType
    $ww.t.m.menu add radiobutton -label Hypotrochoide \
	-variable type_ -value Hypotrochoide -command TSetType
    $ww.t.m.menu add separator
    $ww.t.m.menu add radiobutton -label "Doppelte Erzeugung" \
	-variable type_ -value "DoppelteErzeugung" -command TSetType
    tk_menuBar $ww.t.m
    focus $ww.t.m
    
    bind $ww.t <Any-Enter> {
    setStatuszeile "Wechsel des Trochoiden-Types oder Wechsel zu einem anderen Rderpaar, das die gleiche Trochoide erzeugt."
    }
    bind $ww.t <Any-Leave> {
        setStatuszeile ""
    }

    label $ww.t.l2 -textvariable type_ -width 12
    pack $ww.t.l2 -in $ww.t -side right


    frame $ww.r
    pack $ww.r -fill x -in $w -side top -anchor n

    label $ww.r.l1 -text "r" -bd 0
    pack $ww.r.l1 -in $ww.r -side left -anchor c
    label $ww.r.l2 -text "R" -bd 0
    pack $ww.r.l2 -in $ww.r -side left -anchor s
    label $ww.r.l3 -text "=" -bd 0
    pack $ww.r.l3 -in $ww.r -side left -anchor c
    button $ww.r.iZ- -text "<" -width 1 -command {
	TprepareRestart
        set change "ok"
	if {$iZ_A == 1} then {set change "not ok"}
                if {$type_ == "Hypotrochoide"} then {
	    if {$iN_A == [expr $iZ_A-1]} then {set change "not ok"}
	}
	if {$change == "ok"} then {set iZ_A [expr $iZ_A-1]}
	TSetI
	TRestartTrochoide
    }
    entry $ww.r.e1 -width 4 -textvariable iZ_A
    bind $ww.r.e1 <Return> {
        if {$type_ == "Peritrochoide"} then {
            if {$iZ_A >= $iN_A} then {
                set iZ_A [expr $iN_A-1]
            }
        } elseif {$type_ == "Hypotrochoide"} then {
            if {$iZ_A <= $iN_A} then {set iZ_A [expr $iN_A+1]}
        }
        TSetI
    }
    button $ww.r.iZ+ -text ">" -width 1 -command {
	TprepareRestart
        set change "ok"
	if {$type_ == "Peritrochoide"} then {
	    if {$iN_A == [expr $iZ_A+1]} then {set change "not ok"}
	}
	if {$change == "ok"} then {set iZ_A [expr $iZ_A+1]}
	TSetI
	TRestartTrochoide
    }
    pack $ww.r.iZ+ $ww.r.e1 $ww.r.iZ- -in $ww.r -side right

    bind $ww.r <Any-Enter> {TRaiserRrGKorTrochoide rR $wc
        $ww.r.e1 configure -foreground red
        setStatuszeile "Vergrern oder verkleinern des feststehenden Rades."}
    bind $ww.r <Any-Leave> {TLeaverRrGKorTrochoide rR $wc
        $ww.r.e1 configure -foreground black
        setStatuszeile ""}

    frame $ww.g
    pack $ww.g -fill x -in $w -side top -anchor n

    label $ww.g.l1 -text "r" -bd 0
    pack $ww.g.l1 -in $ww.g -side left -anchor c
    label $ww.g.l2 -text "G" -bd 0
    pack $ww.g.l2 -in $ww.g -side left -anchor s
    label $ww.g.l3 -text "=" -bd 0
    pack $ww.g.l3 -in $ww.g -side left -anchor c
    button $ww.g.iN- -text "<" -width 1 -command {
        TprepareRestart
        set change "ok"
	if {$iN_A == 1} then {set change "not ok"}
	if {$type_ == "Peritrochoide"} then {
	    if {$iN_A == [expr $iZ_A+1]} then {set change "not ok"}
	}
	if {$change == "ok"} then {set iN_A [expr $iN_A-1]}
	TSetI
	TRestartTrochoide
    }
    entry $ww.g.e1 -width 4 -textvariable iN_A
    bind $ww.g.e1 <Return> {
        if {$type_ == "Peritrochoide"} then {
            if {$iN_A <= $iZ_A} then {
                set iN_A [expr $iZ_A+1]
            }
        }
        if {$type_ == "Hypotrochoide"} then {
            if {$iN_A >= $iZ_A} then {
                set iN_A [expr $iZ_A-1]
            }
        }
        TSetI
    }
    button $ww.g.iN+ -text ">" -width 1  -command {
	TprepareRestart
        set change "ok"
        if {$type_ == "Hypotrochoide"} then {
	        if {$iN_A == [expr $iZ_A-1]} then {set change "not ok"}
        }
	if {$change == "ok"} then {set iN_A [expr $iN_A+1]}
	TSetI
	TRestartTrochoide
    }
    pack $ww.g.iN+ $ww.g.e1 $ww.g.iN- -in $ww.g -side right

    bind $ww.g <Any-Enter> {TRaiserRrGKorTrochoide rG_ $wc
        $ww.g.e1 configure -foreground red
        setStatuszeile "Vergrern oder verkleinern des umlaufenden Rades."}
    bind $ww.g <Any-Leave> {TLeaverRrGKorTrochoide rG_ $wc
        $ww.g.e1 configure -foreground black
        setStatuszeile ""}

    frame $ww.rg
    pack $ww.rg -fill x -in $w -side top -anchor n
    bind $ww.rg <Any-Enter> {
        setStatuszeile "Anzeige des bersetzungsverhltnisses zwischen stehendem und umlaufendem Rad"
    }
    bind $ww.rg <Any-Leave> {
        setStatuszeile ""
    }

    label $ww.rg.l1 -text "r" -bd 0
    pack $ww.rg.l1 -in $ww.rg -side left -anchor n
    label $ww.rg.l2 -text "R" -bd 0
    pack $ww.rg.l2 -in $ww.rg -side left -anchor s
    label $ww.rg.l3 -text "/" -bd 0
    pack $ww.rg.l3 -in $ww.rg -side left -anchor n
    label $ww.rg.l4 -text "r" -bd 0
    pack $ww.rg.l4 -in $ww.rg -side left -anchor n
    label $ww.rg.l5 -text "G" -bd 0
    pack $ww.rg.l5 -in $ww.rg -side left -anchor s
    label $ww.rg.l6 -text "=  i  =" -bd 0
    pack $ww.rg.l6 -in $ww.rg -side left -anchor n

    label $ww.rg.l7 -textvariable iN_M
    label $ww.rg.l8 -text "/"
    label $ww.rg.l9 -textvariable iZ_M
    pack $ww.rg.l7 $ww.rg.l8 $ww.rg.l9 -in $ww.rg -side right

    frame $ww.s
    pack $ww.s -fill x -in $w -side top -anchor n
    pack $ww.rg -fill x -in $w -side top -anchor n
    bind $ww.s <Any-Enter> {
        setStatuszeile "Anzeige der Anzahl der Schleifen, Spitzen bzw. 'Wellen' der Trochoide"
    }
    bind $ww.s <Any-Leave> {
        setStatuszeile ""
    }

    label $ww.s.l1 -text "Anzahl Schleifen:"
    pack $ww.s.l1 -in $ww.s -side left
    label $ww.s.l2 -textvariable iZ_M
    pack $ww.s.l2 -in $ww.s -side right

    frame $ww.us
    pack $ww.us -fill x -in $w -side top -anchor n
    bind $ww.us <Any-Enter> {
        setStatuszeile "Anzeige der Anzahl der Umlufe des beweglichen Rades um das stehende Rad pro Bewegungsperiode"
    }
    bind $ww.us <Any-Leave> {
        setStatuszeile ""
    }

    label $ww.us.l1 -text "Stegumlaeufe pro Periode:"
    pack $ww.us.l1 -in $ww.us -side left
    label $ww.us.l2 -textvariable iN_M
    pack $ww.us.l2 -in $ww.us -side right

    frame $ww.a
    pack $ww.a -fill x -in $w -side top -anchor n

    menubutton $ww.a.la -text "Abstand" -menu $ww.a.la.menu -relief raised
    menu $ww.a.la.menu
    $ww.a.la.menu add radiobutton -variable aFaktor -value 1. -label "Differenz=1."
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.5 -label "Differenz=0.5"
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.2 -label "Differenz=0,2"
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.1 -label "Differenz=0.1"
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.05 -label "Differenz=0.05"
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.02 -label "Differenz=0.02"
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.01 -label "Differenz=0.01"
    #$ww.a.la.menu add radiobutton -label "Differenz=0.5" -command "set aFaktor 0.5"
    #$ww.a.la.menu add radiobutton -label "Differenz=0.2" -command "set aFaktor 0.2"
    #$ww.a.la.menu add radiobutton -label "Differenz=0.1" -command "set aFaktor 0.1"
    #$ww.a.la.menu add radiobutton -label "Differenz=0.05" -command "set aFaktor 0.05"
    #$ww.a.la.menu add radiobutton -label "Differenz=0.02" -command "set aFaktor 0.02"
    #$ww.a.la.menu add radiobutton -label "Differenz=0.01" -command "set aFaktor 0.01"
    pack $ww.a.la -in $ww.a -side left -anchor n

    label $ww.a.l1 -text "= M" -bd 0
    pack $ww.a.l1 -in $ww.a -side left -anchor n
    label $ww.a.l2 -text "G" -bd 0
    pack $ww.a.l2 -in $ww.a -side left -anchor s
    label $ww.a.l3 -text "- K  =" -bd 0
    pack $ww.a.l3 -in $ww.a -side left -anchor n
    
    button $ww.a.e1 -text "<" -width 1 -command {
	TprepareRestart
        set a_massstab [round3 [expr $a_massstab-1.*$aFaktor]]
	set a_ [expr $a_massstab*$massstab]
	modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TSetSchnittBlue
        TRestartTrochoide
    }

    entry $ww.a.e -textvariable a_massstab -width 10
    button $ww.a.e2 -text ">" -width 1 -command {
        TprepareRestart
	set a_massstab [round3 [expr $a_massstab+1.*$aFaktor]]
	set a_ [expr $a_massstab*$massstab]
	modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TSetSchnittBlue
        TRestartTrochoide
    }

    bind $ww.a.e <Return> {set a_ [expr $a_massstab*$massstab]
#        TSetI
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
        TSetSchnittBlue}
    #pack $ww.a.e -in $ww.a -side right
    pack $ww.a.e2 $ww.a.e $ww.a.e1 -in $ww.a -side right

    bind $ww.a <Any-Enter> {TRaiserRrGKorTrochoide K $wc
        $ww.a.e configure -foreground red
        setStatuszeile "Abstand des die Trochoide erzeugenden Punktes vom Mittelpunkt des umlaufenden Rades"}
    bind $ww.a <Any-Leave> {TLeaverRrGKorTrochoide K $wc
         $ww.a.e configure -foreground black
         setStatuszeile ""}

    frame $ww.phi
    pack $ww.phi -fill x -in $w -side top -anchor n

    label $ww.phi.l1 -text "Phi" -bd 0
    pack $ww.phi.l1 -in $ww.phi -side left -anchor n
    label $ww.phi.l2 -text " in " -bd 0
    pack $ww.phi.l2 -in $ww.phi -side left -anchor n
    label $ww.phi.l3 -text "Grad" -bd 0
    pack $ww.phi.l3 -in $ww.phi -side left -anchor n
    label $ww.phi.l4 -text " =" -bd 0
    pack $ww.phi.l4 -in $ww.phi -side left -anchor n
    entry $ww.phi.e -textvariable phi_grad -width 10
    bind $ww.phi.e <Return> {
        set phi_ [expr $phi_grad*$Pi/180.]
        modifyGetriebe $wc $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    pack $ww.phi.e -in $ww.phi -side right
    bind $ww.phi <Any-Enter> {
        setStatuszeile "Winkel der Gerade vom Mittelpunkt des stehenden Rades zum Mittelpunkt des umlaufenden Rades"
    }
    bind $ww.phi <Any-Leave> {
        setStatuszeile ""
    }


frame $ww.gam
    pack $ww.gam -fill x -in $w -side top -anchor n

    label $ww.gam.l1 -text "Gamma" -bd 0
    pack $ww.gam.l1 -in $ww.gam -side left -anchor n
     label $ww.gam.l2 -text "0" -bd 0
    pack $ww.gam.l2 -in $ww.gam -side left -anchor s
    label $ww.gam.l3 -text " in " -bd 0
    pack $ww.gam.l3 -in $ww.gam -side left -anchor n
    label $ww.gam.l4 -text "Grad" -bd 0
    pack $ww.gam.l4 -in $ww.gam -side left -anchor n
    label $ww.gam.l5 -text " =" -bd 0
    pack $ww.gam.l5 -in $ww.gam -side left -anchor n
    entry $ww.gam.e -textvariable gam0_grad  -width 10
    bind $ww.gam.e <Return> {
        set gamma0_ [expr $gam0_grad*$Pi/180.]
        modifyGetriebe $wc $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    }
    pack $ww.gam.e -in $ww.gam -side right
    bind $ww.gam <Any-Enter> {
        setStatuszeile "Winkel der Gerade vom Mittelpunkt des umlaufenden Rades zum erzeugenden Punkt der Trochoide, bei Phi=0"
    }
    bind $ww.gam <Any-Leave> {
        setStatuszeile ""
    }
    TStatusFelder 
}
#############################################################
proc TPullDownMenu {} {

global type_ rR a_  canvas_height canvas_width massstab iZ iN a_massstab
global rB_massstab rUe_ showTrochMove showFelder showTrochoide kueStatus
global wc Pi m_ gamma0_ last_massstab showGestell
global xMoveto last_xMoveto yMoveto last_yMoveto 0x 0y
global last_0x last_0y xZoomPos1 yZoomPos1 xzoom yzoom xneu yneu
global dromegTVers
global TShowBall TShowGang TShowUeber TShowSonder

set zoomIn [image create bitmap -file dromegzi.xbm]
set zoomOut [image create bitmap -file dromegzo.xbm]
set zoomLast [image create bitmap -file dromegzl.xbm]
set zoomAll [image create bitmap -file dromegza.xbm]
set bitmapStop [image create bitmap -file dromegsp.xbm]
set bitmapStart [image create bitmap -file dromegst.xbm]
set showFeldEinteilung [image create photo btimage_gif -file dromegfe.gif]
set grafikFensterAendern [image create photo btimage_gif2 -file dromeggv.gif]

#set type_ Epitrochoide

destroy .mbar
frame .mbar -relief raised -bd 2
pack .mbar -side top -fill x

menubutton .mbar.file -text Datei -underline 0 -menu .mbar.file.menu 
menubutton .mbar.type -text Getriebe-Typ -underline 0 -menu .mbar.type.menu
menubutton .mbar.grafik -text Grafik -underline 0 -menu .mbar.grafik.menu
menubutton .mbar.zoom -text Zoom -underline 0 -menu \
	.mbar.zoom.menu 
menubutton .mbar.help -text Hilfe -underline 0 -menu .mbar.help.menu 
    pack .mbar.file .mbar.type .mbar.grafik .mbar.zoom .mbar.help \
	-side left
label .mbar.space3 -text "   " -relief flat
button .mbar.showFeldEinteilung -image $showFeldEinteilung -underline 1 \
    -command TShowFeldeinteilung2
bind .mbar.showFeldEinteilung <Any-Enter> {
    setStatuszeile "'linke Maustaste': Ein- bzw. Ausblenden konzentrischer farbiger Ringe (Felder) zum Einteilen (der Ebene) des bewegten Rades"
}
bind .mbar.showFeldEinteilung <Any-Leave> {
    setStatuszeile ""
}

button .mbar.start -image $bitmapStart -underline 1 \
    -command {TRunTrochoide -1 1}
bind .mbar.start <ButtonPress-2> \
	".mbar.start configure -relief sunken
	TRunTrochoide -1 3"
bind .mbar.start <ButtonPress-3> \
	TChangeGeschwindigkeit
foreach i "2 3" {
    bind .mbar.start <ButtonRelease-$i> \
	".mbar.start configure -relief raised"
}
bind .mbar.start <Any-Enter> {
    setStatuszeile "'linke Maustaste': langsam,\
'mittlere Maustaste': schnell, 'rechte Maustaste': Geschwindigkeits-Menue"
}
bind .mbar.start <Any-Leave> {
    setStatuszeile ""
}
button .mbar.stop -image $bitmapStop -underline 1 -command \
    {TStopTrochoide}
foreach i "2 3" {
    bind .mbar.stop <ButtonPress-$i> {TStopTrochoide}
}
bind .mbar.stop <Any-Enter> {
    setStatuszeile "'alle Maustaste': Animation oder auch \
Berechnung beenden"
}
bind .mbar.stop <Any-Leave> {
    setStatuszeile ""
}
label .mbar.space -text " " -relief flat
label .mbar.space2 -text "  " -relief flat
button .mbar.zoom_a -image $zoomAll -underline 1 -command \
TZoomAll
bind .mbar.zoom_a <Any-Enter> {
    setStatuszeile "'linke Maustaste': Zoom: 'Einpassen: alles'"
}
bind .mbar.zoom_a <Any-Leave> {
    setStatuszeile ""
}
button .mbar.zoom_o -image $zoomOut -underline 1 -command \
TZoomOut
bind .mbar.zoom_o <Any-Enter> {
    setStatuszeile "'linke Maustaste': raus Zoomen"
}
bind .mbar.zoom_o <Any-Leave> {
    setStatuszeile ""
}
button .mbar.zoom_i -image $zoomIn -underline 1 -command \
TSetZoomFenster
bind .mbar.zoom_i <Any-Enter> {
    setStatuszeile "'linke Maustaste': rein Zoomen (Mit Maus Rechteck aufziehen)"
}
bind .mbar.zoom_i <Any-Leave> {
    setStatuszeile ""
}
button .mbar.zoom_l -image $zoomLast -underline 1 -command {
   set irunMaxI 0
   TZoomLast}
bind .mbar.zoom_l <Any-Enter> {
    setStatuszeile "'linke Maustaste': letzten Zoom wieder anzeigen"
}
bind .mbar.zoom_l <Any-Leave> {
    setStatuszeile ""
}

button .mbar.gwindow_m -image $grafikFensterAendern  -underline 1 -command \
TSetFensterGroesser
bind .mbar.gwindow_m <ButtonPress-3> \
	TSetFensterKleiner
bind .mbar.gwindow_m <Any-Enter> {
    setStatuszeile "'linke Maustaste': Grafik-Fenster vergroessern, 'rechte Maustaste': verkleinern"
}
bind .mbar.gwindow_m <Any-Leave> {
    setStatuszeile ""
}
bind .mbar.gwindow_m <ButtonRelease-3> \
	".mbar.gwindow_m configure -relief raised"

pack .mbar.space3 .mbar.showFeldEinteilung -side left

pack .mbar.gwindow_m .mbar.space2 .mbar.zoom_l .mbar.zoom_i .mbar.zoom_o .mbar.zoom_a .mbar.space \
    .mbar.stop .mbar.start -side right

    menu .mbar.file.menu
    .mbar.file.menu add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mf-t.hlp"
    }
    .mbar.file.menu add separator
    .mbar.file.menu add command -label "Speichern: Einstellungen" \
	-command "VGrafikeinstellungSpeichern dromeg-t E"
    .mbar.file.menu add command -label "Default-Einstellungen beim naechsten Programmstart" \
	-command "catch {file delete [speicherDir]dromeg-t.def}"
    .mbar.file.menu add command -label "Speichern: Getriebeparameter" \
	-command "VGrafikeinstellungSpeichern dro-p-t P"
    .mbar.file.menu add command -label "Lesen: Getriebeparameter" \
        -command "VGrafikeinstellungSpeichern dro-p-4 P open"
    .mbar.file.menu add separator
    .mbar.file.menu add command -label "Export: DXF-Datei" \
	-command "TexportDXF"
    .mbar.file.menu add command -label "Export: Tabelle der Trochoiden-Punkte (Semikolon-Separiert)" \
	-command "TexportCSV"
    .mbar.file.menu add command -label "Export: Tabelle der Trochoiden-Punkte (Komma-Separiert)" \
	-command "TexportCSVkomma"
    .mbar.file.menu add separator
    .mbar.file.menu add command -label "Postscript-Datei erstellen" \
        -command {VPostscript}
    .mbar.file.menu add separator
    .mbar.file.menu add command -label Exit -command {
	exit
    }

    bind .mbar.file <Any-Enter> {
        setStatuszeile "Speichern der Getriebe-Parameter, (Grafik-) Einstellungen, Export als DXF-, Postscript-Datei oder Tabelle"
    }
    bind .mbar.file <Any-Leave> {
        setStatuszeile ""
    }

     menu .mbar.type.menu
    .mbar.type.menu add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mt-t.hlp"
    }

    .mbar.type.menu add separator
    .mbar.type.menu add command -label "Gelenkgetriebe darstellen" -command {source dromeg-4.tcl}
    .mbar.type.menu add separator
    .mbar.type.menu add radiobutton -label Epitrochoide \
	-variable type_ -value Epitrochoide -command TSetType
    .mbar.type.menu add radiobutton -label Peritrochoide \
	-variable type_ -value Peritrochoide -command TSetType
    .mbar.type.menu add radiobutton -label Hypotrochoide \
	-variable type_ -value Hypotrochoide -command TSetType
    .mbar.type.menu add separator
    .mbar.type.menu add radiobutton -label "Doppelte Erzeugung der gleichen Trochoide" \
	-variable type_ -value "DoppelteErzeugung" -command TSetType

    bind .mbar.type <Any-Enter> {
        setStatuszeile "Wechsel des Getriebetyps (umlaufenden und feststehendes Rad), gleiche Trochoide mit anderen Rdern etc."
    }
    bind .mbar.type <Any-Leave> {
        setStatuszeile ""
    }

    menu .mbar.grafik.menu
    .mbar.grafik.menu add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mg-t.hlp"
    }
    .mbar.grafik.menu add separator
    .mbar.grafik.menu add command -label "Grafikfenstergroesse" \
	-command {TSetGrafikGroesse}
    .mbar.grafik.menu add command -label "Schritte pro Stegumdrehung" \
	-command {TSetSchritte}
    .mbar.grafik.menu add separator
    .mbar.grafik.menu add checkbutton -label "Linienstaerke breit" \
	-variable lineWidth -command TshowGrafikWithModifiedWidth
    .mbar.grafik.menu add command -label "Radius der Radachsen" \
	-command TsetRadiusAchsen
    .mbar.grafik.menu add separator
    .mbar.grafik.menu add checkbutton -label "Gestell an Rastpolkurve zeigen" \
	-variable showGestellRast -command {TShowGestellRast}

    .mbar.grafik.menu add checkbutton -label "Gestellgelenk zeigen" \
	-variable showGestell -command {TShowGestell}
    .mbar.grafik.menu add checkbutton -label "Getriebe zeigen" \
	-variable showGetriebe -command {TShowGetriebe}
    .mbar.grafik.menu add checkbutton -label "Getriebeumrisse hervorheben" \
	-variable showGetriebeUmrisse -command {TShowGetriebeUmrisse}
    .mbar.grafik.menu add checkbutton -label "Trochoide dynamisch modifizieren" \
	-variable showTrochMove
    .mbar.grafik.menu add checkbutton -label "Feldeinteilung/Ringe zeigen" \
	-variable showFelder -command {TShowFeldeinteilung3}
    #.mbar.grafik.menu add checkbutton -label "Feldeinteilung/BALLsche Kurve zeigen" \
    # 	-variable showFelder -command {TShowFeldeinteilung BALL}
    .mbar.grafik.menu add cascade -label "Feldeinteilung: nur Kurven zeigen" -menu .mbar.grafik.menu.kurven

    .mbar.grafik.menu add checkbutton -label "Trochoide zeigen" \
	-variable showTrochoide -command {TShowTrochoide}

    if {$showFelder == 0} then {
        set state "disabled"
    } else {
        set state "normal"
    }
    .mbar.grafik.menu add checkbutton -label "Inaktive Felder ausblenden" \
	-variable showSingleFeld -command {TShowSingleFeldeinteilung} -state $state
    .mbar.grafik.menu add separator
    .mbar.grafik.menu add command -label "Getriebe starten" \
	-command {TRunTrochoide -1 1}
    .mbar.grafik.menu add command -label "Getriebe anhalten" \
	-command {TStopTrochoide}

    bind .mbar.grafik <Any-Enter> {
        setStatuszeile "Men Grafik zum ndern der Grafik-Fenstergre, des dargestellten Inhalts, Linienbreiten, etc."
    }
    bind .mbar.grafik <Any-Leave> {
        setStatuszeile ""
    }
    menu .mbar.grafik.menu.kurven
    menuMbarGrafikMenuKurven

    menu .mbar.zoom.menu
    .mbar.zoom.menu add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mz-t.hlp"
    }
    .mbar.zoom.menu add separator
    .mbar.zoom.menu add command -label "Einpassen: Alles" \
	-command TZoomAll

    .mbar.zoom.menu add command -label "Einpassen: Bahn" \
	-command {
	    set last_massstab $massstab
	    set width [min $canvas_height  $canvas_width]
	    set massstab [expr ($width-10)/2./(abs($iZ+$iN)+abs($a_massstab))]
	    set a_ [expr $a_massstab*$massstab]
	    TSetI
	    xyViewDefault
	}
    .mbar.zoom.menu add command -label "Einpassen: Gangpolkurve" \
	-command {
	    set last_massstab $massstab
	    set width [min $canvas_height  $canvas_width]
	    set a [max [expr abs($iN)] [expr abs($a_massstab)]]
	    set massstab [expr ($width-10)/2./(abs($iZ+$iN)+$a)]
	    set a_ [expr $a_massstab*$massstab]
	    TSetI
	    xyViewDefault
	}
    .mbar.zoom.menu add separator
    .mbar.zoom.menu add command -label "Zoom: rein (durch Rechteck aufziehen)" \
	-command {TSetZoomFenster}
    .mbar.zoom.menu add command -label "Zoom: Letzter Zoom" \
	-command {TZoomLast}
    .mbar.zoom.menu add command -label "Zoom: raus zoomen" \
	-command {TZoomOut}
    .mbar.zoom.menu add command -label "Zoom: Massstab aendern" \
	-command {TSetMassstab}
	
    bind .mbar.zoom <Any-Enter> {
        setStatuszeile "Men Zoom: wiederholt und erweitert Zoom-Mglichkeiten der Zoom-Icons rechts von den Men-Knpfen"
    }
    bind .mbar.zoom <Any-Leave> {
        setStatuszeile ""
    }

     menu .mbar.help.menu
    .mbar.help.menu add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mh-t.hlp"
    }
    .mbar.help.menu add separator
    .mbar.help.menu add command -label "Grundsaetzliches" -command {
	ThelpHelp "dro-gh-t.hlp"
    }
    .mbar.help.menu add command -label "Hinweise zur Bedienoberflaeche" -command {
	ThelpHelp "dro-t.hlp"
    }
    .mbar.help.menu add command -label "Info" -command {
	ThelpVersion "DROMEG-T" $dromegTVers
    }
    .mbar.help.menu add command -label "Copyright" -command {
	ThelpCopyright "DROMEG-T"
    }

    bind .mbar.help <Any-Enter> {
        setStatuszeile "Men Help mit allgemeinen Hinweisen zur Bedienoberflche, Infos und Copyright"
    }
    bind .mbar.help <Any-Leave> {
        setStatuszeile ""
    }


    tk_menuBar .mbar mbar.file .mbar.type .mbar.grafik .mbar.zoom \
	.mbar.help
    focus .mbar
}
###############################################################
proc menuMbarGrafikMenuKurven {} {

    global TShowBall TShowGang TShowUeber TShowSonder TShowRast TShowKK
    global rS_M showGetriebe rUe_

    #menu .mbar.grafik.menu.kurven

    catch {.mbar.grafik.menu.kurven delete 0 50}

    .mbar.grafik.menu.kurven add radiobutton -label "BALLsche Kurve nicht zeigen" -variable TShowBall -value 0 -command {TShowKurven}
    .mbar.grafik.menu.kurven add radiobutton -label "BALLsche Kurve Linientyp: _____" -variable TShowBall -value 1 -command {TShowKurven}
    .mbar.grafik.menu.kurven add radiobutton -label "BALLsche Kurve Linientyp: _ _ _" -variable TShowBall -value 2 -command {TShowKurven}
    #tk_messageBox -message "showGetriebe=$showGetriebe"
    if {$showGetriebe != 0} then {
        # Getriebe wird gezeigt, also auch die Gangpolkurve
        set TShowGang 0
        set state "disabled"
    } else {
        set state "normal"
    }
    .mbar.grafik.menu.kurven add radiobutton -label "Gangpolkurve nicht zeigen" -variable TShowGang -value 0 -command {TShowGetriebe} -state $state
    .mbar.grafik.menu.kurven add radiobutton -label "Gangpolkurve Linientyp: _____" -variable TShowGang -value 1 -command {TcreateDXF no} -state $state
    .mbar.grafik.menu.kurven add radiobutton -label "Gangpolkurve Linientyp: _ _ _" -variable TShowGang -value 2 -command {TcreateDXF no} -state $state
    if {[info exists rUe_(0)] == 0 ||$rUe_(0) == 0} then {
        # Uebergangskurven existieren nicht
        set TShowUeber 0
        set state "disabled"
    } else {
        set state "normal"
    }
    .mbar.grafik.menu.kurven add radiobutton -label "Uebergangskurve nicht zeigen" -variable TShowUeber -value 0 -command {TShowKurven} -state $state
    .mbar.grafik.menu.kurven add radiobutton -label "Uebergangskurve Linientyp: _____" -variable TShowUeber -value 1 -command {TShowKurven} -state $state
    .mbar.grafik.menu.kurven add radiobutton -label "Uebergangskurve Linientyp: _ _ _" -variable TShowUeber -value 2 -command {TShowKurven} -state $state

    if {[info exists rS_M] == 0 || $rS_M == "existiert nicht"} then {
        # Sonderfall existiert nicht
        set TShowSonder 0
        set state "disabled"
    } else {
        set state "normal"
    }
    .mbar.grafik.menu.kurven add radiobutton -label "Sonderfall nicht zeigen" -variable TShowSonder -value 0 -command {TShowKurven} -state $state
    .mbar.grafik.menu.kurven add radiobutton -label "Sonderfall Linientyp: _____" -variable TShowSonder -value 1 -command {TShowKurven} -state $state
    .mbar.grafik.menu.kurven add radiobutton -label "Sonderfall Linientyp: _ _ _" -variable TShowSonder -value 2 -command {TShowKurven} -state $state
    
    if {$showGetriebe != 0} then {
        # Getriebe wird gezeigt, also auch die Gangpolkurve
        set TShowGang 0
        set state "disabled"
    } else {
        set state "normal"
    }
    .mbar.grafik.menu.kurven add radiobutton -label "Rastpolkurve nicht zeigen" -variable TShowRast -value 0 -command {TShowGetriebe} -state $state
    .mbar.grafik.menu.kurven add radiobutton -label "Rastpolkurve Linientyp: _____" -variable TShowRast -value 1 -command {TcreateDXF no} -state $state
    .mbar.grafik.menu.kurven add radiobutton -label "Rastpolkurve Linientyp: _ _ _" -variable TShowRast -value 2 -command {TcreateDXF no} -state $state
    
    if {$showGetriebe != 0} then {
        # Getriebe wird gezeigt, also auch der erzeugende Punkt
        set TShowKK 0
        set state "disabled"
    } else {
        set state "normal"
    }
    .mbar.grafik.menu.kurven add radiobutton -label "Punkt auf Trochoide nicht zeigen" -variable TShowKK -value 0 -command {TShowGetriebe} -state $state
    .mbar.grafik.menu.kurven add radiobutton -label "Punkt auf Trochoide: Linientyp: _____" -variable TShowKK -value 1 -command {TcreateDXF no} -state $state
}
###############################################################
proc TPullDownMenuUpdate {} {

    global showFelder Android
    
    if {$Android == 1} then {
        TPullDownMenuUpdate_Android
        return
    }

    catch {.mbar.grafik.menu delete 16 50}

    if {$showFelder == 0} then {
        set state "disabled"
    } else {
        set state "normal"
    }

    .mbar.grafik.menu add checkbutton -label "Inaktive Felder ausblenden" \
	-variable showSingleFeld -command {TShowSingleFeldeinteilung} -state $state
    .mbar.grafik.menu add separator
    .mbar.grafik.menu add command -label "Getriebe starten" \
	-command {TRunTrochoide -1 1}
    .mbar.grafik.menu add command -label "Getriebe anhalten" \
	-command {TStopTrochoide}
    menuMbarGrafikMenuKurven
}
####################################################
proc TStatusFelder {} {
     global type_ iZ_A iN_A iN iZ iZ_M iN_M rB_massstab rUe_ a_massstab
     global rB_ wc m_  gamma0_ Pi ww phi_ gamma0_ rG_ phi_grad gam0_grad
     global showFelder statuszeile kueStatus nW_ rS_M rS
     global Android

     if {$Android == 1} then {
        TStatusFelder_Android
        return
     }

     destroy $ww.b
     destroy $ww.b.l1
     destroy $ww.b.l2
     destroy $ww.b.l3

     #if {$showFelder == 1} then {
         frame $ww.b
         pack $ww.b -fill x -in $ww -side top -anchor n

        label $ww.b.l1 -text "r" -bd 0
        pack $ww.b.l1 -in $ww.b -side left -anchor n
        label $ww.b.l2 -text "B  =" -bd 0
        pack $ww.b.l2 -in $ww.b -side left -anchor s
        label $ww.b.l3 -textvariable rB_massstab
        pack $ww.b.l3 -in $ww.b -side right

        bind $ww.b <Any-Enter> {
            $wc itemconfigure ball -width 2
            if {$showFelder == 1} then {
                setStatuszeile "'Linke Maustaste' verlegt \
erzeugenden Punkt auf die BALLsche Kurve"
               $ww.b.l3 configure -relief raised
            } else {
                setStatuszeile " "
            }
        }
        bind $ww.b <Any-Leave> {
            $wc itemconfigure ball -width 1
            setStatuszeile " "
            if {$showFelder == 1} then {
                $ww.b.l3 configure -relief flat
            }
        }
        bind $ww.b.l3 <Button-1> {
            TprepareRestart
            set a_ [expr $rB_]
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
            TSetSchnittBlue
            TRestartTrochoide
        }
    #}

    destroy $ww.g2
    destroy $ww.g2.l1
    destroy $ww.g2.l2
    destroy $ww.g2.l3

    frame $ww.g2
    pack $ww.g2 -fill x -in $ww -side top -anchor n

    label $ww.g2.l1 -text "r" -bd 0
    pack $ww.g2.l1 -in $ww.g2 -side left -anchor n
    label $ww.g2.l2 -text "G  =" -bd 0
    pack $ww.g2.l2 -in $ww.g2 -side left -anchor s
    label $ww.g2.l3 -textvariable iN
    pack $ww.g2.l3 -in $ww.g2 -side right

    bind $ww.g2 <Any-Enter> {
        $wc itemconfigure gang -width 2
        setStatuszeile "'Linke Maustaste' verlegt \
erzeugenden Punkt auf die Gangpolkurve"
        $ww.g2.l3 configure -relief raised
    }
    bind $ww.g2 <Any-Leave> {
        $wc itemconfigure gang -width 1
        setStatuszeile " "
        $ww.g2.l3 configure -relief flat
    }
    bind $ww.g2.l3 <Button-1> {
        TprepareRestart
        set a_ [expr $rG_]
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TSetSchnittBlue
        TRestartTrochoide
    }

    #destroy $ww.ns
    destroy $ww.k
    destroy $ww.k.l1
    destroy $ww.k.l2
    #destroy $ww.ue
    destroy $ww.w
    destroy $ww.sf

    #if {$showFelder == 1} then {

# Uebergangskurven
        frame $ww.k
        pack $ww.k -fill x -in $ww -side top -anchor n

        label $ww.k.l1 -text "Anzahl Uebergangskurven:"
        pack $ww.k.l1 -in $ww.k -side left
        label $ww.k.l2 -textvariable rUe_(0)
        pack $ww.k.l2 -in $ww.k -side right
        bind $ww.k <Any-Enter> {
        setStatuszeile "Anzahl der bergangskurven=Anzahl der Trochoiden, die Selbstberhrungspunkte aufweisen"
        }
        bind $ww.k <Any-Leave> {
            setStatuszeile ""
        }

# Frame fuer Uebergangskurven
        destroy $ww.ue
        frame $ww.ue
        pack $ww.ue -fill x -in $ww -side top -anchor n

        if {$kueStatus == "ok"} then {T_KueStatus }

        frame $ww.w
        pack $ww.w -fill x -in $ww -side top -anchor n

        label $ww.w.l1 -text "Anzahl Wendepunkte" -anchor w
        pack $ww.w.l1 -in $ww.w -side left
        label $ww.w.l4 -textvariable nW_ -bd 0
        pack $ww.w.l4 -in $ww.w -side right
        label $ww.w.l3 -text "," -bd 0
        pack $ww.w.l3 -in $ww.w -side right
        label $ww.w.l2 -text "0" -bd 0
        pack $ww.w.l2 -in $ww.w -side right
        bind $ww.w <Any-Enter> {
        setStatuszeile "Rote Zahl: wie hufig wechselt der Krmmungsmittelpunkt von einer Seite der Trochoide auf die andere."
        }
        bind $ww.w <Any-Leave> {
            setStatuszeile ""
        }

# Frame fuer Schnittpunkt
        destroy $ww.ns
        frame $ww.ns
        pack $ww.ns -fill x -in $ww -side top -anchor n


# Sonderfall: Kreis um Mittelpunkt des bewegten Rades durch Mittelpunkt des ruhenden Rades
        #if {[expr $iZ/2.] != [expr int($iZ/2.)]} then {
            frame $ww.sf
            pack $ww.sf -fill x -in $ww -side top -anchor n
            label $ww.sf.t -text "Sonderfall:" -anchor w
            pack $ww.sf.t -in $ww.sf -side left
            label $ww.sf.v -textvariable rS_M
            pack $ww.sf.v -in $ww.sf -side right
            #tk_messageBox -message "sonderfall"
            #tk_messageBox -message "iZ=$iZ, iN=$iN, iN_M=$iN_M, iZ_M=$iZ_M"

            bind $ww.sf <Any-Enter> {
                $wc itemconfigure sonderfall -width 2
                #setStatuszeile "'Linke Maustaste' verlegt erzeugenden Punkt auf den Kreis durch den Mittelpunkt des stehenden Rades"
                setStatuszeile "'Linke Maustaste': Sonderfall einer Trochoide mit Mehrfachschnittpunkt(en) ohne Selbstberhrungspunkte."
                $ww.sf.v configure -relief raised
            }
            bind $ww.sf <Any-Leave> {
                $wc itemconfigure sonderfall -width 1
                setStatuszeile " "
                $ww.sf.v configure -relief flat
            }
            bind $ww.sf.v <Button-1> {
                if {$rS_M != "existiert nicht"} then {
                    TprepareRestart
                    set a_ $rS
                    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
                    TSetSchnittBlue
                    TRestartTrochoide
                }
            }
        #}
    #}

# Frame fuer Copyright
    destroy $ww.fc

    frame $ww.fc
    pack $ww.fc -fill x -in $ww -side bottom -anchor s
    label $ww.fc.l1 -text "Copyright: 99,00,02,09,11,13,14,16" -bd 0 -foreground blue
    label $ww.fc.l2 -text "Volker Jaekel" -bd 0
    label $ww.fc.l3 -text "Pfingstweide 4" -bd 0
    label $ww.fc.l4 -text "D 35580 Wetzlar" -bd 0
    label $ww.fc.l5 -text "Germany" -bd 0
    pack $ww.fc.l5 -in $ww.fc -side bottom
    pack $ww.fc.l4 $ww.fc.l3 $ww.fc.l2 \
	-in $ww.fc -side bottom
    pack $ww.fc.l1 -in $ww.fc -side bottom -anchor w

    bind $ww.fc <Any-Enter> {
        setStatuszeile "Copyright-Hinweise."
    }
    bind $ww.fc <Any-Leave> {
        setStatuszeile ""
    }

}
################################################################
proc init_noAndroid {dromegTVers canvas_height canvas_width} {

    global wc 0x 0y last_0x last_0y

    set 0x [expr $canvas_width/2.]
    set 0y [expr $canvas_height/2.]
    set last_0x 0x
    set last_0y 0y
    destroy .c
    destroy .cvscroll
    destroy .chscroll
    destroy $wc
    destroy .d
    destroy .a- .aL .aE .a+
    destroy .iN- .iNL .iNE .iN+ .iN0
    destroy .iZ- .iZL .iZE .iZ+ .iZ0
    destroy .s
    TPullDownMenu
    wm title . "DROMEG-T Version $dromegTVers (Freeware)"
        #"Die Uebergangskurven von Trochoiden erzeugenden Raedergetrieben"
    #wm geometry . +10+5
    wm geometry . +1+1
    
    frame .s -background black
    pack .s -in . -expand yes -fill x
    label .s.statuszeile -textvariable statuszeile \
        -background black -foreground white 
    pack .s.statuszeile -in .s -fill x -side left
    setStatuszeile "Hier erscheinen Hinweise zur Programmbedienung \
       (z. B. wenn Sie den Mauszeige ueber eine Kurve legen)"

    frame .c
    pack .c -expand yes -fill both -padx 1 -pady 1

    frame .c.f 
    pack .c.f -expand yes -fill y -in .c -side left

    T_Grafik                                                 

    T_Status .c.f         

    frame .d
    pack .d -expand yes -fill both -padx 1 -pady 1

    T_Bind $wc
    
    TshowGrafik
}
################################################################
proc init_Android {dromegTVers canvas_height canvas_width {side right}} {

    global wc 0x 0y last_0x last_0y xregion_ yregion_ rechtsLinks
    
    set rechtsLinks $side

    set 0x [expr $canvas_width/2.]
    set 0y [expr $canvas_height/2.]
    set last_0x 0x
    set last_0y 0y
    destroy .c
    destroy .cvscroll
    destroy .chscroll
    destroy $wc
    destroy .d
    destroy .a- .aL .aE .a+
    destroy .iN- .iNL .iNE .iN+ .iN0
    destroy .iZ- .iZL .iZE .iZ+ .iZ0
    destroy .s
    #TPullDownMenu_Android .c.f
    wm title . "DROMEG-T Version $dromegTVers (Freeware)"
        #"Die Uebergangskurven von Trochoiden erzeugenden Raedergetrieben"
    #wm geometry . +10+5
    wm geometry . +1+1
    
    frame .s -background black
    pack .s -in . -expand yes -fill x 
    label .s.statuszeile -textvariable statuszeile \
        -background black -foreground white
    pack .s.statuszeile -in .s -fill x -side left
    setStatuszeile "Animation starten den Knopf mit der Startpistole"

    frame .c
    pack .c -expand yes -fill both -padx 1 -pady 1

    frame .c.f
    pack .c.f -expand yes -fill y -in .c -side $side

    T_Grafik
    TPullDownMenu_Android .c.f
    T_Status_Android .c.f

    # Zoom mit 2 Fingern
    bind $wc <<PinchToZoom>> {TSetZoomFenster2finger %W %X %Y %x %y %s}
    bind $wc <<FingerMotion>> {TSetscroll %X %Y %x %y %s}
    bind $wc <<FingerUp>> {TSetFinishScroll}

    frame .d
    pack .d -expand yes -fill both -padx 1 -pady 1

    #T_Bind_Android $wc

    TshowGrafik
}
##########################################################
proc TSetFinishScroll {} {

    global MovetoList

    global last_xMoveto xMoveto last_0x 0x last_massstab massstab
    global last_yMoveto yMoveto last_0y 0y wc xregion_ yregion_
    global last_x last_y

    catch {unset last_x}

    if {[info exists MovetoList] == 1} then {
        if {[string length $MovetoList] < 300} then {
            set anf 0
        } else {
            set anf [expr [string length $MovetoList]-300]
        }
        #tk_messageBox -message "[string range $MovetoList $anf end]last_xMoveto=$last_xMoveto, last_yMoveto=$last_yMoveto\nxMoveto=$xMoveto, yMoveto=$yMoveto\nlast_0x=$last_0x, last_0y=$last_0y\n0x=$0x, 0y=$0y\nxregion_=$xregion_, yregion_=$yregion_\nlast_massstab=$last_massstab, massstab=$massstab"
        set MovetoList ""
    } else {
        # kein aufruf von TSetscroll vorhanden
        #tk_messageBox -message "no MovetoList"
        #setStatuszeile "Bitte Bildaufbau abwarten ... ..."
        #t_wait TSetZoomFenster2finger_1
    }
}
##########################################################
proc TSetscroll {X Y x y state} {

    global last_xMoveto xMoveto last_0x 0x last_massstab massstab
    global last_yMoveto yMoveto last_0y 0y wc xregion_ yregion_
    global MovetoList

    global last2_xMoveto xMoveto last2_0x last_x
    global last2_yMoveto yMoveto last2_0y last_y

    if {[info exists MovetoList] == 1 && $MovetoList != ""} then {
        # do nothing
    } else {
        set last_xMoveto $xMoveto
        set last_0x $0x
        set last_yMoveto $yMoveto
        set last_0y $0y
        set last_massstab $massstab
    }
    set last2_xMoveto $xMoveto
    set last2_0x $0x
    set last2_yMoveto $yMoveto
    set last2_0y $0y

    if {[info exists last_x] == 1} then {

        #set xMoveto [expr $xMoveto+(($x-$last_x)/9999.-$xMoveto)/10000.]
        #set xMoveto [expr $xMoveto+($x-$last_x)/9999./100.]
        set xMoveto [expr $xMoveto-($x-$last_x)/9999./10.]
        $wc xview moveto $xMoveto
        set 0x [expr $0x-($xMoveto-$last2_xMoveto)*$xregion_/10.]

        #set yMoveto [expr $yMoveto+($y/9999.-$yMoveto)/10.]
        set yMoveto [expr $yMoveto-($y-$last_y)/9999./10.]
        $wc yview moveto $yMoveto
        set 0y [expr $0y-($yMoveto-$last2_yMoveto)*$yregion_/10.]
    }

    set last_x $x
    set last_y $y

    #append MovetoList "X=$X,Y=$Y,x=$x,y=$x,state=$state,xMoveto=$xMoveto,yMoveto=$yMoveto,0x=$0x,0y=$0y\n"
    if {$state != 1} then {
        tk_messageBox -message "X=$X, Y=$Y, x=$x, y=$x, state=$state, xMoveto=$xMoveto, yMoveto=$yMoveto,0x=$0x,0y=$0y"
    }
}
#############################################################
proc TSetZoomFenster2finger {wcw X Y dist angle state} {

    # state 0 -> zoom motion
    # state 1 -> zoom start
    # state 2 -> zoom end, 1st finger up
    # state 3 -> zoom end, 2nd finger up

# xzoom,yzoom: Koordinaten in "Getriebekoordinaten" des 1. Punktes des
#	       Zoom-Rechtecks
# xneu,yneu:   Koordinaten in "Getriebekoordinaten" des 2. Punktes des
#	       Zoom-Rechtecks
# 0x,0y:       Ursprung der "Getriebekoordinaten" in Koordinaten des
#	       Bildschirms (Ursprung oben links)
# xMoveto:     Position des linken randes des Bildauschnitts relativ
#	       zu $xregion_ als Zahlenwert zwischen 0 und 1
# xregion_:    Region, die durch verschieben des Bildausschnitts
#	       sichtbar gemacht werden kann, ohne den Massstab zu
#	       aendern

    global massstab wc last_massstab xneu yneu
    global canvas_height canvas_width xzoom yzoom zoom_v 0x 0y
    global statuszeile last_xMoveto last_yMoveto xMoveto yMoveto
    global last_0x last_0y yZoomPos1 xZoomPos1 yZoomPos2 xZoomPos2
    global default_xMoveto default_yMoveto xregion_ yregion_
    global default_xMovetoUr default_yMovetoUr

    global m_ iN gamma0_ Pi rR a_ a_massstab

    global last_X last_Y last_dist a_X a_Y a_dist

    global last_a_ a_ faktor_ massstab last_massstab
    #global iiiii text1

    #if {[info exists iiiii] == 0} then {
    #    set iiiii 0
    #}

    if {$state == 1} then {
        bind $wc <<FingerMotion>> {}
        bind $wc <<FingerUp>> {}
        set last_dist $dist

        TprepareRestart
        set last_massstab $massstab
        set last_a_ $a_

        #set iiiii -1
    } elseif {$state == 0} then {
        #incr iiiii
        #setStatuszeile "X=$X, Y=$Y, dist=$dist, i=$iiiii"
        #if {$iiiii < 30} then {
        #    return
        #}
        #set iiiii 0

        #zoom motion

        set faktor_ [expr double($dist)/double($last_dist)]
        #set faktor_ [expr sqrt(2.0)]
        set massstab [expr $massstab*$faktor_]
        #$wc scale all 0 0 $faktor_ $faktor_

        #$wc scale all [expr ($xMoveto-$default_xMoveto)*10.] [expr ($yMoveto-$default_yMoveto)*10.] $faktor_ $faktor_
        #$wc scale all [expr ($xMoveto-$default_xMoveto)*10./$faktor_] [expr ($yMoveto-$default_yMoveto)*10./$faktor_] $faktor_ $faktor_
        #$wc scale all [expr double($xMoveto-$default_xMoveto)/999999.] [expr double($yMoveto-$default_yMoveto)/999999.] $faktor_ $faktor_
        #$wc scale all [expr -1.*double($xMoveto-$default_xMoveto)] [expr -1.*double($yMoveto-$default_yMoveto)] $faktor_ $faktor_
        
        #$wc scale all [expr -999.*(.1*$xMoveto-$default_xMoveto)] [expr 999.*(.1*$yMoveto-$default_yMoveto)] $faktor_ $faktor_
        #$wc scale all [expr -999.*(.9*$xMoveto-$default_xMoveto)] [expr 999.*(.9*$yMoveto-$default_yMoveto)] $faktor_ $faktor_
        #$wc scale all [expr -999.*(.7*$xMoveto-$default_xMoveto)] [expr 999.*(.7*$yMoveto-$default_yMoveto)] $faktor_ $faktor_
        #$wc scale all [expr -999.*(.7*$xMoveto+0.3*$default_xMovetoUr-$default_xMoveto)] [expr 999.*(.7*$yMoveto+0.3*$default_yMovetoUr-$default_yMoveto)] $faktor_ $faktor_
        #.6/.4 --> nach rechts
        #.5/.5 --> nach rechts
        #.4/.6 --> nach rechts
        #.1/.9 --> nach rechts
        $wc scale all [expr -999.*(.9*$xMoveto+0.1*$default_xMovetoUr-$default_xMoveto)] [expr 999.*(.9*$yMoveto+0.1*$default_yMovetoUr-$default_yMoveto)] $faktor_ $faktor_
        #tk_messageBox -message "faktor_=$faktor_,\ndist=$dist\nlast_dist=$last_dist"

        set last_dist $dist
    } elseif {$state >= 2} then {
        # erster Finger ist oder beide Finger sind oben nach dem Zoomen

        #$wc xview moveto $xMoveto
        set xMovetoBackup $xMoveto
        set 0x [expr $0x-($xMoveto-$last_xMoveto)*$xregion_/10.]
        #$wc yview moveto $yMoveto
        set yMovetoBackup $yMoveto
        set 0y [expr $0y-($yMoveto-$last_yMoveto)*$yregion_/10.]

        setStatuszeile "Bitte Bildaufbau abwarten ..."
        t_wait TSetZoomFenster2finger_1

        tk_messageBox -message "xMoveto=$xMoveto, default_xMoveto=$default_xMoveto"

        t_wait TSetZoomFenster2finger_3
        set showGetriebe 0
        TShowGetriebe
        set a_ [expr $last_a_/($last_massstab/$massstab)]
        #tk_messageBox -message "a_=$a_\nlast_a_=$last_a_\nlast_massstab=$last_massstab\nmassstab=$massstab"
        set showGetriebe 1
        TShowGetriebe
        #tk_messageBox -message "done"
        TRestartTrochoide
        setStatuszeile ""
        tk_messageBox -message "wait2"

        set xMoveto $xMovetoBackup
        set yMoveto $yMovetoBackup

        $wc xview moveto $xMoveto
        #set 0x [expr $0x-($xMoveto-$last_xMoveto)*$xregion_/10.]
        $wc yview moveto $yMoveto
        #set 0y [expr $0y-($yMoveto-$last_yMoveto)*$yregion_/10.]

        t_wait TSetZoomFenster2finger_1
        bind $wc <<FingerMotion>> {TSetscroll %X %Y %x %y %s}
        bind $wc <<FingerUp>> {TSetFinishScroll}
        
        set default_xMoveto $xMoveto
        set default_yMoveto $yMoveto
    }
}
#############################################################
proc T_Bind_Android {wc} {
    global rB_ rG_ a_ m_ iN gamma0_ Pi statuszeile gam0_grad
    global phi_ a_massstab massstab iN_A iZ_A Pi showTrochMove
    global showFelder
    global xMoveto last_xMoveto 0x last_0x xregion_
    global yMoveto last_yMoveto 0y last_0y yregion_
    global last_massstab rS rS_M

    return

    foreach ibind {rR rG_ K Trochoide} {
        $wc bind $ibind <Any-Enter> "TEnterrRrGKorTrochoide $ibind $wc"
        $wc bind $ibind <Any-Leave> "TLeaverRrGKorTrochoide $ibind $wc"
    }
#   $wc bind Trochoide <Button-1> { TRunTrochoide -1 1}
#   $wc bind Trochoide <Button-3> { TRunTrochoide +1 1}

    $wc bind rast <Any-Enter> {
        $wc itemconfigure rast -width 2
        setStatuszeile "'Rand des feststehenden Rades' = Rastpolkurve"
    }
    $wc bind rast <Any-Leave> {
        $wc itemconfigure rast -width 1
    }
    $wc bind gang <Any-Enter> {
        $wc itemconfigure gang -width 2
        setStatuszeile "'Linke Maustaste' verlegt erzeugenden Punkt auf den 'Rand des umlaufenden Rades' = Gangpolkurve"
    }
    $wc bind gang <Any-Leave> {
        $wc itemconfigure gang -width 1
#        TSetrRrGwidth2
        setStatuszeile " "
    }
    $wc bind gang <Button-1> {
        TprepareRestart
        set a_ [expr $rG_]
        set a_massstab [expr $a_/$massstab]
        #if {$showFelder==1} then {
            TSetSchnittBlue
        #}
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TRestartTrochoide
    }
    $wc bind gang <Button-3> {
        TprepareRestart
        set a_ [expr $rG_]
        set a_massstab [expr $a_/$massstab]
        #if {$showFelder==1} then {
            TSetSchnittBlue
        #}
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TRestartTrochoide
    }

    $wc bind sonderfall <Any-Enter> {
        $wc itemconfigure sonderfall -width 2
        #setStatuszeile "'Linke Maustaste' verlegt erzeugenden Punkt auf Kreis durch Mittelpunkt des stehenden Rades"
        setStatuszeile "'Linke Maustaste': Sonderfall einer Trochoide mit Mehrfachschnittpunkt(en) ohne Selbstberhrungspunkte."
    }
    $wc bind sonderfall <Any-Leave> {
        $wc itemconfigure sonderfall -width 1
#        TSetrRrGwidth2
        setStatuszeile " "
    }
    $wc bind sonderfall <Button-1> {
        if {$rS_M != "existiert nicht"} then {
            TprepareRestart
            set a_ $rS
            #if {$showFelder==1} then {
                TSetSchnittBlue
            #}
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
            TRestartTrochoide
        }
    }
    $wc bind sonderfall <Button-3> {
        if {$rS_M != "existiert nicht"} then {
            TprepareRestart
            set a_ $rS
            #if {$showFelder==1} then {
                TSetSchnittBlue
            #}
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
            TRestartTrochoide
        }
    }

    $wc bind ball <Any-Enter> {
        $wc itemconfigure ball -width 2
        setStatuszeile "'Linke Maustaste' verlegt \
erzeugenden Punkt auf die BALLsche Kurve"
    }
    $wc bind ball <Any-Leave> {
        $wc itemconfigure ball -width 1
        setStatuszeile " "
    }
$wc bind t <Any-Enter> {
        $wc itemconfigure t -width 2
        setStatuszeile "Mit 'Linker' bzw. 'rechter Maustaste' kann der \
 die Trochoide erzeugende Punkt bewegt werden"
    }
    $wc bind t <Any-Leave> {
        $wc itemconfigure t -width 1
        setStatuszeile " "
    }
    $wc bind t <ButtonPress-1> {
        set xPos %x
        set yPos %y
        set xPosT $xPos
        set yPosT $yPos
    }
    $wc bind t <B1-Motion> {
        VerschiebeKnoten $wc 4 [expr %x-$xPos] [expr %y-$yPos]
        set xPos %x
        set yPos %y
        if {$showTrochMove == 1} then {
            set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
            set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
            set xG [expr $rG_*$m_*cos($phi_)]
            set yG [expr $rG_*$m_*sin($phi_)]
            set dx [expr $xPos-$xG-( $xPosT-$x)]
            set dy [expr $yPos-$yG-($yPosT-$y)]
            set winkel_alt [expr atan2(($y-$yG),($x-$xG))]
            set winkel_neu [expr atan2($dy,$dx)]
            set gamma0_ [expr $gamma0_+($winkel_neu-$winkel_alt)]
            set gam0_grad [expr $gamma0_*180./$Pi]
            set a_ [expr sqrt($dx*$dx+$dy*$dy)]
            set a_massstab [expr $a_/$massstab]
            TSetSchnittBlue
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
           set xPosT $xPos
           set yPosT $yPos
        }
    }
    $wc bind t <ButtonRelease-1> {
        set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set dx [expr $xPos-$xG-( $xPosT-$x)]
        set dy [expr $yPos-$yG-($yPosT-$y)]
        set xG [expr $rG_*$m_*cos($phi_)]
        set yG [expr $rG_*$m_*sin($phi_)]
        set winkel_alt [expr atan2(($y-$yG),($x-$xG))]
        set winkel_neu [expr atan2($dy,$dx)]
        set gamma0_ [expr $gamma0_+($winkel_neu-$winkel_alt)]
        set gam0_grad [expr $gamma0_*180./$Pi]
        set a_ [expr sqrt($dx*$dx+$dy*$dy)]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    $wc bind t <ButtonPress-3> {
        set xPos %x
        set yPos %y
        set xPosT $xPos
        set yPosT $yPos
        set x [xTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set y [yTrochoide $rG_ $m_ $phi_ $a_ $gamma0_]
        set xG [expr $rG_*$m_*cos($phi_)]
        set yG [expr $rG_*$m_*sin($phi_)]
        set xR [expr $x-$xG]
        set yR [expr $y-$yG]
#        set gamma [expr atan2(($y-$yG),($x-$xG))]
        if {$yR > [expr $xR]} then {
                set follow "x"
        } else {
                set follow "y"
        }
    }
    $wc bind t <B3-Motion> {
        if {$follow == "x"} then {
            set dx [expr %x-$xPos] 
            VerschiebeKnoten $wc 4 $dx [expr $dx/$xR*$yR]
        } else {
            set dy [expr %y-$yPos]
            VerschiebeKnoten $wc 4 [expr $dy*$xR/$yR] $dy
        }
        set xPos %x
        set yPos %y

        if {$showTrochMove == 1} then {
            set dx [expr $xPos-$xG-[expr $xPosT-$x]]
            set dy [expr $yPos-$yG-[expr $yPosT-$y]]
            set a_ [expr sqrt($dx*$dx+$dy*$dy)]
            set a_massstab [expr $a_/$massstab]
            TSetSchnittBlue
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        }
    }
    $wc bind t <ButtonRelease-3> {
        set dx [expr $xPos-$xG-[expr $xPosT-$x]]
        set dy [expr $yPos-$yG-[expr $yPosT-$y]]
        set a_ [expr sqrt($dx*$dx+$dy*$dy)]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    $wc bind ball <Button-1> {
        TprepareRestart
        set a_ [expr $rB_]
        set a_massstab [expr $a_/$massstab]
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TSetSchnittBlue
        TRestartTrochoide
    }
    $wc bind ball <Button-3> {
        TprepareRestart
        set a_ [expr $rB_]
        set a_massstab [expr $a_/$massstab]
        TSetSchnittBlue
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TRestartTrochoide
    }
    $wc bind rG_ <Button-1> {
        set iN_A [expr $iN_A+1]
        TSetI
        calculatePara $iZ $iN $rR
        calculateKueKb "no" $wc $iN $iZ $Pi $rR
        modifyGetriebe $wc $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        setGetriebetyp $iZ $iN 
    }
    $wc bind rG_ <Button-3> {
        if {$iN_A>1} {
	    set iN_A [expr $iN_A-1]
            TSetI
	    calculatePara $iZ $iN $rR
       	    calculateKueKb "no" $wc $iN $iZ $Pi $rR
            modifyGetriebe $wc $rR
	    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
            setGetriebetyp $iZ $iN
        }
    }
    $wc bind rR <Button-1> {
        set iZ_A [expr $iZ_A+1]
        TSetI
        modifyGetriebe $wc $rR
        calculatePara $iZ $iN $rR
        calculateKueKb "no" $wc $iN $iZ $Pi $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    $wc bind rR <Button-3> {
        if {$iZ_A>1} {
	    set iZ_A [expr $iZ_A-1]
            TSetI
            modifyGetriebe $wc $rR
	    calculatePara $iZ $iN $rR
            calculateKueKb "no" $wc $iN $iZ $Pi $rR
	    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
            setGetriebetyp $iZ $iN
        }
    }
    $wc bind K <Button-1> {
        set da [expr $a_*0.1]
        set a_ [expr $a_+$da]
        set a_massstab [expr $a_/$massstab]
        #if {$showFelder==1} then {
            TSetSchnittBlue
        #}
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    }
    $wc bind K <Button-3> {
        set da [expr $a_*0.1]
        set a_ [expr $a_-$da]
        set a_massstab [expr $a_/$massstab]
        #if {$showFelder==1} then {
            TSetSchnittBlue
        #}
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    }
}
#############################################################
proc T_Status_Android {w} {
    global type_ iZ_A iN_A iN iZ iZ_M iN_M rB_massstab rUe_ a_massstab
    global rB_ wc m_  gamma0_ Pi ww phi_ gamma0_ rG_ phi_grad gam0_grad
    global showFelder statuszeile RichtungBackup geschwBackup aFaktor

    set ww $w
    frame $ww.t
    pack $ww.t -fill x -in $w -side top -anchor n

    label $ww.t.l1 -text "TYP:"
    pack $ww.t.l1 -in $ww.t -side left

    menubutton $ww.t.m -text "?" -menu $ww.t.m.menu -relief raised
    pack $ww.t.m -in $ww.t -side right
    menu $ww.t.m.menu
    $ww.t.m.menu add radiobutton -label Epitrochoide \
	-variable type_ -value Epitrochoide -command TSetType
    $ww.t.m.menu add radiobutton -label Peritrochoide \
	-variable type_ -value Peritrochoide -command TSetType
    $ww.t.m.menu add radiobutton -label Hypotrochoide \
	-variable type_ -value Hypotrochoide -command TSetType
    $ww.t.m.menu add separator
    $ww.t.m.menu add radiobutton -label "Doppelte Erzeugung" \
	-variable type_ -value "DoppelteErzeugung" -command TSetType
    tk_menuBar $ww.t.m
    focus $ww.t.m
    
    bind $ww.t <Any-Enter> {
    setStatuszeile "Wechsel des Trochoiden-Types oder Wechsel zu einem anderen Rderpaar, das die gleiche Trochoide erzeugt."
    }
    bind $ww.t <Any-Leave> {
        setStatuszeile ""
    }

    label $ww.t.l2 -textvariable type_ -width 12
    pack $ww.t.l2 -in $ww.t -side right


    frame $ww.r
    pack $ww.r -fill x -in $w -side top -anchor n

    label $ww.r.l1 -text "r" -bd 0
    pack $ww.r.l1 -in $ww.r -side left -anchor c
    label $ww.r.l2 -text "R" -bd 0
    pack $ww.r.l2 -in $ww.r -side left -anchor s
    label $ww.r.l3 -text "=" -bd 0
    pack $ww.r.l3 -in $ww.r -side left -anchor c
    button $ww.r.iZ- -text "<" -width 1 -command {
        TprepareRestart
	set change "ok"
	if {$iZ_A == 1} then {set change "not ok"}
                if {$type_ == "Hypotrochoide"} then {
	    if {$iN_A == [expr $iZ_A-1]} then {set change "not ok"}
	}
	if {$change == "ok"} then {set iZ_A [expr $iZ_A-1]}
	TSetI
	TRestartTrochoide
    }
    entry $ww.r.e1 -width 4 -textvariable iZ_A
    bind $ww.r.e1 <Return> {
        if {$type_ == "Peritrochoide"} then {
            if {$iZ_A >= $iN_A} then {
                set iZ_A [expr $iN_A-1]
            }
        } elseif {$type_ == "Hypotrochoide"} then {
            if {$iZ_A <= $iN_A} then {set iZ_A [expr $iN_A+1]}
        }
        TSetI
    }
    button $ww.r.iZ+ -text ">" -width 1 -command {
	TprepareRestart
        set change "ok"
	if {$type_ == "Peritrochoide"} then {
	    if {$iN_A == [expr $iZ_A+1]} then {set change "not ok"}
	}
	if {$change == "ok"} then {set iZ_A [expr $iZ_A+1]}
	TSetI
	TRestartTrochoide
    }
    pack $ww.r.iZ+ $ww.r.e1 $ww.r.iZ- -in $ww.r -side right

    bind $ww.r <Any-Enter> {TRaiserRrGKorTrochoide rR $wc
        $ww.r.e1 configure -foreground red
        setStatuszeile "Vergrern oder verkleinern des feststehenden Rades."}
    bind $ww.r <Any-Leave> {TLeaverRrGKorTrochoide rR $wc
        $ww.r.e1 configure -foreground black
        setStatuszeile ""}

    frame $ww.g
    pack $ww.g -fill x -in $w -side top -anchor n

    label $ww.g.l1 -text "r" -bd 0
    pack $ww.g.l1 -in $ww.g -side left -anchor c
    label $ww.g.l2 -text "G" -bd 0
    pack $ww.g.l2 -in $ww.g -side left -anchor s
    label $ww.g.l3 -text "=" -bd 0
    pack $ww.g.l3 -in $ww.g -side left -anchor c
    button $ww.g.iN- -text "<" -width 1 -command {
        TprepareRestart
        set change "ok"
	if {$iN_A == 1} then {set change "not ok"}
	if {$type_ == "Peritrochoide"} then {
	    if {$iN_A == [expr $iZ_A+1]} then {set change "not ok"}
	}
	if {$change == "ok"} then {set iN_A [expr $iN_A-1]}
	TSetI
	TRestartTrochoide
    }
    entry $ww.g.e1 -width 4 -textvariable iN_A
    bind $ww.g.e1 <Return> {
        if {$type_ == "Peritrochoide"} then {
            if {$iN_A <= $iZ_A} then {
                set iN_A [expr $iZ_A+1]
            }
        }
        if {$type_ == "Hypotrochoide"} then {
            if {$iN_A >= $iZ_A} then {
                set iN_A [expr $iZ_A-1]
            }
        }
        TSetI
    }
    button $ww.g.iN+ -text ">" -width 1 -command {
	TprepareRestart
        set change "ok"
        if {$type_ == "Hypotrochoide"} then {
	    if {$iN_A == [expr $iZ_A-1]} then {set change "not ok"}
	}
	if {$change == "ok"} then {set iN_A [expr $iN_A+1]}
	TSetI
	TRestartTrochoide
    }
    pack $ww.g.iN+ $ww.g.e1 $ww.g.iN- -in $ww.g -side right

    bind $ww.g <Any-Enter> {TRaiserRrGKorTrochoide rG_ $wc
        $ww.g.e1 configure -foreground red
        setStatuszeile "Vergrern oder verkleinern des umlaufenden Rades."}
    bind $ww.g <Any-Leave> {TLeaverRrGKorTrochoide rG_ $wc
        $ww.g.e1 configure -foreground black
        setStatuszeile ""}

    frame $ww.rg
    pack $ww.rg -fill x -in $w -side top -anchor n
    bind $ww.rg <Any-Enter> {
        setStatuszeile "Anzeige des bersetzungsverhltnisses zwischen stehendem und umlaufendem Rad"
    }
    bind $ww.rg <Any-Leave> {
        setStatuszeile ""
    }

    frame $ww.a
    pack $ww.a -fill x -in $w -side top -anchor n

    menubutton $ww.a.la -text "Abstand" -menu $ww.a.la.menu -relief raised
    menu $ww.a.la.menu
    $ww.a.la.menu add radiobutton -variable aFaktor -value 1. -label "Differenz=1."
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.5 -label "Differenz=0.5"
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.2 -label "Differenz=0,2"
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.1 -label "Differenz=0.1"
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.05 -label "Differenz=0.05"
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.02 -label "Differenz=0.02"
    $ww.a.la.menu add radiobutton -variable aFaktor -value 0.01 -label "Differenz=0.01"
    pack $ww.a.la -in $ww.a -side left -anchor n
    #label $ww.a.l1 -text "M" -bd 0
    #pack $ww.a.l1 -in $ww.a -side left -anchor n
    #label $ww.a.l2 -text "G" -bd 0
    #pack $ww.a.l2 -in $ww.a -side left -anchor s
    #label $ww.a.l3 -text "- K  =" -bd 0
    #pack $ww.a.l3 -in $ww.a -side left -anchor n

    button $ww.a.e1 -text "<" -width 1 -command {
	TprepareRestart
        set a_massstab [round3 [expr $a_massstab-1.*$aFaktor]]
	set a_ [expr $a_massstab*$massstab]
	modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TSetSchnittBlue
        TRestartTrochoide
    }

    entry $ww.a.e -textvariable a_massstab -width 10
    button $ww.a.e2 -text ">" -width 1 -command {
	TprepareRestart
        set a_massstab [round3 [expr $a_massstab+1.*$aFaktor]]
	set a_ [expr $a_massstab*$massstab]
	modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TSetSchnittBlue
        TRestartTrochoide
    }

    bind $ww.a.e <Return> {set a_ [expr $a_massstab*$massstab]
#        TSetI
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TSetSchnittBlue}
    #pack $ww.a.e2 $ww.a.e $ww.a.e1 $ww.a.f2 $ww.a.f $ww.a.f1 -in $ww.a -side right
    pack $ww.a.e2 $ww.a.e $ww.a.e1 -in $ww.a -side right

    bind $ww.a <Any-Enter> {TRaiserRrGKorTrochoide K $wc
        $ww.a.e configure -foreground red
        setStatuszeile "Abstand des die Trochoide erzeugenden Punktes vom Mittelpunkt des umlaufenden Rades"}
    bind $ww.a <Any-Leave> {TLeaverRrGKorTrochoide K $wc
         $ww.a.e configure -foreground black
         setStatuszeile ""}

    frame $ww.phi
    pack $ww.phi -fill x -in $w -side top -anchor n

    label $ww.phi.l1 -text "Phi" -bd 0
    pack $ww.phi.l1 -in $ww.phi -side left -anchor n
    label $ww.phi.l2 -text " in " -bd 0
    pack $ww.phi.l2 -in $ww.phi -side left -anchor n
    label $ww.phi.l3 -text "Grad" -bd 0
    pack $ww.phi.l3 -in $ww.phi -side left -anchor n
    label $ww.phi.l4 -text " =" -bd 0
    pack $ww.phi.l4 -in $ww.phi -side left -anchor n
    entry $ww.phi.e -textvariable phi_grad -width 10
    bind $ww.phi.e <Return> {
        set phi_ [expr $phi_grad*$Pi/180.]
        modifyGetriebe $wc $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi 
    }
    pack $ww.phi.e -in $ww.phi -side right
    bind $ww.phi <Any-Enter> {
        setStatuszeile "Winkel der Gerade vom Mittelpunkt des stehenden Rades zum Mittelpunkt des umlaufenden Rades"
    }
    bind $ww.phi <Any-Leave> {
        setStatuszeile ""
    }


frame $ww.gam
    pack $ww.gam -fill x -in $w -side top -anchor n

    label $ww.gam.l1 -text "Gamma" -bd 0
    pack $ww.gam.l1 -in $ww.gam -side left -anchor n
     label $ww.gam.l2 -text "0" -bd 0
    pack $ww.gam.l2 -in $ww.gam -side left -anchor s
    label $ww.gam.l3 -text " in " -bd 0
    pack $ww.gam.l3 -in $ww.gam -side left -anchor n
    label $ww.gam.l4 -text "Grad" -bd 0
    pack $ww.gam.l4 -in $ww.gam -side left -anchor n
    label $ww.gam.l5 -text " =" -bd 0
    pack $ww.gam.l5 -in $ww.gam -side left -anchor n
    entry $ww.gam.e -textvariable gam0_grad  -width 10
    bind $ww.gam.e <Return> {
        set gamma0_ [expr $gam0_grad*$Pi/180.]
        modifyGetriebe $wc $rR
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
    }
    pack $ww.gam.e -in $ww.gam -side right
    bind $ww.gam <Any-Enter> {
        setStatuszeile "Winkel der Gerade vom Mittelpunkt des umlaufenden Rades zum erzeugenden Punkt der Trochoide, bei Phi=0"
    }
    bind $ww.gam <Any-Leave> {
        setStatuszeile ""
    }
    
    TStatusFelder_Android
    
    # Frame fuer Copyright
    destroy $ww.fc

    frame $ww.fc
    pack $ww.fc -fill x -in $ww -side bottom -anchor s
    label $ww.fc.l1 -text "Copyright: 99,00,02,09,11,13,14" -bd 0 -foreground blue
    label $ww.fc.l2 -text "Volker Jaekel" -bd 0
    label $ww.fc.l3 -text "Pfingstweide 4" -bd 0
    label $ww.fc.l4 -text "D 35580 Wetzlar" -bd 0
    label $ww.fc.l5 -text "Germany" -bd 0
    pack $ww.fc.l5 -in $ww.fc -side bottom
    pack $ww.fc.l4 $ww.fc.l3 $ww.fc.l2 \
	-in $ww.fc -side bottom
    pack $ww.fc.l1 -in $ww.fc -side bottom -anchor w

    bind $ww.fc <Any-Enter> {
        setStatuszeile "Copyright-Hinweise."
    }
    bind $ww.fc <Any-Leave> {
        setStatuszeile ""
    }
    
    frame $ww.s
    pack $ww.s -fill x -in $w -side bottom -anchor n
    bind $ww.s <Any-Enter> {
        setStatuszeile "Anzeige der Anzahl der Schleifen, Spitzen bzw. 'Wellen' der Trochoide"
    }
    bind $ww.s <Any-Leave> {
        setStatuszeile ""
    }

    label $ww.s.l1 -text "Anzahl Schleifen:"
    pack $ww.s.l1 -in $ww.s -side left
    label $ww.s.l2 -textvariable iZ_M
    pack $ww.s.l2 -in $ww.s -side right

    frame $ww.us
    pack $ww.us -fill x -in $w -side bottom -anchor n
    bind $ww.us <Any-Enter> {
        setStatuszeile "Anzeige der Anzahl der Umlufe des beweglichen Rades um das stehende Rad pro Bewegungsperiode"
    }
    bind $ww.us <Any-Leave> {
        setStatuszeile ""
    }

    label $ww.us.l1 -text "Stegumlaeufe pro Periode:"
    pack $ww.us.l1 -in $ww.us -side left
    label $ww.us.l2 -textvariable iN_M
    pack $ww.us.l2 -in $ww.us -side right

    label $ww.rg.l1 -text "r" -bd 0
    pack $ww.rg.l1 -in $ww.rg -side left -anchor n
    label $ww.rg.l2 -text "R" -bd 0
    pack $ww.rg.l2 -in $ww.rg -side left -anchor s
    label $ww.rg.l3 -text "/" -bd 0
    pack $ww.rg.l3 -in $ww.rg -side left -anchor n
    label $ww.rg.l4 -text "r" -bd 0
    pack $ww.rg.l4 -in $ww.rg -side left -anchor n
    label $ww.rg.l5 -text "G" -bd 0
    pack $ww.rg.l5 -in $ww.rg -side left -anchor s
    label $ww.rg.l6 -text "=  i  =" -bd 0
    pack $ww.rg.l6 -in $ww.rg -side left -anchor n

    label $ww.rg.l7 -textvariable iN_M
    label $ww.rg.l8 -text "/"
    label $ww.rg.l9 -textvariable iZ_M
    pack $ww.rg.l7 $ww.rg.l8 $ww.rg.l9 -in $ww.rg -side right

    pack $ww.rg -fill x -in $w -side bottom -anchor n
}
#############################################################
proc TPullDownMenu_Android {w} {

global type_ rR a_  canvas_height canvas_width massstab iZ iN a_massstab
global rB_massstab rUe_ showTrochMove showFelder showTrochoide kueStatus
global wc Pi m_ gamma0_ last_massstab showGestell
global xMoveto last_xMoveto yMoveto last_yMoveto 0x 0y
global last_0x last_0y xZoomPos1 yZoomPos1 xzoom yzoom xneu yneu
global dromegTVers ww bitmapStop bitmapStart ischritte_ 
global wc dromegTVers rechtsLinks

#set zoomIn [image create bitmap -file dromegzi.xbm]
#set zoomOut [image create bitmap -file dromegzo.xbm]
set zoomLast [image create photo btimageZL_gif -file dromegzl-android.gif]
set zoomAll [image create photo btimageZA_gif -file dromegza-android.gif]
set bitmapStop [image create photo btimageSP_gif -file dromegsp-android.gif]
set bitmapStart [image create photo btimageST_gif -file dromegst-android.gif]
set showFeldEinteilung [image create photo btimageFE_gif -file dromegfe-android.gif]
#set grafikFensterAendern [image create photo btimage_gif2 -file dromeggv.gif]

#set type_ Epitrochoide
set ww $w

destroy $ww.mbar
frame $ww.mbar -relief raised -bd 2
pack $ww.mbar -side top -fill x -in $ww

label $ww.mbar.space -text " " -relief flat
label $ww.mbar.space2 -text " " -relief flat
label $ww.mbar.space3 -text " " -relief flat

#if {$rechtsLinks == "right"} then {
#    createButtonStart
#    pack $ww.mbar.space -side $rechtsLinks
#}

menubutton $ww.mbar.menu -text Men -underline 0 -menu $ww.mbar.menu.menu
pack $ww.mbar.menu -side left -in $ww.mbar

menu $ww.mbar.menu.menu
$ww.mbar.menu.menu add cascade -label Datei -underline 0 -menu $ww.mbar.menu.menu.file
$ww.mbar.menu.menu add cascade -label "Rechts- / Linkshnder" -underline 0 -menu $ww.mbar.menu.menu.rechtslinks
$ww.mbar.menu.menu add cascade -label Getriebe-Typ -underline 0 -menu $ww.mbar.menu.menu.type
$ww.mbar.menu.menu add cascade -label Rotationsgeschwindigkeit -underline 0 -menu $ww.mbar.menu.menu.geschw
$ww.mbar.menu.menu add cascade -label Grafik -underline 0 -menu $ww.mbar.menu.menu.grafik
$ww.mbar.menu.menu add cascade -label "Stop / Go" -underline 0 -menu $ww.mbar.menu.menu.stopGo
$ww.mbar.menu.menu add cascade -label Zoom -underline 0 -menu $ww.mbar.menu.menu.zoom
$ww.mbar.menu.menu add cascade -label Hilfe -underline 0 -menu $ww.mbar.menu.menu.help

button $ww.mbar.showFeldEinteilung -image $showFeldEinteilung -underline 1 \
    -command TShowFeldeinteilung2
bind $ww.mbar.showFeldEinteilung <Any-Enter> {
    setStatuszeile "'linke Maustaste': Ein- bzw. Ausblenden konzentrischer farbiger Ringe (Felder) zum Einteilen (der Ebene) des bewegten Rades"
}
bind $ww.mbar.showFeldEinteilung <Any-Leave> {
    setStatuszeile ""
}
#button $ww.mbar.space2 -text " " -relief flat

#label $ww.mbar.space -text " " -relief flat
#label $ww.mbar.space2 -text " " -relief flat
button $ww.mbar.zoom_a -image $zoomAll -underline 1 -command \
TZoomAll
bind $ww.mbar.zoom_a <Any-Enter> {
    setStatuszeile "'linke Maustaste': Zoom: 'Einpassen: alles'"
}
bind $ww.mbar.zoom_a <Any-Leave> {
    setStatuszeile ""
}
#button $ww.mbar.zoom_o -image $zoomOut -underline 1 -command \
#TZoomOut
#bind $ww.mbar.zoom_o <Any-Enter> {
#    setStatuszeile "'linke Maustaste': raus Zoomen"
#}
#bind $ww.mbar.zoom_o <Any-Leave> {
#    setStatuszeile ""
#}
#button $ww.mbar.zoom_i -image $zoomIn -underline 1 -command \
#TSetZoomFenster
#bind $ww.mbar.zoom_i <Any-Enter> {
#    setStatuszeile "'linke Maustaste': rein Zoomen (Mit Maus Rechteck aufziehen)"
#}
#bind $ww.mbar.zoom_i <Any-Leave> {
#    setStatuszeile ""
#}
button $ww.mbar.zoom_l -image $zoomLast -underline 1 -command {TZoomLast}
bind $ww.mbar.zoom_l <Any-Enter> {
    setStatuszeile "'linke Maustaste': letzten Zoom wieder anzeigen"
}
bind $ww.mbar.zoom_l <Any-Leave> {
    setStatuszeile ""
}

#button .mbar.gwindow_m -image $grafikFensterAendern  -underline 1 -command \
#TSetFensterGroesser
#bind .mbar.gwindow_m <ButtonPress-3> \
#	TSetFensterKleiner
#bind .mbar.gwindow_m <Any-Enter> {
#    setStatuszeile "'linke Maustaste': Grafik-Fenster vergroessern, 'rechte Maustaste': verkleinern"
#}
#bind .mbar.gwindow_m <Any-Leave> {
#    setStatuszeile ""
#}
#bind .mbar.gwindow_m <ButtonRelease-3> \
#	".mbar.gwindow_m configure -relief raised"
if {$rechtsLinks == "left"} then {
    pack $ww.mbar.space3 $ww.mbar.showFeldEinteilung -side $rechtsLinks
    pack $ww.mbar.space2 -side $rechtsLinks
} else {
    pack $ww.mbar.showFeldEinteilung -side $rechtsLinks
    pack $ww.mbar.space2 -side $rechtsLinks
}

#pack $ww.mbar.space2 $ww.mbar.zoom_l $ww.mbar.zoom_i $ww.mbar.zoom_o $ww.mbar.zoom_a $ww.mbar.space
pack $ww.mbar.zoom_l $ww.mbar.zoom_a -side $rechtsLinks

pack $ww.mbar.space -side $rechtsLinks
createButtonStart

if {$rechtsLinks == "left"} then {
    pack $ww.mbar.space2 -side $rechtsLinks
}

    menu $ww.mbar.menu.menu.rechtslinks
    $ww.mbar.menu.menu.rechtslinks add command -label "fr Rechtshnder" \
	-command "init_Android $dromegTVers $canvas_height $canvas_width right"
        #"destroy .c.f
	#destroy $wc
        #T_Grafik
        #frame .c.f
        #pack .c.f -expand yes -fill y -in .c -side right
        #TPullDownMenu_Android .c.f
        #TStatusFelder_Android
        #T_Status_Android .c.f"
    $ww.mbar.menu.menu.rechtslinks add command -label "fr Linkshnder" \
	-command "init_Android $dromegTVers $canvas_height $canvas_width left"
        #"destroy .c.f
	#destroy $wc
	#T_Grafik
        #frame .c.f
        #pack .c.f -expand yes -fill y -in .c -side left
        #TPullDownMenu_Android .c.f
        #TStatusFelder_Android
        #T_Status_Android .c.f"

    menu $ww.mbar.menu.menu.geschw
    $ww.mbar.menu.menu.geschw add command -label "Rotationsgeschwindigkeit verzehnfachen" \
	-command "set ischritte_ [expr $ischritte_/10]"
    $ww.mbar.menu.menu.geschw add command -label "Rotationsgeschwindigkeit verfnffachen" \
	-command "set ischritte_ [expr $ischritte_/5]"
    $ww.mbar.menu.menu.geschw add command -label "Rotationsgeschwindigkeit verdoppeln" \
	-command "set ischritte_ [expr $ischritte_/2]"
    $ww.mbar.menu.menu.geschw add command -label "Rotationsgeschwindigkeit halbieren" \
	-command "set ischritte_ [expr $ischritte_*2]"
    $ww.mbar.menu.menu.geschw add command -label "Rotationsgeschwindigkeit vierteln" \
	-command "set ischritte_ [expr $ischritte_*4]"


    #menu $ww.mbar.file.menu
    menu $ww.mbar.menu.menu.file
    $ww.mbar.menu.menu.file add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mf-t.hlp"
    }
    $ww.mbar.menu.menu.file add separator
    $ww.mbar.menu.menu.file add command -label "Speichern: Einstellungen" \
	-command "VGrafikeinstellungSpeichern dromeg-t E"
    $ww.mbar.menu.menu.file add command -label "Default-Einstellungen beim naechsten Programmstart" \
	-command "catch {file delete [speicherDir]dromeg-t.def}"
    $ww.mbar.menu.menu.file add command -label "Speichern: Getriebeparameter" \
	-command "VGrafikeinstellungSpeichern dro-p-t P"
    $ww.mbar.menu.menu.file add command -label "Lesen: Getriebeparameter" \
        -command "VGrafikeinstellungSpeichern dro-p-4 P open"
    $ww.mbar.menu.menu.file add separator
    $ww.mbar.menu.menu.file add command -label "Export: DXF-Datei" \
	-command "TexportDXF"
    $ww.mbar.menu.menu.file add command -label "Export: Tabelle der Trochoiden-Punkte (Semikolon-Separiert)" \
	-command "TexportCSV"
    $ww.mbar.menu.menu.file add command -label "Export: Tabelle der Trochoiden-Punkte (Komma-Separiert)" \
	-command "TexportCSVkomma"
    $ww.mbar.menu.menu.file add separator
    $ww.mbar.menu.menu.file add command -label "Postscript-Datei erstellen" \
        -command {VPostscript}
    $ww.mbar.menu.menu.file add separator
    $ww.mbar.menu.menu.file add command -label Exit -command {
	exit
    }

    #bind $ww.mbar.menu.menu.file <Any-Enter> {
    #    setStatuszeile "Speichern der Getriebe-Parameter, (Grafik-) Einstellungen, Export als DXF-, Postscript-Datei oder Tabelle"
    #}
    #bind $ww.mbar.menu.menu.file <Any-Leave> {
    #    setStatuszeile ""
    #}

    menu $ww.mbar.menu.menu.type
    $ww.mbar.menu.menu.type add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mt-t.hlp"
    }

    #$ww.mbar.menu.menu.type add separator
    #$ww.mbar.menu.menu.type add command -label "Gelenkgetriebe darstellen" -command {source dromeg-4.tcl}
    $ww.mbar.menu.menu.type add separator
    $ww.mbar.menu.menu.type add radiobutton -label Epitrochoide \
	-variable type_ -value Epitrochoide -command TSetType
    $ww.mbar.menu.menu.type add radiobutton -label Peritrochoide \
	-variable type_ -value Peritrochoide -command TSetType
    $ww.mbar.menu.menu.type add radiobutton -label Hypotrochoide \
	-variable type_ -value Hypotrochoide -command TSetType
    $ww.mbar.menu.menu.type add separator
    $ww.mbar.menu.menu.type add radiobutton -label "Doppelte Erzeugung der gleichen Trochoide" \
	-variable type_ -value "DoppelteErzeugung" -command TSetType

    #bind $ww.mbar.menu.menu.type <Any-Enter> {
    #    setStatuszeile "Wechsel des Getriebetyps (umlaufenden und feststehendes Rad), gleiche Trochoide mit anderen Rdern etc."
    #}
    #bind $ww.mbar.menu.menu.type <Any-Leave> {
    #    setStatuszeile ""
    #}

    menu $ww.mbar.menu.menu.grafik
    $ww.mbar.menu.menu.grafik add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mg-t.hlp"
    }
    $ww.mbar.menu.menu.grafik add separator
    $ww.mbar.menu.menu.grafik add command -label "Grafikfenstergroesse" \
	-command {TSetGrafikGroesse}
    $ww.mbar.menu.menu.grafik add command -label "Schritte pro Stegumdrehung" \
	-command {TSetSchritte}
    $ww.mbar.menu.menu.grafik add separator
    $ww.mbar.menu.menu.grafik add checkbutton -label "Linienstaerke breit" \
	-variable lineWidth -command TshowGrafikWithModifiedWidth
    $ww.mbar.menu.menu.grafik add command -label "Radius der Radachsen" \
	-command TsetRadiusAchsen
    $ww.mbar.menu.menu.grafik add separator
    $ww.mbar.menu.menu.grafik add checkbutton -label "Gestell an Rastpolkurve zeigen" \
	-variable showGestellRast -command {TShowGestellRast}

    $ww.mbar.menu.menu.grafik add checkbutton -label "Gestellgelenk zeigen" \
	-variable showGestell -command {TShowGestell}
    $ww.mbar.menu.menu.grafik add checkbutton -label "Getriebe zeigen" \
	-variable showGetriebe -command {TShowGetriebe}
    $ww.mbar.menu.menu.grafik add checkbutton -label "Getriebeumrisse hervorheben" \
	-variable showGetriebeUmrisse -command {TShowGetriebeUmrisse}
    $ww.mbar.menu.menu.grafik add checkbutton -label "Trochoide dynamisch modifizieren" \
	-variable showTrochMove
    $ww.mbar.menu.menu.grafik add checkbutton -label "Feldeinteilung/Ringe zeigen" \
	-variable showFelder -command {TShowFeldeinteilung3}

    $ww.mbar.menu.menu.grafik add checkbutton -label "Trochoide zeigen" \
	-variable showTrochoide -command {TShowTrochoide}

    if {$showFelder == 0} then {
        set state "disabled"
    } else {
        set state "normal"
    }
    $ww.mbar.menu.menu.grafik add checkbutton -label "Inaktive Felder ausblenden" \
	-variable showSingleFeld -command {TShowSingleFeldeinteilung} -state $state
	
    menu $ww.mbar.menu.menu.stopGo
    $ww.mbar.menu.menu.stopGo add command -label "Getriebe starten" \
	-command {TRunTrochoide -1 1}
    $ww.mbar.menu.menu.stopGo add command -label "Getriebe anhalten" \
	-command {TStopTrochoide}
	
    #bind $ww.mbar.menu.menu.grafik <Any-Enter> {
    #    setStatuszeile "Men Grafik zum ndern der Grafik-Fenstergre, des dargestellten Inhalts, Linienbreiten, etc."
    #}
    #bind $ww.mbar.menu.menu.grafik <Any-Leave> {
    #    setStatuszeile ""
    #}

    menu $ww.mbar.menu.menu.zoom
    $ww.mbar.menu.menu.zoom add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mz-t.hlp"
    }
    $ww.mbar.menu.menu.zoom add separator
    $ww.mbar.menu.menu.zoom add command -label "Einpassen: Alles" \
	-command TZoomAll

    $ww.mbar.menu.menu.zoom add command -label "Einpassen: Bahn" \
	-command {
	    set last_massstab $massstab
	    set width [min $canvas_height  $canvas_width]
	    set massstab [expr ($width-10)/2./(abs($iZ+$iN)+abs($a_massstab))]
	    set a_ [expr $a_massstab*$massstab]
	    TSetI
	    xyViewDefault
	}
    $ww.mbar.menu.menu.zoom add command -label "Einpassen: Gangpolkurve" \
	-command {
	    set last_massstab $massstab
	    set width [min $canvas_height  $canvas_width]
	    set a [max [expr abs($iN)] [expr abs($a_massstab)]]
	    set massstab [expr ($width-10)/2./(abs($iZ+$iN)+$a)]
	    set a_ [expr $a_massstab*$massstab]
	    TSetI
	    xyViewDefault
	}
    $ww.mbar.menu.menu.zoom add separator
    $ww.mbar.menu.menu.zoom add command -label "Zoom: rein (durch Rechteck aufziehen)" \
	-command {TSetZoomFenster}
    $ww.mbar.menu.menu.zoom add command -label "Zoom: Letzter Zoom" \
	-command {TZoomLast}
    $ww.mbar.menu.menu.zoom add command -label "Zoom: raus zoomen" \
	-command {TZoomOut}
    $ww.mbar.menu.menu.zoom add command -label "Zoom: Massstab aendern" \
	-command {TSetMassstab}

    #bind $ww.mbar.menu.menu.zoom <Any-Enter> {
    #    setStatuszeile "Men Zoom: wiederholt und erweitert Zoom-Mglichkeiten der Zoom-Icons rechts von den Men-Knpfen"
    #}
    #bind $ww.mbar.menu.menu.zoom <Any-Leave> {
    #    setStatuszeile ""
    #}

     menu $ww.mbar.menu.menu.help
    $ww.mbar.menu.menu.help add command -label "Hilfe zu diesem Menue" \
	-foreground blue -command {
	ThelpHelp "dro-mh-t.hlp"
    }
    $ww.mbar.menu.menu.help add separator
    $ww.mbar.menu.menu.help add command -label "Grundsaetzliches" -command {
	ThelpHelp "dro-gh-t.hlp"
    }
    $ww.mbar.menu.menu.help add command -label "Hinweise zur Bedienoberflaeche" -command {
	ThelpHelp "dro-t.hlp"
    }
    $ww.mbar.menu.menu.help add command -label "Info" -command {
	ThelpVersion "DROMEG-T" $dromegTVers
    }
    $ww.mbar.menu.menu.help add command -label "Copyright" -command {
	ThelpCopyright "DROMEG-T"
    }

    #bind $ww.mbar.menu.menu.help <Any-Enter> {
    #    setStatuszeile "Men Help mit allgemeinen Hinweisen zur Bedienoberflche, Infos und Copyright"
    #}
    #bind $ww.mbar.menu.menu.help <Any-Leave> {
    #    setStatuszeile ""
    #}


    tk_menuBar $ww.mbar $ww.mbar.menu
    focus $ww.mbar
}
##############################################################
proc createButtonStart {} {

        global ww bitmapStart rechtsLinks

        catch {destroy $ww.mbar.stop}

        button $ww.mbar.start -image $bitmapStart -underline 1 \
            -command {createButtonStop
                TRunTrochoide -1 1}
        bind $ww.mbar.start <ButtonPress-2> \
        	"createButtonStop
        	TRunTrochoide -1 3"
        bind $ww.mbar.start <ButtonPress-3> \
        	TChangeGeschwindigkeit
        foreach i "2 3" {
            bind $ww.mbar.start <ButtonRelease-$i> \
        	"$ww.mbar.start configure -relief raised"
        }
        bind $ww.mbar.start <Any-Enter> {
            setStatuszeile "'linke Maustaste': langsam,\
        'mittlere Maustaste': schnell, 'rechte Maustaste': Geschwindigkeit-Menue"
        }
        bind $ww.mbar.start <Any-Leave> {
            setStatuszeile ""
        }

        #pack $ww.mbar.start -side $rechtsLinks
        pack $ww.mbar.start -side left
}
##############################################################
proc createButtonStop {} {

        global ww bitmapStop

        destroy $ww.mbar.start
        
        button $ww.mbar.stop -image $bitmapStop -underline 1 -command \
            {createButtonStart
             TStopTrochoide}
        foreach i "2 3" {
            bind $ww.mbar.stop <ButtonPress-$i> {createButtonStart
               TStopTrochoide}
        }
        bind $ww.mbar.stop <Any-Enter> {
            setStatuszeile "'alle Maustaste': Animation oder auch \
        Berechnung beenden"
        }
        bind $ww.mbar.stop <Any-Leave> {
            setStatuszeile ""
        }
        pack $ww.mbar.stop -side right
}
###############################################################
proc TPullDownMenuUpdate_Android {} {
    
    global showFelder ww

    catch {$ww.mbar.menu.menu.grafik delete 16 50}

    if {$showFelder == 0} then {
        set state "disabled"
    } else {
        set state "normal"
    }

    $ww.mbar.menu.menu.grafik add checkbutton -label "Inaktive Felder ausblenden" \
	-variable showSingleFeld -command {TShowSingleFeldeinteilung} -state $state
    #$ww.mbar.menu.menu.grafik add separator
    #$ww.mbar.menu.menu.grafik add command -label "Getriebe starten" \
    #	-command {TRunTrochoide -1 1}
    #$ww.mbar.menu.menu.grafik add command -label "Getriebe anhalten" \
    #   -command {TStopTrochoide}
}
####################################################
proc TStatusFelder_Android {} {
     global type_ iZ_A iN_A iN iZ iZ_M iN_M rB_massstab rUe_ a_massstab
     global rB_ wc m_  gamma0_ Pi ww phi_ gamma0_ rG_ phi_grad gam0_grad
     global showFelder statuszeile kueStatus nW_ rS_M rS
     global xMoveto yMoveto

     destroy $ww.b
     destroy $ww.b.l1
     destroy $ww.b.l2
     destroy $ww.b.l3

     #if {$showFelder == 1} then {
        frame $ww.b
        pack $ww.b -fill x -in $ww -side top -anchor n

        label $ww.b.l1 -text "r" -bd 0
        pack $ww.b.l1 -in $ww.b -side left -anchor n
        label $ww.b.l2 -text "B  =" -bd 0
        pack $ww.b.l2 -in $ww.b -side left -anchor s
        label $ww.b.l3 -textvariable rB_massstab
        pack $ww.b.l3 -in $ww.b -side right
        $ww.b.l3 configure -relief raised

        bind $ww.b <Any-Enter> {
            $wc itemconfigure ball -width 2
            if {$showFelder == 1} then {
                setStatuszeile "'Linke Maustaste' verlegt \
erzeugenden Punkt auf die BALLsche Kurve"
               #$ww.b.l3 configure -relief raised
            } else {
                setStatuszeile " "
            }
        }
        bind $ww.b <Any-Leave> {
            $wc itemconfigure ball -width 1
            setStatuszeile " "
            if {$showFelder == 1} then {
                #$ww.b.l3 configure -relief flat
            }
        }
        bind $ww.b.l3 <Button-1> {
            TprepareRestart
            set a_ [expr $rB_]
            modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
            TSetSchnittBlue
            TRestartTrochoide
        }
    #}

    destroy $ww.g2
    destroy $ww.g2.l1
    destroy $ww.g2.l2
    destroy $ww.g2.l3

    frame $ww.g2
    pack $ww.g2 -fill x -in $ww -side top -anchor n

    label $ww.g2.l1 -text "r" -bd 0
    pack $ww.g2.l1 -in $ww.g2 -side left -anchor n
    label $ww.g2.l2 -text "G  =" -bd 0
    pack $ww.g2.l2 -in $ww.g2 -side left -anchor s
    label $ww.g2.l3 -textvariable iN
    pack $ww.g2.l3 -in $ww.g2 -side right
    $ww.g2.l3 configure -relief raised

    bind $ww.g2 <Any-Enter> {
        $wc itemconfigure gang -width 2
        setStatuszeile "'Linke Maustaste' verlegt \
erzeugenden Punkt auf die Gangpolkurve"
        #$ww.g2.l3 configure -relief raised
    }
    bind $ww.g2 <Any-Leave> {
        $wc itemconfigure gang -width 1
        setStatuszeile " "
        #$ww.g2.l3 configure -relief flat
    }
    bind $ww.g2.l3 <Button-1> {
        TprepareRestart
        set a_ [expr $rG_]
        modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
        TSetSchnittBlue
        TRestartTrochoide
    }

    #destroy $ww.ns
    destroy $ww.k
    destroy $ww.k.l1
    destroy $ww.k.l2
    #destroy $ww.ue
    destroy $ww.w
    destroy $ww.sf


    #if {$showFelder == 1} then {

# Frame fuer Uebergangskurven
        destroy $ww.ue
        frame $ww.ue
        pack $ww.ue -fill x -in $ww -side top -anchor n

        if {$kueStatus == "ok"} then {T_KueStatus }

        # Sonderfall: Kreis um Mittelpunkt des bewegten Rades durch Mittelpunkt des ruhenden Rades
        #if {[expr $iZ/2.] != [expr int($iZ/2.)]} then {
            frame $ww.sf
            pack $ww.sf -fill x -in $ww -side top -anchor n
            label $ww.sf.t -text "Sonderfall:" -anchor w
            pack $ww.sf.t -in $ww.sf -side left
            label $ww.sf.v -textvariable rS_M
            pack $ww.sf.v -in $ww.sf -side right
            $ww.sf.v configure -relief raised
            #tk_messageBox -message "sonderfall"
            #tk_messageBox -message "iZ=$iZ, iN=$iN, iN_M=$iN_M, iZ_M=$iZ_M"

            bind $ww.sf <Any-Enter> {
                $wc itemconfigure sonderfall -width 2
                #setStatuszeile "'Linke Maustaste' verlegt erzeugenden Punkt auf den Kreis durch den Mittelpunkt des stehenden Rades"
                setStatuszeile "'Linke Maustaste': Sonderfall einer Trochoide mit Mehrfachschnittpunkt(en) ohne Selbstberhrungspunkte."
                #$ww.sf.v configure -relief raised
            }
            bind $ww.sf <Any-Leave> {
                $wc itemconfigure sonderfall -width 1
                setStatuszeile " "
                #$ww.sf.v configure -relief flat
            }
            bind $ww.sf.v <Button-1> {
                if {$rS_M != "existiert nicht"} then {
                    TprepareRestart
                    set a_ $rS
                    modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
                    TSetSchnittBlue
                    TRestartTrochoide
                } else {
                #    TSetZoomFenster2finger wcw 279 264 322 -3957 1
                #    TSetZoomFenster2finger wcw 254 256 354 -3957 0
                #    TSetZoomFenster2finger wcw 254 256 384 -3957 0
                #    TSetZoomFenster2finger wcw 254 256 414 -3957 0
                #    TSetZoomFenster2finger wcw 254 256 364 -3957 2
                tk_messageBox -message "xMoveto=$xMoveto, yMoveto=$yMoveto"
                }
            }
        #}



        # Uebergangskurven
        frame $ww.k
        pack $ww.k -fill x -in $ww -side top -anchor n

        label $ww.k.l1 -text "Anzahl Uebergangskurven:"
        pack $ww.k.l1 -in $ww.k -side left
        label $ww.k.l2 -textvariable rUe_(0)
        pack $ww.k.l2 -in $ww.k -side right
        bind $ww.k <Any-Enter> {
        setStatuszeile "Anzahl der bergangskurven=Anzahl der Trochoiden, die Selbstberhrungspunkte aufweisen"
        }
        bind $ww.k <Any-Leave> {
            setStatuszeile ""
        }

        frame $ww.w
        pack $ww.w -fill x -in $ww -side top -anchor n

        label $ww.w.l1 -text "Anzahl Wendepunkte" -anchor w
        pack $ww.w.l1 -in $ww.w -side left
        label $ww.w.l4 -textvariable nW_ -bd 0
        pack $ww.w.l4 -in $ww.w -side right
        label $ww.w.l3 -text "," -bd 0
        pack $ww.w.l3 -in $ww.w -side right
        label $ww.w.l2 -text "0" -bd 0
        pack $ww.w.l2 -in $ww.w -side right
        bind $ww.w <Any-Enter> {
        setStatuszeile "Rote Zahl: wie hufig wechselt der Krmmungsmittelpunkt von einer Seite der Trochoide auf die andere."
        }
        bind $ww.w <Any-Leave> {
            setStatuszeile ""
        }

# Frame fuer Schnittpunkt
        destroy $ww.ns
        frame $ww.ns
        pack $ww.ns -fill x -in $ww -side top -anchor n

    #}


}
##############################################################
global a_ phi_ pradi_ rG_ i_ m_ gamma0_ iTyp_ iZ_A iN_A iN_M iZ_M
global iZ iN wc rR Pi irunMaxI xMax_ yMax_ massstab a_massstab
global statuszeile gam0_grad showTrochMove showFelder showFelderOld kueStatus
global canvas_height canvas_width ischritte_ iT umdr_ phi_grad
global last_massstab xMoveto yMoveto 0x 0y last_0x last_0y
global showGestell showTrochoide plotName
global dromegTVers
global lineWidth typeOld_
global showGetriebe showGestellRast showGetriebeUmrisse
global Android
global aFaktor
global default_xMovetoUr default_yMovetoUr
global showOnlyKurven TShowBall TShowGang TShowUeber TShowSonder TShowRast TShowKK
global getriebeTyp_

set dromegTVers 1.3.5

#Dieser Befehl gilt nur fuer eine EXE-Datei DROMEG-T.exe
#cd "dromeg-v$dromegTVers"

set getriebeTyp_ "Trochoide"
set showOnlyKurven 0
set TShowBall 0
set TShowGang 0
set TShowUeber 0
set TShowSonder 0
set TShowRast 0
set TShowKK 0
set xMoveto .35
set yMoveto .35
set showTrochMove 1
set showTrochoide 1
set showFelder 0
set showSingleFeld 0
set showGetriebe 1
set showGetriebeUmrisse 1
set showFelderOld $showFelder
set showGestell 1
set showGestellRast 1
set kueStatus "not ok"
set Pi [expr 4.*atan(1.)]
set umdr_ 0
set aFaktor 1.
#set iT 180
#set ischritte_ 360
set iT 360
if {[catch {sdltk android}]} then {
    # Betriebssystem ist nicht Android
    set Android 0
    set ischritte_ [expr 360*50]
} else {
    # Betriebssystem ist Android
    set Android 1
    set ischritte_ [expr 360]
}

set phi_ [expr -$Pi/6.]
set phi_grad [expr $phi_/$Pi*180.]
set gamma0_ 0
set gam0_grad 0
set a 40
set da 5
set pradi_ 5
set iZ 4.
set iN 1.
set iZ_A 4
set iN_A 1
set rG_ 20
set rR 80
set rUe_(0) 0
set type_ Epitrochoide
set typeOld_ Epitrochoide
set aFaktor 0.2
set lineWidth 0

# dro-p-t.def einlesen

    set filename [speicherDir]
    append filename dro-p-t.def
    if {[file exists $filename] == 1} then {
        source $filename
    }

set a_ $a
set iZ_M $iZ_A
set iN_M $iN_A

calculatePara $iZ $iN $rR
set xMax_ [expr ($rG_*$m_+abs($a))+10]
set yMax_ [expr ($rG_*$m_+abs($a))+10]
set irunMaxI 0
set iTyp_ Epitrochoide
set massstab 20
set last_massstab 20
set a_massstab [expr $a_/$massstab]
set plotName "C:/temp/dromeg.ps"

# dromeg-t.def einlesen

    set filename [speicherDir]
    append filename dromeg-t.def
    if {[file exists $filename] == 1} then {
        source $filename
    }
    #k_messageBox -message "filename=$filename, pradi_=$pradi_"

set wc .canvas
if {$Android == 0} then {
    # Betriebssystem ist nicht Android
    if {[info exists canvas_height] == 0} then {
        set filename [speicherDir]
        append filename dromeg.def
        if {[file exists $filename] == 1} then {
            source $filename
        } else {
            #set canvas_height 350
            set canvas_height 500
            set canvas_width 630
            set plotName c:/temp/dromeg.eps
            #set canvas_width 400
        }
    }
} else {
    # start unter Android

    # ermittel der Display-Groesse
    set displayMetrics [borg displaymetrics]
    sdltk touchtranslate on
    regexp { width ([0-9]+) height ([0-9]+) } $displayMetrics dummy displayWidth displayHeight
    set dHeight $displayHeight
    if {$displayWidth < $dHeight} then {
        set dHeight $displayWidth
    }
    set canvas_height [expr $dHeight -90]
    set canvas_width [expr $dHeight -90]
}

#set 0x [expr double($xregion_)/2.]
#set 0y [expr double($yregion_)/2.]

if {$Android != 1} then {
    #set answer [tk_messageBox -type yesno -message "Android Simulation?"]
    set answer "no"
}

if {$Android == 1 || [string tolower $answer] == "yes"} then {
    #if {$Android != 1} then {
    #    tk_messageBox -message "Android-Simulations-Mode"
    #}
    set Android 1
    init_Android $dromegTVers $canvas_height $canvas_width
} else {
    init_noAndroid $dromegTVers $canvas_height $canvas_width
}

set dxfFile "no"

set default_xMovetoUr $default_xMoveto
set default_yMovetoUr $default_yMoveto
#tk_messageBox -message "default_yMovetoUr=$default_yMovetoUr"

#Knoten $wc 0 0 rR $dxfFile
#set xP [expr $rR*cos($phi_)]
#set yP [expr $rR*sin($phi_)]
#Knoten $wc $xP $yP rG_ $dxfFile 0.5
#set xG [expr $rG_*$m_*cos($phi_)]
#set yG [expr $rG_*$m_*sin($phi_)]
#Knoten $wc $xG $yG K $dxfFile
#set y [yTrochoide $rG_ $m_ $phi_ $a $gamma0_]
#set x [xTrochoide $rG_ $m_ $phi_ $a $gamma0_]
#Knoten $wc $x $y t $dxfFile
#Kante $wc 1 2 rR rr
#Kante $wc 2 3 rG_ rg_
#Kante $wc 3 4 K k
#Kante $wc 1 3 S s
# Gangpolkurve
#dxfKreis $wc "no" 13 black [expr $xG-$rG_] [expr $yG-$rG_] \
#        [expr $xG+$rG_] [expr $yG+$rG_] gang yellow

#TshowGrafik

#TcreateDXF $dxfFile
#$wc lower gang
# Rastpolkurve
#dxfKreis $wc "no" 12 black [expr -$rR] [expr -$rR] $rR $rR rast lightgrey
#$wc lower rast

#calculateKueKb "no" $wc $iN $iZ $Pi $rR

# BALLsche Kurve
#dxfKreis $wc "no" 14 red [expr $xG-$rB_] [expr $yG-$rB_] \
#        [expr $xG+$rB_] [expr $yG+$rB_] ball GreenYellow

#TCreateGestellGelenk
#TCreateGestellRast
#createTrochoide $wc $iN $Pi
#TLowerKurven

#fuer Vorfuehrung:
##################

#Vorfuehrung#set type_ Hypotrochoide
#TSetType

#Vorfuehrung#set iZ_A 5
#Vorfuehrung#set iN_A 1
#TSetI

#Vorfuehrung#set a_massstab 1.5
#set a_ [expr $a_massstab*$massstab]
#modifyTrochoide $wc $m_ $iN $gamma0_ $Pi
#TSetSchnittBlue

#set showFelder 0
#TShowFeldeinteilung

#focus $wc


# wenn "Feldeinteilung zeigen" modifiziert werden soll, dann suche nach "if {$showFelder == 1} then {"
# bzw. nach "orange" und ebenfalls suche nach "GreenYellow"

# V1.3.3 bugfix: fuer Getriebe nicht darstellen
# V1.3.4 bugfix: doppelte Erzeugung
# V1.3.5 bugfix Aufruf von v1.3.5 statt 1.3
#               bugfix beim Abspeichern von DXF-Daeien (Kein Lschen von Elementen auf dem Bildschirm)